#INCLUDE "PROTHEUS.CH"
#INCLUDE "DBTREE.CH"
#INCLUDE "MSOLE.CH"
#INCLUDE "FATR600.CH"

/*/


Ŀ
Funcao    FATR600      Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Impressao de documentos via integracao com WORD.				
Ĵ
Retorno    Nenhum                                                      	
Ĵ
Parametros Nenhum					 									
Ĵ
   DATA    Programador   Manutencao Efetuada                         	
Ĵ
                                                                     	
ٱ


/*/
Function FATR600(cTemplate)

Local aArea			:= GetArea()						//Guarda area atual
Local cPais			:= Criavar("AG4_PAIS")				//Pais selecionado
Local cIdioma		:= Criavar("AG4_IDIOMA")			//Idiona selecionado
Local cCodigo		:= SPACE(len(AG1->AG1_CODIGO))		//Codigo do modelo selecionado
Local aComponente	:= {}								//Array para os componentes do modelo selecionado
Local oObrigat 											//Objeto utilizado no Tree  (Obrigatorio)
Local oOpcSelec   										//Objeto utilizado no Tree  (Opcional Selecionado)
Local oOpcNSelec 										//Objeto utilizado no Tree  (Opcional nao selecionado)
Local oTree												//Objeto para o Tree do aComponentes
Local lHtml 		:= FindFunction("ISHTML") .And. IsHTML()  // Verifica se e Html

Default cTemplate := ""
//Ŀ
// Nao e permitido realizar impressao pelo remote HTML   
//
If lHtml
	FWAvisoHTML()
	Return(.T.)
EndIf 

AjustaSXB()

Define MSDialog oDlg Title STR0001 From 000,000 To 425,450 Of oMainWnd Pixel //"Impresso de Modelo - Integrao com Word"

@ 07,015  	Say STR0008 PIXEL //"Pais"
@ 06,040  	MSGET cPais	Picture "@!" F3 "SYA" Valid ExistCpo( "SYA", cPais ) When(IIF(Empty(Alltrim(cPais)),.T.,.F.)) PIXEL

@ 07,072    Say STR0009 pixel //"Idioma"
@ 06,097  	MSGET cIdioma Picture "@!" F3 "F8" Valid ExistCpo( "SX5","F8" + cIdioma ) When(IIF(Empty(Alltrim(cIdioma)),.T.,.F.)) PIXEL

@ 21,015  	SAY STR0003		PIXEL //"Modelo"
@ 19,040  	MSGET cCodigo	Picture "@!" F3 "AG1MOD"  Valid (ExistCpo("AG1",M->cCodigo,1) .AND. MsgRun(STR0004,STR0016,{||R600Tree(cCodigo,@aComponente,cPais,cIdioma,oTree)})) When(IIF(Empty(Alltrim(cCodigo)),.T.,.F.)) PIXEL //"Carregando modelo ..."
@ 19,073   	MSGET Posicione("AG1", 01, xFilial("AG1")+cCodigo, "AG1_DESCRI") When .F.  Size 135,10 PIXEL

///--- tree
oTree := DbTree():New(060,015,190,210,oDlg,{||R600MudaStatus(aComponente,@oTree:GetCargo(),oTree),oTree:Refresh()},,.T.,.F.)

///--- legenda
oObrigat 	:= TBitmap():New(003,002,008,008,"br_vermelho",,.T.,oDlg)
@ 42,025 	SAY STR0005		PIXEL //"Item Obrigatorio"

oOpcSelec	:= TBitmap():New(003,009,008,008,"br_azul",,.T.,oDlg)
@ 42,081  	SAY STR0006		PIXEL //"Opcional Selecionado"

oOpcNSelec 	:= TBitmap():New(003,018,008,008,"br_cinza",,.T.,oDlg)
@ 42,153  	SAY STR0007	PIXEL //"Opcional nao selecinado"

///--- botoes
DEFINE SBUTTON oBtnV1 FROM 195,140 TYPE 1 ENABLE OF oDlg ACTION (R600Impressao(aComponente,cIdioma,cCodigo,cTemplate),oDlg:End(),RestArea(aArea))
DEFINE SBUTTON oBtnV2 FROM 195,180 TYPE 2 ENABLE OF oDlg ACTION (RestArea(aArea),oDlg:End())

Activate MSDialog oDlg Centered

RestaRea( aArea )

Return

/*/


Ŀ
Funcao    R600Tree     Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Monta TREE contento a estrutura de impressa do modelo		
Ĵ
Retorno    Nenhum                                                      	
Ĵ
Parametros cCodigo	   - Modelo selecionado				 				
			  aComponente - Array contendo os componentes da proposta		
			  cPais	   - Pais informado				 					
			  cIdioma     - Idiona informado								
			  oTree	   - Objeto contento o Tree							
Ĵ
   DATA    Programador   Manutencao Efetuada                         	
Ĵ
                                                                     	
ٱ


/*/
Static Function R600Tree(cCodigo,aComponente,cPais,cIdioma,oTree)

Local nItemArray	:= 0
Local cProcessa		:= "2"

aComponente:={}

If 	Empty(cCodigo) .or. Empty(cPais) .or. Empty(cIdioma)
	Return (.T.)
Endif

oTree:Reset() 			//Limpar a tree
oTree:BeginUpdate() 	//Iniciar Inclusao de itens

oTree:AddTree(PADR(STR0001,TAMSX3("AG3_DESCRI")[1]),.T.,"MENUDOWN","MENURIGHT",,,"!") //"Impresso de Proposta Comercial"

DbSelectArea("AG2")
DbSetOrder(1)
MsSeek(xFilial("AG2")+cCodigo)

cComp  	:=	AG2->AG2_COMPPR //Componente Capitulo
cCompAs	:=  AG2->AG2_COMPAS //Componente Item

DbSelectArea("AG3")
DbSetOrder(1)
MsSeek(xFilial("AG3")+AG2->AG2_COMPPR)

cCompPrDs 	:=AG3->AG3_DESCRI// Descricao do componente capitulo

MsSeek(xFilial("AG3")+AG2->AG2_COMPAS)

cCompAsDs 	:=  AG3->AG3_DESCRI //Descricao do componente item

DbSelectArea("AG4")
DbSetorder(2)

If 	MsSeek(xFilial("AG4")+cCompAs+cPais+cIdioma)
	cRotina 	:=  AG4->AG4_FUNCAO //Rotina que ira realizar a integracao com word
	cAtualiza	:=  AG4->AG4_ATUALI //Se atualiza o documento via web
Else
	oTree:EndTree()
	oTree:EndUpdate()
	Return .F.
Endif

If 	Empty(AG4->AG4_VLDCOM)
	cProcessa:=AG2->AG2_OBRIGA
Else
	cProcessa:=&(AllTrim(AG4->AG4_VLDCOM))
Endif

If 	cProcessa <> "3"
	
	nItemArray:=1
	
	//Ŀ
	// Estrutura do aComponente:    
	//------------------------------
	//01 Cod Capitulo               
	//02 Nm Capitulo                
	//03 Nm Componente              
	//04 Obrigat                    
	//05 DocWord                    
	//06 cCargo                     
	//07 Vai para o Dot?[.T./.F.]   
	//08 Rotina que aciona macros   
	//09 Quantidade Niveis do doc   
	//10 Quantidade SubNiveis do doc
	//11 Incrementa Cap [1|2]       
	//12 Atualiza o doc via web     
	//13 Cod Componente associado   
	//
	aadd(aComponente,{cComp,cCompPrDs,cCompAsDs,cProcessa,alltrim(AG4->AG4_DOCWOR),chr(nItemArray+33),iif(cProcessa=="1",.T.,.F.),AllTrim(cRotina),AG4->AG4_NIVEL,AG4->AG4_SUBNIV,AG2->AG2_INCCAP,cAtualiza,cCompAs})
	
	///-> Alimenta 1.o item da Tree
	oTree:AddTree(aComponente[nItemArray][2],.T.,"MENUDOWN","MENURIGHT",,,"!")
	oTree:AddTreeItem(aComponente[nItemArray][3],,R600Status(aComponente,aComponente[nItemArray][6]),chr(nItemArray+33))
Endif

cComp   	:=	AG2->AG2_COMPPR

AG2->(DbSkip())

While cCodigo == AG2->AG2_COD .and. AG2->(!Eof())
	
	DbSelectArea("AG3")
	DbSetOrder(1)
	MsSeek(xFilial("AG3")+AG2->AG2_COMPPR)
	
	cCompPrDs 	:=AG3->AG3_DESCRI// Descricao do componente capitulo
	
	MsSeek(xFilial("AG3")+AG2->AG2_COMPAS)
	
	cCompAsDs 	:=  AG3->AG3_DESCRI //Descricao do componente item
	
	DbSelectArea("AG4")
	DbSetorder(2)
	
	If 	MsSeek(xFilial("AG4")+AG2->AG2_COMPAS+cPais+cIdioma)
		cRotina 	:=  AG4->AG4_FUNCAO //Rotina que ira realizar a integracao com word
		cAtualiza	:=  AG4->AG4_ATUALI //Se atualiza o documento via web
	Else
		oTree:EndTree()
		oTree:EndUpdate()
		//"Este modelo no est disponvel para impressao nesse PAIS/IDIOMA. Traduo no encontrada para: "####"Atencao"
		MsgAlert(STR0012 + cCompAsDs, STR0002)
	Endif
	
	cCompPr		:=  AG2->AG2_COMPPR
	cCompAs		:=	AG2->AG2_COMPAS
	
	If 	Empty(AG4->AG4_VLDCOM)
		cProcessa:=AG2->AG2_OBRIGA
	Else
		cProcessa:=&(AllTrim(AG4->AG4_VLDCOM))
	Endif
	
	If 	cProcessa <> "3"
		
		nItemArray++
		//Ŀ
		// Estrutura do aComponente:    
		//------------------------------
		//01 Cod Capitulo               
		//02 Nm Capitulo                
		//03 Nm Componente              
		//04 Obrigat                    
		//05 DocWord                    
		//06 cCargo                     
		//07 Vai para o Dot?[.T./.F.]   
		//08 Rotina que aciona macros   
		//09 Quantidade Niveis do doc   
		//10 Quantidade SubNiveis do doc
		//11 Incrementa Cap [1|2]       
		//12 Atualiza o doc via web     
		//13 Cod Componente associado   
		//
		
		//Adiciona cada Item do BD de modelo para o Array
		aadd(aComponente,{cCompPr,cCompPrDs,cCompAsDs,cProcessa,alltrim(AG4->AG4_DOCWOR),chr(nItemArray+33),iif(cProcessa=="1",.T.,.F.),AllTrim(cRotina),AG4->AG4_NIVEL,AG4->AG4_SUBNIV,AG2->AG2_INCCAP,cAtualiza,cCompAs})
		//Se o componente capitulo for diferente, encerra o capitulo atual da tree e abre um novo
		If 	cComp<> AG2->AG2_COMPPR
			If 	nItemArray > 1
				oTree:EndTree()
			Endif
			oTree:AddTree(aComponente[nItemArray][2],.T.,"MENUDOWN","MENURIGHT",,,"!")
		Endif
		
		// Adiciona Item no capitulo
		oTree:AddTreeItem(aComponente[nItemArray][3],,R600Status(aComponente,aComponente[nItemArray][6]),chr(nItemArray+33))
	Endif
	
	cComp := AG2->AG2_COMPPR
	AG2->(DbSkip())
	
Enddo

oTree:EndTree()
oTree:EndUpdate()

Return

/*/


Ŀ
Funcao    R600Tree     Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Status do componente											
Ĵ
Retorno    Nenhum                                                      	
Ĵ
Parametros aComponente - Array contendo os componentes do modelo		
			  oTree	   - Objeto contento o Tree							
Ĵ
   DATA    Programador   Manutencao Efetuada                         	
Ĵ
                                                                     	
ٱ


/*/
Static Function R600Status(aComponente,cItens)

Local cRetorno	:= ""
Local nPos		:= Ascan(aComponente,{|x|x[6]==cItens})

//Ŀ
// Estrutura do aComponente:    
//------------------------------
//01 Cod Capitulo               
//02 Nm Capitulo                
//03 Nm Componente              
//04 Obrigat                    
//05 DocWord                    
//06 cCargo                     
//07 Vai para o Dot?[.T./.F.]   
//08 Rotina que aciona macros   
//09 Quantidade Niveis do doc   
//10 Quantidade SubNiveis do doc
//11 Incrementa Cap [1|2]       
//12 Atualiza o doc via web     
//13 Cod Componente associado   
//

If cItens == "!" .or. cItens == " " .or. nPos == 0
	Return Iif (nFunc == 1,NIL,cRetorno)
ElseIf aComponente[nPos][4]=="1"
	Return ("br_vermelho") //-> Bitmap do Componente obrigatorio
ElseIf aComponente[nPos][4]=="2" .and. aComponente[nPos][7]== .F.
	Return("br_cinza")  //-> Bitmap do componente opcional no selecionado
ElseIf aComponente[nPos][4]=="2" .and. aComponente[nPos][7]== .T.
	Return ("br_azul")//-> Bitmap do componente opcional selecionado
Else
	//-> Se tiver alguma coisas diferente no BD, o bitmap sera de componente nao selecionado,
	//	porem nao conseguira selecionar o componente
	Return ("br_cinza")
Endif

//Atualiza Tree
oTree:Refresh()

Return

/*/


Ŀ
Funcao    R600MudaStatus Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Muda o status do componente.									  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros aComponente - Array contendo os componentes do modelo		  
			  cItens	   - Item do Tree posicionando						  
			  oTree	   - Objeto contento o Tree							  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600MudaStatus(aComponente,cItens,oTree)

//Ŀ
// Estrutura do aComponente:    
//------------------------------
//01 Cod Capitulo               
//02 Nm Capitulo                
//03 Nm Componente              
//04 Obrigat                    
//05 DocWord                    
//06 cCargo                     
//07 Vai para o Dot?[.T./.F.]   
//08 Rotina que aciona macros   
//09 Quantidade Niveis do doc   
//10 Quantidade SubNiveis do doc
//11 Incrementa Cap [1|2]       
//12 Atualiza o doc via web     
//13 Cod Componente associado   
//

nPos:=Ascan(aComponente,{|x|x[6]==cItens})

If 	cItens == "!" .or. cItens == " "
	//-> Se for capitulo, ou houver dados errados no BD, no fara nada
	Return
ElseIf 	aComponente[nPos][4]=="1"
	//-> Se for item obrigatorio, chumbar que o componente ira para o Doc, mesmo que ja estaja marcado
	aComponente[nPos][7]:= .T.
ElseIf 	aComponente[nPos][7]== .F. .and. aComponente[nPos][4]=="2"
	//-> troca componente opcional de desmarcado para marcado
	aComponente[nPos][7]:= .T.
	//-> muda bitmap de desmarcado para marcado
	oTree:ChangeBMP("br_azul","br_azul")
	oTree:Refresh()
ElseIf aComponente[nPos][7]== .T. .and. aComponente[nPos][4]=="2"
	//-> troca componente opcional de marcado para desmarcado
	aComponente[nPos][7]:= .F.
	//-> muda bitmap de marcado para desmarcado
	oTree:ChangeBMP("br_cinza","br_cinza")
	oTree:Refresh()
Else
	//-> caso haja erro no cadastro, o componente nao ira para o dot e permanecera desmarcado
	aComponente[nPos][7]:= .F.
	oTree:ChangeBMP("br_cinza","br_cinza")
Endif

Return

/*/


Ŀ
Funcao    R600Impressao  Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Realiza a impressao do modelo (DOT) selecionado.				  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros Nenhum					 									  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600Impressao(aComponente,cIdioma,cCodigo,cTemplate)

Local aArea			:= GetArea()													//Aguarda area atual
Local hWord 		:= Nil															//Conexao com o Word
Local cPathOri		:= AllTrim(SuperGetMv("MV_PATWORD"))							//Diretorio que esta todos componentes ( c:\wordstd )
Local cPathFinal 	:= AllTrim(SuperGetMv("MV_PATTERM"))							//Diretorio que sera gravado o documento final ( c:\wordtmp )
Local cPathServer	:= Alltrim(SuperGetMv("MV_DOCAR"))								//Diretorio que estao os DOTS originais ("\Sigaadv\WORD\DOC_AR\")
Local cDotMacros	:= IIf(cTemplate == "VistoriaTec",Alltrim(SuperGetMv("MV_VISTDOT",.F.,"CRM-Exec_Macro_Vistoria.dot")),Alltrim(SuperGetMv("MV_NOMEDOT",,"CRM-Exec_Macro.dot")))	//Documento WORD contendo todas as macro usadas na impressao do modelo
Local lMsDocument	:= SuperGetMv("MV_FTMSDOC",,.F.)                               //Define se a proposta comercial sera vinculada ao banco de conhecimento
Local lFR600Val		:= ExistBlock("FR600VAL") 										//Ponto de entrada para validacao de usuario
Local lRet600Val	:= .T. 															//Trata o retorno do ponto de entrada
Local cRevisao		:= ''                                                           //Revisao da Proposta Comercial
Local cArqUsr		:= ''                                                           //cPathFinal+cNomeWord+cRevisao+'.doc'
LocaL nCount 		:= 1                                                            //Contador utilizado na revisao do documento

Local lPdf 		:= IIf( Type("M->AD1_PROVEN")<>"U", R600ImpPDF(), .F. ) 	//Verifica se o tipo de impresso ser PDF

Private cNomeWord	:= STR0010														// Nome do arquivo Word gerado

If	!File(cPathServer+cDotMacros)
	//"Modelo do WORD :"###"" usado na integrao no encontrado no servidor. Impresso cancelada !"###"Ateno"
	MsgAlert(STR0013+cDotMacros+STR0014,STR0002) //""###"Ateno"
	Return NIL
Endif

If	lFR600Val
	//Passa por parametro o numero da proposta comercial
	lRet600Val := ExecBlock( "FR600VAL",.F.,.F.)
	If 	ValType(lRet600Val) <> "L"
		lRet600Val := .T.
	EndIf
Endif

If	!lRet600Val
	Return(.T.)
Endif

//"Verificando documentos na estaoo..."###"Aguarde"
Processa({|| R600Dots(aComponente,cPathOri,cPathFinal,cPathServer,cDotMacros)},STR0015,STR0016,.F.)

//Ŀ
//Cria link com o WORD 
//
hWord := OLE_CreateLink("TMSOLEWORD97")

OLE_SetProperty(hWord,oleWdWindowState,"MAX" )
OLE_SetProperty(hWord,oleWdVisible,.T.)

//Ŀ
//Reune componentes que farao parte do documento final 
//
R600IniDoc(@hWord,cPathOri,cDotMacros,aComponente)

//Ŀ
//Numera os capitulos 
//
R600Numera(aComponente,hWord)

//Ŀ
// Executa os programas que alimentam as DOCVARIABLE e MACROS para tabelas. 
//
R600Macros(aComponente,hWord)

//Ŀ
//Atualiza os campos de DocVariable 
//
OLE_UpDateFields(hWord)


If lMsDocument
	
	//Ŀ
	// Faz revisao do documento pelo banco de conhecimento. 
	//
	
	DbSelectArea("ACB")
	DbSetOrder(2)
	
	If lPdf
		If !DbSeek(xFilial("ACB")+Upper(cNomeWord+'.pdf'))
			OLE_SaveAsFile(hWord,cPathFinal+cNomeWord,,,.F.,oleWdFormatDocument)
			MsgRun(STR0031,STR0032,{||ConvPDF(hWord,cPathFinal,cNomeWord)}) //"Aguarde"##Impresso em PDF...
			MsgInfo(cNomeWord+STR0017+cPathFinal,STR0002)
		Else
			While ACB->(!Eof())
				cRevisao := ' - R'+cValToChar(nCount)
				If !DbSeek(xFilial("ACB")+Upper(cNomeWord+cRevisao+'.pdf'))
					OLE_SaveAsFile(hWord,cPathFinal+cNomeWord+cRevisao,,,.F.,oleWdFormatDocument)
					MsgRun(STR0031,STR0032,{||ConvPDF(hWord,cPathFinal,cNomeWord,cRevisao)})//"Aguarde"##Impresso em PDF...
					MsgInfo(cNomeWord+cRevisao+STR0017+cPathFinal,STR0002)
					Exit
				EndIf
				nCount++
				ACB->(DbSkip())
			End
		EndIf
		
		//Ŀ
		// Grava a proposta comercial no Banco de Conhecimento. 
		//
		cArqUsr := cPathFinal+cNomeWord+cRevisao+'.pdf'
		R600GrvBco(cArqUsr)
		
	Else		
		If !DbSeek(xFilial("ACB")+Upper(cNomeWord+'.doc'))
			OLE_SaveAsFile(hWord,cPathFinal+cNomeWord,,,.F.,oleWdFormatDocument)
			MsgInfo(cNomeWord+STR0017+cPathFinal,STR0002)
		Else
			While ACB->(!Eof())
				cRevisao := ' - R'+cValToChar(nCount)
				If !DbSeek(xFilial("ACB")+Upper(cNomeWord+cRevisao+'.doc'))
					OLE_SaveAsFile(hWord,cPathFinal+cNomeWord+cRevisao,,,.F.,oleWdFormatDocument)
					MsgInfo(cNomeWord+cRevisao+STR0017+cPathFinal,STR0002)
					Exit
				EndIf
				nCount++
				ACB->(DbSkip())
			End
		EndIf
		
		//Ŀ
		// Grava a proposta comercial no Banco de Conhecimento. 
		//
	
		cArqUsr := cPathFinal+cNomeWord+cRevisao+'.doc'
		R600GrvBco(cArqUsr)
		
	EndIf
	
Else
	
	//Ŀ
	//Salva o documento 
	//
	OLE_SaveAsFile(hWord,cPathFinal+cNomeWord,,,.F.,oleWdFormatDocument)
	
	If lPdf
		MsgRun(STR0031,STR0032,{||ConvPDF(hWord,cPathFinal,cNomeWord)})//"Aguarde"##Impresso em PDF...
	EndIf
	
	MsgInfo(cNomeWord+STR0017+cPathFinal,STR0002) //" salva no diretrio:"###"Ateno"
	
EndIf

//Ŀ
// Fecha o link com o WORD
//
hWord := OLE_CloseLink()

RestArea(aArea) //Restaura a area


Return cArqUsr

/*/


Ŀ
Funcao    R600IniDoc	 Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Reune os componentes que farao parte do documento final		  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros hWord 		- Conexao com WORD								  
			  cPathOri	   	- Diretorio que esta todos componentes			  
			  cDotMacros	- Documento WORD contendo todas as macro 		  
			  aComponente	- Array contendo os componentes do modelo		  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600IniDoc(hWord,cPathOri,cDotMacros,aComponente)

Local i
Local nComponente	:= 0
Local cCapitulo		:= " "

Ole_NewFile(hWord,cPathOri+cDotMacros)

Ole_SetDocumentVar(hWord,'cDiretorio',alltrim(cPathOri))

//Ŀ
// Estrutura do aComponente:    
//------------------------------
//01 Cod Capitulo               
//02 Nm Capitulo                
//03 Nm Componente              
//04 Obrigat                    
//05 DocWord                    
//06 cCargo                     
//07 Vai para o Dot?[.T./.F.]   
//08 Rotina que aciona macros   
//09 Quantidade Niveis do doc   
//10 Quantidade SubNiveis do doc
//11 Incrementa Cap [1|2]       
//12 Atualiza o doc via web     
//13 Cod Componente associado   
//

For i := 1 To Len(aComponente)
	
	If	!Empty(alltrim(aComponente[i][5])) .and. aComponente[i][7]==.T.
		
		nComponente++
		OLE_SetDocumentVar(hWord,'cComponente'+alltrim(str(nComponente)),ALLTRIM(aComponente[i][5]))
		
		IF 	I==1
			OLE_SetDocumentVar(hWord,'nAltCap'+alltrim(str(nComponente)),"0")
		Else
			If 	aComponente[ i,1 ] != cCapitulo
				cCapitulo 	:= alltrim( aComponente[ i ,1 ] )
				OLE_SetDocumentVar(hWord,'nAltCap'+alltrim(str(nComponente)),"1")
			Else
				OLE_SetDocumentVar(hWord,'nAltCap'+alltrim(str(nComponente)),"0")
			EndIf
		Endif
		
	Endif
	
Next i

Ole_SetDocumentVar(hWord,'nComponente',alltrim(str(nComponente)))

//Ŀ
//Macro para passar um array com nome dos dots 
//
OLE_ExecuteMacro(hWord,"AlimentaArray")

//Ŀ
// Macro para juntar os componentes que irao para o documento final
//
OLE_ExecuteMacro(hWord,"Insere_Componente")

Return nil

/*/


Ŀ
Funcao    R600Dots	 	 Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Valida a existencia dos DOTS na estacao de trabalho 			  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros aComponente	- Array contendo os componentes do modelo		  
			  cPathOri	   	- Diretorio que esta todos componentes			  
			  cPathFinal	- Diretorio que sera gravado o modelo final 	  
			  cPathServer	- Diretorio que estao os DOTS originais			  
			  cDotMacros	- Documento WORD contendo todas as macro 		  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600Dots(aComponente,cPathOri,cPathFinal,cPathServer,cDotMacros)

Local i
Local nPosLocal:=0
Local nPosServer:=0
nHandle := fCreate(cPathOri+"TESTE")

If nHandle <> -1 // Testa para ver se consegue ou nao criar o arquivo
	fClose(nHandle)
	fErase(cPathOri+"TESTE") // apaga o arquivo de teste de gravacao
Else
	If	MAKEDIR(cPathOri)!= 0
		//		Aviso(STR0001,STR0026+cPathOri+STR0027,{"OK"}) //"Inconsistencia"###"Nao foi possivel criar diretorio "###".Finalizando ..."
		return nil
	EndIf
EndIf

nHandle := fCreate(cPathFinal+"TESTE")

If nHandle <> -1 // Testa para ver se consegue ou nao criar o arquivo
	fClose(nHandle)
	fErase(cPathFinal+"TESTE") // apaga o arquivo de teste de gravacao
Else
	If	MAKEDIR(cPathFinal)!= 0
		//		Aviso(STR0001,STR0026+cPathFinal+STR0027,{"OK"}) //"Inconsistencia"###"Nao foi possivel criar diretorio "###".Finalizando ..."
		return nil
	EndIf
EndIf


//->Carrega os modelo de documento existentes no Server
aDocServer:=Directory(cPathServer+"*.DOT")
//->Carrega os modelo de documento existentes na maquina do usuario
aDocLocal:=Directory(cPathOri+"*.dot")

// Ordena os arrays de modelos de documentos por ordem de nome
aSort(aDocServer,,,{|x,y| UPPER(x[1]) < UPPER(y[1])})
aSort(aDocLocal,,, {|x,y| UPPER(x[1]) < UPPER(y[1])})

///-> Varre todos os componentes do modelo verificando se existe o modelo na maquina do usario
//	   e se os modelos estao iguais aos que estao no servidos,
//		exceto os que estiverem marcado no cadastro de componente(AG3) para nao atualizar.
ProcRegua(len(aComponente))

For i:=1 to len(aComponente)
	
	//Ŀ
	// Estrutura do aComponente:    
	//------------------------------
	//01 Cod Capitulo               
	//02 Nm Capitulo                
	//03 Nm Componente              
	//04 Obrigat                    
	//05 DocWord                    
	//06 cCargo                     
	//07 Vai para o Dot?[.T./.F.]   
	//08 Rotina que aciona macros   
	//09 Quantidade Niveis do doc   
	//10 Quantidade SubNiveis do doc
	//11 Incrementa Cap [1|2]       
	//12 Atualiza o doc via web     
	//13 Cod Componente associado   
	//
	
	IncProc(aComponente[i][3])
	nPosLocal:=aScan(aDocLocal,{|x|alltrim(x[1])==Upper(alltrim(aComponente[i][5]))+".DOT"})
	nPosServer:=aScan(aDocServer,{|x|alltrim(x[1])==Upper(alltrim(aComponente[i][5]))+".DOT"})
	if nPosServer <=0
		MsgStop(Upper(alltrim(aComponente[i][5]))+".DOT"+ STR0011 ) //" no encontrado no servidor."
	Endif
	if aComponente[i][12] <> "2" .and. nPosLocal == 0
		__CopyFile( cPathServer+alltrim(aComponente[i][5])+".DOT" , cPathOri+alltrim(aComponente[i][5])+".DOT" )
	Elseif aComponente[i][12] <> "2" .and. nPosServer > 0 .and. (aDocLocal[nPosLocal][2] != aDocServer[nPosServer][2].or. aDocLocal[nPosLocal][3] != aDocServer[nPosServer][3] .or. aDocLocal[nPosLocal][4] != aDocServer[nPosServer][4])
		__CopyFile( cPathServer+alltrim(aComponente[i][5])+".DOT" , cPathOri+alltrim(aComponente[i][5])+".DOT" )
	Endif
Next

__CopyFile( cPathServer+cDotMacros , cPathOri+cDotMacros  )

Return

/*/


Ŀ
Funcao    R600Numera	 Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Numera os capitulos											  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros aComponente - Array contendo os componentes do modelo		  
			  hWord	   - Conexao com WORD								  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600Numera(aComponente,hWord)

Local nCapitulo	:= 0
Local nItem		:= 0
Local nSubitem	:= 0
Local cCapitulo	:= ""
Local nx1
Local nx2
Local nx3

//Ŀ
// Estrutura do aComponente:    
//------------------------------
//01 Cod Capitulo               
//02 Nm Capitulo                
//03 Nm Componente              
//04 Obrigat                    
//05 DocWord                    
//06 cCargo                     
//07 Vai para o Dot?[.T./.F.]   
//08 Rotina que aciona macros   
//09 Quantidade Niveis do doc   
//10 Quantidade SubNiveis do doc
//11 Incrementa Cap [1|2]       
//12 Atualiza o doc via web     
//13 Cod Componente associado   
//

For nx1 := 1 to Len( aComponente )
	
	lMarcado 	:= acomponente[nx1,7]
	cIncrementa := alltrim( acomponente[nx1,11] )
	
	///--- verifica componente
	If !lMarcado
		Loop
	Endif
	
	///--- incrementa capitulo
	If 	aComponente[ nx1,1 ] != cCapitulo .and. cIncrementa == "1"
		nCapitulo 	++
		nItem		:= 0
		cCapitulo 	:= alltrim( aComponente[ nx1 ,1 ] )
	EndIf
	
	///--- atribui codigo componente
	cComponente	:= alltrim (aComponente[ nx1,13 ] )
	
	///--- criacao de variaveis -> P99 CAPITULO
	cVWordCap 	:= cComponente
	cConteudo	:= alltrim (str( nCapitulo ) )
	Ole_SetDocumentVar(hWord,cVWordCap,cConteudo+" - ")
	
	nCItem 		:= aComponente[ nx1 , 9 ]
	nCSubitem	:= aComponente[ nx1 , 10 ]
	
	///--- criacao de variaveis -> P99.9 ITEM
	For nx2 := 1 To nCItem
		
		nItem 		++
		cVWordItem	:= cComponente + '.' + alltrim (str( nx2 ) )
		cConteudo	:= alltrim( str( nCapitulo ) )+ '.' + alltrim( str( nItem ) )
		Ole_SetDocumentVar(hWord,cVWordItem,cConteudo+" - ")
		nSubItem	:= 0
		
		///--- criacao de variaveis -> P99.9 ITEM
		For nx3 := 1 To nCSubItem
			
			nSubItem 		++
			cVWordSubItem	:= cComponente + '.' + alltrim( str( nx2 ) ) + '.' + alltrim( str( nx3 ) )
			cConteudo		:= alltrim( str( nCapitulo ) ) + '.' + alltrim( str( nItem ) ) + '.' + alltrim( str( nSubitem ) )
			
			Ole_SetDocumentVar(hWord,cVWordSubItem,cConteudo+" - ")
			
		Next nx3
		
	Next nx2
	
Next nx1

return

/*/


Ŀ
Funcao    R600Macros	 Autor Eduardo Gomes Junior    Data  30/06/08 
Ĵ
Descrio  Executa os programas que alimentam as DOCVARIABLE e MACROS 	  
			  para tabelas 												  
Ĵ
Retorno    Nenhum                                                         
Ĵ
Parametros aComponente - Array contendo os componentes do modelo		  
			  hWord	   - Conexao com WORD								  
Ĵ
   DATA    Programador   Manutencao Efetuada                         	  
Ĵ
                                                                     	  
ٱ


/*/
Static Function R600Macros(aComponente,hWord)

Local nfuncao:=0

//Ŀ
// Estrutura do aComponente:    
//------------------------------
//01 Cod Capitulo               
//02 Nm Capitulo                
//03 Nm Componente              
//04 Obrigat                    
//05 DocWord                    
//06 cCargo                     
//07 Vai para o Dot?[.T./.F.]   
//08 Rotina que aciona macros   
//09 Quantidade Niveis do doc   
//10 Quantidade SubNiveis do doc
//11 Incrementa Cap [1|2]       
//12 Atualiza o doc via web     
//13 Cod Componente associado   
//

For nfuncao:=1 To Len(aComponente)
	
	//Ŀ
	//Se o nome do doc nao estiver em branco, estiver marcado para ir para o WORD e tiver 	  
	//nome de rotina no campo AG2_FUNCAO.													  
	//
	If !Empty(alltrim(aComponente[nfuncao][5])) .AND. aComponente[nfuncao][7] == .T. .AND. !Empty(alltrim(aComponente[nfuncao][8]))
		
		//Ŀ
		//Executa a funcao informada no campo AG4_FUNCAO 
		//
		ExecBlock(aComponente[nfuncao][8],.F.,.F.,{hWord} )
		
	Endif
	
Next nfuncao

Return




/*


ͻ
Programa  R600GrvBcoAutor  Vendas CRM           Data   03/01/2011 
͹
Desc.     Gravacao da proposta comercial no banco de conhecimento.    
                                                                      
͹
Uso       FatR600                                                     
ͼ


*/

Static Function R600GrvBco(cPathUsr)

Local cFile      := ""  					//Nome do arquivo
Local cExten     := "" 						//Extensao do documento
Local aAreaACB	 := ACB->(GetArea())  		//Salva a area atual
Local aAreaAD1   := AD1->(GetArea()) 		//Salva a area atual
Local aAreaAC9   := AC9->(GetArea()) 		//Salva a area atual
Local nReg		 := AD1->(RecNo())  		//Retorna o numero do recno selecionado
Local lMultDir   := .T.  					//Ativa a gravacao em varios niveis de diretorio quando o parametro MV_MULTDIR for .T. e o campo ACB->ACB_PATH for criado.
Local lRet 		 := Ft340CpyObj(cPathUsr) 	//Grava o objeto no Banco de Conhecimento


If lRet
	
	//Ŀ
	// Transforma o path completo em arquivo / extensao 
	//
	
	SplitPath(cPathUsr,,,@cFile, @cExten )
	cObjeto := Left(Upper(cFile+cExten ),Len(cPathUsr))
	cCodObj := GetSXENum("ACB","ACB_CODOBJ")
	
	dbSelectArea( "ACB" )
	dbSetOrder(1)
	
	RecLock("ACB",.T.)
	ACB->ACB_FILIAL  := xFilial( "ACB" )
	ACB->ACB_CODOBJ  := cCodObj
	ACB->ACB_OBJETO	 := cObjeto
	ACB->ACB_DESCRI	 :=	cFile
	If FindFunction( "MsMultDir" ) .And. MsMultDir()
		ACB->ACB_PATH	:= MsDocPath(lMultDir)
	Endif
	
	ACB->(MsUnLock())
	ACB->(ConfirmSX8())
	
	dbSelectArea("AD1")
	DbGoto(nReg)
	cCodEnt  := PadR(AD1_NROPOR, TamSX3("AC9_CODENT")[1])
	
	//Ŀ
	// Inclui e grava os campos chave                                         
	//
	RecLock( "AC9", .T. )
	AC9->AC9_FILIAL := xFilial("AC9")
	AC9->AC9_FILENT := xFilial("AD1")
	AC9->AC9_ENTIDA := "AD1"
	AC9->AC9_CODENT := cCodEnt
	AC9->AC9_CODOBJ := cCodObj
	AC9->(MsUnLock())
	
Endif

RestArea(aAreaACB)
RestArea(aAreaAD1)
RestArea(aAreaAC9)

Return(lRet)


/*


ͻ
Programa  R600TWrd  Autor  Vendas CRM           Data   01/06/11     
͹
Desc.     Criacao de um template de proposta comercial para integracao, 
          com Microsoft Word.                                           
͹
Uso        R600TWrd                                                     
ͼ


*/

Function R600TWrd()

Local lTempWord 	:= SuperGetMv("MV_TEMPWRD",,.T.)   	//Cria um template para proposta comercial.
Local cPathDot 		:= ' '   								//Caminho onde se encontra os dots salvos no servidor
Local cMacroPdr 	:= 'CRM-Exec_Macro.dot'   				//Arquivo dot que contem as macros que serao utilizado pela funcao de integracao com word.
Local cMacroVt		:= 'CRM-Exec_Macro_Vistoria.dot'		//Arquivo dot que contem as macros da vistoria que serao utilizado pela funcao de integracao com word
Local cPathUsr 		:= 'c:\wordtmp\'  						//Diretorio na maquina do usuario que sera gravado os documento word
Local cPathUsrDot 	:= 'c:\wordstd\' 						//Diretorio na maquina do usuario que sera gravado os dot.

Static cCodigo		:= A620NUMSEQ('AG1','AG1_CODIGO')      //Codigo do Modelo
Static cCodVist		:= Soma1(cCodigo)

If lTempWord
	
	#IFDEF SPANISH
		cPathDot := 'samples\documents\crm\espanhol\'
	#ELSE
		#IFDEF ENGLISH
			cPathDot := 'samples\documents\crm\ingles\'
		#ELSE
			cPathDot := 'samples\documents\crm\portugues\'
		#ENDIF
	#ENDIF
	
	//Ŀ
	//Ajusta os parametros relacionado a integracao com word. 
	//
	
	If AllTrim(SuperGetMv("MV_DOCAR")) <> cPathDot
		PutMv("MV_DOCAR",cPathDot)
	EndIf
	
	If AllTrim(SuperGetMv("MV_NOMEDOT")) <> cMacroPdr
		PutMv("MV_NOMEDOT",cMacroPdr)
	EndIf
	If AllTrim(SuperGetMv("MV_VISTDOT",.F.,"")) <> cMacroVt
		PutMv("MV_VISTDOT",cMacroVt)
	EndIf
	If AllTrim(SuperGetMv("MV_PATTERM")) <> cPathUsr
		PutMv("MV_PATTERM",cPathUsr)
	EndIf
	If AllTrim(SuperGetMv("MV_PATWORD")) <> cPathUsrDot
		PutMv("MV_PATWORD",cPathUsrDot)
	EndIf
	
	DbSelectArea("AG1")
	DbSetOrder(1)
	
	If !DbSeek(xFilial("AG1")+cCodigo)
		CriaAG1()
	EndIf
	
	DbSelectArea("AG2")
	DbSetOrder(1)
	
	If !DbSeek(xFilial("AG2")+cCodigo)
		CriaAG2()
	EndIf
	
	DbSelectArea("AG3")
	DbSetOrder(1)
	CriaAG3()

	DbSelectArea("AG4")
	DbSetOrder(1)
	CriaAG4()

	DbSelectArea("SX6")
	DbSetOrder(1)
	
	If !DbSeek( Space(FWSizeFilial()) + "MV_TEMPWRD" )
		CriaMV()
	EndIf
	
	PutMv("MV_TEMPWRD",.F.)
	
EndIf


Return(.T.)


/*


ͻ
Programa  CriaAG1   Autor  Vendas CRM           Data   01/06/11   
͹
Desc.     Criacao do cabecalho do modelo.                             
͹
Uso        R600TWrd                                                   
ͼ


*/

Static Function CriaAG1()

DbSelectArea("AG1")
DbSetOrder(1)

RecLock("AG1", .T. )
AG1->AG1_FILIAL := xFilial("AG1")
AG1->AG1_CODIGO := cCodigo
AG1->AG1_DESCRI := STR0018 //TEMPLATE DE PROPOSTA COMERCIAL
AG1->(MsUnLock())

RecLock("AG1", .T. )
AG1->AG1_FILIAL := xFilial("AG1")
AG1->AG1_CODIGO := cCodVist
AG1->AG1_DESCRI := STR0027 //TEMPLATE DE VISTORIA TECNICA
AG1->(MsUnLock())

Return Nil


/*


ͻ
Programa  CriaAG2   Autor  Vendas CRM           Data   01/06/11   
͹
Desc.     Criacao dos itens do modelo.                                
͹
Uso        R600TWrd                                                   
ͼ


*/

Static Function CriaAG2()

Local aAG2 	:= {}
Local aAG2V	:= {}
Local nX	:= 0
Local nY	:= 0

aAG2 := {{cCodigo,'001',STR0018,'P01','P02','1','2'},;
{cCodigo,'002',STR0018,'P01','P03','1','2'},;
{cCodigo,'003',STR0018,'P01','P04','1','2'},;
{cCodigo,'004',STR0018,'P01','P05','1','2'},;
{cCodigo,'005',STR0018,'P01','P06','1','2'},;
{cCodigo,'006',STR0018,'P01','P07','1','2'}}

aAG2V := {{cCodVist,'001',STR0027,'V01','V02','1','2'},;
{cCodVist,'002',STR0027,'V01','V03','1','2'}}

DbSelectArea("AG2")
DbSetOrder(1)

For nX := 1 To Len(aAG2)
	RecLock("AG2",.T.)
	AG2->AG2_FILIAL := xFilial("AG2")
	AG2->AG2_COD    := aAG2[nX][1]
	AG2->AG2_ORDEM  := aAG2[nX][2]
	AG2->AG2_DESCRI := aAG2[nX][3]
	AG2->AG2_COMPPR := aAG2[nX][4]
	AG2->AG2_COMPAS := aAG2[nX][5]
	AG2->AG2_OBRIGA := aAG2[nX][6]
	AG2->AG2_INCCAP := aAG2[nX][7]
	AG2->(MsUnlock())
Next nX

For nY := 1 To Len(aAG2V)
	RecLock("AG2",.T.)
	AG2->AG2_FILIAL := xFilial("AG2")
	AG2->AG2_COD    := aAG2V[nY][1]
	AG2->AG2_ORDEM  := aAG2V[nY][2]
	AG2->AG2_DESCRI := aAG2V[nY][3]
	AG2->AG2_COMPPR := aAG2V[nY][4]
	AG2->AG2_COMPAS := aAG2V[nY][5]
	AG2->AG2_OBRIGA := aAG2V[nY][6]
	AG2->AG2_INCCAP := aAG2V[nY][7] 
	AG2->(MsUnlock())
Next nY

Return Nil


/*


ͻ
Programa  CriaAG3   Autor  Vendas CRM           Data   01/06/11   
͹
Desc.     Criacao do cabecalho do componente.                         
͹
Uso        R600TWrd                                                   
ͼ


*/

Static Function CriaAG3()

Local aAG3  	:= {}
Local aAG3V		:= {}
Local nX		:= 0
Local nW		:= 0
Local lNewReg	:= .F.

aAG3 := {{'P01',STR0019,'1','1',0,0},;
{'P02',STR0020,'2','1',0,0},;
{'P03',STR0021,'2','1',0,0},;
{'P04',STR0022,'2','1',0,0},;
{'P05',STR0023,'2','1',0,0},;
{'P06',STR0024,'2','1',0,0},;
{'P07',STR0025,'2','1',0,0}}

aAG3V := {{'V01',STR0028,'1','1',0,0},;
{'V02',STR0029,'2','1',0,0},;
{'V03',STR0030,'2','1',0,0}}

DbSelectArea("AG3")
DbSetOrder(1)

For nX := 1 To Len(aAG3)
	lNewReg := AG3->( !DbSeek( xFilial( "AG3" ) + aAG3[nX][1] ) )

	RecLock( "AG3", lNewReg )
	AG3->AG3_FILIAL	:= xFilial("AG3")
	AG3->AG3_CODIGO	:= aAG3[nX][1]
	AG3->AG3_DESCRI	:= aAG3[nX][2]
	AG3->AG3_TIPO	:= aAG3[nX][3]
	AG3->AG3_ATUALI	:= aAG3[nX][4]
	AG3->AG3_NIVEL	:= aAG3[nX][5]
	AG3->AG3_SUBNIV	:= aAG3[nX][6]
	AG3->(MsUnlock())
Next nX

For nW := 1 To Len(aAG3V)
	lNewReg := AG3->( !DbSeek( xFilial( "AG3" ) + aAG3V[nW][1] ) )
	RecLock( "AG3", lNewReg )
	AG3->AG3_FILIAL	:= xFilial("AG3")
	AG3->AG3_CODIGO	:= aAG3V[nW][1]
	AG3->AG3_DESCRI	:= aAG3V[nW][2]
	AG3->AG3_TIPO	:= aAG3V[nW][3]
	AG3->AG3_ATUALI	:= aAG3V[nW][4]
	AG3->AG3_NIVEL	:= aAG3V[nW][5]
	AG3->AG3_SUBNIV	:= aAG3V[nW][6]
	AG3->(MsUnlock())
Next nW

Return Nil


/*


ͻ
Programa  CriaAG3   Autor  Vendas CRM           Data   01/06/11   
͹
Desc.     Criacao dos itens do componente.                            
͹
Uso        R600TWrd                                                   
ͼ


*/

Static Function CriaAG4()

Local aAG4 	  := {}
Local aAG4V	  := {}
Local nX 	  := 0
Local nZ	  := 0
Local lNewReg := .F.
 
#IFDEF SPANISH
	aAG4 :=  {{'P01','','','','','','',0,0},;
	{'P02','01','105','003','','CRM01-CAR_SPA','1',0,0},;  
	{'P03','01','105','003','','CRM02-CARTA_SPA','1',0,0},;  
	{'P04','01','105','003','FT600EXE','CRM03-PROPUESTA_SPA','1',0,0},;    
	{'P05','01','105','003','','CRM04-SERVICIOS_SPA','1',0,0},;  
	{'P06','01','105','003','','CRM05-CONDICION_PAGO_SPA','1',0,0},;  
	{'P07','01','105','003','','CRM06-ACEPTACION_SPA','1',0,0}}   
	aAG4V :=  {{'V01','','','','','','',0,0},;
	{'V02','01','105','003','','CRM07-CAR_VIST_SPA','1',0,0},;  
	{'V03','01','105','003','FV600EXE','CRM08-ESTUDIO_SPA','1',0,0}}
#ELSE
	#IFDEF ENGLISH
		aAG4 :=  {{'P01','','','','','','',0,0},;
		{'P02','01','105','002','','CRM01-CAPA_ENG','1',0,0},;  
		{'P03','01','105','002','','CRM02-LETTER_ENG','1',0,0},;  
		{'P04','01','105','002','FT600EXE','CRM03-PROPOSAL_ENG','1',0,0},;    
		{'P05','01','105','002','','CRM04-SERVICE_ENG','1',0,0},;  
		{'P06','01','105','002','','CRM05-PAYMENT_TERM_ENG','1',0,0},;  
		{'P07','01','105','002','','CRM06-ACCEPTANCE_ENG','1',0,0}}   
		aAG4V :=  {{'V01','','','','','','',0,0},;
		{'V02','01','105','002','','CRM07-CAPA_VIST_ENG','1',0,0},;  
		{'V03','01','105','002','FV600EXE','CRM08-SURVEY_ENG','1',0,0}}   
	#ELSE
		aAG4 :=  {{'P01','','','','','','',0,0},;
		{'P02','01','105','001','','CRM01-CAPA_POR','1',0,0},;  
		{'P03','01','105','001','','CRM02-CARTA_POR','1',0,0},;  
		{'P04','01','105','001','FT600EXE','CRM03-PROPOSTA_POR','1',0,0},;   
		{'P05','01','105','001','','CRM04-SERVICOS_POR','1',0,0},;  
		{'P06','01','105','001','','CRM05-COND_PAGAMENTO_POR','1',0,0},;  
		{'P07','01','105','001','','CRM06-ACEITE_POR','1',0,0}}
		aAG4V :=  {{'V01','','','','','','',0,0},;
		{'V02','01','105','001','','CRM07-CAPA_VIST_POR','1',0,0},;  
		{'V03','01','105','001','FV600EXE','CRM08-VISTORIA_POR','1',0,0}}
	#ENDIF
#ENDIF
                  

DbSelectArea("AG4")
DbSetOrder(1)

For nX := 1 To Len(aAG4)
	lNewReg := AG4->( !DbSeek( xFilial( "AG4" ) + aAG4[nX][1] + aAG4[nX][2] ) )

	RecLock( "AG4", lNewReg )
	AG4->AG4_FILIAL := xFilial("AG4")
	AG4->AG4_CODIGO := aAG4[nX][1]
	AG4->AG4_ITEM   := aAG4[nX][2]
	AG4->AG4_PAIS   := aAG4[nX][3]
	AG4->AG4_IDIOMA := aAG4[nX][4]
	AG4->AG4_FUNCAO := aAG4[nX][5]
	AG4->AG4_DOCWOR := aAG4[nX][6]
	AG4->AG4_ATUALI := aAG4[nX][7]
	AG4->AG4_NIVEL  := aAG4[nX][8]
	AG4->AG4_SUBNIV := aAG4[nX][9]
	AG4->(MsUnlock())
Next nX

For nZ := 1 To Len(aAG4V)
	lNewReg := AG4->( !DbSeek( xFilial( "AG4" ) + aAG4V[nZ][1] + aAG4V[nZ][2] ) )
	RecLock( "AG4", lNewReg )
	AG4->AG4_FILIAL := xFilial("AG4")
	AG4->AG4_CODIGO := aAG4V[nZ][1]
	AG4->AG4_ITEM   := aAG4V[nZ][2]
	AG4->AG4_PAIS   := aAG4V[nZ][3]
	AG4->AG4_IDIOMA := aAG4V[nZ][4]
	AG4->AG4_FUNCAO := aAG4V[nZ][5]
	AG4->AG4_DOCWOR := aAG4V[nZ][6]
	AG4->AG4_ATUALI := aAG4V[nZ][7]
	AG4->AG4_NIVEL  := aAG4V[nZ][8]
	AG4->AG4_SUBNIV := aAG4V[nZ][9]
	AG4->(MsUnlock())
Next nZ

Return Nil

/*


ͻ
Programa  CriaAG1   Autor  Vendas CRM           Data   01/06/11   
͹
Desc.     Criacao do Parametro MV_TEMPWRD                             
͹
Uso        R600TWrd                                                   
ͼ


*/

Static Function CriaMV()

DbSelectArea("SX6")
DbSetOrder(1)

RecLock("SX6",.T.)
SX6->X6_FIL     := Space(FWSizeFilial()) //xFilial( "SX6" )
SX6->X6_VAR     := "MV_TEMPWRD"
SX6->X6_TIPO    := "L"
#IFDEF SPANISH
	SX6->X6_DSCSPA  := SubStr(STR0026,1,50)      
	SX6->X6_DSCSPA1 := SubStr(STR0026,51,Len(STR0026))
#ELSE
	#IFDEF ENGLISH
		SX6->X6_DSCENG  := SubStr(STR0026,1,50)
		SX6->X6_DSCENG1 := SubStr(STR0026,51,Len(STR0026))
	#ELSE
		SX6->X6_DESCRIC := SubStr(STR0026,1,50)
		SX6->X6_DESC1   := SubStr(STR0026,51,Len(STR0026))
	#ENDIF
#ENDIF
SX6->X6_PROPRI    := "S"
SX6->X6_PYME      := "S"
MsUnLock()

Return Nil

/*


ͻ
Programa  AjustaSXB Autor  Vendas CRM           Data   21/03/13   
͹
Desc.      Ajustes na consulta padro.								  
          		                                                      
͹
Uso       FATR600                                                     
ͼ


*/
Static Function AjustaSXB()

Local aAreaSXB 	:= SXB->(GetArea())

SXB->(dbSetOrder(1))
If SXB->(MsSeek("AG1MOD40101")) .And. ("AG1_CODIGO" <> AllTrim(SXB->XB_CONTEM))
	RecLock("SXB",.F.)
	SXB->XB_CONTEM := "AG1_CODIGO"
	MsUnlock()
EndIf

If SXB->(MsSeek("AG1MOD40102")) .And. ("AG1_DESCRI" <> AllTrim(SXB->XB_CONTEM))
	RecLock("SXB",.F.)
	SXB->XB_CONTEM := "AG1_DESCRI"
	MsUnlock()
EndIf

RestArea(aAreaSXB)

Return 

/*


ͻ
Programa  R600ImpPDF   Autor  CRM      			  Data   07/06/13   
͹
Desc.     Verifica se o tipo de impresso  PDF						    
           		                                                     
͹
Uso        FATR600                                                    
ͼ


*/
Function R600ImpPDF()
Local lRetorno	:= .F.
Local cTipImp	:= M->AD1_PROVEN		

//Verifica no Processo de Venda(Tabela AC1) se o tipo de impresso  2=PDF
If AC1->(FieldPos("AC1_TPIMP")) > 0 
	DbSelectArea("AC1")
	DbSetOrder(1) // AC1_FILIAL+AC1_PROVEN
	If DbSeek(xFilial("AC1")+cTipImp)
		If AC1->AC1_TPIMP == "2"
			lRetorno := .T.
		EndIf	
	EndIf	
EndIf

Return(lRetorno)

/*


ͻ
Programa  ConvPDF   Autor  CRM      			  Data   07/06/13   
͹
Desc.     Impressao de proposta em PDF 								    
           		                                                     
͹
Uso        FATR600                                                    
ͼ


*/
Function ConvPDF(hWord,cPathFinal,cNomeWord,cRevisao)

Default cRevisao	:= ""

// Salva com PDF
wdFormatPDF = '17' //' PDF format.

If Empty(cRevisao)
	OLE_SaveAsFile(hWord,cPathFinal+cNomeWord+'.pdf',,,.F.,wdFormatPDF)
	ShellExecute("open",cPathFinal+cNomeWord+'.pdf',"","",5) // 5=SW_SHOW
	
	// Fecha conexao com OLE
	OLE_CloseFile(hWord)
	hWord := OLE_CloseLink()

	DELETE FILE &cPathFinal+Alltrim(cNomeWord)+'.doc'
	
Else
	OLE_SaveAsFile(hWord,cPathFinal+cNomeWord+cRevisao+'.pdf',,,.F.,wdFormatPDF)
	ShellExecute("open",cPathFinal+cNomeWord+cRevisao+'.pdf',"","",5) // 5=SW_SHOW
	
	// Fecha conexao com OLE
	OLE_CloseFile(hWord)
	hWord := OLE_CloseLink()

	DELETE FILE &cPathFinal+Alltrim(cNomeWord+cRevisao)+'.doc'
	
EndIf

Return