#INCLUDE "MATR242.CH"
#INCLUDE "PROTHEUS.CH"

/*


Ŀ
Funo     MATR242   Autor  Ricardo Berti          Data 14.06.2006
Ĵ
Descrio  Relatorio de Comparativo de Custos                         
Ĵ
 Uso       SIGAEST                                                    
ٱ


*/
Function MATR242()

Local oReport

If FindFunction("TRepInUse") .And. TRepInUse()
	//Ŀ
	//Interface de impressao                                                  
	//
	oReport := ReportDef()
	oReport:PrintDialog()
Else
	MATR242R3()
EndIf

Return


/*/


Ŀ
Programa  ReportDef  Autor  Ricardo Berti 		 Data 14.06.2006
Ĵ
Descrio A funcao estatica ReportDef devera ser criada para todos os 
          relatorios que poderao ser agendados pelo usuario.          
                                                                      
Ĵ
Retorno   ExpO1: Objeto do relatorio                                  
Ĵ
ParametrosNenhum                                                      
                                                                      
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function ReportDef()

Local aOrdem	:= {STR0006}
Local cAliasQRY := "SB2"
Local cPerg		:= "MTR242"
Local cPicQ		:= PesqPict("SB2","B2_QATU")
Local cPicV		:= PesqPict("SB2","B2_CM1")
Local cTamQ		:= TamSX3("B2_QATU")[1]
Local cTamV		:= TamSX3("B2_CM1")[1]
Local oReport
Local oSection1

//Ŀ
//Criacao do componente de impressao                                      
//                                                                        
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//                                                                        
//
oReport := TReport():New("MATR242",STR0018,cPerg, {|oReport| ReportPrint(oReport,@cAliasQRY)},STR0002+" "+STR0003) //'Comparativo de Custos'##"Este programa ira' emitir um comparativo de custos, em valores e "##'quantidades, dos produtos em estoque.'
oReport:SetTotalInLine(.F.)
oReport:SetLandScape()

//Ŀ
// Variaveis utilizadas para parametros                                  
// mv_par01     // Filial De                                             
// mv_par02     // Filial Ate                                            
// mv_par03     // Armazem De                                            
// mv_par04     // Armazem Ate                                           
// mv_par05     // 1a.Data		                                          
// mv_par06     // 2a.Data		                                          
// mv_par07     // Produto De                                            
// mv_par08     // Produto Ate                                           
//
Pergunte(cPerg,.F.)

//Ŀ
//Criacao da secao utilizada pelo relatorio                               
//                                                                        
//TRSection():New                                                         
//ExpO1 : Objeto TReport que a secao pertence                             
//ExpC2 : Descricao da seao                                              
//ExpA3 : Array com as tabelas utilizadas pela secao. A primeira tabela   
//        sera considerada como principal para a seo.                   
//ExpA4 : Array com as Ordens do relatrio                                
//ExpL5 : Carrega campos do SX3 como celulas                              
//        Default : False                                                 
//ExpL6 : Carrega ordens do Sindex                                        
//        Default : False                                                 
//
//Ŀ
//Criacao das celulas da secao do relatorio                               
//                                                                        
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de codigo para impressao.                                 
//        Default : ExpC2                                                 
//

oSection1 := TRSection():New(oReport,STR0019,{"SB2","SB1"},aOrdem,/*Campos do SX3*/,/*Campos do SIX*/)
oSection1:SetHeaderPage()
oSection1:SetTotalInLine(.F.)
oSection1:SetTotalText(STR0010) // "Total"

TRCell():New(oSection1,"B2_COD"		,"SB2",/*Titulo*/												,/*Picture*/	,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oSection1,"B1_DESC"	,"SB1",/*Titulo*/												,/*Picture*/	,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oSection1,"B1_TIPO"	,"SB1",/*Titulo*/												,/*Picture*/	,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oSection1,"B1_UM"		,"SB1",/*Titulo*/												,/*Picture*/	,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oSection1,"B2_LOCAL"	,"SB2",/*Titulo*/												,/*Picture*/	,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oSection1,"QTD1"		,"   ",STR0015	   												,cPicQ			,cTamQ		,/*lPixel*/,{|| CalcEst((cAliasQRY)->B2_COD, (cAliasQRY)->B2_LOCAL,mv_par05)[1] },,,"RIGHT") //"Quantidade"
TRCell():New(oSection1,"VLRUNIT1"	,"   ","["+AllTrim(STR0013)+dtoc(mv_par05)+"]"+CRLF+STR0016	,cPicV			,cTamV		,/*lPixel*/,{|| C242CalVU(@oReport,cAliasQRY,"QTD1","VALOR1") },,,"RIGHT")  //"Data: "##"Valor Unitario"
TRCell():New(oSection1,"VALOR1"		,"   ",STR0010													,cPicV			,cTamV		,/*lPixel*/,/*{|| code-block de impressao }*/,,,"RIGHT") //"Total"
TRCell():New(oSection1,"QTD2"		,"   ",STR0015													,cPicQ			,cTamQ		,/*lPixel*/,{|| CalcEst((cAliasQRY)->B2_COD, (cAliasQRY)->B2_LOCAL,mv_par06)[1] },,,"RIGHT") //"Quantidade"
TRCell():New(oSection1,"VLRUNIT2"	,"   ","["+AllTrim(STR0013)+dtoc(mv_par06)+"]"+CRLF+STR0016		,cPicV			,cTamV		,/*lPixel*/,{|| C242CalVU(@oReport,cAliasQRY,"QTD2","VALOR2") },,,"RIGHT") //"Data: "##"Valor Unitario"
TRCell():New(oSection1,"VALOR2"		,"   ",STR0010													,cPicV			,cTamV		,/*lPixel*/,/*{|| code-block de impressao }*/,,,"RIGHT") //"Total"
TRCell():New(oSection1,"DIFUNIT"	,"   ",STR0007+CRLF+STR0016										,cPicV			,cTamV		,/*lPixel*/,{|| C242CalDif(oReport,"VLRUNIT1","VLRUNIT2") },,,"RIGHT") //"Diferenca"##"Valor Unitario"
TRCell():New(oSection1,"VARIACAO"	,"   ",STR0017													,"@E 99999.99"	,/*Tamanho*/,/*lPixel*/,{|| C242CalVar(oReport,"VLRUNIT1","VLRUNIT2") }) //"Variacao(%)"

Return(oReport)


/*


Ŀ
Funo    C242CalVU  Autor  Ricardo Berti          Data 14.06.2006
Ĵ
Descrio  Calcula/retorna valor unitario (tb atualizando valor total)
Ĵ
Sintaxe    ExpN1 := C4242CalVU(ExpO1,ExpC1,ExpC2,ExpC3)	              
Ĵ
Parametros ExpO1: obj report										  
           ExpC1: alias do arq.										  
           ExpC2: nome do campo de qtde (celula)					  
           ExpC3: nome do campo de valor (celula)					  
Ĵ
Retorno    ExpN1: valor unitario									  
Ĵ
 Uso       MATR242                                                    
ٱ


*/
Static Function C242CalVU(oReport,cAliasQRY,cCpQtd,cCpValor)

Local nQtd		:= oReport:Section(1):Cell(cCpQtd):GetValue(.T.)
Local nTotal	:= CalcEst( (cAliasQRY)->B2_COD, (cAliasQRY)->B2_LOCAL,If(Upper(cCpValor)=="VALOR2",mv_par06,mv_par05))[mv_par09+1]
//Ŀ
//Atualiza celula VALOR1 ou VALOR2 (valor total)	                       
//
oReport:Section(1):Cell(cCpValor):SetValue(nTotal)

Return ( nTotal / nQtd )


/*


Ŀ
Funo    C242CalDif Autor  Ricardo Berti          Data 14.06.2006
Ĵ
Descrio  Calcula a diferenca entre os valores unitarios			  
Ĵ
Sintaxe    ExpN1 := C4242CalDif(ExpO1,ExpC1,ExpC2)                    
Ĵ
Parametros ExpO1: obj report										  
           ExpC1: nome do campo valor unitario 1 (celula)			  
           ExpC2: nome do campo valor unitario 2 (celula)			  
Ĵ
Retorno    ExpN1: diferenca entre valores unitarios (sempre positiva) 
Ĵ
 Uso       MATR242                                                    
ٱ


*/
Static Function C242CalDif(oReport,cCpValor1,cCpValor2)

Local nVlrUnit1 := oReport:Section(1):Cell(cCpValor1):GetValue(.T.)
Local nVlrUnit2 := oReport:Section(1):Cell(cCpValor2):GetValue(.T.)
Return ( ABS( nVlrUnit1 - nVlrUnit2 ) )


/*


Ŀ
Funo    C242CalVar Autor  Ricardo Berti          Data 14.06.2006
Ĵ
Descrio  Calcula a porcentagem de Variacao entre valores unitarios  
Ĵ
Sintaxe    ExpN1 := C4242CalVar(ExpO1,ExpC1,ExpC2)                    
Ĵ
Parametros ExpO1: obj report										  
           ExpC1: nome do campo valor unitario 1 (celula)			  
           ExpC2: nome do campo valor unitario 2 (celula)			  
Ĵ
Retorno    ExpN1: porcentagem de variacao 							  
Ĵ
 Uso       MATR242                                                    
ٱ


*/
Static Function C242CalVar(oReport,cCpValor1,cCpValor2)

Local nVlrUnit1 := oReport:Section(1):Cell(cCpValor1):GetValue(.T.)
Local nVlrUnit2 := oReport:Section(1):Cell(cCpValor2):GetValue(.T.)
Local nPerc := 0
If ! (nVlrUnit1 == 0 .OR. nVlrUnit2 == 0 .or. (nVlrUnit1 == nVlrUnit2))
	nPerc := (nVlrUnit2/nVlrUnit1)*100
Endif   
Return (nPerc)


/*/


Ŀ
Programa  ReportPrin Autor  Ricardo Berti          Data 14.06.2006
Ĵ
Descrio A funcao estatica ReportDef devera ser criada para todos os 
          relatorios que poderao ser agendados pelo usuario.          
                                                                      
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosExpO1: Objeto Report do Relatorio                           
          ExpC1: Alias do arquivo principal                           
ٱ


/*/
Static Function ReportPrint(oReport,cAliasQRY)

Local oSection1	:= oReport:Section(1)
Local aAreaSB1	:= SB1->(GetArea())
Local aAreaSB2	:= SB2->(GetArea())

#IFNDEF TOP
	Local cCondicao := ""
#ENDIF

oSection1:Cell("VLRUNIT1"):SetTitle("["+AllTrim(STR0013)+dtoc(mv_par05)+"]"+CRLF+STR0016) //"Valor Unitario"
oSection1:Cell("VLRUNIT2"):SetTitle("["+AllTrim(STR0013)+dtoc(mv_par06)+"]"+CRLF+Padc(STR0016,18)) //"Valor Unitario"

oReport:SetTitle(oReport:Title()+" "+STR0014+Alltrim(Str(mv_par09))) //" na Moeda "

TRFunction():New(oSection1:Cell("VALOR1"),NIL,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,.T./*lEndReport*/,.F./*lEndPage*/,/*Obj*/)
TRFunction():New(oSection1:Cell("VALOR2"),NIL,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,.T./*lEndReport*/,.F./*lEndPage*/,/*Obj*/)

//Ŀ
//Filtragem do relatorio                                                  
//

#IFDEF TOP
	//Ŀ
	//Transforma parametros Range em expressao SQL                            
	//
	MakeSqlExpr(oReport:uParam)
	//Ŀ
	//Query do relatrio da secao 1                                           
	//
	cAliasQRY := GetNextAlias()

	oReport:Section(1):BeginQuery()	
	
	BeginSql Alias cAliasQRY
	SELECT	B2_FILIAL,B2_COD,B2_LOCAL
	FROM %table:SB2% SB2
 	  WHERE	B2_FILIAL  >= %Exp:mv_par01% AND
 	       	B2_FILIAL  <= %Exp:mv_par02% AND
			B2_LOCAL   >= %Exp:mv_par03% AND 
			B2_LOCAL   <= %Exp:mv_par04% AND 
			B2_COD     >= %Exp:mv_par07% AND 
			B2_COD     <= %Exp:mv_par08% AND 
			SB2.%NotDel% 
	ORDER BY %Order:SB2% 
			
	EndSql 
	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//                                                                        
	//Prepara o relatrio para executar o Embedded SQL.                       
	//                                                                        
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oReport:Section(1):EndQuery(/*Array com os parametros do tipo Range*/)

#ELSE
	//Ŀ
	//Transforma parametros Range em expressao ADVPL                          
	//
	MakeAdvplExpr(oReport:uParam)

	dbSelectArea('SB2')
	dbSetOrder(1)
 
	cCondicao := "B2_FILIAL>='"+mv_par01+"' .And. B2_FILIAL <='"+mv_par02+"' .And. "
	cCondicao += "B2_COD>='"+mv_par07+"' .And. B2_COD<='"+mv_par08+"' .And. "
	cCondicao += "B2_LOCAL>='"+mv_par03+"' .And. B2_LOCAL<='"+mv_par04+"'"

	oSection1:SetFilter(cCondicao,IndexKey())

#ENDIF		

//Ŀ
//Posicionamento das tabelas			  
//
TRPosition():New(oSection1,"SB1",1,{|| xFilial("SB1")+(cAliasQRY)->B2_COD })

//Ŀ
//Inicio da impressao do relatorio		  
//
oSection1:Print()

RestArea(aAreaSB2)
Return NIL

/*


ͻ
Programa  MATR242R3 Autor  Marcos V. Ferreira   Data   13.10.04   
͹
Desc.      Relatorio de Comparativo de Custos                         
                                                                      
͹
Uso        MATR242                                                    
ͼ


*/
Function MATR242R3()

Local Tamanho    := "G"
Local Titulo     := STR0001 // 'Comparativo de Custos'
Local cDesc1     := STR0002 // "Este programa ira' emitir um comparativo de custos, em valores e "
Local cDesc2     := STR0003 // 'quantidades, dos produtos em estoque.'
Local cDesc3     := ""
Local aOrd       := {OemToAnsi(STR0006)}
Local cString    := "SB2"
Local WnRel      := "MATR242" 

//Ŀ
// Variaveis tipo Private padrao de todos os relatorios         
//
Private aReturn  := {OemToAnsi(STR0004), 1,OemToAnsi(STR0005), 2, 2, 1,"",1 }
Private nLastKey := 0
Private cPerg    := "MTR242"

//Ŀ
// Verifica as perguntas selecionadas                           
//
//Ŀ
// Variaveis utilizadas para parametros                                  
// mv_par01     // Filial De                                             
// mv_par02     // Filial Ate                                            
// mv_par03     // Armazem De                                            
// mv_par04     // Armazem Ate                                           
// mv_par05     // 1a.Data		                                          
// mv_par06     // 2a.Data		                                          
// mv_par07     // Produto De                                            
// mv_par08     // Produto Ate                                           
//

Pergunte(cPerg,.F.)

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel := SetPrint(cString,WnRel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,.F.,Tamanho)

Titulo := Alltrim(Titulo)+" "+Upper(STR0014)+Alltrim(Str(mv_par09)) //" na Moeda "

If nLastKey = 27
	dbClearFilter()
	Return .T.
Endif

SetDefault(aReturn,cString)

If nLastKey = 27
	dbClearFilter()
	Return .T.
Endif

RptStatus({|lEnd| C242Imp(aOrd,@lEnd,WnRel,Titulo,Tamanho)},Titulo)

Return Nil

/*


Ŀ
Funo     C242IMP   Autor  Marcos V. Ferreira     Data  13.10.04 
Ĵ
Descrio  Chamada do Relatorio                                       
Ĵ
 Uso       MATR242													  
ٱ


*/
Static Function C242Imp(aOrd,lEnd,WnRel,Titulo,Tamanho)

Local cCabec1    := STR0008 
Local cCabec2    := STR0012
Local nTipo      := 0 
Local lTotal     := .F.
Local aAreaSB1   := SB1->(GetArea()) 
Local aAreaSB2   := SB2->(GetArea())
Local nQtd1      := 0
Local nQtd2      := 0
Local nValor1    := 0
Local nValor2    := 0
Local nTotValor1 := 0
Local nTotValor2 := 0
Local nDifQtd    := 0
Local nDifVlr    := 0
Local nVlrUnit1  := 0
Local nVlrUnit2  := 0
Local nPorc      := 0

//Ŀ
// Contadores de linha e pagina                                 
//
Private Li         := 80
Private m_pag      := 1

//Ŀ
// Inicializa os codigos de caracter Comprimido/Normal da impressora 
//
nTipo := If(aReturn[4]==1,15,18)

//Ŀ
// Define texto do cabecalho                                         
//
cCabec1 += Space(13)+"["+STR0013+dtoc(mv_par05)+" ]"+Space(30)+"["+STR0013+dtoc(mv_par06)+" ]"+Space(17)+STR0007

dbSelectArea('SB2')
dbSetOrder(1)
 
//-- Condio de Filtragem da IndRegua
cCondicao := "B2_FILIAL>='"+mv_par01+"' .And. B2_FILIAL <='"+mv_par02+"' .And. "
cCondicao += "B2_COD>='"+mv_par07+"' .And. B2_COD<='"+mv_par08+"' .And. "
cCondicao += "B2_LOCAL>='"+mv_par03+"' .And. B2_LOCAL<='"+mv_par04+"'"

cArqTrb := CriaTrab("SB2", .F.)

IndRegua("SB2", cArqTrb, IndexKey(),,cCondicao, STR0011) //"Selecionando Registros..."

#IFNDEF TOP
	dbSetIndex(cArqTrb+OrdBagExt())
#ENDIF

SB2->(dbGoTop())
SetRegua(LastRec())

While !Eof() 

	If lEnd
		@ PROW()+1,001 PSAY STR0009	//"CANCELADO PELO OPERADOR"
		Exit
	EndIf
   
    If Li > 55
	   Cabec(Titulo,cCabec1,cCabec2,WnRel,Tamanho,nTipo)
	EndIf
	IncRegua()
    
    cProduto := SB2->B2_COD
    
	dbSelectArea("SB1")
	dbSeek(xFilial()+cProduto)
    @ Li,000 Psay SB1->B1_COD
    @ Li,016 Psay SB1->B1_DESC
    @ Li,048 Psay SB1->B1_TIPO
    @ Li,052 Psay SB1->B1_UM
    
    dbSelectArea("SB2")
    nQtd1    := CalcEst(SB2->B2_COD, SB2->B2_LOCAL,mv_par05)[1] 
    nQtd2    := CalcEst(SB2->B2_COD, SB2->B2_LOCAL,mv_par06)[1] 
    nValor1  := CalcEst(SB2->B2_COD, SB2->B2_LOCAL,mv_par05)[mv_par09+1] 
    nValor2  := CalcEst(SB2->B2_COD, SB2->B2_LOCAL,mv_par06)[mv_par09+1] 
    nVlrUnit1:= nValor1/nQtd1
    nVlrUnit2:= nValor2/nQtd2

    nDifQtd  := nQtd1 - nQtd2
    If nDifQtd < 0 
       nDifQtd := nDifQtd * (-1)
    Endif
    nDifVlr  := nValor1 - nValor2
    If nDifVlr < 0
       nDifVlr := nDifVlr * (-1)
    Endif
    nDifUnit := nVlrUnit1 - nVlrUnit2
    If nDifUnit < 0
       nDifUnit := nDifUnit * (-1)
    Endif
    If nVlrUnit1 == 0 .OR. nVlrUnit2 == 0 .or. (nVlrUnit1 == nVlrUnit2)
       nPorc := 0
    Else   
       nPorc := (nVlrUnit2/nVlrUnit1)*100
    Endif   
    
    @ Li,056 Psay SB2->B2_LOCAL
    @ Li,059 Psay nQtd1     Picture PesqPict("SB2","B2_QATU")
    @ Li,075 Psay nVlrUnit1 Picture PesqPict("SB2","B2_CM1")
    @ Li,091 Psay nValor1   Picture PesqPict("SB2","B2_CM1")
    @ Li,107 Psay nQtd2     Picture PesqPict("SB2","B2_QATU")
    @ Li,123 Psay nVlrUnit2 Picture PesqPict("SB2","B2_CM1")
    @ Li,138 Psay nValor2   Picture PesqPict("SB2","B2_CM1") 
    @ Li,154 Psay nDifUnit  Picture PesqPict("SB2","B2_CM1")
    @ Li,178 Psay nPorc     Picture "9999.99"
    
    nTotValor1 += nValor1
    nTotValor2 += nValor2  
    lTotal := .T.
    
    SB2->(dbSkip())
    Li++
Enddo

If lTotal
   
   If Li > 55
      Cabec(Titulo,cCabec1,cCabec2,WnRel,Tamanho,nTipo)
   EndIf
   
   Li++
   @ Li, 000 PSay __PrtThinLine()
   Li++
   @ Li,047 Psay STR0010
   @ Li,091 Psay nTotValor1 Picture PesqPict("SB2","B2_CM1")
   @ Li,138 Psay nTotValor2 Picture PesqPict("SB2","B2_CM1")
   Li++
   @ Li, 000 PSay __PrtThinLine()
EndIf

If aReturn[5] = 1
	Set Printer To
	Commit
	OurSpool(wnrel)
EndIf
MS_FLUSH()

RestArea(aAreaSB1)
RestArea(aAreaSB2)

Return 