#INCLUDE "MATR927.CH"
#INCLUDE "PROTHEUS.CH"

/*


ͻ
Programa  MATR927   Autor  Mary C. Hergert      Data  28/09/2004  
͹
Desc.     Relatorio de PIS/COFINS com base na apropriacao de ativo    
          imobilizado.                                                
͹
Uso       Sigafis                                                     
ͼ


*/

Function Matr927  
   
Local aArea		:= GetArea()
Local Titulo    := OemToAnsi(STR0014)  	// "Crdito de PIS/COFINS na Depreciao do Ativo Imobilizado"
Local cDesc1    := OemToAnsi(STR0002) 	// "Este programa ira emitir o relatorio de credito de PIS/COFINS"
Local cDesc2    := OemToAnsi(STR0003)  	// "com base nas depreciacoes do Ativo Imobilizado"
Local cDesc3    := OemToAnsi(STR0004)  	// "e parametros informados pelo usuario"
Local lDic    	:= .F. 					// Habilita/Desabilita Dicionario
Local lComp    	:= .F. 					// Habilita/Desabilita o Formato Comprimido/Expandido
Local lFiltro  	:= .F. 					// Habilita/Desabilita o Filtro
Local wnrel     := "MATR927"  			// Nome do Arquivo utilizado no Spool
Local nomeprog  := "MATR927"  			// nome do programa
Local cString	:= "SN1"
Local aFilsCalc	:= {} 

Private Tamanho := "M"					// P/M/G
Private Limite  := 132 					// 80/132/220
Private cPerg   := "MTR927"				// Pergunta do Relatorio
Private aReturn := {STR0005,1,STR0006,1,2,1,"",1}	//"Zebrado"###"Administracao"

Private lEnd    := .F.					// Controle de cancelamento do relatorio
Private m_pag   := 1  					// Contador de Paginas
Private nLastKey:= 0  					// Controla o cancelamento da SetPrint e SetDefault

//Ŀ
// Variaveis utilizadas para parametros                     
// mv_par01            // Data Inicial de aquisicao   		 
// mv_par02            // Data Final de aquisicao           
// mv_par03            // Codigo Ativo Inicial              
// mv_par04            // Codigo Ativo Final                
// mv_par05            // Data Inicial para impressao 		 
// mv_par06            // Data Final para impressao         
// mv_par07            // Seleciona Filiais                 
// mv_par08            // Tipo de Bens                      
//

//Ŀ
//Ajusta o grupo de perguntas
//
AjustaSX1()
Pergunte(cPerg,.F.)

//Ŀ
//Envia para a SetPrint                                                   
//
wnrel:=SetPrint(cString,wnrel,cPerg,@titulo,cDesc1,cDesc2,cDesc3,lDic,"",lComp,Tamanho,lFiltro,.F.)
If ( nLastKey==27 )
	dbSelectArea(cString)
	dbSetOrder(1)
	dbClearFilter()
	Return
Endif

aFilsCalc := MatFilCalc( MV_PAR07 == 1 )
If Empty( aFilsCalc )
	dbSelectArea(cString)
	dbSetOrder(1)
	dbClearFilter()
	Return
Endif

SetDefault(aReturn,cString)
If ( nLastKey==27 )
	dbSelectArea(cString)
	dbSetOrder(1)
	dbClearFilter()
	Return
Endif 

//Ŀ
//Checa a existencia dos parametros necessarios
//
If GetNewPar("MV_TXPIS",0) == 0
	MsgStop(OemToAnsi(STR0009) + Chr(13) + Chr(10) + OemToAnsi(STR0010),OemToAnsi(STR0011))
	// "Parametro MV_TXPIS (aliquota de PIS) nao cadastrado." "Verifique o cadastro para a correta geracao do relatorio." "Parametro MV_TXPIS"
Endif
If GetNewPar("MV_TXCOFIN",0) == 0
	MsgStop(OemToAnsi(STR0012) + Chr(13) + Chr(10) + OemToAnsi(STR0010),OemToAnsi(STR0013))
	// "Parametro MV_TXCOFIN (aliquota de COFINS) nao cadastrado." "Verifique o cadastro para a correta geracao do relatorio." "Parametro MV_TXCOFIN"
Endif
 

//Ŀ
//Imprime o relatorio
//
RptStatus({|lEnd| ImpDet(@lEnd,wnRel,cString,nomeprog,Titulo,aFilsCalc)},Titulo)

dbSelectArea(cString)
dbClearFilter()
Set Device To Screen
Set Printer To

If (aReturn[5] = 1)
	dbCommitAll()
	OurSpool(wnrel)
Endif 
MS_FLUSH()

Return(.T.)

/*


ͻ
Programa  ImpDet    Autor  Mary C. Hergert      Data  28/09/2004  
͹
Desc.     Imprime o detalhe do relatorio                              
                                                                      
͹
Uso       Matr927                                                     
ͼ


*/

Static Function ImpDet( lEnd, wnRel, cString,nomeprog, Titulo, aFilsCalc )

Local lHouveMov	:= .F.

Local cBem		:= ""
Local cItem		:= ""   
Local cCabec1 	:= STR0018 + Transform(SuperGetMv("MV_TXPIS"),"@R 99.99%") + " / " + Transform(SuperGetMv("MV_TXCOFIN"),"@R 99.99%")
Local cCabec2 	:= ""          

Local nMvTxPis	:= SuperGetMv("MV_TXPIS")
Local nMvTxCof	:= SuperGetMv("MV_TXCOFIN")
Local cMvAPCR927:= SuperGetMv("MV_APCR927",.F.,"3")    
Local nAliqPis	:= 0
Local nALiqCof 	:= 0 

Local aLay	    := RetLayOut()
Local aDetail	:= {}
Local aTemp		:= {}
Local aProcItem	:= {}
Local lNovoBem	:= .T.

Local nLinha     := 80
Local nTotPis    := 0
Local nTotCof    := 0
Local nTotBase   := 0
Local nGTotPis   := 0
Local nGTotCof   := 0
Local nGTotBase  := 0
Local nValPis    := 0
Local nValCof    := 0
Local nBase      := 0 
Local aNome		 := {"PIS E COFINS CALCULADOS COM BASE NO VALOR DA DEPRECIAO","PIS E COFINS CALCULADOS COM BASE NO VALOR DA AQUISIO"}
Local aTipExc	:= IIf (!Empty(MV_PAR08) .And. Type(MV_PAR08)== "A",&(MV_PAR08),{})
Local lAquisicao:= IIf((MV_PAR09) == 1,.T.,.F.) //PARA ESTABELECER DLIMITE --> .T. = DATA DE AQUISICAO / .F. = Considera DATA INICIO DEPRECIACAO (PADRAO)

// Variaveis de controle de multiplas filiais
Local cFilBack   := cFilAnt
Local nForFilial := 0  

For nForFilial := 1 to Len( aFilsCalc )

	If aFilsCalc[nForFilial][1]

		cFilAnt   := aFilsCalc[nForFilial][2] 
        nLinha    := 80  // faz a quebra de pagina por filial 
       	titulo	:= STR0014 + Space(01) + STR0019 + cFilAnt //"Crdito de PIS/COFINS na Depreciao do Ativo Imobilizado" + " - Filial "
        lHouveMov := .F. 
        
		//Ŀ
		//Carregando o array com os parametros para processamento por item
		//
		aAdd(aProcItem,mv_par03)
		aAdd(aProcItem,mv_par04)
		aAdd(aProcItem,mv_par01)
		aAdd(aProcItem,mv_par02)
		aAdd(aProcItem,"ATI")
		
		//Ŀ
		//Quando o movimento e referente a apenas um mes
		//
		aTemp := DeprecAtivo(mv_par05,mv_par06,.T.,.F.,aProcItem,.T.,,,,,aTipExc,,lAquisicao)
		
		//
		//Imprime as informacoes contidas na tabela temporaria
		//
		dbSelectArea("ATI")
		ATI->(dbSetOrder(1))
		ATI->(dbGoTop())
		SetRegua(ATI->(LastRec()))
		
		While ! ATI->(Eof())
		
			If ATI->BASE > 0   // Calculado por frao ser exibido na segunda parte do relatrio
				ATI->( DbSkip() )
				Loop
			EndIf   		
		
		    IncRegua()
		
			If Interrupcao(@lEnd)
			    Exit
		 	Endif
		
			Mtr927Cabec(@nLinha,Titulo,cCabec1,cCabec2,nomeprog,aNome[1])
			
			//Ŀ
			//Quando mudar o bem, reinicia os totalizadores
			//
			If (cBem <> ATI->BEM .Or. cItem <> ATI->ITEM)
				// Totaliza o bem                      
				If lHouveMov
					FmtLin({},aLay[05],,,@nLinha)
			    	aDetail := {Transform(nTotBase,"@e 99,999,999,999.99"),;
								Transform(nTotPis,"@e 99,999,999,999.99"),;
								Transform(nTotCof,"@e 99,999,999,999.99")}				
					FmtLin(aDetail,aLay[06],,,@nLinha)
					FmtLin({},aLay[07],,,@nLinha)
				Endif
				lNovoBem 	:= .T.
				nTotPis 	:= 0
				nTotCof 	:= 0                         
				nTotBase	:= 0          
				cItem		:= ATI->ITEM
				cBem		:= ATI->BEM                         
				cDescr		:= Alltrim(ATI->BEM) + " - " + Alltrim(ATI->ITEM) + " - " + Left(Alltrim(Upper(ATI->DESCRI)),34)
			Endif
		
		    lHouveMov := .T.    
		    
		    //Ŀ  
			//19/10/2012 - FNC 00000025086/2012 - CHAMADO: TFWLHK                              		    
			//Para considerar qual aliquota utilizar. Verifica parametro MV_APCR927            
			// '1' - CONSIDERA DO CADASTRO DO BEM/MOVIMENTO -> ATI->ALIQPIS/ATI->ALIQCOFINS    
			// '2' - CONSIDERA DOS PARAMETROS MV_TXPIS / MV_TXCOFIN	                          
			// '3' - * DEFAULT * - VERIFICA OS CAMPOS DA ATI. SE = ZERO, CONSID. PARAMETROS 
			// 
			If cMvAPCR927$"1" 
				nAliqPis := ATI->ALIQPIS 
				nAliqCof := ATI->ALIQCOFINS
			ElseIf cMvAPCR927$"2"    
				nAliqPis := nMvTxPis // MV_TXPIS 
				nAliqCof := nMvTxCof // MV_TXCOFIN
			Else
			    nAliqPis := IIf(ATI->ALIQPIS>0,ATI->ALIQPIS,nMvTxPis)  
			    nAliqCof := Iif(ATI->ALIQCOFINS>0,ATI->ALIQCOFINS,nMvTxCof)      
			EndIf
		    
			// Calcula os valores de credito de PIS/COFINS
		  /*	If ATI->BASE > 0
				nValPis	:= ATI->BASE * ATI->ALIQPIS / 100
				nValCof	:= ATI->BASE * ATI->ALIQCOFINS / 100
				nBase	:= ATI->BASE
			Else */
				nValPis	:= ATI->VRET * nAliqPis / 100
				nValCof	:= ATI->VRET * nAliqCof / 100
				nBase	:= ATI->VRET
			/*Endif		*/
			
			If lNovoBem == .T.
				lNovoBem := .F.
			    aDetail := {cDescr,;
			    			StrZero(Month(ATI->DTAPR),2),;
			    			StrZero(Year(ATI->DTAPR),4),;
							Transform(nBase,"@e 99,999,999,999.99"),;
							Transform(nValPis,"@e 99,999,999,999.99"),;
							Transform(nValCof,"@e 99,999,999,999.99")}				
			Else
			    aDetail := {"",;
			    			StrZero(Month(ATI->DTAPR),2),;
			    			StrZero(Year(ATI->DTAPR),4),;
							Transform(nBase,"@e 99,999,999,999.99"),;
							Transform(nValPis,"@e 99,999,999,999.99"),;
							Transform(nValCof,"@e 99,999,999,999.99")}				
			Endif
							
			FmtLin(aDetail,aLay[04],,,@nLinha)
		
			//Ŀ
			//Acumula total                                                           
			//
			nTotPis  += nValPis
			nTotCof  += nValCof
			nTotBase += nBase
		    
			//Ŀ
			//Acumula total Geral                                                     
			//
			nGTotPis  += nValPis
			nGTotCof  += nValCof
			nGTotBase += nBase
		
		    ATI->(dbSkip())  
				  
		EndDo	
		
		//Ŀ
		//Imprime total                                                           
		//
		If lHouveMov                          
		
			If nLinha > 60
				lHouveMov := .F.
			Endif
			
			Mtr927Cabec(@nLinha,Titulo,cCabec1,cCabec2,nomeprog,aNome[1])
			
			If lHouveMov 
				FmtLin({},aLay[05],,,@nLinha)
			Endif
		
			// Total do ultimo bem impresso
		   	aDetail := {Transform(nTotBase,"@e 99,999,999,999.99"),;
						Transform(nTotPis,"@e 99,999,999,999.99"),;
						Transform(nTotCof,"@e 99,999,999,999.99")}				
			FmtLin(aDetail,aLay[06],,,@nLinha)
			FmtLin({},aLay[07],,,@nLinha)
			
			// Total Geral
		   	aDetail := {Transform(nGTotBase,"@e 99,999,999,999.99"),;
						Transform(nGTotPis,"@e 99,999,999,999.99"),;
						Transform(nGTotCof,"@e 99,999,999,999.99")}				
			FmtLin(aDetail,aLay[08],,,@nLinha)
			FmtLin({},aLay[09],,,@nLinha)
		Endif
			
		//Ŀ
		//Reinicia os totalizadores para exibir a segunda parte
		//	
		//caio
		nGTotPis  := 0
		nGTotCof  := 0
		nGTotBase := 0
		lHouveMov := .F.
		cBem		:= ""  
		cItem		:= ""
		
		nLinha := 80
	   //	Mtr927Cabec(@nLinha,Titulo,cCabec1,cCabec2,nomeprog,aNome[2])
		
		ATI->(DbGoTop())
		While ! ATI->(Eof())
		    
	 		If ATI->BASE == 0   // Calculado por depreciao j foi exibido na primeira parte do relatrio
				ATI->( DbSkip() )
				Loop
			EndIf 
		
		    IncRegua()
		
			If Interrupcao(@lEnd)
			    Exit
		 	Endif
		
			Mtr927Cabec(@nLinha,Titulo,cCabec1,cCabec2,nomeprog,aNome[2])
			
			//Ŀ
			//Quando mudar o bem, reinicia os totalizadores
			//
			If (cBem <> ATI->BEM .Or. cItem <> ATI->ITEM)
				// Totaliza o bem                      
				If lHouveMov
					FmtLin({},aLay[05],,,@nLinha)
			    	aDetail := {Transform(nTotBase,"@e 99,999,999,999.99"),;
								Transform(nTotPis,"@e 99,999,999,999.99"),;
								Transform(nTotCof,"@e 99,999,999,999.99")}				
					FmtLin(aDetail,aLay[06],,,@nLinha)
					FmtLin({},aLay[07],,,@nLinha)
				Endif
				lNovoBem 	:= .T.
				nTotPis 	:= 0
				nTotCof 	:= 0                         
				nTotBase	:= 0          
				cItem		:= ATI->ITEM
				cBem		:= ATI->BEM                         
				cDescr		:= Alltrim(ATI->BEM) + " - " + Alltrim(ATI->ITEM) + " - " + Left(Alltrim(Upper(ATI->DESCRI)),34)
			Endif
		
		    lHouveMov := .T. 
		    
		    //Ŀ  
			//19/10/2012 - FNC 00000025086/2012 - CHAMADO: TFWLHK                              		    
			//Para considerar qual aliquota utilizar. Verifica parametro MV_APCR927            
			// '1' - CONSIDERA DO CADASTRO DO BEM/MOVIMENTO -> ATI->ALIQPIS/ATI->ALIQCOFINS    
			// '2' - CONSIDERA DOS PARAMETROS MV_TXPIS / MV_TXCOFIN	                          
			// '3' - * DEFAULT * - VERIFICA OS CAMPOS DA ATI. SE = ZERO, CONSID. PARAMETROS 
			// 
			If cMvAPCR927$"1" 
				nAliqPis := ATI->ALIQPIS 
				nAliqCof := ATI->ALIQCOFINS
			ElseIf cMvAPCR927$"2"    
				nAliqPis := nMvTxPis // MV_TXPIS 
				nAliqCof := nMvTxCof // MV_TXCOFIN
			Else
			    nAliqPis := IIf(ATI->ALIQPIS>0,ATI->ALIQPIS,nMvTxPis)  
			    nAliqCof := Iif(ATI->ALIQCOFINS>0,ATI->ALIQCOFINS,nMvTxCof)      
			EndIf
			
		    
			// Calcula os valores de credito de PIS/COFINS
		   /*	If ATI->BASE > 0*/
				nValPis	:= ATI->BASE * nAliqPis / 100
				nValCof	:= ATI->BASE * nAliqCof / 100
				nBase	:= ATI->BASE
			/*Else
				nValPis	:= ATI->VRET * ATI->ALIQPIS  / 100
				nValCof	:= ATI->VRET * ATI->ALIQCOFINS / 100
				nBase	:= ATI->VRET
			Endif		*/
			
			If lNovoBem == .T.
				lNovoBem := .F.
			    aDetail := {cDescr,;
			    			StrZero(Month(ATI->DTAPR),2),;
			    			StrZero(Year(ATI->DTAPR),4),;
							Transform(nBase,"@e 99,999,999,999.99"),;
							Transform(nValPis,"@e 99,999,999,999.99"),;
							Transform(nValCof,"@e 99,999,999,999.99")}				
			Else
			    aDetail := {"",;
			    			StrZero(Month(ATI->DTAPR),2),;
			    			StrZero(Year(ATI->DTAPR),4),;
							Transform(nBase,"@e 99,999,999,999.99"),;
							Transform(nValPis,"@e 99,999,999,999.99"),;
							Transform(nValCof,"@e 99,999,999,999.99")}				
			Endif
							
			FmtLin(aDetail,aLay[04],,,@nLinha)
		
			//Ŀ
			//Acumula total                                                           
			//
			nTotPis  += nValPis
			nTotCof  += nValCof
			nTotBase += nBase
		    
			//Ŀ
			//Acumula total Geral                                                     
			//
			nGTotPis  += nValPis
			nGTotCof  += nValCof
			nGTotBase += nBase
		
		    ATI->(dbSkip())  
				  
		EndDo	
		
		//Ŀ
		//Imprime total                                                           
		//
		If lHouveMov                          
		
			If nLinha > 60
				lHouveMov := .F.
			Endif
			
			Mtr927Cabec(@nLinha,Titulo,cCabec1,cCabec2,nomeprog,aNome[2])
			
			If lHouveMov 
				FmtLin({},aLay[05],,,@nLinha)
			Endif
		
			// Total do ultimo bem impresso
		   	aDetail := {Transform(nTotBase,"@e 99,999,999,999.99"),;
						Transform(nTotPis,"@e 99,999,999,999.99"),;
						Transform(nTotCof,"@e 99,999,999,999.99")}				
			FmtLin(aDetail,aLay[06],,,@nLinha)
			FmtLin({},aLay[07],,,@nLinha)
			
			// Total Geral
		   	aDetail := {Transform(nGTotBase,"@e 99,999,999,999.99"),;
						Transform(nGTotPis,"@e 99,999,999,999.99"),;
						Transform(nGTotCof,"@e 99,999,999,999.99")}				
			FmtLin(aDetail,aLay[08],,,@nLinha)
			FmtLin({},aLay[09],,,@nLinha)
		Endif
			
		//Ŀ
		//Quando mudar a filial, reinicia os totalizadores
		//	
		//nTotPis   := 0
		//nTotCof   := 0                         
		//nTotBase  := 0   
		nGTotPis  := 0
		nGTotCof  := 0
		nGTotBase := 0
		
		//Ŀ
		//Excluindo o arquivo temporario criado pela funcao DeprecAtivo()
		//
		dbSelectArea(aTemp[1,2])
		dbCloseArea()
		Ferase(aTemp[1,1]+GetDBExtension())
		Ferase(aTemp[1,1]+OrdBagExt()) 

	EndIf

Next nForFilial

cFilAnt := cFilBack 
		
Return

/*


ͻ
Programa  Mtr927CabecAutor  Mary C. Hergert      Data  28/09/2004  
͹
Desc.     Cabecalho do relatorio                                       
                                                                       
͹
Uso       Matr927                                                      
ͼ


*/

Static Function Mtr927Cabec(nLinha,Titulo,cCabec1,cCabec2,nomeprog,cNome)

Local aLay	:= RetLayOut()
	
If nLinha > 60
	If nLinha < 70                                                  
		FmtLin({},aLay[09],,,@nLinha)
	Endif
	nLinha := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)

	nLinha += 1
	FmtLin({},aLay[01],,,@nLinha)
	FmtLin({PadC(cNome,130)},aLay[10],,,@nLinha)
	FmtLin({},aLay[01],,,@nLinha)                              
	FmtLin({},aLay[02],,,@nLinha)                              
	FmtLin({},aLay[03],,,@nLinha)                              
Endif

Return .T.
	
/*/


Ŀ
Funcao    RetLayOut | Autor  Mary C. Hergert        Data  13.07.04 
Ĵ
Descrio  Retorna o LayOut a ser impresso                            
Ĵ
Retorno    Array com o LayOut                                         
Ĵ
Parametros Nenhum                                                     
                                                                      
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/

Static Function RetLayOut()

Local aLay := Array(11)      

aLay[10] :=            "|##################################################################################################################################|"
aLay[01] :=            "+----------------------------------------------------------------------------------------------------------------------------------+"
aLay[02] := STR0015 // "|                Bem do Ativo Imobilizado                 | Mes | Ano  |  Base de Credito  |     Valor PIS     |   Valor COFINS    |"
aLay[03] :=            "+---------------------------------------------------------+-----+------+-------------------+-------------------+-------------------+"
aLay[04] :=            "| ####################################################### | ##  | #### | ################# | ################# | ################# |"
aLay[05] :=            "|---------------------------------------------------------+-----+------+-------------------+-------------------+-------------------|"
aLay[06] := STR0016 // "|                            Total do Ativo                            | ################# | ################# | ################# |"
aLay[07] :=            "|----------------------------------------------------------------------+-------------------+-------------------+-------------------|"
aLay[08] := STR0017 // "|                             TOTAL GERAL                              | ################# | ################# | ################# |"
aLay[09] :=            "+----------------------------------------------------------------------------------------------------------------------------------+"

Return(aLay)

/*/


Ŀ
Funcao    AjustaSX1  Autor Mary C. Hergert         Data 28/09/2004
Ĵ
Descrio Acerta o arquivo de perguntas                               
Ĵ
Retorno   Nenhum                                                      
ٱ


/*/

Static Function AjustaSx1()

Local aArea 	:= GetArea()
Local aHelpP 	:= {}
Local aHelpE 	:= {}
Local aHelpS	:= {}
	
Aadd( aHelpP, "Informe a data inicial de aquisicao para" )
Aadd( aHelpP, "filtrar os bens que serao processados   " )
Aadd( aHelpP, "na impressao do relatorio.              " ) 
Aadd( aHelpE, "Informe a data inicial de aquisicao para" )
Aadd( aHelpE, "filtrar os bens que serao processados   " )
Aadd( aHelpE, "na impressao do relatorio.              " ) 
Aadd( aHelpS, "Informe a data inicial de aquisicao para" )
Aadd( aHelpS, "filtrar os bens que serao processados   " )
Aadd( aHelpS, "na impressao do relatorio.              " ) 
PutSx1("MTR927","01","Data de ?","Data de ?","Data de ?","mv_ch1","D",08,0,0,"G","","","","","mv_par01","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92701.",aHelpP,aHelpE,aHelpS)
	
aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe a data final de aquisicao para  " )
Aadd( aHelpP, "filtrar os bens que serao processados   " )
Aadd( aHelpP, "na impressao do relatorio.              " ) 
Aadd( aHelpE, "Informe a data final de aquisicao para  " )
Aadd( aHelpE, "filtrar os bens que serao processados   " )
Aadd( aHelpE, "na impressao do relatorio.              " ) 
Aadd( aHelpS, "Informe a data final de aquisicao para  " )
Aadd( aHelpS, "filtrar os bens que serao processados   " )
Aadd( aHelpS, "na impressao do relatorio.              " ) 
PutSx1("MTR927","02","Data ate ?","Data ate ?","Data ate ?","mv_ch2","D",08,0,0,"G","","","","","mv_par02","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92702.",aHelpP,aHelpE,aHelpS)
	
aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe o codigo do ativo inicial para  " )
Aadd( aHelpP, "geracao do relatorio.                   " )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "                                        " )    
Aadd( aHelpE, "                                        " )
Aadd( aHelpE, "                                        " )   
Aadd( aHelpS, "                                        " )
Aadd( aHelpS, "                                        " )
Aadd( aHelpS, "                                        " )
PutSx1("MTR927","03","Codigo de ?","Codigo de ?","Codigo de ?","mv_ch3","C",10,0,0,"G","","","","","mv_par03","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92703.",aHelpP,aHelpE,aHelpS)
	
aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe o codigo do ativo final para    " )
Aadd( aHelpP, "geracao do relatorio.                   " )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "                                        " )    
Aadd( aHelpE, "                                        " )
Aadd( aHelpE, "                                        " )   
Aadd( aHelpS, "                                        " )
Aadd( aHelpS, "                                        " )
Aadd( aHelpS, "                                        " )
PutSx1("MTR927","04","Codigo ate ?","Codigo ate ?","Codigo ate ?","mv_ch4","C",10,0,0,"G","","","","","mv_par04","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92704.",aHelpP,aHelpE,aHelpS)
	
aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe a data inicial para impressao   " )
Aadd( aHelpP, "das depreciacoes.                       " )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "Informe a data inicial para impressao   " )
Aadd( aHelpE, "das depreciacoes.                       " )
Aadd( aHelpE, "                                        " ) 
Aadd( aHelpS, "Informe a data inicial para impressao   " )
Aadd( aHelpS, "das depreciacoes.                       " )
Aadd( aHelpS, "                                        " ) 
PutSx1("MTR927","05","Deprec. de ?","Deprec. de ?","Deprec. de ?","mv_ch5","D",08,0,0,"G","","","","","mv_par05","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92705.",aHelpP,aHelpE,aHelpS)

aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe a data final para impressao     " )
Aadd( aHelpP, "das depreciacoes.                       " )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "Informe a data final para impressao     " )
Aadd( aHelpE, "das depreciacoes.                       " )
Aadd( aHelpE, "                                        " ) 
Aadd( aHelpS, "Informe a data final para impressao     " )
Aadd( aHelpS, "das depreciacoes.                       " )
Aadd( aHelpS, "                                        " ) 
PutSx1("MTR927","06","Deprec. ate ?","Deprec. ate ?","Deprec. ate ?","mv_ch6","D",08,0,0,"G","","","","","mv_par06","","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92706.",aHelpP,aHelpE,aHelpS)

aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Seleciona filial para o Relatorio.      " )
Aadd( aHelpP, "                                        " )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "Seleciona filial para o Relatorio.      " )
Aadd( aHelpE, "                                        " )
Aadd( aHelpE, "                                        " ) 
Aadd( aHelpS, "Seleciona filial para o Relatorio.      " )
Aadd( aHelpS, "                                        " )
Aadd( aHelpS, "                                        " ) 
PutSx1("MTR927","07","Seleciona Filial"   ,"Seleciona Filial" ,"Seciona Filial"   ,"mv_CH7","N",1,0,2,"C","","","","","mv_par07","Sim","","","","Nao","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92707.",aHelpP,aHelpE,aHelpS)

aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe os Tipos dos Bens que nao devem " )
Aadd( aHelpP, "constar no Relatorio Ex:{'02','10','42'}" )
Aadd( aHelpP, "                                        " ) 
Aadd( aHelpE, "Informe os Tipos dos Bens que nao devem " )
Aadd( aHelpE, "constar no Relatorio Ex:{'02','10','42'}" )
Aadd( aHelpE, "                                        " ) 
Aadd( aHelpS, "Informe os Tipos dos Bens que nao devem " )
Aadd( aHelpS, "constar no Relatorio Ex:{'02','10','42'}" )
Aadd( aHelpS, "                                        " ) 
PutSx1("MTR927","08","Tipo Bens","Tipo Bens","Tipo Bens","mv_CH8","C",60,0,0,"G","","","","","mv_par08","{'02','10','42'}","","","","","","","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92708.",aHelpP,aHelpE,aHelpS)

aHelpP 	:= {}
aHelpE 	:= {}
aHelpS	:= {}
Aadd( aHelpP, "Informe Sim p/ que seja considerada a Dta" )
Aadd( aHelpP, "da efetiva aquisio do bem e No p/     " )
Aadd( aHelpP, "Dta de inicio da depreciao do bem.     " )
Aadd( aHelpE, "Informe Sim p/ que seja considerada a Dta" )
Aadd( aHelpE, "da efetiva aquisio do bem e No p/     " )
Aadd( aHelpE, "Dta de inicio da depreciao do bem.     " )
Aadd( aHelpS, "Informe Sim p/ que seja considerada a Dta" )
Aadd( aHelpS, "da efetiva aquisio do bem e No p/     " )
Aadd( aHelpS, "Dta de inicio da depreciao do bem.     " ) 
PutSx1("MTR927","09","Cons Data Bem?","Cons Data Bem?","Cons Data Bem?","mv_ch9","N",1,0,2,"C","","","","","mv_par09","Sim","Si","Yes","","Nao","No","No","","","","","","","","","",aHelpP,aHelpE,aHelpS)
PutSX1Help("P.MTR92709.",aHelpP,aHelpE,aHelpS)

RestArea(aArea)

Return Nil
		
