#INCLUDE "matrur2.ch"
#INCLUDE "Protheus.ch"

//Ŀ
// Defines das posicoes do array aItens 
//
#DEFINE _DATA		1
#DEFINE _DOCTO		2
#DEFINE _CLIENTE	3
#DEFINE _VALTOT		4
#DEFINE _PERCEP		5
#DEFINE _IVAMAIOR	6
#DEFINE _IVAMENOR	7
#DEFINE _COFIS		8
#DEFINE _FIS		9
#DEFINE _INAC		10
#DEFINE _VALBASE	11
/*/


Ŀ
Programa  MATRUR2    Autor Sergio S. Fuzinaka      Data  24.05.06 
Ĵ
Descricao Livros Fiscais de Vendas                                    
                                                                      
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
                                                                      
Ĵ
Uso       Uruguai                                                     
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
Function MATRUR2()

Local oReport
Local cPerg := "MTRUR2"

If FindFunction("TRepInUse") .And. TRepInUse()
	AjustaSX1(cPerg)
	Pergunte(cPerg,.F.)
	oReport:=ReportDef()
	oReport:PrintDialog()
Else
	MatrUr2R3()
EndIf

Return

/*/


Ŀ
Programa  ReportDef   Autor Sergio S. Fuzinaka      Data  24.05.06 
Ĵ
Descricao A funcao estatica ReportDef devera ser criada para todos os  
          relatorios que poderao ser agendados pelo usuario.           
                                                                       
Ĵ
Retorno   ExpO1: Objeto do relatrio                                   
Ĵ
ParametrosNenhum                                                       
                                                                       
Ĵ
   DATA    Programador   Manutencao efetuada                          
Ĵ
                                                                      
ٱ


/*/
Static Function ReportDef()

Local oReport
Local oEmpresa
Local oLinha
Local cReport	:= "MATRUR2"
Local cPerg		:= "MTRUR2"
Local cTitulo	:= OemToAnsi(STR0021)
Local cDesc		:= OemToAnsi(STR0022)

//Ŀ
//Criacao do componente de impressao                                      
//                                                                        
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//                                                                        
//
oReport := TReport():New(cReport,cTitulo,cPerg,{|oReport| ReportPrint(oReport)},cDesc)
oReport:SetLandscape() 
oReport:SetTotalInLine(.F.)
Pergunte(oReport:uParam,.F.)

//Ŀ
//Criacao da secao utilizada pelo relatorio                               
//                                                                        
//TRSection():New                                                         
//ExpO1 : Objeto TReport que a secao pertence                             
//ExpC2 : Descricao da seao                                              
//ExpA3 : Array com as tabelas utilizadas pela secao. A primeira tabela   
//        sera considerada como principal para a seo.                   
//ExpA4 : Array com as Ordens do relatrio                                
//ExpL5 : Carrega campos do SX3 como celulas                              
//        Default : False                                                 
//ExpL6 : Carrega ordens do Sindex                                        
//        Default : False                                                 
//                                                                        
//
//Ŀ
//Criacao da celulas da secao do relatorio                                
//                                                                        
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//                                                                        
//

//Ŀ
//Secao 1 - Cabecalho          
//
oEmpresa := TRSection():New(oReport,OemToAnsi(STR0037),{"SM0"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
TRCell():New(oEmpresa,"M0_NOMECOM","SM0",OemToAnsi(STR0037),/*Picture*/,40,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oEmpresa,"M0_ENDENT","SM0",OemToAnsi(STR0038),/*Picture*/,30,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oEmpresa,"M0_CGC","SM0",OemToAnsi(STR0039),/*Picture*/,14,/*lPixel*/,/*{|| code-block de impressao }*/)

//Ŀ
//Secao 2 - Detalhe            
//
oLinha := TRSection():New(oReport,OemToAnsi(STR0040),{"SF3","SA2"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
TRCell():New(oLinha,"F3_ENTRADA","SF3",OemToAnsi(STR0026),/*Picture*/,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"F3_NFISCAL","SF3",OemToAnsi(STR0027),/*Picture*/,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"A1_NOME","",OemToAnsi(STR0028),/*Picture*/,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"VALTOT","",OemToAnsi(STR0029),PesqPict("SF3","F3_VALCONT"),TamSx3("F3_VALCONT")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"PERCEP","",OemToAnsi(STR0030),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"IVAMAIOR","",OemToAnsi(STR0031),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"IVAMENOR","",OemToAnsi(STR0032),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"COFIS","",OemToAnsi(STR0033),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"VALBASE","",OemToAnsi(STR0034),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"FIS","",OemToAnsi(STR0035),PesqPict("SF3","F3_VALIMP1"),TamSx3("F3_VALIMP1")[1],/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oLinha,"INAC","",OemToAnsi(STR0036),PesqPict("SF3","F3_VALCONT"),TamSx3("F3_VALCONT")[1],/*lPixel*/,/*{|| code-block de impressao }*/)

//Ŀ
//Totais                       
//
TRFunction():New(oLinha:Cell("VALTOT"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("PERCEP"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("IVAMAIOR"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("IVAMENOR"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("COFIS"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("VALBASE"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("FIS"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)
TRFunction():New(oLinha:Cell("INAC"),NIL,"SUM",/*oBreak*/,/*cTitulo*/,/*cPicture*/,/*uFormula*/,.F.,.T.)

Return(oReport)

/*/


Ŀ
Programa  ReportPrint Autor Sergio S. Fuzinaka      Data  24.05.06 
Ĵ
Descricao A funcao estatica ReportDef devera ser criada para todos os  
          relatorios que poderao ser agendados pelo usuario.           
Ĵ
Retorno   Nenhum                                                       
Ĵ
ParametrosExpO1: Objeto Report do Relatorio                            
                                                                       
ٱ


/*/
Static Function ReportPrint(oReport)

Local cCabec	:= OemToAnsi(STR0021)+OemToAnsi(STR0024)+DtoC(mv_par01)+OemToAnsi(STR0025)+DtoC(mv_par02)
Local aImpostos	:= {}
Local cAliasSF3	:= "SF3"
Local cChave	:= ""
Local cClieFor	:= ""
Local nI		:= 0
Local nZ		:= 0
Local cNomeCom	:= ""
Local cEndEnt	:= ""
Local cCGC		:= ""
Local dEntrada	:= CtoD("")
Local cNFiscal	:= ""
Local cNome		:= ""
Local nVALTOT	:= 0
Local nPERCEP	:= 0
Local nIVAMAIOR	:= 0
Local nIVAMENOR	:= 0
Local nCOFIS	:= 0
Local nVALBASE	:= 0
Local nFIS		:= 0
Local nINAC		:= 0
Local aItens	:= {}

//Ŀ
//Altera o titulo para impressao                         
//
oReport:SetTitle(cCabec)

//Ŀ
//Monta aImpostos com as informacoes de cada imposto     
//
dbSelectArea("SFB")
dbSetOrder(1)
dbGoTop()

AAdd(aImpostos,{"IVA|IV3",""}) 
AAdd(aImpostos,{"IV2|IV4",""}) 
AAdd(aImpostos,{"COF",""})
AAdd(aImpostos,{"PVI",""})                
AAdd(aImpostos,{"PFI",""})
AAdd(aImpostos,{"FIS",""})                
AAdd(aImpostos,{"INC",""})                

While !SFB->(Eof()) 
	If aScan(aImpostos,{|x| SFB->FB_CODIGO $ x[1]}) > 0
		aImpostos[aScan(aImpostos,{|x| SFB->FB_CODIGO $ x[1]})][2] := SFB->FB_CPOLVRO
	EndIf	
	DbSkip()
EndDo                 
aSort(aImpostos,,,{|x,y| x[2] < y[2]})

//Ŀ
//Filtragem do relatorio                                                  
//
dbSelectArea("SF3")
dbSetOrder(1)

#IFDEF TOP
	//Ŀ
	//Transforma parametros Range em expressao SQL                            
	//
	MakeSqlExpr(oReport:uParam)

	//Ŀ
	//Query do relatrio da secao 1                                           
	//
	oReport:Section(2):BeginQuery()	
	
	cAliasSF3 := GetNextAlias()
		
	BeginSql Alias cAliasSF3
		SELECT SF3.*
		FROM %table:SF3% SF3
		WHERE F3_FILIAL = %xFilial:SF3%	AND 
			F3_ENTRADA	>=	%Exp:mv_par01%	AND 
			F3_ENTRADA	<=	%Exp:mv_par02%	AND 
			F3_TIPOMOV	=	'V'				AND 
			SF3.%NotDel% 
		ORDER BY %Order:SF3%
	EndSql 

	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//                                                                        
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oReport:Section(2):EndQuery(/*Array com os parametros do tipo Range*/)
		
#ELSE

	//Ŀ
	//Transforma parametros Range em expressao SQL                            
	//
	MakeAdvplExpr(oReport:uParam)

	cCondicao := "F3_FILIAL == '"+xFilial("SF3")+"' .And. "
	cCondicao += "F3_TIPOMOV == 'V' .And. "
	cCondicao += "Dtos(F3_ENTRADA) >= '"+Dtos(mv_par01)+"' .And. "
	cCondicao += "Dtos(F3_ENTRADA) <= '"+Dtos(mv_par02)+"'"

	oReport:Section(2):SetFilter(cCondicao,IndexKey())
	
#ENDIF		

oReport:Section(1):Cell("M0_NOMECOM"):SetBlock({|| cNomeCom})
oReport:Section(1):Cell("M0_ENDENT"):SetBlock({|| cEndEnt})
oReport:Section(1):Cell("M0_CGC"):SetBlock({|| cCGC})

oReport:Section(2):Cell("F3_ENTRADA"):SetBlock({|| dEntrada})
oReport:Section(2):Cell("F3_NFISCAL"):SetBlock({|| cNFiscal})
oReport:Section(2):Cell("A1_NOME"):SetBlock({|| cNome})
oReport:Section(2):Cell("VALTOT"):SetBlock({|| nValTot})
oReport:Section(2):Cell("PERCEP"):SetBlock({|| nPercep})
oReport:Section(2):Cell("IVAMAIOR"):SetBlock({|| nIVAMaior})
oReport:Section(2):Cell("IVAMENOR"):SetBlock({|| nIVAMenor})
oReport:Section(2):Cell("COFIS"):SetBlock({|| nCOFIS})
oReport:Section(2):Cell("VALBASE"):SetBlock({|| nValBase})
oReport:Section(2):Cell("FIS"):SetBlock({|| nFIS})
oReport:Section(2):Cell("INAC"):SetBlock({|| nINAC})

//Ŀ
//Inclui as posicoes dos campos de impostos no array aImpostos 
//
For nZ:=1 To Len(aImpostos)
	AAdd(aImpostos[nZ],FieldPos("F3_BASIMP"+aImpostos[nZ][2]))
	AAdd(aImpostos[nZ],FieldPos("F3_VALIMP"+aImpostos[nZ][2]))
Next	          

//Ŀ
//Metodo TrPosition()                                                     
//                                                                        
//Posiciona em um registro de uma outra tabela. O posicionamento ser     
//realizado antes da impressao de cada linha do relatrio.                
//                                                                        
//ExpO1 : Objeto Report da Secao                                          
//ExpC2 : Alias da Tabela                                                 
//ExpX3 : Ordem ou NickName de pesquisa                                   
//ExpX4 : String ou Bloco de cdigo para pesquisa. A string ser macroexe-
//        cutada.                                                         
//

//Ŀ
//Posicionamento das tabelas                             
//
SA1->(dbSelectArea("SA1"))
SA1->(dbSetOrder(1))

SA2->(dbSelectArea("SA2"))
SA2->(dbSetOrder(1))

//Ŀ
//Inicio da impressao do fluxo do relatorio                               
//
cNomeCom	:= SM0->M0_NOMECOM
cEndEnt		:= SM0->M0_ENDENT
cCGC		:= SM0->M0_CGC
oReport:SetMeter(1)
oReport:Section(1):Init()
oReport:Section(1):PrintLine() 	
oReport:Section(1):Finish()	

dbSelectArea(cAliasSF3)
dbGoTop()
oReport:SetMeter((cAliasSF3)->(LastRec()))
oReport:Section(2):Init()

While !oReport:Cancel() .And. !(cAliasSF3)->(Eof())

	aItens := {}
	oReport:IncMeter()

	cChave := (cAliasSF3)->F3_FILIAL+DTOS((cAliasSF3)->F3_ENTRADA)+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+;
				(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA+(cAliasSF3)->F3_CFO+(cAliasSF3)->F3_ESPECIE+(cAliasSF3)->F3_TIPOMOV
				
	dEntrada	:= (cAliasSF3)->F3_ENTRADA                                                   
	cNFiscal	:= (cAliasSF3)->F3_NFISCAL

    If Empty((cAliasSF3)->F3_DTCANC)

		cClieFor := (cAliasSF3)->F3_CLIEFOR
		If Len(cClieFor) > 0
			If (cAliasSF3)->F3_TIPO <> "B"
				SA1->(dbGoTop())
				If SA1->(dbSeek(xFilial("SA1")+cClieFor))
					cNome := SA1->A1_NOME
				Else 
					cNome := cClieFor
				EndIf           
			Else	
				SA2->(dbGoTop())
				If SA2->(dbSeek(xFilial("SA2")+cClieFor))
					cNome := SA2->A2_NOME
				Else 
					cNome := cClieFor
				EndIf
			EndIf	
		EndIf	
		
		AAdd(aItens,{dEntrada,cNFiscal,cNome,(cAliasSF3)->F3_VALCONT,0,0,0,0,0,0,0,(cAliasSF3)->F3_TIPO})
		
		For nI:=1 To Len(aImpostos)
			Do Case
				Case  aImpostos[nI][1] $ "PVI|PFI" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_PERCEP]   += FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "IV2|IV4" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_IVAMAIOR] := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "IVA|IV3" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_IVAMENOR] := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "COF" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_COFIS]    := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "FIS" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_FIS]      := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "INC" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_INAC]     := FieldGet(aImpostos[nI][4])
			EndCase							
		Next  
	
		(cAliasSF3)->(dbSkip())
	
		While (cAliasSF3)->F3_FILIAL+DTOS((cAliasSF3)->F3_ENTRADA)+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA+(cAliasSF3)->F3_CFO+;
			  (cAliasSF3)->F3_ESPECIE+(cAliasSF3)->F3_TIPOMOV == cChave 
			  
			aItens[Len(aItens)][_VALTOT] += FieldGet(FieldPos("F3_VALCONT"))
			
			For nI:=1 To Len(aImpostos)
				Do Case
					Case  aImpostos[nI][1] $ "PVI|PFI" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_PERCEP] += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "IV2|IV4" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_IVAMAIOR]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "IVA|IV3" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_IVAMENOR]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "COF" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_COFIS]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "FIS" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_FIS]    += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "INC" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_INAC]   += FieldGet(aImpostos[nI][4])
				EndCase							
			Next  
			(cAliasSF3)->(dbSkip())        
		Enddo	                

		aItens[Len(aItens)][_VALBASE] += aItens[Len(aItens)][_VALTOT] - (aItens[Len(aItens)][_PERCEP] + aItens[Len(aItens)][_IVAMAIOR] +;
										aItens[Len(aItens)][_IVAMENOR] + aItens[Len(aItens)][_COFIS])
		
		//Ŀ
		// Faz a somatoria dos totais a serem apresentados no relatorio        
		//
		If aItens[1][Len(aItens[1])] <> "D"
			nValTot		:= aItens[1][_VALTOT]
			nPercep		:= aItens[1][_PERCEP]
			nIVAMaior	:= aItens[1][_IVAMAIOR]
			nIVAMenor	:= aItens[1][_IVAMENOR]
			nCOFIS		:= aItens[1][_COFIS]
			nValBase	:= aItens[1][_VALBASE]
			nFIS		:= aItens[1][_FIS]
			nINAC		:= aItens[1][_INAC]
		Else                               
			nValTot		:= (aItens[1][_VALTOT] * -1)
			nPercep		:= (aItens[1][_PERCEP] * -1)
			nIVAMaior	:= (aItens[1][_IVAMAIOR] * -1)
			nIVAMenor	:= (aItens[1][_IVAMENOR] * -1)
			nCOFIS		:= (aItens[1][_COFIS] * -1)
			nValBase	:= (aItens[1][_VALBASE] * -1)
			nFIS		:= (aItens[1][_FIS] * -1)
			nINAC		:= (aItens[1][_INAC] * -1)
		EndIf	
	
    Else
    
		cNome := "********** "+ STR0023 +" **********"
		(cAliasSF3)->(dbSkip())

	Endif
	
	oReport:Section(2):PrintLine() 	

Enddo	

oReport:Section(2):Finish()	

Return

/*/


ͻ
Programa  MATRUR2R3  Autor  Paulo Eduardo       Data   31/10/03   
͹
Descricao  Funcao para impressao de livros fiscais de vendas para o   
           Uruguai.                                                   
͹
Uso        Localizacoes                                               
ͼ


/*/

Function MatrUR2R3()

//Ŀ
// Declaracao de Variaveis                                             
//

Local cDesc1       := STR0001 //"Este programa tem como objetivo imprimir relatorio "
Local cDesc2       := STR0002 //"de Livros Fiscais de Compras e Vendas para o"
Local cDesc3       := ""
Local cPict        := ""
Local titulo       := STR0003 //"Livro Fiscal de Vendas"
Local nLin         := 80
Local Cabec1       := ""
Local Cabec2       := ""
Local imprime      := .T.
Local aOrd         := {}
Private lEnd       := .F.
Private lAbortPrint:= .F.
Private limite     := 220
Private tamanho    := "G"
Private nomeprog   := "MATRUR2" 
Private nTipo      := 18
Private aReturn    := { STR0004, 1, STR0005, 2, 2, 1, "", 1} //"Zebrado"###"Administracao"
Private nLastKey   := 0
Private cbtxt      := Space(10)
Private cbcont     := 00
Private CONTFL     := 01
Private m_pag      := 01
Private wnrel      := "MATRUR2" 
Private cPerg      := "MTRUR2"
Private cString    := ""
Private cAliasSF3
Private aItens, aImpostos
Private nTotal    := 0, nTotPerc  := 0, nTotIVA23 := 0
Private nTotIVA14 := 0, nTotCOFIS := 0, nTotBase  := 0
Private nTotFIS   := 0, nTotINAC  := 0

//Ŀ
// Cria as perguntas no SX1 caso nao existam                           
//
AjustaSX1(cPerg)              

//Ŀ
// Monta a interface padrao com o usuario...                           
//
cString := "SF3"

wnrel := SetPrint(cString,NomeProg,cPerg,@titulo,cDesc1,cDesc2,cDesc3,.F.,,.T.,Tamanho,,.T.)

Pergunte(cPerg,.F.)

//Ŀ
//Monta aImpostos com as informacoes de cada imposto     
//
DbSelectArea("SFB")
DbSetOrder(1)
DbGoTop()

aImpostos := {}
AAdd(aImpostos,{"IVA|IV3",""})                
AAdd(aImpostos,{"IV2|IV4",""})                
AAdd(aImpostos,{"COF",""})
AAdd(aImpostos,{"PVI",""})                
AAdd(aImpostos,{"PFI",""})
AAdd(aImpostos,{"FIS",""})                
AAdd(aImpostos,{"INC",""})                
While !SFB->(EOF()) 
	If aScan(aImpostos,{|x| SFB->FB_CODIGO $ x[1]}) > 0
		aImpostos[aScan(aImpostos,{|x| SFB->FB_CODIGO $ x[1]})][2] := SFB->FB_CPOLVRO
	EndIf	
	DbSkip()
EndDo                 
aSort(aImpostos,,,{|x,y| x[2] < y[2]})

//Ŀ
// Monta os cabecalhos do relatorio                                    
//                        
titulo := STR0006 +space(1)+ DTOC(mv_par01) +space(1)+ STR0007 +space(1)+ DTOC(mv_par02) //"Livro de Vendas de"###"a"
                                  
Cabec1 := Padr(STR0008,10," ") +space(3)+ Padr(STR0009,12," ") +space(3)+ Padr(STR0010,30," ") +space(3)+ PadL(STR0011,17," ") +space(3)+ PadL(STR0012,17," ") +space(3)+; //"Data"###"Documento"###"Cliente"###"Valor Total"###"Percepcion"
		PadL("IVA 23%",17," ") +space(3)+ PadL("IVA 14%",17," ") +space(3)+ PadL("COFIS",17," ") +space(3)+ PadL(STR0013,17," ") +space(3)+ PadL("FIS",17," ") +space(3)+ PadL("INAC",17," ") //"Valor Base"
	
If nLastKey == 27
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
Endif

nTipo := If(aReturn[4]==1,15,18)		

//Ŀ
// Processamento. RPTSTATUS monta janela com a regua de processamento. 
//

RptStatus({|| MUr2Imprime(Cabec1,Cabec2,Titulo,nLin) },Titulo)								

Return

/*/


ͻ
Funo    MUR2IMPRIME Autor  AP6 IDE             Data   31/10/03   
͹
Descrio  Funcao auxiliar chamada pela RPTSTATUS. A funcao RPTSTATUS  
           monta a janela com a regua de processamento.                
͹
Uso        Programa principal                                          
ͼ


/*/

Static Function MUr2Imprime(Cabec1,Cabec2,Titulo,nLin)

Local nY := 1
Local cbcont:=0,cbtxt:=space(10)
Local cCond, cArqTrab, cOrdem, cChave
Local cCliLivro, cCliente
Local dDataEntr, dDataCanc
Local nValTot 	   :=0
Local nOrdSF3      := 1, nZ:= 1, nI:=1
Local cCGCDesc := Rtrim(RetTitle("A1_CGC"))
Local aCabec := {STR0014 +space(1)+ SM0->M0_NOMECOM +Padc("",130)+padL(STR0015+space(1)+STRZERO(m_pag,3,0),81),; //"Empresa:"###"Pagina:"
		STR0016 +space(1)+ Alltrim(SM0->M0_ENDENT)+" - "+ AllTrim(SM0->M0_CIDENT)+" - "+ AllTrim(SM0->M0_ESTENT)+; //"Endereco:"
		Padc(Titulo,130) + PadL(STR0008+": "+DTOC(dDataBase),111),; //"Data"
		cCGCDesc + ": " + Transform(SM0->M0_CGC,PesqPict("SA1","A1_CGC"))}

#IFDEF TOP
Local cQuery := ""

//Ŀ
//Monta query para selecao dos itens a serem mostrados
//
	cAliasSF3:="F3TMP"
	If Select(cAliasSF3)<>0
   		DbSelectArea(cAliasSF3)
   		DbCloseArea()
	Endif            
	
	cQuery := "SELECT * FROM "+RetSqlName("SF3")+" "+cAliasSF3+" "
    cQuery += "WHERE F3_FILIAL='"+ xFilial("SF3")+"'"+" AND F3_TIPOMOV = 'V' AND "
    cQuery += "F3_ENTRADA >= '"+Dtos(mv_par01)+"'"+" AND F3_ENTRADA <= '"+Dtos(mv_par02)+"'"
	cQuery +=" AND D_E_L_E_T_<>'*' ORDER BY " 
	cQuery +="F3_ENTRADA,F3_NFISCAL,F3_SERIE,F3_CLIEFOR,F3_LOJA,F3_CFO"
	cQuery :=ChangeQuery(cQuery)
	MsAguarde({|| dbUseArea(.T.,"TOPCONN",TCGenQry(,,cQuery),cAliasSF3,.F.,.T.)},STR0017) //"Selecionando registros..."
	TCSetField(cAliasSF3,"F3_ENTRADA","D",8,0)
#ELSE
	
//Ŀ
//Monta IndRegua para selecao do itens
//
	cAliasSF3:="SF3"
	DbSelectArea(cAliasSF3)
	DbGoTop()         

	nOrdSF3 := IndexOrd()

	cCond := cAliasSF3+"->F3_FILIAL == '"+ xFilial(cAliasSF3) + "' "
	cCond += ".and. "+cAliasSF3+"->F3_TIPOMOV =='V' .and."
	cCond += "Dtos("+cAliasSF3+"->F3_ENTRADA) >= '"+ Dtos(mv_par01) +"' .and. "
	cCond += "Dtos("+cAliasSF3+"->F3_ENTRADA) <= '"+ Dtos(mv_par02) +"'"
	cArqTrab := CriaTrab(Nil,.F.)
	cOrdem:=SF3->(IndexKey())
	IndRegua(cAliasSF3,cArqTrab,cOrdem,,cCond,STR0017) //"Selecionando registros..."
#ENDIF    

//Ŀ
//Inclui as posicoes dos campos de impostos no array aImpostos 
//
For nZ:=1 To Len(aImpostos)
	AAdd(aImpostos[nZ],FieldPos("F3_BASIMP"+aImpostos[nZ][2]))
	AAdd(aImpostos[nZ],FieldPos("F3_VALIMP"+aImpostos[nZ][2]))
Next	          

//Ŀ
//Monta array contendo as informacoes do cabecalho             
//


//Ŀ
// SETREGUA -> Indica quantos registros serao processados para a regua 
//
SetRegua(RecCount())

//Ŀ
//Monta array de com os itens do SF3  
//

aItens := {}
While !(cAliasSF3)->(EOF())
	cChave := (cAliasSf3)->F3_FILIAL+DTOS((cAliasSF3)->F3_ENTRADA)+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+;
				(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA+(cAliasSF3)->F3_CFO+(cAliasSF3)->F3_ESPECIE+(cAliasSF3)->F3_TIPOMOV
	dDataEntr := (cAliasSF3)->F3_ENTRADA                                                   
	dDataCanc := (cAliasSF3)->F3_DTCANC
	cDocumento:= (cAliasSF3)->F3_NFISCAL
    If !Empty(dDataCanc)
    	AAdd(aItens,{dDataEntr,cDocumento,"********** "+ STR0020 +" **********"})
    Else
		cCliLivro := (cAliasSF3)->F3_CLIEFOR
		If Len(cCliLivro) > 0
			If (cAliasSf3)->F3_TIPO <> "B"
				SA1->(DbGoTop())
				If SA1->(MsSeek(xFilial()+cCliLivro))
					cCliente := TransForm(SubStr(SA1->A1_NOME,1,30),PesqPict("SA1","A1_NOME"))
				Else 
					cCliente := SubStr(cCliLivro,1,30)
				EndIf           
			Else	
				SA2->(DbGoTop())
				If SA2->(MsSeek(xFilial()+cCliLivro))
					cCliente := TransForm(SubStr(SA2->A2_NOME,1,30),PesqPict("SA2","A2_NOME"))
				Else 
					cCliente := SubStr(cCliLivro,1,30)
				EndIf
			EndIf	
		EndIf	
		nValTot  := (cAliasSF3)->F3_VALCONT
		AAdd(aItens,{dDataEntr,cDocumento,cCliente,nValTot,0,0,0,0,0,0,0,(cAliasSF3)->F3_TIPO})
		
		For nI:=1 To Len(aImpostos)
			Do Case
				Case  aImpostos[nI][1] $ "PVI|PFI" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_PERCEP]   += FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "IV2|IV4" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_IVAMAIOR] := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "IVA|IV3" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_IVAMENOR] := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "COF" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_COFIS]    := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "FIS" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_FIS]      := FieldGet(aImpostos[nI][4])
				Case  aImpostos[nI][1] $ "INC" .And. aImpostos[nI][4] > 0
					aItens[Len(aItens)][_INAC]     := FieldGet(aImpostos[nI][4])
			EndCase							
		Next  
	EndIf	
	
	(cAliasSF3)->(DbSkip())
	
	While (cAliasSF3)->F3_FILIAL+DTOS((cAliasSF3)->F3_ENTRADA)+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA+(cAliasSF3)->F3_CFO+;
		  (cAliasSF3)->F3_ESPECIE+(cAliasSF3)->F3_TIPOMOV == cChave 
		If Empty(dDataCanc)  
			aItens[Len(aItens)][_VALTOT] += FieldGet(FieldPos("F3_VALCONT"))
			For nI:=1 To Len(aImpostos)
				Do Case
					Case  aImpostos[nI][1] $ "PVI|PFI" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_PERCEP] += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "IV2|IV4" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_IVAMAIOR]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "IVA|IV3" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_IVAMENOR]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "COF" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_COFIS]  += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "FIS" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_FIS]    += FieldGet(aImpostos[nI][4])
					Case  aImpostos[nI][1] $ "INC" .And. aImpostos[nI][4] > 0
						aItens[Len(aItens)][_INAC]   += FieldGet(aImpostos[nI][4])
				EndCase							
			Next  
		EndIf
		(cAliasSF3)->(DbSkip())        
	EndDo	                
	If Empty(dDataCanc)
		aItens[Len(aItens)][_VALBASE] += aItens[Len(aItens)][_VALTOT] - (aItens[Len(aItens)][_PERCEP] + aItens[Len(aItens)][_IVAMAIOR] +;
									aItens[Len(aItens)][_IVAMENOR] + aItens[Len(aItens)][_COFIS])
	EndIf								
	
	//Ŀ
	// Faz a somatoria dos totais a serem apresentados no relatorio        
	//
	If Len(aItens[Len(aItens)]) > 3
		If aItens[1][Len(aItens[1])] <> "D"
			nTotal    += aItens[1][_VALTOT]
			nTotPerc  += aItens[1][_PERCEP]
			nTotIVA23 += aItens[1][_IVAMAIOR]
			nTotIVA14 += aItens[1][_IVAMENOR]
			nTotCOFIS += aItens[1][_COFIS]
			nTotBase  += aItens[1][_VALBASE]
			nTotFIS   += aItens[1][_FIS]
			nTotINAC  += aItens[1][_INAC]
		Else                               
			nTotal    -= aItens[1][_VALTOT]
			nTotPerc  -= aItens[1][_PERCEP]
			nTotIVA23 -= aItens[1][_IVAMAIOR]
			nTotIVA14 -= aItens[1][_IVAMENOR]
			nTotCOFIS -= aItens[1][_COFIS]
			nTotBase  -= aItens[1][_VALBASE]
			nTotFIS   -= aItens[1][_FIS]
			nTotINAC  -= aItens[1][_INAC]
		EndIf	
	EndIf	
	
	//Ŀ
	// Verifica o cancelamento pelo usuario...                             
	//
	
	If lAbortPrint
		@nLin,00 PSAY STR0018 //"*** CANCELADO PELO OPERADOR ***"
		Exit
	Endif
	
	//Ŀ
	// Impressao do cabecalho do relatorio. . .                            
	//
	
	If nLin > 58 // Salto de Pgina. Neste caso o formulario tem 58 linhas...
		nLin := Cabec(Titulo,Cabec1,Cabec2,NomeProg,Tamanho,nTipo,aCabec)
		nLin ++
	Endif
	If Len(aItens[Len(aItens)]) > 3
		@nLin,00   PSAY Padr(aItens[nY][_DATA],10)
		@nLin,13   PSAY aItens[nY][_DOCTO]
		@nLin,28   PSAY aItens[nY][_CLIENTE]
		If aItens[1][Len(aItens[1])] <> "D"
			@nLin,61   PSAY Transform(aItens[nY][_VALTOT],PesqPict("SF3","F3_VALCONT"))
			@nLin,80   PSAY Transform(aItens[nY][_PERCEP],PesqPict("SF3","F3_VALIMP1"))
			@nLin,100  PSAY Transform(aItens[nY][_IVAMAIOR],PesqPict("SF3","F3_VALIMP1"))
			@nLin,120  PSAY Transform(aItens[nY][_IVAMENOR],PesqPict("SF3","F3_VALIMP1"))
			@nLin,140  PSAY Transform(aItens[nY][_COFIS],PesqPict("SF3","F3_VALIMP1"))
			@nLin,161  PSAY Transform(aItens[nY][_VALBASE],PesqPict("SF3","F3_VALCONT"))
			@nLin,180  PSAY Transform(aItens[nY][_FIS],PesqPict("SF3","F3_VALIMP1"))
			@nLin,200  PSAY Transform(aItens[nY][_INAC],PesqPict("SF3","F3_VALIMP1"))
		Else                                                                            
			@nLin,61   PSAY Transform(aItens[nY][_VALTOT]*-1,PesqPict("SF3","F3_VALCONT"))
			@nLin,80   PSAY Transform(aItens[nY][_PERCEP]*-1,PesqPict("SF3","F3_VALIMP1"))
			@nLin,100  PSAY Transform(aItens[nY][_IVAMAIOR]*-1,PesqPict("SF3","F3_VALIMP1"))
			@nLin,120  PSAY Transform(aItens[nY][_IVAMENOR]*-1,PesqPict("SF3","F3_VALIMP1"))
			@nLin,140  PSAY Transform(aItens[nY][_COFIS]*-1,PesqPict("SF3","F3_VALIMP1"))
			@nLin,161  PSAY Transform(aItens[nY][_VALBASE]*-1,PesqPict("SF3","F3_VALCONT"))
			@nLin,180  PSAY Transform(aItens[nY][_FIS]*-1,PesqPict("SF3","F3_VALIMP1"))
			@nLin,200  PSAY Transform(aItens[nY][_INAC]*-1,PesqPict("SF3","F3_VALIMP1"))
		EndIf	
	Else                                           
		@nLin,00   PSAY Padr(aItens[nY][_DATA],10)
		@nLin,13   PSAY aItens[nY][_DOCTO]
		@nLin,28   PSAY aItens[nY][_CLIENTE]
	EndIf	
	
	nLin := nLin + 1 // Avanca a linha de impressao
	aItens := {}
EndDo	

If nTotal <> 0
	//Ŀ
	// Monta linha de totais do relatorio.                                 
	//                                    
	nLin := nLin + 2
	                 
	@nLin,00   PSAY STR0019                                        //"TOTAIS GERAIS"
	@nLin,61   PSAY Transform(nTotal,PesqPict("SF3","F3_VALCONT"))
	@nLin,80   PSAY Transform(nTotPerc,PesqPict("SF3","F3_VALIMP1"))
	@nLin,100  PSAY Transform(nTotIVA23,PesqPict("SF3","F3_VALIMP1"))
	@nLin,120  PSAY Transform(nTotIVA14,PesqPict("SF3","F3_VALIMP1"))
	@nLin,140  PSAY Transform(nTotCOFIS,PesqPict("SF3","F3_VALIMP1"))
	@nLin,161  PSAY Transform(nTotBase,PesqPict("SF3","F3_VALCONT"))
	@nLin,180  PSAY Transform(nTotFIS,PesqPict("SF3","F3_VALIMP1"))
	@nLin,200  PSAY Transform(nTotINAC,PesqPict("SF3","F3_VALIMP1"))	
		
	//Ŀ
	// Monta rodape da pagina                                              
	//
	roda(cbcont,cbtxt,"G")
EndIf                     

#IFDEF TOP                                              
	DbSelectArea(cAliasSF3)
	DbCloseArea()
#ELSE	
	RetIndex(cAliasSF3)
	(cAliasSF3)->(DbSetOrder(nOrdSF3))
	cArqTrab+=OrdBagExt()
	File(cArqTrab)
	Ferase(cArqTrab)
#ENDIF	
	
//Ŀ
// Finaliza a execucao do relatorio...                                 
//
	
SET DEVICE TO SCREEN
	
//Ŀ
// Se impressao em disco, chama o gerenciador de impressao...          
//
	
If aReturn[5]==1
   dbCommitAll()
   SET PRINTER TO
   OurSpool(wnrel)
Endif
	
MS_FLUSH()
Fim := .F.
	
Return

/*


ͻ
Funcao    AjustaSX1 Autor   Paulo Eduardo       Data   04/06/03   
͹
Descricao  Cria as perguntas caso nao existam                         
͹
Uso        MATC110                                                    
ͼ


*/
Static Function AjustaSX1(cPerg)
                      
Local cKey := ""
Local aHelpEng := {}             
Local aHelpPor := {}             
Local aHelpSpa := {}             

PutSx1(cPerg,"01","Data De            ?","De Fecha           ?","From Date          ?","mv_ch1","D",8,0,0,"G","","","","","mv_par01","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"02","Data Ate           ?","A Fecha            ?","To Date            ?","mv_ch2","D",8,0,0,"G","","","","","mv_par02","","","","","","","","","","","","","","","","")

cKey     := "P.MTRUR201."
aHelpEng := {}             
aHelpPor := {}             
aHelpSpa := {}             
aAdd(aHelpEng,"Inform the initial date to be      ")
aAdd(aHelpEng,"considered in the filter.")
aAdd(aHelpPor,"Informe a data inicial que sera    ")
aAdd(aHelpPor,"considerada no filtro.")
aAdd(aHelpSpa,"Informe la fecha inicial que sera  ")
aAdd(aHelpSpa,"considerada en el filtro")
PutSX1Help(cKey,aHelpPor,aHelpEng,aHelpSpa)	

cKey     := "P.MTRUR202."
aHelpEng := {}             
aHelpPor := {}             
aHelpSpa := {}             
aAdd(aHelpEng,"Inform the final date to be      ")
aAdd(aHelpEng,"considered in the filter.")
aAdd(aHelpPor,"Informe a data final que sera    ")
aAdd(aHelpPor,"considerada no filtro.")
aAdd(aHelpSpa,"Informe la fecha final que sera  ")
aAdd(aHelpSpa,"considerada en el filtro")
PutSX1Help(cKey,aHelpPor,aHelpEng,aHelpSpa)	

Return             
