#INCLUDE "MATR971.CH"
#INCLUDE "PROTHEUS.CH"                              

/*                                                         


Ŀ
Funao    Matr971    Autor  Andressa Fagundes      Data 14/09/2006
Ĵ
Descrio  Relatorio auxiliar para preenchimento da DACON             
Ĵ
 Uso       Generico                                                   
Ĵ
 ATUALIZACOES SOFRIDAS DESDE A CONSTRUCAO INICIAL.                     
Ĵ
 PROGRAMADOR   DATA    BOPS   MOTIVO DA ALTERACAO                   
Ĵ
Marcos kato   17/06/09SBNLJH Retirado a variavel cFilAnt declarada  
                             comolocal para resolver o problema de  
                             valores multiplicados de acordo com a  
                             quantidade de filial processada.       
ٱ


*/

Function Matr971()

Local oReport
Local aMes     	:= {}
Local aMercado	:= {}
Private nVAgrDes := 0

//Arrays utilizados na gerao das fichas 15/25A e 15/25B - RESUMO PIS/Pasep - COFINS
Private aWizCum := {}
Private aCumVlrs:= {}
Private aWizNCum:= {}
Private aNCumVlr:= {} 
Private lPisFolha := Existblock("MTR971F")          
Private lPisFolSN := Existblock("MTR971S")    
AjustaSx1()

If FindFunction("TRepInUse") .And. TRepInUse()
	//Ŀ
	//Interface de impressao                                                  
	//
	oReport	:= ReportDef(@aMes,@aMercado)
	oReport:PrintDialog()
Else
	Matr971R3(@aMes,@aMercado)
EndIf

//Gera Arquivo Magntico
If mv_par11 == 2
	DACONMS(@aMes,@nVAgrDes,aWizCum,aCumVlrs,aWizNCum,aNCumVlr,aMercado)
EndIf

//Fecho a tabela temporria aps a gerao do arquivo
If Select("TMP")>0
	dbSelectArea("TMP")
	dbCloseArea()
EndIf
If Select("T01")>0
	dbSelectArea("T01")
	dbCloseArea()
EndIf

Return

/*/


Ŀ
Programa  ReportDef  Autor Andressa Fagundes       Data 14/09/2006
Ĵ
Descrio A funcao estatica ReportDef devera ser criada para todos os 
          relatorios que poderao ser agendados pelo usuario.          
Ĵ
Retorno   ExpO1: Objeto do relatrio                                  
Ĵ
ParametrosNenhum                                                      
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function ReportDef(aMes,aMercado)

Local oReport
Local oCabec
Local oFicha6
Local oFicha7
Local oFicha8
Local oFicha9
Local oFicha10
Local oFicha6b
Local oFicha010
Local oFicha15
Local oFicha25

//Ŀ
//Componente de impressao
//
oReport := TReport():New("MATR971",STR0003,"MTR971", {|oReport| ReportPrint(oReport,@aMes,@aMercado)},STR0004+" "+"para auxiliar o preenchimento do DACON.")
Pergunte("MTR971",.F.)

//
//Secao 1 - Dados da Empresa				                    
//
oCabec	:= TRSection():New(oReport,"Dados da Empresa/Filial",{"SM0"},{"Empresa"},/*Campos do SX3*/,/*Campos do SIX*/)
TRCell():New(oCabec,"M0_CGC"		,"SM0",STR0093 ,"@R 99.999.999/9999-99",20	,/*lPixel*/,/*{||  }*/)
TRCell():New(oCabec,"PERIODO"		,""	,"Periodo" ,/*Picture*/,50,/*lPixel*/,/*{||  }*/)
TRCell():New(oCabec,"MES"			,""	,"Mes" ,/*Picture*/,25,/*lPixel*/,/*{||  }*/)
TRCell():New(oCabec,"VALIDADOR"		,""	,"Validador" ,/*Picture*/,26,/*lPixel*/,/*{||  }*/)

//
//Secao 2 - Regime Nao Cumulativo Ficha 06A e Ficha 16A       	
//
oFicha6:= TRSection():New(oReport,STR0133,{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha6:SetEdit(.F.)
TRCell():New(oFicha6,"MOVIMENTO"	,"SF3"	,STR0134 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha6,"VAL01"		,"SF3"	,"Trib.Mer.Interno" ,/*Picture*/,18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha6,"VAL02"		,"SF3"	,"No Trib.Merc.Interno" ,/*Picture*/,21,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha6,"VAL03"		,"SF3"	,"Exportao" ,/*Picture*/,18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 3 - Regime Nao Cumulativo  Ficha 07A e Ficha 17A       
//
oFicha7:= TRSection():New(oReport,STR0153,{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha7:SetEdit(.F.)
TRCell():New(oFicha7,"MOVIMENTO"	,"SF3"	,STR0162 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha7,"VAL01"		,"SF3"	,"Receita" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha7,"VAL02"		,"SF3"	,"Base de Clculo" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha7,"VAL03"		,"SF3"	,"Contribuio" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 4 - Ficha 09A e Ficha 19A - Aliquotas Diferenciadas	
//
oFicha9:= TRSection():New(oReport,STR0168,{"TMP"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha9:SetEdit(.F.)
TRCell():New(oFicha9,"PRODUTO"		,"TMP"	,,/*Picture*/,55,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha9,"VAL01"		,"TMP"	,"Receita Vendas" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha9,"VAL02"		,"TMP"	,"Base Clculo" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha9,"VAL03"		,"TMP"	,"Alquota%" ,"@E 99.99",05,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha9,"VAL04"		,"TMP"	,"Vl.Apurado" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 5 - Regime Cumulativo Ficha 08A e Ficha 18A      		
//
oFicha8:= TRSection():New(oReport,STR0098,{"SE5"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha8:SetEdit(.F.)
TRCell():New(oFicha8,"MOVIMENTO"	,"SE5"	,STR0099 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha8,"VAL01"		,"SF3"	,"Receita" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha8,"VAL02"		,"SF3"	,"Base de Clculo" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha8,"VAL03"		,"SF3"	,"Contribuio" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 6 - Regime Nao Cumulativo e Cumulativo Ficha 06A/16A e Ficha 07B/17B  	  
//
oFicha10:= TRSection():New(oReport,STR0173,{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha10:SetEdit(.F.)
TRCell():New(oFicha10,"MOVIMENTO"	,"SF3"	,STR0099 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha10,"VAL01"		,"SF3"	,"Receita" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha10,"VAL02"		,"SF3"	,"Base de Clculo" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha10,"VAL03"		,"SF3"	,"Contribuio" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 7 - Importacao Regime Nao Cumulativo Ficha 06B e Ficha 16B       	
//
oFicha6b:= TRSection():New(oReport,STR0251,{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha6b:SetEdit(.F.)
TRCell():New(oFicha6b,"MOVIMENTO"	,"SF3"	,STR0134 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha6b,"VAL01"		,"SF3"	,STR0222 ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/) //"Trib.Mer.Interno"
TRCell():New(oFicha6b,"VAL02"		,"SF3"	,STR0223 ,"@!",21,/*lPixel*/,/*{|| code-block de impressao }*/) //"No Trib.Merc.Interno"
TRCell():New(oFicha6b,"VAL03"		,"SF3"	,STR0224 ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/) //"Exportao"

//
//Secao 8 - Ficha 10A - Aliquotas por Unidade de Medida    	
//
oFicha010:= TRSection():New(oReport,STR0254,{"T01"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha010:SetEdit(.F.)
TRCell():New(oFicha010,"PRODUTO"	,"T01"	,,/*Picture*/,55,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha010,"VAL01"		,"T01"	,"Receita Vendas" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha010,"VAL02"		,"T01"	,"Quantidade" ,"@E 99999999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha010,"VAL03"		,"T01"	,"Alquota" ,"@E 99.9999",05,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha010,"VAL04"		,"T01"	,"Vl.Apurado" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 9 - Regime Cumulativo Ficha 15A                        
//
oFicha15:= TRSection():New(oReport,"Ficha 15a",{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha15:SetEdit(.F.)
TRCell():New(oFicha15,"MOVIMENTO"	,"SF3"	,STR0306 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha15,"VAL01"		,"SF3"	,"Valor" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 10 - Regime Nao Cumulativo Ficha 15B                   
//
oFicha15:= TRSection():New(oReport,"Ficha 15b",{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha15:SetEdit(.F.)
TRCell():New(oFicha15,"MOVIMENTO"	,"SF3"	,STR0306 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha15,"VAL01"		,"SF3"	,"Valor" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/) 

//
//Secao 11 - Regime Cumulativo Ficha 25A                       
//
oFicha25:= TRSection():New(oReport,"Ficha 25a",{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha25:SetEdit(.F.)
TRCell():New(oFicha25,"MOVIMENTO"	,"SF3"	,STR0336 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha25,"VAL01"		,"SF3"	,"Valor" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 12 - Regime Nao Cumulativo Ficha 25B                   
//
oFicha25:= TRSection():New(oReport,"Ficha 25b",{"SF3"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha25:SetEdit(.F.)
TRCell():New(oFicha25,"MOVIMENTO"	,"SF3"	,STR0336 ,/*Picture*/,100,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha25,"VAL01"		,"SF3"	,"Valor" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 13 - Ficha 11 - Controle do Diferimento - PIS          
//
oFicha013:= TRSection():New(oReport,STR0361,{"CFB"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha013:SetEdit(.F.)
TRCell():New(oFicha013,"RegCont"	,""	,"Regime de Apurao da Contribuio",/*Picture*/,55,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha013,"VAL01"		,""	,"Perodo do Diferimento" ,/*Picture*/,07,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha013,"VAL02"		,"CFB"	,"Contribuio Diferida" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha013,"VAL03"		,"CFB"	,"Crdito Diferido" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)

//
//Secao 14 - Ficha 12 - Controle do Diferimento - PIS        	
//
oFicha014:= TRSection():New(oReport,STR0357,{"CFA"},/*{Array com as ordens do relatrio}*/,/*Campos do SX3*/,/*Campos do SIX*/)
oFicha014:SetEdit(.F.)
TRCell():New(oFicha014,"Regime"	,""	,"Regime de Apurao da Contribuio",/*Picture*/,55,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha014,"VAL01"		,""	,"Perodo do Diferimento" ,/*Picture*/,07,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha014,"VAL02"		,"CFA"	,"Contribuio Adicionada" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)
TRCell():New(oFicha014,"VAL03"		,"CFA"	,"Crdito Adicionado" ,"@E 99,999,999,999.99",18,/*lPixel*/,/*{|| code-block de impressao }*/)


Return(oReport)
               
/*/


Ŀ
Programa  ReportPrin Autor Andressa Fagundes       Data 14/09/2006
Ĵ
Descrio A funcao estatica ReportPrint devera ser criada para todos  
          os relatorios que poderao ser agendados pelo usuario.       
Ĵ
Retorno   Nenhum                                                      
Ĵ
Parametros                                                            
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function ReportPrint(oReport,aMes,aMercado)

Local dDtIni	:= mv_par01
Local dDtFin	:= mv_par02
Local nVDeprAt	:= 0
Local nTotVlMI	:= 0
Local nTotVlEX	:= 0
Local nTotVlNTr	:= 0
Local nTotVRec	:= 0
Local nTotVCum	:= 0
Local nBsCrdAqI	:= 0
Local nBsCrdAqE	:= 0
Local nPercInt	:= 0
Local nPercExt	:= 0
Local nPercNTr	:= 0
Local nRecFinC	:= 0
Local nRecFinN	:= 0
Local nOutRecN	:= 0
Local nOutRecC	:= 0
Local nRecVen   := 0
Local nPosMes	:= 0
Local nI		:= 0
Local nY		:= 0
Local nX		:= 0
Local nToCreMI	:= 0
Local nToCreEX	:= 0
Local nToCreNT	:= 0
Local nToMAMI1	:= 0
Local nToMAEX1	:= 0
Local nToMAMI3	:= 0
Local nToMAEX3	:= 0
Local nTot		:= 0
Local nTotCum	:= 0
Local nPis		:= 0
Local nCof		:= 0
Local nItem1	:= 0
Local nItem2	:= 0
Local nItem3	:= 0
Local nValor1	:= 0
Local nValor2	:= 0
Local nValor3	:= 0
Local nValor4   := 0
Local nVlrTot15 := 0
Local nVlrTot25 := 0
Local nNTrib	:= 0
Local cCod		:= ""
Local cMovimento:= ""
Local aDescr	:= {}
Local aDescr06B	:= {}
Local aDescr1	:= {}
Local aDescr2	:= {}
Local aDescr3	:= {}
Local aDescr4	:= {}
Local aDescr15A := {} 
Local aDescr25A := {}
Local aDescr15B := {}  
Local aDescr25B := {}
Local aArea		:= GetArea()
Local lFirst	:= .T.
Local lRet		:= .F.
Local nCont1	:= 0
Local nCont2	:= 0
Local nAjusMI	:= 0
Local nAjusEX	:= 0 
Local nAjusNT	:= 0
Local aRecAuf 	:= {}
Local nQuant    := 0
Local n09A_15   := 0
Local n09A_25   := 0
Local n10A_15   := 0
Local n10A_25   := 0
Local nScan     := 0
Local cTpCon := ""
Local cDtPer := StrZero(Month(mv_par01),2)+Str(Year(mv_par01),4)
Local cRegApur	:= ""

Default aMercado  := {}

aMercado  := {{0,0,0},{0,0,0},{0,0,0}}

//Ŀ
//Validacao/tratamento do periodo informado              
//
If Empty(mv_par01) .Or. Empty(mv_par02) .Or. (Month(mv_par01)<>Month(mv_par02)) .Or. (Year(mv_par01)<>Year(mv_par02))
	xMagHelpFis(OemToAnsi(STR0163),OemToAnsi(STR0164),OemToAnsi(STR0165))
	Return(.F.)
Else
	If Day(mv_par01) <> 1
		mv_par01 := CtoD("01/"+StrZero(Month(mv_par01),2)+"/"+StrZero(Year(mv_par01),4))
	Endif
	If Day(mv_par02) <> Day(LastDay(mv_par02))
		mv_par02 := CtoD(StrZero(Day(LastDay(mv_par02)),2)+"/"+StrZero(Month(mv_par02),2)+"/"+StrZero(Year(mv_par02),4))
	Endif
Endif

//Ŀ
//Processamento do Dacon - Regime Cumulativo e Nao Cumulativo             
//
aMes:= ProcDacon(@nVDeprAt,@nTotVlMI,@nTotVlEX,@nBsCrdAqI,@nBsCrdAqE,@nPercInt,@nPercExt,@nOutRecN,@nOutRecC,@nPosMes,@lRet,@nNTrib,@aRecAuf,@nRecVen,@nVAgrDes,@aMercado)

If lRet
	//aDescr --> Descricao/Posicao do ames (aMes[nPosMes][2]"[3]"[2])
	If mv_par06==2 .Or. mv_par06==3 // Regime Nao Cumulativo e Ambos(Regime Nao Cumulativo + Cumulativo)
		//
		//Descricao das Fichas 06A e 16A       
		//
		aAdd(aDescr,{STR0012,3})//01.Bens para Revenda
		aAdd(aDescr,{STR0013,4})//02.Bens Utilizados como Insumos
		aAdd(aDescr,{STR0014,6})//03.Servicos Utilizados como Insumos
		aAdd(aDescr,{STR0015,5})//04.Despesas de Energia Eletrica
		aAdd(aDescr,{STR0135,20})//05.Despesas de Alugueis de Predios Locados de Pessoas Juridicas
		aAdd(aDescr,{STR0136,21})//06.Despesas de Alugueis de Maquinas e Equipamentos Locados de Pessoas Juridicas
		aAdd(aDescr,{STR0137,23})//07.Despesas de Armazenagem de Mercadoria e Frete na Operacao de Venda
		aAdd(aDescr,{STR0138,99})//08.Despesas de Contraprestacoes de Arrendamento Mercantil
		aAdd(aDescr,{STR0139,99})//09.Sobre Bens do Ativo Imobilizado(Com Base nos Encargos de Depreciao)
		aAdd(aDescr,{STR0140,99})//10.Sobre Bens do Ativo Imobilizado(Com Base no Valor de Aquisio)
		aAdd(aDescr,{STR0141,99})//11.Encargos de Amortizao de Edificaes e Benfeitorias
		aAdd(aDescr,{STR0142,7})//12.Devoluo de Vendas Sujeitas a Alquota de 
		aAdd(aDescr,{STR0143,22})//13.Outras Operaes com Direito a Crdito
		aAdd(aDescr,{STR0144,99})//14.BASE DE CALCULO DOS CREDITOS
		aAdd(aDescr,{STR0145,99})//15.Creditos a Descontar
		aAdd(aDescr,{STR0027,99})//APURACAO DE OUTROS CREDITOS
		aAdd(aDescr,{STR0146,1,2})//16.Creditos Calculados a Aliquotas Diferenciadas - Pis/Cofins
		aAdd(aDescr,{STR0147,99})//17.Creditos Calculados por Unidade de Produto
		aAdd(aDescr,{STR0079,99})//18.Crditos da Atividade de Transporte de Cargas - Subcontr.Servios
		aAdd(aDescr,{STR0149,99})//19.Credito Presumido Relativo a Estoque de Abertura
		aAdd(aDescr,{STR0150,99})//20.Creditos da Atividade Imobiliaria
		aAdd(aDescr,{STR0037,99})//21.Outros Crditos a Descontar
		aAdd(aDescr,{STR0043,99})//22.Ajustes Positivos de Crditos
		aAdd(aDescr,{STR0044,10})//23.(-)Ajustes Negativos de Crditos
		aAdd(aDescr,{STR0152,99})//24.TOTAL DE CREDITOS APURADOS APOS AJUSTES
		aAdd(aDescr,{STR0080,99})//CREDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS
		aAdd(aDescr,{STR0081,52})//25.Calculados a Alquota de 0,9900%
		aAdd(aDescr,{STR0083,99})//26.Calculados a Alquota de 0,5775%
		aAdd(aDescr,{STR0084,99})//27.Ajustes Positivos de Crditos
		aAdd(aDescr,{STR0085,99})//28.(-)Ajustes Negativos de Crditos
		aAdd(aDescr,{STR0086,99})//29.TOTAL DE CRDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS, APS AJUSTES
		aAdd(aDescr,{STR0089,99})//CREDITOS DECORRENTES DA AQUISICAO DE EMBALAGENS PARA REVENDA
		aAdd(aDescr,{STR0092,99})//30.Crditos Apurados
		aAdd(aDescr,{STR0094,99})//31.Ajustes Positivos de Crditos
		aAdd(aDescr,{STR0095,99})//32.(-)Ajustes Negativos de Crditos
		aAdd(aDescr,{STR0100,99})//33.TOTAL DE CREDITOS DECORRENTES DA AQUISICAO DE EMBALAGENS PARA REVENDA, APOS AJUSTES
		//
		//Descricao das Fichas 07A e 17A       
		//
		aAdd(aDescr1,{STR0101,8})//01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%
		aAdd(aDescr1,{STR0103,9})//02.Demais Receitas - Aliquota de 1,65%
		aAdd(aDescr1,{STR0105,99})//03.TOTAL DA CONTRIBUICAO PARA O PIS/PASEP APURADA A ALIQUOTA DE 1,65%
		aAdd(aDescr1,{STR0082,99})//OUTRAS RECEITAS AUFERIDAS
		aAdd(aDescr1,{STR0107,99})//04.Receita Tributada a Alquota Zero
		aAdd(aDescr1,{STR0108,99})//05.Receita Tributada a Alquota Zero-Revenda Prod. Sujeitos Trib. Monof.
		aAdd(aDescr1,{STR0109,99})//06.Receita de Vendas de Bens do Ativo Permanente
		aAdd(aDescr1,{STR0110,99})//07.Receita sem Incidncia da Contribuio - Exportao
		aAdd(aDescr1,{STR0111,99})//08.Receita Isenta e Demais Receitas sem Incid.Contribuio
		aAdd(aDescr1,{STR0112,99})//09.Receita com Suspenso da Contribuio
		aAdd(aDescr1,{STR0115,99})//10.Receita de Revenda Dec.Operaes Suj.Subs.Tribut.
		aAdd(aDescr1,{STR0116,99})//11.Receita Tributada pelo RET -Patrimnio de Afetao
		aAdd(aDescr1,{STR0117,99})//12.CONTRIBUICAO PARA O PIS/PASEP -FOLHA DE SALARIOS
		//
		//Descricao das Fichas 07B e 17B       
		//
		aAdd(aDescr4,{STR0101,10})//01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%
		aAdd(aDescr4,{STR0103,11})//02.Demais Receitas - Aliquota de 1,65%
		aAdd(aDescr4,{STR0105,99})//03.TOTAL DA CONTRIBUICAO PARA O PIS/PASEP APURADA A ALIQUOTA DE 1,65%
		aAdd(aDescr4,{STR0176,99})//"APURAO DA CONTRIBUIO PARA O PIS/PASEP - REGIME CUMULATIVO"
		aAdd(aDescr4,{STR0177,12})//04.Receita de Vendas de Bens e Servicos - Aliq. 0,65%
		aAdd(aDescr4,{STR0178,13})//05.Demais Receitas - Alq. 0,65%
		aAdd(aDescr4,{STR0179,99})//06.Receita Tributada no Regime de Substituicao Tributaria - Aliq.0,65%
		aAdd(aDescr4,{STR0180,99})//07.TOTAL DA CONTRIBUICAO PARA O PIS/PASEP APURADA A ALIQUOTA DE 0,65%
		aAdd(aDescr4,{STR0082,99})//OUTRAS RECEITAS AUFERIDAS
		aAdd(aDescr4,{STR0181,99})//08.Receita Tributada a Alquota Zero
		aAdd(aDescr4,{STR0182,99})//09.Receita Tributada a Alquota Zero-Revenda Prod. Sujeitos Trib. Monof.
		aAdd(aDescr4,{STR0183,99})//10.Receita de Vendas de Bens do Ativo Permanente
		aAdd(aDescr4,{STR0184,99})//11.Receita sem Incidncia da Contribuio - Exportao
		aAdd(aDescr4,{STR0185,99})//12.Receita Isenta e Demais Receitas sem Incid.Contribuio
		aAdd(aDescr4,{STR0186,99})//13.Receita com Suspenso da Contribuio
		aAdd(aDescr4,{STR0187,99})//14.Receita de Revenda Dec.Operaes Suj.Subs.Tribut.
		aAdd(aDescr4,{STR0188,99})//15.Receita Tributada pelo RET -Patrimnio de Afetao
		aAdd(aDescr4,{STR0189,99})//16.CONTRIBUICAO PARA O PIS/PASEP -FOLHA DE SALARIOS
	Else
		//
		//Descricao das Fichas 08A e 18A       
		//
		aAdd(aDescr3,{STR0118,8})//01.Receita de Vendas de Bens e Servicos - Aliq. 0,65%
		aAdd(aDescr3,{STR0120,9})//02.Demais Receitas - Alq. 0,65%
		aAdd(aDescr3,{STR0122,99})//03.Receita Tributada no Regime de Substituicao Tributaria - Aliq.0,65%
		aAdd(aDescr3,{STR0166,99})//04.TOTAL DA CONTRIBUICAO PARA O PIS/PASEP APURADA A ALIQUOTA DE 0,65%
		aAdd(aDescr3,{STR0082,99})//OUTRAS RECEITAS AUFERIDAS
		aAdd(aDescr3,{STR0126,99})//05.Receita Tributada a Aliquota Zero
		aAdd(aDescr3,{STR0127,99})//06.Receita Tributada a Aliqota Zero-Revenda Prod. Sujeitos Trib. Monof.
		aAdd(aDescr3,{STR0128,99})//07.Receita de Vendas de Bens do Ativo Permanente
		aAdd(aDescr3,{STR0129,99})//08.Receita sem Incidencia da Contribuicao - Exportacao
		aAdd(aDescr3,{STR0130,99})//09.Receita Isenta e Demais Receitas sem Incid.Contribuicao
		aAdd(aDescr3,{STR0131,99})//10.Receita com Suspensao da Contribuicao
		aAdd(aDescr3,{STR0132,99})//11.Receita de Revenda Dec.Operacoes Suj.Subs.Tribut.
		aAdd(aDescr3,{STR0148,99})//12.Receita Tributada pelo RET -Patrimnio de Afetao
		aAdd(aDescr3,{STR0151,99})//13.CONTRIBUICAO PIS/PASEP -FOLHA DE SALARIOS
	Endif
	
	If mv_par13==2
		//Ficha 15A
		aAdd(aDescr15A,{STR0257})
		aAdd(aDescr15A,{STR0258})
		aAdd(aDescr15A,{STR0259})
		aAdd(aDescr15A,{STR0260})
		aAdd(aDescr15A,{STR0261})
		aAdd(aDescr15A,{STR0262})
		aAdd(aDescr15A,{STR0263})
		aAdd(aDescr15A,{STR0264})
		aAdd(aDescr15A,{STR0265})
		aAdd(aDescr15A,{STR0307}) //DEDUES
		aAdd(aDescr15A,{STR0266})
		aAdd(aDescr15A,{STR0267})
		aAdd(aDescr15A,{STR0268})
		aAdd(aDescr15A,{STR0269})
		aAdd(aDescr15A,{STR0270})
		aAdd(aDescr15A,{STR0271})
		aAdd(aDescr15A,{STR0272})
		aAdd(aDescr15A,{STR0273})
		aAdd(aDescr15A,{STR0274})
		aAdd(aDescr15A,{STR0275})
		aAdd(aDescr15A,{STR0276})
		aAdd(aDescr15A,{STR0277})
		aAdd(aDescr15A,{STR0278})
		aAdd(aDescr15A,{STR0279})
		aAdd(aDescr15A,{STR0280})
		//Ficha 25A
	    aAdd(aDescr25A,{STR0313})//01. Cofins Apurada
		aAdd(aDescr25A,{STR0314})//02. Cofins Apurada - Aliquotas Diferenciadas
		aAdd(aDescr25A,{STR0315})//03. Cofins Apurada - Aliquotas Diferenciadas - Sunstituto Tributario
		aAdd(aDescr25A,{STR0316})//04. Cofins Apurada - Aliquotas por Unidade de Medida de Produto
		aAdd(aDescr25A,{STR0317})//05. Cofins Apurada - Aliquotas por Unidade de Medida de Produto - Substituto Tributario
		aAdd(aDescr25A,{STR0318})//06. Cofins Diferida em Meses Anteriores
		aAdd(aDescr25A,{STR0319})//07. (-) Creditos Diferidos em Meses Anteriores
		aAdd(aDescr25A,{STR0320})//08. (-) Cofins Diferida no Mes
		aAdd(aDescr25A,{STR0321})//09. TOTAL DA COFINS APURADA NO MES
		aAdd(aDescr25A,{STR0307})//DEDUCOES
		aAdd(aDescr25A,{STR0322})//10. (-) Cofins Retida na Fonte por Orgaos, Autarquias e Fundacoes Federais
		aAdd(aDescr25A,{STR0323})//11. (-) Cofins Retida na Fonte pelas Demais Entidades da Administracao Publica Federal
		aAdd(aDescr25A,{STR0324})//12. (-) Cofins Retida na Fonte por Pessoas Juridicas de Direito Privado
		aAdd(aDescr25A,{STR0325})//13. (-) Cofins Retida na Fonte por Orgaos, Autarquias e Fundacoes dos Estados, Distrito Federal e Municipios
		aAdd(aDescr25A,{STR0326})//14. (-) Cofins Retida na Fonte por Sociedade Cooperativa
		aAdd(aDescr25A,{STR0327})//15. (-) Cofins Retida na Fonte por Fabricantes de Veiculos e Maquinas
		aAdd(aDescr25A,{STR0328})//16. (-) Cofins Substituio pela no Ocorrencia do Fato Gerador Presumido
		aAdd(aDescr25A,{STR0329})//17. (-)Credito Presumido e Medicamentos
		aAdd(aDescr25A,{STR0330})//18. (-)Creditos Admitidos no Regime Cumulativo
		aAdd(aDescr25A,{STR0331})//19. (-)Cofins Paga pelo Substituto Tributrio
		aAdd(aDescr25A,{STR0332})//20. (-) Outras Deducoes
		aAdd(aDescr25A,{STR0333})//21. COFINS A PAGAR - FATURAMENTO
		aAdd(aDescr25A,{STR0334})//22. COFINS A PAGAR DE SCP
		aAdd(aDescr25A,{STR0335})//23. COFINS A PAGAR RETIDA DE COOPERADOS
		//Ficha 15B
		aAdd(aDescr15B,{STR0257})
		aAdd(aDescr15B,{STR0258})
		aAdd(aDescr15B,{STR0259})
		aAdd(aDescr15B,{STR0260})
		aAdd(aDescr15B,{STR0261})
		aAdd(aDescr15B,{STR0262})
		aAdd(aDescr15B,{STR0311})
		aAdd(aDescr15B,{STR0310})
		aAdd(aDescr15B,{STR0308}) //CRDITOS DESCONTADOS REFERENTES A AQUISIES NO MERCADO INTERNO
		aAdd(aDescr15B,{STR0282})
		aAdd(aDescr15B,{STR0283})
		aAdd(aDescr15B,{STR0284})
		aAdd(aDescr15B,{STR0285})
		aAdd(aDescr15B,{STR0286})
		aAdd(aDescr15B,{STR0309}) //CRDITOS DESCONTADOS REFERENTES A IMPORTAES
		aAdd(aDescr15B,{STR0287})
		aAdd(aDescr15B,{STR0288})
		aAdd(aDescr15B,{STR0289})
		aAdd(aDescr15B,{STR0290})
		aAdd(aDescr15B,{STR0307}) //DEDUES
		aAdd(aDescr15B,{STR0291})
		aAdd(aDescr15B,{STR0292})
		aAdd(aDescr15B,{STR0293})
		aAdd(aDescr15B,{STR0294})
		aAdd(aDescr15B,{STR0295})
		aAdd(aDescr15B,{STR0296})
		aAdd(aDescr15B,{STR0297})
		aAdd(aDescr15B,{STR0298})
		aAdd(aDescr15B,{STR0299})
		aAdd(aDescr15B,{STR0300})
		aAdd(aDescr15B,{STR0301})
		aAdd(aDescr15B,{STR0302})
		aAdd(aDescr15B,{STR0303})
		aAdd(aDescr15B,{STR0304})
		aAdd(aDescr15B,{STR0305}) 
		//Ficha 25B 
		aAdd(aDescr25B,{STR0313})//01. Cofins Apurada  
		aAdd(aDescr25B,{STR0314})//02. Cofins Apurada - Aliquotas Diferenciadas
		aAdd(aDescr25B,{STR0315})//03. Cofins Apurada - Aliquotas Diferenciadas - Sunstituto Tributario
		aAdd(aDescr25B,{STR0316})//04. Cofins Apurada - Aliquotas por Unidade de Medida de Produto
		aAdd(aDescr25B,{STR0317})//05. Cofins Apurada - Aliquotas por Unidade de Medida de Produto - Substituto Tributario
		aAdd(aDescr25B,{STR0318})//06. Cofins Diferida em Meses Anteriores
		aAdd(aDescr25B,{STR0338})//07. (-) Cofins Diferida no Mes
		aAdd(aDescr25B,{STR0339})//08. TOTAL DA COFINS APURADA NO MES
		aAdd(aDescr25B,{STR0308})//Creditos descontados referentes a aquisicoes no mercado interno
		aAdd(aDescr25B,{STR0282})//09. (-)Vinculados  Receita Tributada no Mercado Interno
		aAdd(aDescr25B,{STR0283})//10. (-) Vinculados  Receita No Tributada no Mercado Interno
		aAdd(aDescr25B,{STR0284})//11. (-) Vinculados  Receita de Exportao
		aAdd(aDescr25B,{STR0285})//12. (-) Presumido - Atividades Agroindustriais
		aAdd(aDescr25B,{STR0286})//13. (-) Vinculados a Embalagens para Revend
		aAdd(aDescr25B,{STR0309})//Creditos descontados referentes a importacoes
		aAdd(aDescr25B,{STR0287})//14. (-) Vinculados  Receita Tributada no Mercado Interno
		aAdd(aDescr25B,{STR0288})//15. (-) Vinculados a Receita no Tributada no Mercado Interno
		aAdd(aDescr25B,{STR0289})//16. (-) Vinculados  Receita de Exportao
		aAdd(aDescr25B,{STR0340})//17. TOTAL DA CONTRIBUIO DEVIDA NO MS
		aAdd(aDescr25B,{STR0307})//Deducoes
		aAdd(aDescr25B,{STR0341})//18. (-) Cofins Retida na Fonte por rgos, Autarquias e Fundaes Federais
		aAdd(aDescr25B,{STR0342})//19. (-) Cofins Retida na Fonte pelas Demais Entidades da Administrao Pblica Federal
		aAdd(aDescr25B,{STR0343})//20. (-) Cofins Retida na Fonte por Pessoas Jurdicas de Direito Privado
		aAdd(aDescr25B,{STR0344})//21. (-) Cofins Retida na Fonte por rgos, Autarquias e Fundaes dos Estados, Distrito Federal e Municpios
		aAdd(aDescr25B,{STR0345})//22. (-) Cofins Retida na Fonte por Sociedade Cooperativa
		aAdd(aDescr25B,{STR0346})//23. (-) Cofins Retida na Fonte por Fabricantes de Veculos e Mquinas
		aAdd(aDescr25B,{STR0347})//24. (-) Cofins Substituio pela no Ocorrncia do Fato Gerador Presumido
		aAdd(aDescr25B,{STR0348})//25. (-) Crdito Presumido  Medicamentos
		aAdd(aDescr25B,{STR0349})//26. (-) Crditos Admitidos no Regime Cumulativo
		aAdd(aDescr25B,{STR0350})//27. (-) Cofins Paga pelo Substituto Tributrio
		aAdd(aDescr25B,{STR0351})//28. (-) Outras Dedues 	
		aAdd(aDescr25B,{STR0352})//29. COFINS A PAGAR  FATURAMENTO
		aAdd(aDescr25B,{STR0353})//30. COFINS A PAGAR DE SCP
		aAdd(aDescr25B,{STR0354})//31.	COFINS A PAGAR RETIDA DE COOPERADOS	
	Endif		
	
	If mv_par09==2
		//
		//Descricao das Fichas 06B e 16B       
		//
		aAdd(aDescr06B,{STR0012,3})  //01.Bens para Revenda
		aAdd(aDescr06B,{STR0013,4})  //02.Bens Utilizados como Insumos
		aAdd(aDescr06B,{STR0014,6})  //03.Servicos Utilizados como Insumos
		aAdd(aDescr06B,{STR0015,5})  //04.Despesas de Energia Eletrica
		aAdd(aDescr06B,{STR0225,20}) //"05.Despesas de Alugueis de Predios"
		aAdd(aDescr06B,{STR0226,99}) //"06.Sobre Bens do Ativo Imobilizado(Com Base nos Encargos de Depreciao)"
		aAdd(aDescr06B,{STR0227,99}) //"07.Sobre Bens do Ativo Imobilizado(Com Base no Valor de Aquisio)"
		aAdd(aDescr06B,{STR0228,22}) //"08.Outras Operacoes com Direito a Credito"
		aAdd(aDescr06B,{STR0229,99}) //"09.BASE DE CALCULO DOS CREDITOS"
		aAdd(aDescr06B,{STR0230,99}) //"10.Creditos a Descontar"
		aAdd(aDescr06B,{STR0027,99}) //APURACAO DE OUTROS CREDITOS
		aAdd(aDescr06B,{STR0231,1})  //"11.Creditos Calculados a Aliquotas Diferenciadas"
		aAdd(aDescr06B,{STR0232,99}) //"12.Creditos Calculados por Unidade de Medida de Produto"
		aAdd(aDescr06B,{STR0252,99}) //"13.Credito presumido Relat. Estoque de Abertura - Alcool"
		aAdd(aDescr06B,{STR0233,99}) //"14.Creditos da Atividade Imobiliria"
		aAdd(aDescr06B,{STR0234,99}) //"15.Outros Creditos a Descontar"
		aAdd(aDescr06B,{STR0235,99}) //"16.Ajustes Positivos de Creditos"
		aAdd(aDescr06B,{STR0236,10}) //"17.(-)Ajustes Negativos de Creditos"
		aAdd(aDescr06B,{STR0237,99}) //"18.TOTAL DE CREDITOS APURADOS APOS AJUSTES"
	EndIf
	
	For nI := 1 to nPosMes 
	//Ŀ
	//REGIME NAO CUMULATIVO e AMBOS					  	
	//
		If mv_par06==2 .Or. mv_par06==3 // Regime Nao Cumulativo e Ambos
			For nY:= 1 To 4
				//Ŀ
				//Apuracao - Painel 1 - Regime Nao Cumulativo  
				//
				nTotVlMI :=0
				nTotVlMI += aMes[nI][2][3][1]+aMes[nI][2][4][1]+aMes[nI][2][6][1]+aMes[nI][2][5][1]+aMes[nI][2][20][1]+aMes[nI][2][21][1]+aMes[nI][2][22][1]+aMes[nI][2][23][1]+aMercado[01][01]+aMercado[02][01]+aMercado[03][01]+nBsCrdAqI+nVDeprAt
				nTotVlEX :=0	
				nTotVlEX += aMes[nI][2][3][2]+aMes[nI][2][4][2]+aMes[nI][2][6][2]+aMes[nI][2][5][2]+aMes[nI][2][20][2]+aMes[nI][2][21][2]+aMes[nI][2][22][2]+aMes[nI][2][23][2]+aMercado[01][03]+aMercado[02][03]+aMercado[03][03]+nBsCrdAqE+nVDeprAt
				nTotVlNTr :=0
				nTotVlNTr +=aMes[nI][2][3][3]+aMes[nI][2][4][3]+aMes[nI][2][6][3]+aMes[nI][2][5][3]+aMes[nI][2][20][3]+aMes[nI][2][21][3]+aMes[nI][2][22][3]+aMes[nI][2][23][3]+aMercado[01][02]+aMercado[02][02]+aMercado[03][02]
				
				//Ŀ
				//Calcula o percentual em relacao ao total faturado de vendas ao mercado
				//interno e vendas ao mercado externo.                                  
				//
				If aMes[nI][2][17][1] <> 0 .Or. aMes[nI][2][18][1] <> 0 .Or. aMes[nI][2][36][1] <> 0
					nPercInt := aMes[nI][2][17][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
					nPercExt := aMes[nI][2][18][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
					nPercNTr := aMes[nI][2][36][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
				Else                                  
			       	nPercInt := 1 
			       	nPercNTr := 1
			       	nPercExt := 1
				Endif
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
		   		oReport:EndPage()
	
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()	
	
				If nY == 1 .Or. nY == 3 //Ficha 06A ou Ficha 16A
			    	oReport:SkipLine()
					oReport:PrintText(IIF(nY==1,STR0133,STR0155))
					oReport:SkipLine()
					oReport:Section(2):Cell("MOVIMENTO"):SetTitle(IIF(nY==1,STR0134+" 1,65% ",STR0134+" 7,6% "))
				ElseIf nY == 2 .Or. nY == 4 // Ficha 07A ou Ficha 17A // Ficha 07B ou 17B
					oReport:SkipLine()
					If mv_par06==2
						// Ficha 07A ou Ficha 17A
						oReport:PrintText(IIF(nY==2,STR0153,STR0156))
						oReport:Section(3):Cell("MOVIMENTO"):SetTitle(IIF(nY==2,STR0099,STR0124))
					Elseif mv_par06==3
						// Ficha 07B ou Ficha 17B
						oReport:PrintText(IIF(nY==2,STR0173,STR0174))
						oReport:Section(6):Cell("MOVIMENTO"):SetTitle(IIF(nY==2,STR0191,STR0192))
					Endif
					oReport:SkipLine()
				Endif
				
				If oReport:Cancel()
					Exit
				EndIf
			                          
				If (nY == 1 .Or. nY == 3)
			
					For nX := 1 to Len(aDescr)
						cMovimento 	:= aDescr[nX,1]
						oReport:Section(2):Init()
						oReport:Section(2):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
						oReport:Section(2):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('08,11,17,18,19,20,21,22,26,27,28,29,30,31,32,33'),"------------------",nValor1)})
						oReport:Section(2):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('08,11,17,18,19,20,21,22,26,27,28,29,30,31,32,33'),"------------------",nValor2)})
						oReport:Section(2):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('08,11,17,18,19,20,21,22,26,27,28,29,30,31,32,33'),"------------------",nValor3)})
					
						If Substr(cMovimento,1,2) $('08,11,17,18,19,20,21,22,26,27,28,29,31,32,33')
	  						oReport:Section(2):Cell("VAL01"):SetPicture ("@!")
	  						oReport:Section(2):Cell("VAL02"):SetPicture ("@!")
		  					oReport:Section(2):Cell("VAL03"):SetPicture ("@!")
		  				Elseif Substr(cMovimento,1,2) == "09"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@!")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
	  						nValor1	:= nVDeprAt*nPercInt
	  						nValor2	:= "------------------"
							nValor3	:= nVDeprAt*nPercExt	
		    	        Elseif Substr(cMovimento,1,2) == "10"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
	  						nValor1	:= nBsCrdAqI*nPercInt
	  						nValor2	:= nBsCrdAqI*nPercNTr
							nValor3	:= nBsCrdAqE*nPercExt
						Elseif Substr(cMovimento,1,2) == "12"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							cMovimento := IIF(nY==1,STR0142+"1,65%",STR0142+"7,6%")
							nValor1	:= aMes[nI][2][aDescr[nX,2]][1]
							nValor2 := nNTrib
							nValor3	:= aMes[nI][2][aDescr[nX,2]][2]
						Elseif Substr(cMovimento,1,2) == "13"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= (aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt
							nValor2 := (aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr
							nValor3	:= (aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt
						Elseif Substr(cMovimento,1,2) == "14"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
	  						nValor1	:= ((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1]
	  						nValor2 := ((nTotVlNTr+nVAgrDes)*nPercNTr)+nNTrib
							nValor3	:= ((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2]
						Elseif Substr(cMovimento,1,2) == "15"
	   						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							cMovimento := IIF(nY==1,STR0145+"  Alquota de 1,65%",STR0145+"  Alquota de 7,6%")
	  						nValor1	:= (((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076))   
	  						nValor2 := (((nTotVlNTr+nVAgrDes)*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076))
 							nValor3	:= (((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076))
						Elseif cMovimento == STR0027 //"APURACAO DE OUTROS CREDITOS"
	   						oReport:Section(2):Cell("VAL01"):Disable()
							oReport:Section(2):Cell("VAL02"):Disable()     
							oReport:Section(2):Cell("VAL03"):Disable()
							oReport:SkipLine()
						Elseif Substr(cMovimento,1,2) == "16"
							oReport:Section(2):Cell("VAL01"):Enable()
							oReport:Section(2):Cell("VAL02"):Enable()
							oReport:Section(2):Cell("VAL03"):Enable()
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
		  					If nY==1
			  					nValor1	:= (aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt
			  					nValor2	:= (aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr
								nValor3	:= (aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt
							Elseif nY==3
			  					nValor1	:= (aMes[nI][2][aDescr[nX,3]][1]+aMes[nI][2][aDescr[nX,3]][2])*nPercInt
			  					nValor2	:= (aMes[nI][2][aDescr[nX,3]][3]+aMes[nI][2][aDescr[nX,3]][2])*nPercNTr
								nValor3	:= (aMes[nI][2][aDescr[nX,3]][2]+aMes[nI][2][aDescr[nX,3]][2])*nPercExt
							Endif
							oReport:SkipLine()
						Elseif Substr(cMovimento,1,2) == "23"
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)*(IIF(nY==1,0.0165,0.076))
							nValor2	:= ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
							nValor3	:= ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)*(IIF(nY==1,0.0165,0.076))
							nAjusMI	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)*(IIF(nY==1,0.0165,0.076))
							nAjusNT := ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
							nAjusEX := ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)*(IIF(nY==1,0.0165,0.076))
						Elseif Substr(cMovimento,1,2) == "24"
						    If nY==1
								nToCreMI := ((((((nTotVlMI+nVAgrDes))*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][1]))-nAjusMI
								nToCreNT := ((((((nTotVlNTr+nVAgrDes))*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][3]))-nAjusNT
			 					nToCreEX := ((((((nTotVlEX+nVAgrDes))*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][2]))-nAjusEX					
							Elseif 	nY==3
			 					nToCreMI := ((((((nTotVlMI+nVAgrDes))*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][1]))-nAjusMI
		 						nToCreNT := ((((((nTotVlNTr+nVAgrDes))*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][3]))-nAjusNT
		 						nToCreEX := ((((((nTotVlEX+nVAgrDes))*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][2]))-nAjusEX
							Endif
	   						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
	  						nValor1	:= nToCreMI
	  						nValor2 := nToCreNT
							nValor3	:= nToCreEX
					   Elseif cMovimento == STR0080 //"CRDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS"
							oReport:Section(2):Cell("VAL01"):Disable()
							oReport:Section(2):Cell("VAL02"):Disable()
							oReport:Section(2):Cell("VAL03"):Disable()
							oReport:SkipLine() 	   	
					   	Elseif Substr(cMovimento,1,2) == "25"
				  			oReport:Section(2):Cell("VAL01"):Enable()
							oReport:Section(2):Cell("VAL02"):Enable()
							oReport:Section(2):Cell("VAL03"):Enable()
							oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							cMovimento := IIF(nY==1,STR0081,STR0171)
	  				   		nValor1	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)*(IIF(nY==1,0.0099,0.0456))
							nValor2	:= ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)*(IIF(nY==1,0.0099,0.0456))
							nValor3	:= ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)*(IIF(nY==1,0.0099,0.0456)) 
	  						oReport:SkipLine()    					              
	  				   	Elseif cMovimento == STR0089 //"CRDITOS DECORRENTES DA AQUISIO DE EMBALAGENS PARA REVENDA"
							oReport:Section(2):Cell("VAL01"):Disable()
							oReport:Section(2):Cell("VAL02"):Disable()
							oReport:Section(2):Cell("VAL03"):Disable()
							oReport:SkipLine()
						Elseif Substr(cMovimento,1,2) == "30"
							oReport:Section(2):Cell("VAL01"):Enable()
							oReport:Section(2):Cell("VAL02"):Enable()
							oReport:Section(2):Cell("VAL03"):Enable()
			  				oReport:Section(2):Cell("VAL02"):SetPicture ("@!")
			  				oReport:Section(2):Cell("VAL02"):SetPicture ("@!")
		  					oReport:Section(2):Cell("VAL02"):SetPicture ("@!")
	  						oReport:SkipLine()
	  					Elseif Substr(cMovimento,1,2) == "04" 
	  						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
			   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)+aMercado[01][01]
							nValor2 := ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)+aMercado[01][02]
							nValor3	:= ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)+aMercado[01][03]	
	  					Elseif Substr(cMovimento,1,2) == "05" 
	  						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
			   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)+aMercado[02][01]
							nValor2 := ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)+aMercado[02][02]
							nValor3	:= ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)+aMercado[02][03]
						Elseif Substr(cMovimento,1,2) == "06" 
	  						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
			   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= ((aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt)+aMercado[03][01]
							nValor2 := ((aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr)+aMercado[03][02]
							nValor3	:= ((aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt)+aMercado[03][03]				
					  	Elseif Substr(cMovimento,1,2) == "01" 
	  						oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
			   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= aMes[nI][2][aDescr[nX,2]][1]
							nValor2 := aMes[nI][2][aDescr[nX,2]][3]
							nValor3	:= aMes[nI][2][aDescr[nX,2]][2]	   		
						Else
			   				oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
			   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
							oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
							nValor1	:= (aMes[nI][2][aDescr[nX,2]][1]+aMes[nI][2][aDescr[nX,2]][2])*nPercInt
							nValor2 := (aMes[nI][2][aDescr[nX,2]][3]+aMes[nI][2][aDescr[nX,2]][2])*nPercNTr
							nValor3	:= (aMes[nI][2][aDescr[nX,2]][2]+aMes[nI][2][aDescr[nX,2]][2])*nPercExt
						Endif
						oReport:Section(2):PrintLine()
					Next
				Else // Calculo Pis/Cofins- 2painel (Regime Nao Cumulativo + Regime Cumulativo)
                    If mv_par06==2 //Regime Nao Cumulativo
						For nX := 1 to Len(aDescr1)
							cMovimento 	:= aDescr1[nX,1]
							oReport:Section(3):Init()          
							oReport:Section(3):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
								oReport:Section(3):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('12'),"------------------",nValor1)})
							If lPisFolha .Or. lPisFolSN
						    	oReport:Section(3):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('05,07,08,09,10,11'),"------------------",nValor2)})
							    oReport:Section(3):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('05,07,08,09,10,11'),"------------------",nValor3)})
	                        Else
						    	oReport:Section(3):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('05,07,08,09,10,11,12'),"------------------",nValor2)})
							    oReport:Section(3):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('05,07,08,09,10,11,12'),"------------------",nValor3)})
	                        Endif
							If Substr(cMovimento,1,2) == "01"
								oReport:Section(3):Cell("VAL01"):Enable()
								oReport:Section(3):Cell("VAL02"):Enable()
								oReport:Section(3):Cell("VAL03"):Enable()
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0101,STR0102) //Receita de Vendas
								nValor1	:= aMes[nI][2][8][1]+ nRecVen
								nValor2	:= ((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))
								nValor3 := (((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
								nCont1 := (((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
							Elseif Substr(cMovimento,1,2)== "02"
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0103,STR0104) //Demais Receitas
								nValor1	:= aMes[nI][2][9][1]+nOutRecN
								nValor2	:= (aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1])
								nValor3 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
								nCont2 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
							Elseif Substr(cMovimento,1,2) == '03'
								cMovimento :=IIF(nY==2,STR0105,STR0106)
								oReport:Section(3):Cell("VAL01"):SetPicture("@!")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								nValor1	:= ""
								nValor2	:= ""
								nValor3 := nCont1+nCont2
					 		Elseif cMovimento == STR0082 //"OUTRAS RECEITAS AUFERIDAS"
								oReport:Section(3):Cell("VAL01"):Disable()
								oReport:Section(3):Cell("VAL02"):Disable()
								oReport:Section(3):Cell("VAL03"):Disable()
								oReport:SkipLine()
							Elseif Substr(cMovimento,1,2) == '04'       
								oReport:Section(3):Cell("VAL01"):Enable()
								oReport:Section(3):Cell("VAL02"):Enable()
								oReport:Section(3):Cell("VAL03"):Enable()
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][29][1]
								nValor2 := "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '05'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][30][1]+ aRecAuf[2]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '06'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][31][1]+ aRecAuf[3]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '07'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][27][1]+ aRecAuf[4]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '08'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][32][1]+ aRecAuf[5]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '09'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][33][1]+ aRecAuf[6]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '10'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][34][1] + aRecAuf[7]
								nValor2	:= "------------------"
								nValor3 := "------------------"
							Elseif Substr(cMovimento,1,2) == '11'
								oReport:Section(3):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(3):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(3):Cell("VAL03"):SetPicture("@!")
								nValor1	:= aMes[nI][2][35][1]+ aRecAuf[8]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					Elseif Substr(cMovimento,1,2) == "12"
								If (nY==2) //Pis      
									oReport:SkipLine()
									oReport:Section(3):Cell("MOVIMENTO"):Enable()
	   							    oReport:Section(3):Cell("VAL01"):Enable()
									oReport:Section(3):Cell("VAL02"):Enable()
									oReport:Section(3):Cell("VAL03"):Enable()
				  					oReport:Section(3):Cell("VAL01"):SetPicture ("@!")
					  				If lPisFolha .Or. lPisFolSN
					  			   	    oReport:Section(3):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")  // ("@!")
					  				    oReport:Section(3):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")  //("@!")
    								    nValor1	:= "------------------"
		    						    nValor2	:= aMes[nI][2][36][2]
			    					    nValor3 := nValor2*0.01
			    					Else
					  			   	    oReport:Section(3):Cell("VAL02"):SetPicture ("@!")
					  				    oReport:Section(3):Cell("VAL03"):SetPicture ("@!")
    								    nValor1	:= "------------------"
		    						    nValor2	:= "------------------"
			    					    nValor3 := "------------------"
			    					Endif    
						  		Else
							  		oReport:Section(3):Cell("MOVIMENTO"):Disable()
					   				oReport:Section(3):Cell("VAL01"):Disable()
									oReport:Section(3):Cell("VAL02"):Disable()
									oReport:Section(3):Cell("VAL03"):Disable()
		       	    		    Endif 
						    Endif             
							oReport:Section(3):PrintLine()
						Next
					Elseif mv_par06==3 //Ambos (Regime Nao Cumulativo e Cumulativo)
						For nX := 1 to Len(aDescr4)
							cMovimento 	:= aDescr4[nX,1]
							oReport:Section(6):Init()
							oReport:Section(6):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
							If lPisFolha .Or. lPisFolSN
					    		oReport:Section(6):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06'),"------------------",nValor1)})
						    	oReport:Section(6):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06'),"------------------",nValor2)})
							    oReport:Section(6):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06'),"------------------",nValor3)})
							Else
					    		oReport:Section(6):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,16'),"------------------",nValor1)})
						    	oReport:Section(6):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,16'),"------------------",nValor2)})
							    oReport:Section(6):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,16'),"------------------",nValor3)})
							EndIf
							//
							// Regime Nao Cumulativo	                            
                            //
							If Substr(cMovimento,1,2) == "01"
								oReport:Section(6):Cell("VAL01"):Enable()
								oReport:Section(6):Cell("VAL02"):Enable()
								oReport:Section(6):Cell("VAL03"):Enable()
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0101,STR0102) //Receita de Vendas
								nValor1	:= aMes[nI][2][8][1]+ nRecVen
								nValor2	:= ((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))
								nValor3 := (((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
								nCont1 := (((aMes[nI][2][8][1]+ nRecVen)-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
							Elseif Substr(cMovimento,1,2)== "02"
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0103,STR0104) //Demais Receitas
								nValor1	:= aMes[nI][2][9][1]+nOutRecN
								nValor2	:= (aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1])
								nValor3 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
								nCont2 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
							Elseif Substr(cMovimento,1,2)== "03"
								cMovimento :=IIF(nY==2,STR0105,STR0106)
								oReport:Section(6):Cell("VAL01"):SetPicture("@!")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								nValor1	:= ""
								nValor2	:= ""
								nValor3 := nCont1+nCont2
							//
							// Regime Cumulativo
                            //
					 		Elseif cMovimento == STR0176
						 		cMovimento :=IIF(nY==2,STR0176,STR0190)
								oReport:Section(6):Cell("VAL01"):Disable()
								oReport:Section(6):Cell("VAL02"):Disable()
								oReport:Section(6):Cell("VAL03"):Disable()
								oReport:SkipLine(2)
							Elseif Substr(cMovimento,1,2) == "04"
								oReport:Section(6):Cell("VAL01"):Enable()
								oReport:Section(6):Cell("VAL02"):Enable()
								oReport:Section(6):Cell("VAL03"):Enable()
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0177,STR0194) //Receita de Vendas
								nValor1	:= aMes[nI][2][12][1]+ nRecVen
								nValor2	:= ((aMes[nI][2][12][1]+ nRecVen)-(aMes[nI][2][14][1]+aMes[nI][2][25][1]))
								nValor3 := (((aMes[nI][2][12][1]+ nRecVen)-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==2,0.0065,0.03)
								nCont1 := (((aMes[nI][2][12][1]+ nRecVen)-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==2,0.0065,0.03)
							Elseif Substr(cMovimento,1,2)== "05"
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								cMovimento :=IIF(nY==2,STR0178,STR0196) //Demais Receitas
								nValor1	:= aMes[nI][2][13][1]+nOutRecC
								nValor2	:= (aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1])
								nValor3 := ((aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==2,0.0065,0.03)
								nCont2 := ((aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==2,0.0065,0.03)
							Elseif Substr(cMovimento,1,2)== "06"
								cMovimento :=IIF(nY==2,STR0179,STR0193)
				  				oReport:Section(6):Cell("VAL01"):SetPicture ("@!")
				  				oReport:Section(6):Cell("VAL02"):SetPicture ("@!")
					  			oReport:Section(6):Cell("VAL03"):SetPicture ("@!")
							Elseif Substr(cMovimento,1,2)== "07"
								cMovimento :=IIF(nY==2,STR0180,STR0195)
								oReport:Section(6):Cell("VAL01"):SetPicture("@!")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
								nValor1	:= ""
								nValor2	:= ""
								nValor3 := nCont1+nCont2
					 		Elseif cMovimento == STR0082 //"OUTRAS RECEITAS AUFERIDAS"
								oReport:Section(6):Cell("VAL01"):Disable()
								oReport:Section(6):Cell("VAL02"):Disable()
								oReport:Section(6):Cell("VAL03"):Disable()
								oReport:SkipLine(2)
		  					ElseIf Substr(cMovimento,1,2) = '08'
								oReport:Section(6):Cell("VAL01"):Enable()
								oReport:Section(6):Cell("VAL02"):Enable()
								oReport:Section(6):Cell("VAL03"):Enable()
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
								nValor1 := aMes[nI][2][29][1] 
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '09'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!") 
								nValor1 := aMes[nI][2][30][1]+ aRecAuf[2]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '10'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
 								oReport:Section(6):Cell("VAL03"):SetPicture("@!") 
   							    nValor1 := aMes[nI][2][31][1]+ aRecAuf[3]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '11'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
 							    nValor1 := aMes[nI][2][27][1]+ aRecAuf[4]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '12'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
  							    nValor1 := aMes[nI][2][32][1]+ aRecAuf[5]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '13'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
							    nValor1 := aMes[nI][2][33][1]+ aRecAuf[6]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '14'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
								nValor1 := aMes[nI][2][34][1]+ aRecAuf[7]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					ElseIf Substr(cMovimento,1,2) = '15'
								oReport:Section(6):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
								oReport:Section(6):Cell("VAL02"):SetPicture("@!") 
								oReport:Section(6):Cell("VAL03"):SetPicture("@!")
								nValor1 := aMes[nI][2][35][1]+ aRecAuf[8]
								nValor2	:= "------------------"
								nValor3 := "------------------"
		  					Elseif Substr(cMovimento,1,2) == "16"
								If (nY==2) //Pis      
									oReport:SkipLine()
									oReport:Section(6):Cell("MOVIMENTO"):Enable()
	   								oReport:Section(6):Cell("VAL01"):Enable()
									oReport:Section(6):Cell("VAL02"):Enable()
									oReport:Section(6):Cell("VAL03"):Enable()
			  			            If lPisFolha .Or. lPisFolSN
			  					    	oReport:Section(6):Cell("VAL01"):SetPicture ("@!")
					  				    oReport:Section(6):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
					  				    oReport:Section(6):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
										nValor1 := "------------------"
								        nValor2	:= aMes[nI][2][36][2]
								        nValor3 := aMes[nI][2][36][2]*0.01
			  			            Else
			  					    	oReport:Section(6):Cell("VAL01"):SetPicture ("@!")
					  				    oReport:Section(6):Cell("VAL02"):SetPicture ("@!")
					  				    oReport:Section(6):Cell("VAL03"):SetPicture ("@!")
						  		    EndIf
						  		Else
							  		oReport:Section(6):Cell("MOVIMENTO"):Disable()
					   				oReport:Section(6):Cell("VAL01"):Disable()
									oReport:Section(6):Cell("VAL02"):Disable()
									oReport:Section(6):Cell("VAL03"):Disable()
	       	    		    	Endif 
						    Endif             
							oReport:Section(6):PrintLine()
						Next
					Endif
				Endif
				oReport:Section(2):Finish()
				oReport:Section(3):Finish()
				oReport:Section(6):Finish()
		 	Next                
	//Ŀ
	//REGIME CUMULATIVO 							    	
	//
		Else
			For nY:= 1 To 2
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
		   		oReport:EndPage()
	    		
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()
		
				If nY == 1 // Pis
	  			    oReport:SkipLine()
					oReport:PrintText(STR0098)
					oReport:SkipLine()
					oReport:Section(5):Cell("MOVIMENTO"):SetTitle(STR0099)
	 			Else // Cofins
					oReport:SkipLine()
					oReport:PrintText(STR0123)
					oReport:Section(5):Cell("MOVIMENTO"):SetTitle(STR0124)
					oReport:SkipLine()
				Endif
				
				If oReport:Cancel()
					Exit
				EndIf
				                          
				For nX := 1 to Len(aDescr3)
					cMovimento 	:= aDescr3[nX,1]
					
					oReport:Section(5):Init()
					oReport:Section(5):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					If lPisFolha .Or. lPisFolSN
					    oReport:Section(5):Cell("VAL01"):SetBlock({||nValor1})   
					    oReport:Section(5):Cell("VAL02"):SetBlock({||nValor2})   
					    oReport:Section(5):Cell("VAL03"):SetBlock({||nValor3})   					    
					Else
					    oReport:Section(5):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('13'),"------------------",nValor1)})
					    oReport:Section(5):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('13'),"------------------",nValor2)})
					    oReport:Section(5):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('13'),"------------------",nValor3)})
					EndIf
					oReport:Section(5):Cell("VAL01"):Enable()
					oReport:Section(5):Cell("VAL02"):Enable()
					oReport:Section(5):Cell("VAL03"):Enable()
						
					If Substr(cMovimento,1,2) == "01"
						oReport:Section(5):Cell("VAL01"):Enable()
						oReport:Section(5):Cell("VAL02"):Enable()
						oReport:Section(5):Cell("VAL03"):Enable()
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
						cMovimento :=IIF(nY==1,STR0118,STR0119) //Receita de Vendas
						nValor1	:= aMes[nI][2][8][2]+ nRecVen
						nValor2	:= ((aMes[nI][2][8][2]+ nRecVen)-(aMes[nI][2][19][2]+aMes[nI][2][15][2]))
						nValor3 := (((aMes[nI][2][8][2]+ nRecVen)-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*IIF(nY==1,0.0065,0.03)
						nCont1 := (((aMes[nI][2][8][2]+ nRecVen)-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*IIF(nY==1,0.0065,0.03)
					Elseif Substr(cMovimento,1,2)== "02"
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
						cMovimento :=IIF(nY==1,STR0120,STR0121) //Demais Receitas
						nValor1	:= aMes[nI][2][9][2]+nOutRecC
						nValor2	:= (aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2])
						nValor3 := ((aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*IIF(nY==1,0.0065,0.03)
						nCont2 := ((aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*IIF(nY==1,0.0065,0.03)
					Elseif Substr(cMovimento,1,2)== "03"
						cMovimento :=IIF(nY==1,STR0122,STR0170)
		  				oReport:Section(5):Cell("VAL01"):SetPicture ("@!")
		  				oReport:Section(5):Cell("VAL02"):SetPicture ("@!")
			  			oReport:Section(5):Cell("VAL03"):SetPicture ("@!")
					Elseif Substr(cMovimento,1,2) == '04'
						cMovimento :=IIF(nY==1,STR0166,STR0167)
						oReport:Section(5):Cell("VAL01"):SetPicture("@!")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@E 99,999,999,999.99")
						nValor1	:= ""
						nValor2	:= ""
						nValor3 := nCont1+nCont2
			 		Elseif cMovimento == STR0082 //"OUTRAS RECEITAS AUFERIDAS"
						oReport:Section(5):Cell("VAL01"):Disable()
						oReport:Section(5):Cell("VAL02"):Disable()
						oReport:Section(5):Cell("VAL03"):Disable()
  						oReport:SkipLine()
					Elseif Substr(cMovimento,1,2) == '05'
						oReport:Section(5):Cell("VAL01"):Enable()
						oReport:Section(5):Cell("VAL02"):Enable()
						oReport:Section(5):Cell("VAL03"):Enable()
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][29][2] + aRecAuf[1]
						nValor2	:= "------------------"
						nValor3 := "------------------"
						oReport:SkipLine()
					Elseif Substr(cMovimento,1,2) == '06'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][30][2]+ aRecAuf[2]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '07'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][31][2]+ aRecAuf[3]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '08'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][27][2]+ aRecAuf[4]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '09'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][32][2]+ aRecAuf[5]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '10'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][33][2]+ aRecAuf[6]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '11'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][34][2]+ aRecAuf[7]
						nValor2	:= "------------------"
						nValor3 := "------------------"
					Elseif Substr(cMovimento,1,2) == '12'
						oReport:Section(5):Cell("VAL01"):SetPicture("@E 99,999,999,999.99")
						oReport:Section(5):Cell("VAL02"):SetPicture("@!") 
						oReport:Section(5):Cell("VAL03"):SetPicture("@!") 
						nValor1	:= aMes[nI][2][35][2]+ aRecAuf[8]
						nValor2	:= "------------------"
						nValor3 := "------------------"
  					Elseif Substr(cMovimento,1,2) == "13"
						If (nY==1) //Pis
							oReport:SkipLine()
							oReport:Section(5):Cell("MOVIMENTO"):Enable()
   							oReport:Section(5):Cell("VAL01"):Enable()
							oReport:Section(5):Cell("VAL02"):Enable()
							oReport:Section(5):Cell("VAL03"):Enable()
							If lPisFolha .Or. lPisFolSN
		  					    oReport:Section(5):Cell("VAL01"):SetPicture ("@!")
			  				    oReport:Section(5):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
			  				    oReport:Section(5):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
								nValor1	:= "------------------"
    							nValor2	:= aMes[nI][2][36][2]
								nValor3 := nValor2*0.01       
							Else
		  					    oReport:Section(5):Cell("VAL01"):SetPicture ("@!")
			  				    oReport:Section(5):Cell("VAL02"):SetPicture ("@!")
			  				    oReport:Section(5):Cell("VAL03"):SetPicture ("@!")
				  		    EndIf
				  		Else
					  		oReport:Section(5):Cell("MOVIMENTO"):Disable()
			   				oReport:Section(5):Cell("VAL01"):Disable()
							oReport:Section(5):Cell("VAL02"):Disable()
							oReport:Section(5):Cell("VAL03"):Disable()
       	    		    Endif 
				    Endif             
					oReport:Section(5):PrintLine()
				Next    
				oReport:Section(5):Finish()
			Next
			oReport:SkipLine()
			oReport:ThinLine()
			oReport:IncMeter()
		Endif
		
	//
	//FICHA 06B/16B - NAO CUMULATIVO - IMPORTACAO  
	//
		If mv_par09==2 .And. Len(aMes[nI])>=3
			For nY:= 1 To 2

				nTotVlMI :=0    
  			    nTotVlMI += aMes[nI][3][3][1]+aMes[nI][3][4][1]+aMes[nI][3][6][1]+aMes[nI][3][5][1]+aMes[nI][3][20][1]+aMes[nI][3][22][1]+nBsCrdAqI+nVDeprAt			   
				
				//Ŀ
				//Calcula o percentual em relacao ao total faturado de vendas ao mercado
				//interno e vendas ao mercado externo.                                  
				//
				If aMes[nI][2][17][1] <> 0 .Or. aMes[nI][2][18][1] <> 0 .Or. aMes[nI][2][36][1] <> 0
					nPercInt := aMes[nI][2][17][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
					nPercExt := aMes[nI][2][18][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
					nPercNTr := aMes[nI][2][36][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
				Else                                  
			       	nPercInt := 1
	       			nPercExt := 0
	     		  	nPercNTr := 0
				Endif
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
		   		oReport:EndPage()
	
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()	
	
		    	oReport:SkipLine()
				oReport:PrintText(IIF(nY==1,STR0238,STR0239)) //"Ficha 06B - Apurao dos Crditos de PIS/PASEP - Importao - Regime No Cumulativo"###"Ficha 16B - Apurao dos Crditos da COFINS - Importao - Regime No Cumulativo"
				
				oReport:SkipLine()
				oReport:Section(7):Cell("MOVIMENTO"):SetTitle(IIF(nY==1,STR0134+" 1,65% ",STR0134+" 7,6% "))
				
				If oReport:Cancel()
					Exit
				EndIf
			                          
				For nX := 1 to Len(aDescr06B)
					cMovimento 	:= aDescr06B[nX,1]        
					oReport:Section(7):Init()
					oReport:Section(7):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					oReport:Section(7):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,12,13,14,15'),"------------------",nValor1)})
					oReport:Section(7):Cell("VAL02"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,12,13,14,15'),"------------------",nValor2)})
					oReport:Section(7):Cell("VAL03"):SetBlock({||Iif(Substr(cMovimento,1,2)$('06,12,13,14,15'),"------------------",nValor3)})
				
					If Substr(cMovimento,1,2) $('06,12,13,14,15,16')
  						oReport:Section(7):Cell("VAL01"):SetPicture ("@!")
  						oReport:Section(7):Cell("VAL02"):SetPicture ("@!")
	  					oReport:Section(7):Cell("VAL03"):SetPicture ("@!")
	    	        Elseif Substr(cMovimento,1,2) == "07"
						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
  						nValor1	:= nBsCrdAqI*nPercInt
  						nValor2 := nBsCrdAqI*nPercNTr
						nValor3	:= nBsCrdAqE*nPercExt
					Elseif Substr(cMovimento,1,2) == "09"
						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
  						nValor1	:= (nTotVlMI)*nPercInt
  						nValor2	:= (nTotVlMI)*nPercNTr  						
						nValor3	:= (nTotVlMI)*nPercExt
					Elseif Substr(cMovimento,1,2) == "10"
   						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
						cMovimento := IIF(nY==1,STR0230+"  Alquota de 1,65%",STR0230+"  Alquota de 7,6%") //"10.Creditos a Descontar"###"10.Creditos a Descontar"
  						nValor1	:= ((nTotVlMI)*nPercInt)*(IIF(nY==1,0.0165,0.076))
  						nValor2 := ((nTotVlMI)*nPercNTr)*(IIF(nY==1,0.0165,0.076))  
						nValor3	:= ((nTotVlMI)*nPercExt)*(IIF(nY==1,0.0165,0.076))
					Elseif cMovimento == STR0027 //"APURACAO DE OUTROS CREDITOS"
   						oReport:Section(7):Cell("VAL01"):Disable()
						oReport:Section(7):Cell("VAL02"):Disable()
						oReport:Section(7):Cell("VAL03"):Disable()
						oReport:SkipLine()
					Elseif Substr(cMovimento,1,2) == "11"
						oReport:Section(7):Cell("VAL01"):Enable()
						oReport:Section(7):Cell("VAL02"):Enable()
						oReport:Section(7):Cell("VAL03"):Enable()
						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")  
	  					nValor1	:= (aMes[nI][3][aDescr06B[nX,2]][1])*nPercInt
	  					nValor2 := (aMes[nI][3][aDescr06B[nX,2]][1])*nPercNTr  
						nValor3	:= (aMes[nI][3][aDescr06B[nX,2]][1])*nPercExt
						oReport:SkipLine()
					Elseif Substr(cMovimento,1,2) == "17"
						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")  
						nValor1	:= ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercInt)*(IIF(nY==1,0.0165,0.076))
						nValor2 := ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
						nValor3	:= ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercExt)*(IIF(nY==1,0.0165,0.076))
						nAjusMI	:= ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercInt)*(IIF(nY==1,0.0165,0.076))
						nAjusNT := ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
						nAjusEX := ((aMes[nI][3][aDescr06B[nX,2]][1])*nPercExt)*(IIF(nY==1,0.0165,0.076))
					Elseif Substr(cMovimento,1,2) == "18"
						nToCreMI := ((((nTotVlMI)*nPercInt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusMI
						nToCreNT := ((((nTotVlMI)*nPercNTr)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusNT
						nToCreEX := ((((nTotVlMI)*nPercExt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusEX
   						oReport:Section(7):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(7):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
  						nValor1	:= nToCreMI
  						nValor2 := nToCreNT
						nValor3	:= nToCreEX
					Else
		   				oReport:Section(2):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
		   				oReport:Section(2):Cell("VAL02"):SetPicture ("@E 99,999,999,999.99")
						oReport:Section(2):Cell("VAL03"):SetPicture ("@E 99,999,999,999.99")
						nValor1	:= (aMes[nI][3][aDescr06B[nX,2]][1])*nPercInt
						nValor2	:= (aMes[nI][3][aDescr06B[nX,2]][1])*nPercNTr
						nValor3	:= (aMes[nI][3][aDescr06B[nX,2]][1])*nPercExt
					Endif
					oReport:Section(7):PrintLine()
				Next
				oReport:Section(7):Finish()
		 	Next                
		EndIf
		
	//
	//FICHA 09A/19A - ALIQUOTAS DIFERENCIADAS	    
	//
		If mv_par07 == 2
			For nY:= 1 To 2
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
	   			oReport:EndPage()
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()
			
				If nY == 1 // Pis
  				    oReport:SkipLine()
					oReport:PrintText(STR0168)
					oReport:SkipLine()
 				Else // Cofins
					oReport:SkipLine()
					oReport:PrintText(STR0169)
					oReport:SkipLine()
				Endif

				dbSelectArea("TMP")
				cMes :=	StrZero(aMes[nI,1],2)
				oReport:Section(4):Init()
				oReport:Section(4):Cell("PRODUTO"):SetBlock({|| Alltrim(cCod) + " - " + Alltrim(Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC"))})
				oReport:Section(4):Cell("VAL01"):SetBlock({||nItem1})
				oReport:Section(4):Cell("VAL02"):SetBlock({||(nItem1-(nItem2+nItem3))})
				oReport:Section(4):Cell("VAL03"):SetBlock({|| Iif(nY==1,nPis,nCof)})
				oReport:Section(4):Cell("VAL04"):SetBlock({|| Iif(nY==1,(((nItem1-(nItem2+nItem3))*nPis)/100),(((nItem1-(nItem2+nItem3))*nCof)/100))})
			
				If dbSeek(cMes)
					If nY == 1 // Pis
						nPis := TMP->PIS
						cCod := TMP->CODIGO
						While !Eof() .And. TMP->MES == cMes
							While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
								Do Case
									Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
									Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
									Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
								EndCase
								dbSelectArea("TMP")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							oReport:Section(4):PrintLine()
							n09A_15 += (nItem1+nItem2+nItem3) * nPis / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
							nPis 	:= TMP->PIS
							cCod 	:= TMP->CODIGO
							nItem1	:= 0
							nItem2	:= 0
							nItem3	:= 0
						Enddo
					Else // Cofins
						nCof := TMP->COFINS
						cCod := TMP->CODIGO
						While !Eof() .And. TMP->MES == cMes
							While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
								Do Case
									Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
									Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
									Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
								EndCase
								dbSelectArea("TMP")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							oReport:Section(4):PrintLine() 
							n09A_25 += (nItem1+nItem2+nItem3) * nCof / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 25A e 25B
							nCof 	:= TMP->COFINS
							cCod 	:= TMP->CODIGO
							nItem1	:= 0
							nItem2	:= 0
							nItem3	:= 0
						Enddo
					Endif	
				Endif
				oReport:Section(4):Finish()
			Next
		Endif             
		oReport:SkipLine()
		oReport:ThinLine() 
		oReport:IncMeter()	

	//
	//FICHA 10A - ALIQUOTAS POR UNIDADE DE MEDIDA  
	//
		If mv_par12 == 2
		//If GetNewPar("MV_TESTE",.F.)
			For nY:= 1 To 2
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
	   			oReport:EndPage()
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()
			
				If nY == 1 // Pis
  				    oReport:SkipLine()
					oReport:PrintText(STR0254)
					oReport:SkipLine()
 				Else // Cofins
					oReport:SkipLine()
					oReport:PrintText(STR0355)
					oReport:SkipLine()
			   	Endif

				dbSelectArea("T01")
				cMes :=	StrZero(aMes[nI,1],2)
				oReport:Section(8):Init()
				oReport:Section(8):Cell("PRODUTO"):SetBlock({|| Alltrim(cCod) + " - " + Alltrim(Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC"))})
				oReport:Section(8):Cell("VAL01"):SetBlock({||nItem1})
				oReport:Section(8):Cell("VAL02"):SetBlock({||nQuant})
				oReport:Section(8):Cell("VAL03"):SetBlock({|| Iif(nY==1,nPis,nCof)})
				oReport:Section(8):Cell("VAL04"):SetBlock({|| Iif(nY==1,nQuant * nPis,nQuant * nCof)})
			
				If dbSeek(cMes)
					If nY == 1 // Pis
						nPis := T01->PIS
						cCod := T01->CODIGO
						While !Eof() .And. T01->MES == cMes
							While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod								
								nItem1 += T01->VALOR
								nQuant += T01->QUANT								
								dbSelectArea("T01")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							oReport:Section(8):PrintLine()
							//PIS por unidade de medida  calculado multiplicando a quantidade da operao pelo valor de pauta.
							n10A_15 += nQuant * nPis  //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
							nPis 	:= T01->PIS
							cCod 	:= T01->CODIGO
							nItem1	:= 0
							nQuant  := 0
						Enddo
						
				  	Else // Cofins
				   	   	nCof := T01->COFINS
						cCod := T01->CODIGO
						While !Eof() .And. T01->MES == cMes
							While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
								nItem1 += T01->VALOR
								nQuant += T01->QUANT
								dbSelectArea("T01")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							oReport:Section(8):PrintLine()
							//COFINS por unidade de medida  calculado multiplicando a quantidade da operao pelo valor de pauta.
							n10A_25 += nQuant * nCof  //Utilizado para gerar RESUMO de Cofins - Fichas 25A e 25B
							nCof 	:= T01->COFINS
							cCod 	:= T01->CODIGO
							nItem1	:= 0
							nQuant  := 0              
						Enddo
					Endif	
				Endif
				oReport:Section(8):Finish()
			Next
		Endif             
		oReport:SkipLine()
		oReport:ThinLine() 
		oReport:IncMeter()
		
	//
	//FICHA 11 - Controle do Diferimento - PIS           
	//
  	  	If mv_par14 == 2 
			
			Do Case
				Case mv_par06 == 1 ; cRegApur := "Regime Cumulativo"
				Case mv_par06 == 2 ; cRegApur := "Regime No-Cumulativo"
				Case mv_par06 == 3 ; cRegApur := "Regime Cumulativo e No Cumulativo (Ambos)"
			EndCase
			
			dbSelectArea("CFB")
			dbSetOrder(1)
			
			For nY:= 1 To 2
			
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
	   			oReport:EndPage()
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()
				
				If nY == 1 // Pis
  				    oReport:SkipLine()
					oReport:PrintText(STR0361)
					oReport:SkipLine()
					cTpCon := "PIS"
 				Else // Cofins
					oReport:SkipLine()
					oReport:PrintText(STR0362)
					oReport:SkipLine()
					cTpCon := "COF"
			   	Endif

				If dbSeek(xFilial("CFB")+cDtPer+cTpCon)
					
					oReport:Section(13):Init()
					oReport:Section(13):Cell("RegCont"):SetBlock({||cRegApur})
					oReport:Section(13):Cell("VAL01"):SetBlock({||SubStr(DtoC(mv_par01),4,7)})
					oReport:Section(13):Cell("VAL02"):SetBlock({||CFB->CFB_CONREC})
					If mv_par06 <> 1
						oReport:Section(13):Cell("VAL03"):SetBlock({||CFB->CFB_CREDES})
					EndIf
				Endif
				oReport:Section(13):PrintLine()
				oReport:Section(13):Finish()
			Next
		Endif             
		oReport:SkipLine()
		oReport:ThinLine() 
		oReport:IncMeter()   
		
	//
	//FICHA 12 - Controle do Diferimento - PIS           
	//
	  	If mv_par14 == 2 
			
			Do Case
				Case mv_par06 == 1 ; cRegApur := "Regime Cumulativo"
				Case mv_par06 == 2 ; cRegApur := "Regime No-Cumulativo"
				Case mv_par06 == 3 ; cRegApur := "Regime Cumulativo e No Cumulativo (Ambos)"
			EndCase
			
			dbSelectArea("CFA")
			dbSetOrder(1)
			
			For nY:= 1 To 2
			
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
                //Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				End
				oReport:SetMeter(1)
	   			oReport:EndPage()
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()
				oReport:Section(1):Finish()

				If nY == 1 // Pis
  				    oReport:SkipLine()
					oReport:PrintText(STR0357)
					oReport:SkipLine()
					cTpCon := "PIS"
 				Else // Cofins
					oReport:SkipLine()
					oReport:PrintText(STR0358)
					oReport:SkipLine()
					cTpCon := "COF"
			   	Endif

				If dbSeek(xFilial("CFA")+cDtPer+cTpCon)
					
					oReport:Section(14):Init()
					oReport:Section(14):Cell("Regime"):SetBlock({||cRegApur})
					oReport:Section(14):Cell("VAL01"):SetBlock({||SubStr(DtoC(mv_par01),4,7)})
					oReport:Section(14):Cell("VAL02"):SetBlock({||CFA->CFA_CONDIF})
					If mv_par06 <> 1
						oReport:Section(14):Cell("VAL03"):SetBlock({||CFA->CFA_CREDIF})
					EndIf
				Endif
				oReport:Section(14):PrintLine()
				oReport:Section(14):Finish()                                       
			Next
		Endif             
		oReport:SkipLine()
		oReport:ThinLine() 
		oReport:IncMeter() 
				
		//
		//FICHA 15A - CUMULATIVO - RESUMO PIS/PASEP         
		//
		If mv_par13==2 .And. mv_par06==1
			For nY:= 1 To 1
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
	   			//Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				Endif
				oReport:SetMeter(1)
		   		oReport:EndPage()
	    		
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()                                                                
				oReport:Section(1):Finish()
				
				oReport:SkipLine()
				oReport:PrintText(STR0256)
				oReport:SkipLine()
				
				For nX := 1 to Len(aDescr15A)
					nScan := aScan(aWizCum,{|x| x[2]==STR0256 } )
					cMovimento :=	aDescr15A[nX,1]
					oReport:Section(9):Init()	
					oReport:Section(9):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					oReport:Section(9):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('03,05,06,07,08'),"------------------",nValor4)})
					oReport:Section(9):Cell("VAL01"):Enable()
					
					If Substr(cMovimento,1,2) $('03,05,06,07,08')
						oReport:Section(7):Cell("VAL01"):SetPicture ("@!")	 
					Elseif Substr(cMovimento,1,2) $('01')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nCont1 		:= (((aMes[nI][2][8][2]+aMes[nI][2][51][1])-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*(0.0065)
						nCont2 		:= ((aMes[nI][2][9][2]+aMes[nI][2][39][1])-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*(0.0065)
						nValor4 	:= nCont1+nCont2
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('02')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n09A_15
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('04')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n10A_15 
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('09')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot15
					Elseif Substr(cMovimento,1,2) $('10')
						oReport:Section(9):Cell("VAL01"):Enable()
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][1])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('11')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][2])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('12')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][3])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('13')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][4])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('14')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][5])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('15')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][6])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('16')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][7])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('17')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][8])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('18')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][9])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('19')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][10])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('20')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][11])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('21')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot15 
					Elseif Substr(cMovimento,1,2) $('22')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						If lPisFolha .Or. lPisFolSN
							nValor4 	:=	aMes[nI][2][36][2]*0.01 
						Else
							nValor4 	:= 0
						EndIf
					Elseif Substr(cMovimento,1,2) $('23')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][12])	 
					Elseif Substr(cMovimento,1,2) $('24')
						oReport:Section(9):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][13]) 
					Elseif cMovimento == STR0307 //"DEDUES"
   						oReport:Section(9):Cell("VAL01"):Disable()
						oReport:SkipLine()      
					Endif                                                                    
					
					oReport:Section(9):PrintLine()
				Next		
				oReport:Section(9):Finish()
			Next
		Endif  
	
		//
		//FICHA 25A - CUMULATIVO - RESUMO PIS/PASEP            
		//
	   	If mv_par13==2 .And. mv_par06==1
			For nY:= 1 To 1
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
	   			//Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				Endif
				oReport:SetMeter(1)
		   		oReport:EndPage()
	    		
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()                                                                
				oReport:Section(1):Finish()
				
				oReport:SkipLine()
				oReport:PrintText(STR0312)
				oReport:SkipLine()
				
				For nX := 1 to Len(aDescr25A)
					nScan := aScan(aWizCum,{|x| x[2]==STR0312 } )
					cMovimento :=	aDescr25A[nX,1]
					oReport:Section(11):Init()	
					oReport:Section(11):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					oReport:Section(11):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('03,05,06,07,08'),"------------------",nValor4)})
					oReport:Section(11):Cell("VAL01"):Enable()
					
					If Substr(cMovimento,1,2) $('03,05,06,07,08')
						oReport:Section(7):Cell("VAL01"):SetPicture ("@!")	 
					Elseif Substr(cMovimento,1,2) $('01')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nCont1 		:= (((aMes[nI][2][8][2]+aMes[nI][2][51][1])-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*(0.03)
						nCont2 		:= ((aMes[nI][2][9][2]+aMes[nI][2][39][1])-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*(0.03)
						nValor4 	:= nCont1+nCont2
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('02')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n09A_25
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('04')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n10A_25 
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('09')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot25
					Elseif Substr(cMovimento,1,2) $('10')
						oReport:Section(11):Cell("VAL01"):Enable()
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][1])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('11')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][2])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('12')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][3])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('13')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][4])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('14')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][5])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('15')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][6])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('16')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][7])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('17')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][8])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('18')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][9])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('19')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][10])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('20')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][11])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('21')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot25 
					Elseif Substr(cMovimento,1,2) $('22')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][12]) 
					Elseif Substr(cMovimento,1,2) $('23')
						oReport:Section(11):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aCumVlrs[nScan][13]) 
					Elseif cMovimento == STR0307 //"DEDUCOES"
   						oReport:Section(11):Cell("VAL01"):Disable()
						oReport:SkipLine()      
					Endif                                                                    
					
					oReport:Section(11):PrintLine()
				Next		
				oReport:Section(11):Finish()
			Next
		Endif 		
		
		
		//
		//FICHA 15B - NAO CUMULATIVO - RESUMO PIS/PASEP     
		//
		If mv_par13==2 .And. (mv_par06==2 .Or. mv_par06==3)
			For nY:= 1 To 1
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
	   			//Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				Endif
				oReport:SetMeter(1)
		   		oReport:EndPage()
	    		
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()                                                                
				oReport:Section(1):Finish()
				
				oReport:SkipLine()
				oReport:PrintText(STR0281)
				oReport:SkipLine()
		        
				For nX := 1 to Len(aDescr15B)
					nScan := aScan(aWizNCum,{|x| x[2]==STR0281 } )
					cMovimento :=	aDescr15B[nX,1]
					oReport:Section(10):Init()	
					oReport:Section(10):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					oReport:Section(10):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('03,05,06,07'),"------------------",nValor4)})
					oReport:Section(10):Cell("VAL01"):Enable()
					
					If Substr(cMovimento,1,2) $('03,05,06,07')
						oReport:Section(7):Cell("VAL01"):SetPicture ("@!")	 
					Elseif Substr(cMovimento,1,2) $('01')
					    nCont1 		:= ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*0.0165
					    nCont2 		:= ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*(0.0165) + ;
										(((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*(0.0065) + ;
										((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*(0.0065)
						nValor4 	:= nCont1+nCont2
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('02')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n09A_15
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('04')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n10A_15
						nVlrTot15  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('08')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot15
					Elseif Substr(cMovimento,1,2) $('09')
						oReport:Section(10):Cell("VAL01"):Enable()
				   		oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][1])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('10')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][2])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('11')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][3])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('12')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][4])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('13')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][5])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('14')
						oReport:Section(10):Cell("VAL01"):Enable()
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][6])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('15')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][7])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('16')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][8])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('17')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot15 
					Elseif Substr(cMovimento,1,2) $('18')
						oReport:Section(10):Cell("VAL01"):Enable()
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][9])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('19')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][10])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('20')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][11])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('21')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][12])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('22')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][13])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('23')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][14])
						nVlrTot15  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('24')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][15])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('25')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][16])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('26')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][17])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('27')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][18])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('28')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][19])
						nVlrTot15  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('29')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot15
					Elseif Substr(cMovimento,1,2) $('30')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][20])
					Elseif Substr(cMovimento,1,2) $('31')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][21])
					Elseif Substr(cMovimento,1,2) $('32')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][22])
					Elseif cMovimento == STR0307 .Or. cMovimento == STR0308 .Or. cMovimento == STR0309
   						oReport:Section(10):Cell("VAL01"):Disable()
						oReport:SkipLine()   
					Endif                                                                    
					
					oReport:Section(10):PrintLine()
				Next		
				oReport:Section(10):Finish()
			Next
		Endif 
	
		//
		//FICHA 25B - NAO CUMULATIVO - RESUMO COFINS       
		//
		If mv_par13==2 .And. (mv_par06==2 .Or. mv_par06==3)
			For nY:= 1 To 1
				//Ŀ
				//Secao 1 - Cabecalho Padrao                             
				//
				oReport:Section(1):Cell("PERIODO"):SetBlock({|| DtoC(dDtIni)+" a "+DtoC(dDtFin)})
				oReport:Section(1):Cell("MES"):SetBlock({|| Alltrim(MesExtenso(aMes[nI][1]))})
	   			//Versao do Validador
				If mv_par08 == 1
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal " + mv_par10})
				Elseif mv_par08 == 2
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Semestral " + mv_par10})
				Else
					oReport:Section(1):Cell("VALIDADOR"):SetBlock({|| "Dacon Mensal-Semestral " + mv_par10})
				Endif
				oReport:SetMeter(1)
		   		oReport:EndPage()
	    		
				oReport:Section(1):Init()
				oReport:Section(1):PrintLine()                                                                
				oReport:Section(1):Finish()
				
				oReport:SkipLine()
				oReport:PrintText(STR0337)
				oReport:SkipLine()
		        
				For nX := 1 to Len(aDescr25B)
					nScan := aScan(aWizNCum,{|x| x[2]==STR0337 } )
					cMovimento :=	aDescr25B[nX,1]
					oReport:Section(12):Init()	
					oReport:Section(12):Cell("MOVIMENTO"):SetBlock({|| cMovimento })
					oReport:Section(12):Cell("VAL01"):SetBlock({||Iif(Substr(cMovimento,1,2)$('03,05,06,07'),"------------------",nValor4)})
					oReport:Section(12):Cell("VAL01"):Enable()
					
					If Substr(cMovimento,1,2) $('03,05,06,07')
						oReport:Section(7):Cell("VAL01"):SetPicture ("@!")	 
					Elseif Substr(cMovimento,1,2) $('01')
					    nCont1 		:= ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*0.076
					    nCont2 		:= ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*(0.076) + ;
										(((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*(0.076) + ;
										((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*(0.076)
						nValor4 	:= nCont1+nCont2
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('02')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n09A_25
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('04')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= n10A_25
						nVlrTot25  	+= nValor4
					Elseif Substr(cMovimento,1,2) $('08')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot25
					Elseif Substr(cMovimento,1,2) $('09')
						oReport:Section(12):Cell("VAL01"):Enable()
				   		oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][1])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('10')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][2])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('11')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][3])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('12')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][4])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('13')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][5])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('14')
						oReport:Section(12):Cell("VAL01"):Enable()
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][6])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('15')
						oReport:Section(10):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][7])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('16')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][8])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('17')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot25 
					Elseif Substr(cMovimento,1,2) $('18')
						oReport:Section(12):Cell("VAL01"):Enable()
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][9])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('19')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][10])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('20')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][11])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('21')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][12])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('22')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][13])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('23')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][14])
						nVlrTot25  	-= nValor4 
					Elseif Substr(cMovimento,1,2) $('24')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][15])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('25')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][16])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('26')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][17])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('27')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][18])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('28')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][19])
						nVlrTot25  	-= nValor4
					Elseif Substr(cMovimento,1,2) $('29')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= nVlrTot25
					Elseif Substr(cMovimento,1,2) $('30')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][20])
					Elseif Substr(cMovimento,1,2) $('31')
						oReport:Section(12):Cell("VAL01"):SetPicture ("@E 99,999,999,999.99")
						nValor4 	:= Val(aNCumVlr[nScan][21])
					Elseif cMovimento == STR0307 .Or. cMovimento == STR0308 .Or. cMovimento == STR0309
   						oReport:Section(12):Cell("VAL01"):Disable()
						oReport:SkipLine()   
					Endif                                                                    
					
					oReport:Section(12):PrintLine()
				Next		
				oReport:Section(12):Finish()
			Next
		Endif			 
					 
		oReport:SkipLine()
		oReport:ThinLine() 
		oReport:IncMeter()
	Next
Endif

RestArea(aArea)
	
//dbSelectArea("TMP")
//dbCloseArea()

Return Nil

/*/


Ŀ
Programa  MATR971R3  Autor Andressa Ataides        Data 11/09/2006
Ĵ
Descrio Relatorio auxiliar para preenchimento da DACON              
Ĵ
Uso        Sigafis                                                    
ͼ


/*/

Function MATR971R3(aMes,aMercado)

Local aCFOPs	:= {}
Local aArea		:= GetArea()
Local aWizard	:=	{}
Local lRet		:= .T.
Local lDic      := .F. 					// Habilita/Desabilita Dicionario
Local lComp     := .F. 					// Habilita/Desabilita o Formato Comprimido/Expandido
Local lFiltro   := .F. 					// Habilita/Desabilita o Filtro
Local Titulo    := OemToAnsi(STR0003)  //"DACON - Demonstrativo de Apuracao de Contribuicoes Sociais"
Local cDesc1    := OemToAnsi(STR0004)  //"Este relatorio emite as informacoes necessarias "
Local cDesc2    := OemToAnsi(STR0097)  //"para auxiliar o preenchimento da DACON"
Local cDesc3    := ""
Local cString	:= "SF3"
Local cRegime   := ""
Local wnrel     := "MATR971"  			// Nome do Arquivo utilizado no Spool
Local nomeprog  := "MATR971"  			// nome do programa
Local nPagina	:= 1
//
Private Tamanho := "M"					// P/M/G
Private Limite  := 132 					// 80/132/220
Private cPerg   := "MTR971"				// Pergunta do Relatorio
Private aReturn := {STR0007,1,STR0008,1,2,1,"",1}	//"Zebrado"###"Administracao"
Private lEnd    := .F.					// Controle de cancelamento do relatorio
Private m_pag   := 1  					// Contador de Paginas
Private nLastKey:= 0  					// Controla o cancelamento da SetPrint e SetDefault

If Pergunte("MTR971",.T.)

	//Ŀ
	//Validacao/tratamento do periodo informado              
	//
	If Empty(mv_par01) .Or. Empty(mv_par02) .Or. (Month(mv_par01)<>Month(mv_par02)) .Or. (Year(mv_par01)<>Year(mv_par02))
		xMagHelpFis(OemToAnsi(STR0163),OemToAnsi(STR0164),OemToAnsi(STR0165))
		Return Nil
	Else
		If Day(mv_par01) <> 1
			mv_par01 := CtoD("01/"+StrZero(Month(mv_par01),2)+"/"+StrZero(Year(mv_par01),4))
		Endif
		If Day(mv_par02) <> Day(LastDay(mv_par02))
			mv_par02 := CtoD(StrZero(Day(LastDay(mv_par02)),2)+"/"+StrZero(Month(mv_par02),2)+"/"+StrZero(Year(mv_par02),4))
		Endif
	Endif
	
	//Ŀ
	//Envia para a SetPrinter                                                 
	//
	If lRet
		wnrel:=SetPrint(cString,wnrel,"",@titulo,cDesc1,cDesc2,cDesc3,lDic,,lComp,Tamanho,lFiltro,.F.)
		If ( nLastKey==27 )
			dbSelectArea(cString)
			dbSetOrder(1)
			dbClearFilter()
			Return
		Endif
		SetDefault(aReturn,cString)
		If ( nLastKey==27 )
			dbSelectArea(cString)
			dbSetOrder(1)
			dbClearFilter()
			Return
		Endif
		
		RptStatus({|lEnd| ImpDacon(lEnd,wnrel,cString,Tamanho,nPagina,cRegime,Titulo,nomeprog,@aMes,@aMercado)},Titulo)
		
		//Ŀ
		// Restaura Ambiente                                            
		//
		dbSelectArea(cString)
		dbClearFilter()
		Set Device To Screen
		Set Printer To
		
		If ( aReturn[5] = 1 )
			dbCommitAll()
			OurSpool(wnrel)
		Endif
		MS_FLUSH()

//		dbSelectArea("TMP")
//		dbCloseArea()
	EndIf
Endif

Return

/*


ͻ
Programa   Wiz_NCum   Autor  Andressa Ataides     Data  11/09/2006       
͹
Desc.     Monta a wizard com as perguntas necessarias- REGIME NAO CUMULATIVO 
͹
Uso       Matr971                                                            
ͼ


*/
Static Function Wiz_NCum(nPainel10A)

Local aTxtPre 	:= {}
Local aPaineis	:= {}
Local cTitObj1	:= ""
Local nPos		:= 0	
Local nCampo	:= 240
Local lRet		:=	.F.
Local lPreenche := ""
Default nPainel10A	:= 0 //Nmero do painel da ficha 10A

// Ŀ
// Monta wizard com as perguntas necessarias
// 
aAdd(aTxtPre,STR0003) //"DACON - Demonstrativo de Apuracao de Contribuicoes Sociais"
aAdd(aTxtPre,STR0001) //"Atencao"
aAdd(aTxtPre,STR0002) //"Preencha corretamente as informacoes solicitadas."
aAdd(aTxtPre,STR0004+STR0005)//"Este relatorio emite as informacoes necessarias" //"para auxiliar o preenchimento da DACON - Regime Nao-Cumulativo"
									
// Ŀ
// Painel 1 Apuracao Pis/Pasep e Cofis - Nao Cumulativo 
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0010) //"Apuracao dos Creditos para o Pis/Pasep(Aliq.1,65%) e Cofins(Aliq.7,6%) - Nao Cumulativo"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0011 //"BASE DE CALCULO DOS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0012 //"01.Bens para Revenda"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0013 //"02.Bens Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0014 //"03.Servicos Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0015 //"04.Despesas de Energia Eletrica"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0016 //"05.Desp.Alug. Predios Locados de PJ"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0017 //"06.Desp.Alug. Maq/Equip. Locados de PJ"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0018 //"07.Desp.Armaz. Merc./Frete na Oper. Venda"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0019 //"08.Desp. Contraprest. Arrend. Mercantil"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0020 //"09.Bens Ativo Imob.-Encargos Depreciao"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0021 //"10.Bens Ativo Imob.-Valor de Aquisio"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0022 //"11.Encargos Amort.Edific. e Benfeitorias"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0023 //"12.Devol.Vendas Suj. Aliq. 1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T., STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0024 //"13.Outras Oper. com Direito Cred."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0027 //"APURACAO DE OUTROS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0028 //"16.Cred. Calc. a Aliq. Diferenciadas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0029 //"17.Cred. Calc. por Un. de Produto" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0025 //"18.Cred. Ativ. Transporte de Cargas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0031 //"19.Cred. Presumido Rel. Est.Abertura"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0032 //"20.Cred. Ativ.Imobiliaria"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0037 //"21.Outros Creditos a Descontar" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0043 //"22.Ajustes Positivos de Creditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0044 // "23.(-)Ajustes Negativos de Creditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0026 //"CRED.PRESUMID. ATIV.AGROIND."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0030 //"25.Calculados a Alquota de 0,99/4,56%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0033 //"26.Calculados a Alquota de 0,5775/2,66%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0034 //"27.Ajustes Positivos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0035 //"28.(-)Ajustes Negativos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0036 //"CRED.DECORRENTES AQUIS.EMBALAGENS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0038 //"30.Crditos Apurados"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0039 //"31.Ajustes Positivos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0040 //"32.(-)Ajustes Negativos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

// Ŀ
// Painel 2 Calculo Pis/Pasep e Cofins - Nao Cumulativo 
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0046) //"Clculo da Contribuio para o Pis/Pasep e Cofins"
aAdd(aPaineis[nPos],{})
	
cTitObj1 :=	STR0047 //"APURACAO PIS/PASEP E COFINS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0048 //"01.Rec.Bens e Servicos-Aliq.1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0049 //"02.Demais Receitas-Aliq.1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0082 //"OUTRAS RECEITAS AUFERIDAS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0041 //"04.Receita Trib. Aliq.Zero" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0042 //"05.Receita Trib. Aliq.Zero-Rev.Prod." 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                    
cTitObj1 :=	STR0045 //"06.Receita Vendas Bens Ativ.Perman."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0050 //"07.Receita Sem Incid.Contrib." 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})  
lPreenche := SuperGetMv("MV_RECALZ4",.F.,"")
If Trim(lPreenche) == ""
  aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})  
else 
  aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo, {.T.,STR0087}})
EndIf
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0051 //"08.Receita Isenta Sem Incid.Contrib." 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0052 //"09.Receita com Susp.Contrib." 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0053 //"10.Receita Revenda Op.Subst.Trib." 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0054 //"11.Receita Tributada pelo RET" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0055 //"12.CONTRIB. FOLHA SALARIOS" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0058 //"EXCLUSOES- BASE DE CALCULO"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0056 //"13.Vendas Canc./Descontos(Rec.Vendas)" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0057 //"14.IPI e ICMS/Subst. Tributario(Rec.Vendas)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                                      
cTitObj1 :=	STR0059 //"15.Vendas Canc./Descontos(Demais Rec.)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0060 //"16.IPI e ICMS/Subst.Trib.(Demais Rec.)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0090 //"Faturamento Mercado Interno-Tributada"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//  
cTitObj1 :=	STR0091 //"Faturamento Mercado Externo"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	STR0253 //"Faturamento Mercado Interno-No Tributada"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
If mv_par09 == 2
	Wiz_IMNC(@aPaineis,nPos,cTitObj1,nCampo)
EndIf

//  Ficha 09A /19A - PIS/PASEP e COFINS Ŀ
// Painel Calculo Pis/Pasep e Cofins - Aliquotas Diferenciadas	  
// 
If mv_par07 == 2	//Imprime Ficha 09A/ 19A
	Wizard_AD(@aPaineis,nPos,cTitObj1,nCampo)
Endif

//  Ficha 10A - PIS/PASEP  Ŀ
// Painel Calculo Pis/Pasep - Aliquotas por Unidade de Medida	  
// 
If mv_par12 == 2	//Imprime Ficha 10A
	Wizard_10(@aPaineis,nPos,cTitObj1,nCampo)
	nPainel10A	:= len(aPaineis)
Endif

If mv_par13==2
	Wizard_15B(@aPaineis,nPos,cTitObj1,nCampo) 
	Wizard_25B(@aPaineis,nPos,cTitObj1,nCampo)
Endif

aWizNCum := aClone(aPaineis)
    
lRet :=	xMagWizard(aTxtPre,aPaineis,"MTR971")
	
Return(lRet)
/*


ͻ
Programa   Wiz_Cum    Autor  Andressa Ataides     Data 11/09/2006      
͹
Desc.     Monta a wizard com as perguntas necessarias - REGIME CUMULATIVO  
͹
Uso       Matr971                                                          
ͼ


*/
Static Function Wiz_Cum(nPainel10A)
	
Local aTxtPre	:= {}
Local aPaineis	:= {}
Local cTitObj1	:= ""                
Local nPos		:= 0
Local nCampo	:= 240
Local lRet		:=	.F.                                  

DEFAULT nPainel10A	:= 0 //Nmero do painel da ficha 10A

// Ŀ
// Monta wizard com as perguntas necessarias
// 
aAdd(aTxtPre,STR0003) //"DACON - Demonstrativo de Apuracao de Contribuicoes Sociais"
aAdd(aTxtPre,STR0001) //"Atencao"
aAdd(aTxtPre,STR0002) //"Preencha corretamente as informacoes solicitadas."
aAdd(aTxtPre,STR0004+STR0006)	//"Este relatorio emite as informacoes necessarias"
								//"para auxiliar o preenchimento da DACON - Regime Cumulativo"

// Ŀ
// Painel 1 Calculo Pis/Pasep e Cofis - Cumulativo      
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0046) //"Calculo da Contribuicao para o Pis/Pasep e Cofins"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0047 //"APURACAO PIS/PASEP E COFINS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0061 //"01.Rec.Bens e Servicos-Aliq.0,65%/Cumul."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0062 //"02.Demais Receitas-Aliq.0,65%/Cumul."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0063 //"03.Receita Trib. Reg.Subst.Trib-Aliq.0,65/3%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0082 //"OUTRAS RECEITAS AUFERIDAS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0064 //"05.Receita Trib. Aliq.Zero"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0065 //"06.Receita Trib. Aliq.Zero-Rev.Prod."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                    
cTitObj1 :=	STR0066 //"07.Receita Vendas Bens Ativ.Perman."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0067 //"08.Receita Sem Incid.Contrib."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0068 //"09.Receita Isenta Sem Incid.Contrib."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0069 //"10.Receita com Susp.Contrib."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0070 //"11.Receita Revenda Op.Subst.Trib."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0071 //"12.Receita Tributada pelo RET"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0072 //"13.CONTRIB. FOLHA SALARIOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0058 //"EXCLUSOES- BASE DE CALCULO"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0073 //"14.Vendas Canc./Descontos(Rec.Vendas)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0074 //"15.IPI e ICMS/Subst. Tributario(Rec.Vendas)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                                      
cTitObj1 :=	STR0075 //"16.Vendas Canc./Descontos(Demais Rec.)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0076 //"17.IPI e ICMS/Subst.Trib.(Demais Rec.)"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
If mv_par09 == 2
	Wiz_IMNC(@aPaineis,nPos,cTitObj1,nCampo)
EndIf

//  Ficha 09A /19A - PIS/PASEP e COFINS Ŀ
// Painel Calculo Pis/Pasep e Cofins - Aliquotas Diferenciadas	  
// 
If mv_par07 == 2	//Imprime Ficha 09A/ 19A
	Wizard_AD(@aPaineis,nPos,cTitObj1,nCampo)
Endif

//  Ficha 10A - PIS/PASEP Ŀ
// Painel Calculo Pis/Pasep - Aliquotas por Unidade de Medida	  
// 
If mv_par12 == 2	//Imprime Ficha 10A
	Wizard_10(@aPaineis,nPos,cTitObj1,nCampo)
	nPainel10A	:= len(aPaineis)
Endif

If mv_par13==2
	Wizard_15A(@aPaineis,nPos,cTitObj1,nCampo) 
	Wizard_25A(@aPaineis,nPos,cTitObj1,nCampo)
Endif   

aWizCum := aClone(aPaineis)

lRet :=	xMagWizard(aTxtPre,aPaineis,"MTR971C")
	
Return(lRet)


/*


ͻ
Programa   Wiz_Ambos  Autor  Andressa Ataides     Data  11/09/2006       
͹
Desc.     Monta a wizard com as perguntas necessarias- REGIME NAO CUMULATIVO 
͹
Uso       Matr971                                                            
ͼ


*/
Static Function Wiz_Ambos(nPainel10A)

Local aTxtPre 	:= {}
Local aPaineis	:= {}
Local cTitObj1	:= ""
Local nPos		:= 0	
Local nCampo	:= 240
Local lRet		:=	.F.

DEFAULT nPainel10A	:= 0 //Nmero do painel da ficha 10A

// Ŀ
// Monta wizard com as perguntas necessarias
// 
aAdd(aTxtPre,STR0003) //"DACON - Demonstrativo de Apuracao de Contribuicoes Sociais"
aAdd(aTxtPre,STR0001) //"Atencao"
aAdd(aTxtPre,STR0002) //"Preencha corretamente as informacoes solicitadas."
aAdd(aTxtPre,STR0004+STR0175)//"Este relatorio emite as informacoes necessarias" //"para auxiliar o preenchimento da DACON - Regime Nao-Cumulativo e Cumulativo"
									
// Ŀ
// Painel 1 Apuracao Pis/Pasep e Cofis - Nao Cumulativo 
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0010) //"Apuracao dos Creditos para o Pis/Pasep(Aliq.1,65%) e Cofins(Aliq.7,6%) - Nao Cumulativo"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0011 //"BASE DE CALCULO DOS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0012 //"01.Bens para Revenda"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0013 //"02.Bens Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0014 //"03.Servicos Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0015 //"04.Despesas de Energia Eletrica"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0016 //"05.Desp.Alug. Predios Locados de PJ"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0017 //"06.Desp.Alug. Maq/Equip. Locados de PJ"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0018 //"07.Desp.Armaz. Merc./Frete na Oper. Venda"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0019 //"08.Desp. Contraprest. Arrend. Mercantil"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0020 //"09.Bens Ativo Imob.-Encargos Depreciao"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0021 //"10.Bens Ativo Imob.-Valor de Aquisio"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0022 //"11.Encargos Amort.Edific. e Benfeitorias"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0023 //"12.Devol.Vendas Suj. Aliq. 1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T., STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0024 //"13.Outras Oper. com Direito Cred."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0027 //"APURACAO DE OUTROS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0028 //"16.Cred. Calc. a Aliq. Diferenciadas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0029 //"17.Cred. Calc. por Un. de Produto" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0025 //"18.Cred. Ativ. Transporte de Cargas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0031 //"19.Cred. Presumido Rel. Est.Abertura"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0032 //"20.Cred. Ativ.Imobiliaria"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0037 //"21.Outros Creditos a Descontar" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0043 //"22.Ajustes Positivos de Creditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0044 // "23.(-)Ajustes Negativos de Creditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0026 //"CRED.PRESUMID. ATIV.AGROIND."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0030 //"25.Calculados a Alquota de 0,99/4,56%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0033 //"26.Calculados a Alquota de 0,5775/2,66%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0034 //"27.Ajustes Positivos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0035 //"28.(-)Ajustes Negativos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0036 //"CRED.DECORRENTES AQUIS.EMBALAGENS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0038 //"30.Crditos Apurados"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0039 //"31.Ajustes Positivos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0040 //"32.(-)Ajustes Negativos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
              
// Ŀ
// Painel 2 Calculo Pis/Pasep e Cofins - Nao Cumulativo e Cumulativo 
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0197) //STR0046 "Calculo da Contribuicao para o Pis/Pasep e Cofins"
aAdd(aPaineis[nPos],{})
	
cTitObj1 :=	STR0221
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0048 //"01.Rec.Bens e Servicos-Aliq.1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0049 //"02.Demais Receitas-Aliq.1,65/7,6%"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0198
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	STR0199
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0200
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0201
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0082
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0202
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0203
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                    
cTitObj1 :=	STR0204
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0205
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0206
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0207
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0208
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0209
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0210
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0211 //"EXCLUSOES-BASE CALC. NAO CUMUL."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0212
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0213
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                                      
cTitObj1 :=	STR0214
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0215
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0216 //"EXCLUSOES-BASE CALC. NAO CUMUL."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0217
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0218
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//                                                                      
cTitObj1 :=	STR0219
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0220
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0090 //"Faturamento Mercado Interno-Tributada"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//  
cTitObj1 :=	STR0091 //"Faturamento Mercado Externo"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
cTitObj1 :=	STR0253 //"Faturamento Mercado Interno-No Tributada"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})


If mv_par09 == 2
	Wiz_IMNC(@aPaineis,nPos,cTitObj1,nCampo)
EndIf

//  Ficha 09A /19A - PIS/PASEP e COFINS Ŀ
// Painel Calculo Pis/Pasep e Cofins - Aliquotas Diferenciadas	  
// 
If mv_par07 == 2	//Imprime Ficha 09A/ 19A
	Wizard_AD(@aPaineis,nPos,cTitObj1,nCampo)
Endif

//  Ficha 10A - PIS/PASEP Ŀ
// Painel Calculo Pis/Pasep - Aliquotas por Unidade de Medida	  
// 
If mv_par12 == 2	//Imprime Ficha 10A
	Wizard_10(@aPaineis,nPos,cTitObj1,nCampo)
	nPainel10A	:= len(aPaineis)
Endif

If mv_par13==2
	Wizard_15B(@aPaineis,nPos,cTitObj1,nCampo)
	Wizard_25B(@aPaineis,nPos,cTitObj1,nCampo)
Endif

aWizNCum := aClone(aPaineis)
    
lRet :=	xMagWizard(aTxtPre,aPaineis,"MTR971A")
	
Return(lRet)


/*/


Ŀ
Program   Wizard_AD  Autor Sergio S. Fuzinaka      Data  11/09/2006     
Ĵ
Descricao Wizard da Aliquota Diferenciada-Ficha 09A(Pis/Pasep)e 19A(Cofins) 
Ĵ
Uso       MATR971                                                           
ٱ


/*/                                                                                
Static Function Wizard_AD(aPaineis,nPos,cTitObj1,nCampo)

//  Ficha 09A E 19A Ŀ
// Painel do Calculo Pis/Pasep e Cofins - Aliquotas Diferenciadas   
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0157) //"Calculo da Contribuicao para o Pis/Pasep e Cofins - Aliquotas Diferenciadas"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0159 //"01.Receitas de Vendas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	STR0058 //"EXCLUSES - BASE DE CLCULO"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	STR0160 //"02.(-)Vendas Canc. e Desc.Incondic."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	STR0161 //"03.(-)IPI e ICMS/Subst. Tributario"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T., STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

Return Nil


/*/


Ŀ
Program   Wizard_10  Autor Luccas Curcio      Data  17/01/2011          
Ĵ
Descricao Wizard da Aliquota por Unidade de Medida -Ficha 10A               
Ĵ
Uso       MATR971                                                           
ٱ


/*/                                                                                
Static Function Wizard_10(aPaineis,nPos,cTitObj1,nCampo)

//  Ficha 10A Ŀ
// Painel do Calculo Pis/Pasep - Aliquotas por Unidade de Medida    
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0255) //"Clculo Da Contribuio Para O Pis/pasep - Aliquotas por Unidade de Medida"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0159 //"01.Receitas de Vendas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

Return Nil

/*/


Ŀ
Program   Wizard_15A  Autor Luccas Curcio      Data  18/05/2011         
Ĵ
Descricao Wizard Ficha 15A - RESUMO Cumulativo PIS/pasep                    
Ĵ
Uso       MATR971                                                           
ٱ


/*/        

Static Function Wizard_15A(aPaineis,nPos,cTitObj1,nCampo)

aAdd(aPaineis,{})
nPos := Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0256) //"Ficha 15A - RESUMO - Contribuio para PIS/Pasep - Regime Cumulativo"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	"DEDUES" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarquias e Fundaes Federais",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte pelas demais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Entidades da Adm Pblica Federal",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por Pessoas " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Jurdicas de Direito Privado",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarq. e Fund. do Estado, DF e Munic.",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por Socied."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Cooperativa",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 := "PIS/Pasep Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Fabricantes de Veculos e Mquinas",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Substituio pela No       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Ocorrncia do Fato Gerador Presumido",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crdito Presumido - Medicamentos      "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 := "Crditos Admit. no Regime Cumulativo  "	
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Paga pelo Substituto Tribut."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Outras Dedues                       "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O PIS/PASEP A PAGAR "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"DE SCP",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O PIS/PASEP A PAGAR "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"RETIDA DE COOPERADOS",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

Return Nil 
 
/*/


Ŀ
Program    Wizard_25A  Autor Beatriz Scarpa          Data  13/09/2012     
Ĵ
Descricao  Wizard Ficha 25A - RESUMO Cumulativo COFINS                        
Ĵ
Uso        MATR971                                                            
ٱ


/*/ 

Static Function Wizard_25A(aPaineis,nPos,cTitObj1,nCampo)  

aAdd(aPaineis,{})
nPos := Len(aPaineis)
aAdd(aPaineis[nPos],STR0009)//"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0312)//"Ficha 25A - RESUMO - Cofins - Regime Cumulativo"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	"DEDUES" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarquias e Fundaes Federais",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Retida na Fonte pelas demais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Entidades da Adm Pblica Federal",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Retida na Fonte por Pessoas " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Jurdicas de Direito Privado",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarq. e Fund. do Estado, DF e Munic.",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Retida na Fonte por Sociedade"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Cooperativa",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 := "Cofins Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Fabricantes de Veculos e Mquinas",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Substituio pela No       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Ocorrncia do Fato Gerador Presumido",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crdito Presumido - Medicamentos      "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 := "Crditos Admit. no Regime Cumulativo  "	
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Cofins Paga pelo Substituto Tribut."
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Outras Dedues                       "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O Cofins A PAGAR "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"DE SCP",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O Cofins A PAGAR "
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"RETIDA DE COOPERADOS",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

Return Nil

/*/


Ŀ
Program   Wizard_15B  Autor Luccas Curcio      Data  18/05/2011         
Ĵ
Descricao Wizard Ficha 15B - RESUMO No Cumulativo PIS/pasep                
Ĵ
Uso       MATR971                                                           
ٱ


/*/       

Static Function Wizard_15B(aPaineis,nPos,cTitObj1,nCampo)

aAdd(aPaineis,{})
nPos := Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0281) //"Ficha 15A - RESUMO - Contribuio para PIS/Pasep - Regime Cumulatico"
aAdd(aPaineis[nPos],{})

aAdd(aPaineis[nPos][3],{1,"CRDITOS DESCONTADOS REFERENTES A     ",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{1,"AQUISIES NO MERCADO INTERNO",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita Tributada no     " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita No Tributada no " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita de Exportao    " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Presumido - Atividades Agroindustriais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados a Embalagens para Revenda  " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

aAdd(aPaineis[nPos][3],{1,"CRDITOS DESCONTADOS REFERENTES A     ",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{1,"IMPORTAES",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados a Receita Tributada no     " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita No Tributada no " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita de Exportao    " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

aAdd(aPaineis[nPos][3],{1,"DEDUES",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarquias e Fundaes Federais",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte pelas Demais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Entidades da Admin. Pblica Federal",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por Pessoas " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Jurdicas de Direito Privado",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarq. e Fund. dos Estados, DF e Mun.",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Sociedade Cooperativa",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Fabricantes de Veculos e Mquinas",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep Substituio pela no       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"ocorrncia do Fato Gerador Presumido",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crdito Presumido - Medicamentos      " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crditos Admitidos no Regime Cumulat. " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"PIS/Pasep paga pelo Substituto        " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Tributrio",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Outras Dedues                       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O PIS/PASEP A PAGAR " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"- FOLHA DE SALRIOS",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O PIS/PASEP A PAGAR " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"DE SCP",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIAO PARA O PIS/PASEP A PAGAR " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"RETIDA DE COOPERADOS",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})


/*/


Ŀ
Program   Wizard_25B  Autor Beatriz Scarpa          Data  13/09/2012     
Ĵ
Descricao Wizard Ficha 25B - RESUMO Nao Cumulativo COFINS                    
Ĵ
Uso       MATR971                                                            
ٱ


/*/
Static Function Wizard_25B(aPaineis,nPos,cTitObj1,nCampo)

aAdd(aPaineis,{})
nPos := Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0337) //"Ficha 25B - Cofins - Regime No-Cumulativo"
aAdd(aPaineis[nPos],{})

aAdd(aPaineis[nPos][3],{1,"CRDITOS DESCONTADOS REFERENTES A     ",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{1,"AQUISIES NO MERCADO INTERNO",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita Tributada no     " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita No Tributada no " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita de Exportao    " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Presumido - Atividades Agroindustriais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados a Embalagens para Revenda  " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

aAdd(aPaineis[nPos][3],{1,"CRDITOS DESCONTADOS REFERENTES A     ",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{1,"IMPORTAES",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados a Receita Tributada no     " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita No Tributada no " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Vinculados  Receita de Exportao    " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

aAdd(aPaineis[nPos][3],{1,"DEDUES",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarquias e Fundaes Federais",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte pelas Demais" 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Entidades da Admin. Pblica Federal",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte por Pessoas " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Jurdicas de Direito Privado",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte por rgos, " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Autarq. e Fund. dos Estados, DF e Mun.",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Sociedade Cooperativa",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Retida na Fonte por         " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Fabricantes de Veculos e Mquinas",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS Substituio pela no       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"ocorrncia do Fato Gerador Presumido",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crdito Presumido - Medicamentos      " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Crditos Admitidos no Regime Cumulat. " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"COFINS paga pelo Substituto        " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Tributrio",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"Outras Dedues                       " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"Mercado Interno",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIO PARA O COFINS A PAGAR " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"DE SCP",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

cTitObj1 :=	"CONTRIBUIAO PARA O COFINS A PAGAR " 
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,"@E 9,99,999,999.99",2,2,,,15})
aAdd(aPaineis[nPos][3],{1,"RETIDA DE COOPERADOS",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})


/*


ͻ
Programa   Wiz_IMNC   Autor  Liber De esteban     Data  19/09/2008       
͹
Desc.     Monta a wizard com as perguntas necessarias - IMPORTACAO REGIME    
          NAO CUMULATIVO (6B/16B)                                            
͹
Uso       Matr971                                                            
ͼ


*/
Static Function Wiz_IMNC(aPaineis,nPos,cTitObj1,nCampo)

// Ŀ
// Monta wizard com as perguntas necessarias
// 
//aAdd(aPaineis,{})
//aAdd(aTxtPre,STR0003) //"DACON - Demonstrativo de Apuracao de Contribuicoes Sociais"
//aAdd(aTxtPre,STR0001) //"Atencao"
//aAdd(aTxtPre,STR0002) //"Preencha corretamente as informacoes solicitadas."
//aAdd(aTxtPre,STR0004+STR0240)//"Este relatorio emite as informacoes necessarias" //"para auxiliar o preenchimento da DACON - Importao - Regime No Cumulativo"
									
// Ŀ
// Painel 1 Apuracao Pis/Pasep e Cofis - Importacao Nao Cumulativo 
// 
aAdd(aPaineis,{})
nPos :=	Len(aPaineis)
aAdd(aPaineis[nPos],STR0009) //"Assistente de parametrizacao"
aAdd(aPaineis[nPos],STR0241) //"Apuracao dos Creditos para o Pis/Pasep(Aliq.1,65%) e Cofins(Aliq.7,6%) - Importao - No Cumulativo"
aAdd(aPaineis[nPos],{})

cTitObj1 :=	STR0011 //"BASE DE CALCULO DOS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0012 //"01.Bens para Revenda"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0013 //"02.Bens Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0014 //"03.Servicos Utilizados como Insumos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0015 //"04.Despesas de Energia Eletrica"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0242 //"05.Despesas de Aluguis de Prdios"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0243 //"06.Bens Ativo Imob. - Encargos Depreciao"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0244 //"07.Bens Ativo Imob. - Valor de Aquisio"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0245 //"08.Outras Operaes com Direito a Crdito"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//

cTitObj1 :=	STR0027 //"APURACAO DE OUTROS CREDITOS"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,}) 
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0246 //"11.Cred. Calc. a Aliq. Diferenciadas"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0247  //"12.Cred. Calc. por Un. de Medida de Produto"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0248 //"13.Cred. Ativ. Imabiliaria"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0249 //"14.Outros Crditos a Descontar"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0250 //"15.Ajustes Positivos de Crditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0088}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
//
cTitObj1 :=	STR0236 //"16.(-)Ajustes Negativos de Creditos"
aAdd(aPaineis[nPos][3],{1,cTitObj1,,,,,,})
aAdd(aPaineis[nPos][3],{2,,Replicate("X",nCampo),1,,,,nCampo,{.T.,STR0087}})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})
aAdd(aPaineis[nPos][3],{0,"",,,,,,})

Return Nil

/*/


Ŀ
Program   ProcDacon  Autor Andressa Ataides        Data  11/09/2006     
Ĵ
Descrio Processamento dos Dados para preenchimento do DACON               
Ĵ
Uso        MATR971                                                          
ͼ


/*/                                                                                
                
Function ProcDacon(nVDeprAt,nTotVlMI,nTotVlEX,nBsCrdAqI,nBsCrdAqE,nPercInt,nPercExt,nOutRecN,nOutRecC,nPosMes,lRet,nNTrib,aRecAuf,nRecVen,nVAgrDes,aMercado)

Local aAtivo    := {}
Local aAtAqu    := {}
Local aRelImp2  := MaFisRelImp("MT100",{ "SD2" })
Local aStruSE5  := {}
Local aMes		:= {}
Local aWizard	:= {}
Local lQuery	:= .F.
Local lProcessa := .F.
Local lAliqDif	:= .F.	// PIS/PASEP e COFINS - Aliquota Diferenciada
Local lValido	:= .F.
Local lConsCmp	:= .F.
Local lApurac	:= (SF4->(FieldPos("F4_PISFISC")) > 0)
Local lTpRec    := (SF4->(FieldPos("F4_RECDAC")) > 0)
Local lTpDes    := (SED->(FieldPos("ED_RECDAC")) > 0)
Local lRegCaixa := SuperGetMv("MV_RGCAIXA",.F.,.F.) // Regime de Caixa
Local cProdAgro := ""
Local cCampoAgro := GetNewPar("MV_PRODAGR","")
Local nX		:= 0
Local nX1		:= 0
Local nBaseCred	:= 0   
Local nItemValCont := 0
Local nRegEmp 	:= SM0->(RecNo())
Local nTPReg	:= SuperGetMV("MV_M996TPR",,"")
Local cRegCam	:= Iif(nTPReg == 2,"SB1->B1_TPREG",Iif(nTPReg == 1,"SF4->F4_TPREG","SA1->A1_TPREG"))
Local nTpRegPrd := Iif(nTPReg == 2,SB1->(FieldPos("B1_TPREG")),Iif(nTPReg == 1,SF4->(FieldPos("F4_TPREG")),SA1->(FieldPos("A1_TPREG"))))//Cumulativo e Nao Cumulativo
Local nPPis		:= 0	//Percentual de PIS/PASEP
Local nPCofins	:= 0	//Percentual de COFINS
Local nX2       := 0
Local nBasPisPas := 0
Local nPsVlPisSa := 0
Local nPsBsPisSa := 0 
Local nPsBsCofSa := 0  
Local nBasPisDev := 0
Local nBasCofDev := 0
Local nBasPisCof := 0
Local nValIpiDev := 0
Local nValIcmDev := 0
Local nPag		 := 0	
Local nTotAbat   := 0
Local nTamTit	 := TamSX3("E1_PREFIXO")[1]+TamSX3("E1_NUM")[1]+TamSX3("E1_PARCELA")[1]+1
Local nDevol 	 := 0
Local nF		 := 0                            
Local nI		 := 0
Local nY		 := 0                           
Local nAlDifCof  := 0
Local nAlDifPis  := 0 
Local nScanPis   := 0
Local nScanCof   := 0
Local cCfop01 := cCfop02 := cCfop03 := cCfop04 := cCfop05 := cCfop06 := ""
Local cCfop07 := cCfop08 := cCfop09 := cCfop10 := cCfop11 := cCfop12 := "" 
Local cCfop13 := cCfop14 := cCfop15 := cCfop16 := cCfop17 := cCfop18 := ""
Local cCfop22 := cCfop23 := cCfop24 := cCfop25 := cCfop26 := cCfop27 := ""
Local cCfop28 := cCfop29 := cCfop30 := cCfop31 := cCfop32 := cCfop33 := ""
Local cCfop34 := cCfop35 := cCfop36 := cCfop37 := cCfop38 := cCfop39 := ""
Local cCfop40 := cCfop41 := cCfop42 := cCfop43 := cCfop44 := cCfop45 := cCfop46 := ""
Local cChaveF3	:= ""
Local cCFOP   	:= ""
Local cCondicao := ""
Local cAliasSF3 := "SF3"
Local cFilDe    := mv_par04
Local cFilAte   := mv_par05
Local cMVCALC   :=	"" 
Local cMVCALCAD	:=	"" 
Local cMVAPUR   :=	"" 
Local cDebSTCOF := SuperGetMv("MV_DBSTCOF",.F.,"1")
Local cDebSTPIS := SuperGetMv("MV_DBSTPIS",.F.,"1")
Local cDebDBCOF := SuperGetMv("MV_DEDBCOF",.F.,"N")
Local cDebDBPIS := SuperGetMv("MV_DEDBPIS",.F.,"N")  
Local cMVOutRec := SuperGetMv("MV_OUTREC",.F.,"") // Outras Receitas
Local cMvRecVen := LeparSeq("MV_RECVEN","") // Receita de Vendas de Bens e Servicos
Local cMVRecAl05 := SuperGetMv("MV_RECALZ1",.F.,"") // Receita Auferidas Aliq Zero
Local cMVRecAl06 := SuperGetMv("MV_RECALZ2",.F.,"") // Receita Auferidas Aliq Zero - Revenda de Produto 
Local cMVRecAl07 := SuperGetMv("MV_RECALZ3",.F.,"") // Receita Vendas de Bens do Ativo Permanente
Local cMVRecAl08 := SuperGetMv("MV_RECALZ4",.F.,"") // Receita Sem Incidencia da Contribuicao -  Exportacao
Local cMVRecAl09 := SuperGetMv("MV_RECALZ5",.F.,"") // Receita Isenta e Demais Receitas Sem Incidencia da Contribuicao
Local cMVRecAl10 := SuperGetMv("MV_RECALZ6",.F.,"") // Receita com Suspensao da Contribuicao  
Local cMVRecAl11 := SuperGetMv("MV_RECALZ7",.F.,"") // Receita de Revenda Decorrente de operacoes  Sujeitas a ST
Local cMVRecAl12 := SuperGetMv("MV_RECALZ8",.F.,"") // Receita Tributada pelo RET - Patrimonio de Afetacao
Local cMVenergia := SuperGetMv("MV_ENERGIA",.F.,"") // Despesas de Energia Eletrica
Local cMValupred := SuperGetMv("MV_ALUPRED",.F.,"") // Despesas de Alugueis de Predio Locados de Pessoas Jurdicas
Local cMValumaqu := SuperGetMv("MV_ALUMAQU",.F.,"") // Despesas de Alugueis de Maquinas e Equipamentos Locados de Pessoas Juridicas

Local cChaveAnt := ""
Local cChaveSe1 := "" 
Local cQuery	:= ""
Local cAliasSE5	:= "SE5"
Local cAliasSE1	:= "SE1"
Local cAliasSD2 := "SD2"
Local cAliasSD1 := "SD1"
Local cAliasSF2	:= "SF2"
Local cAliasSF4	:= "SF4"
Local cAliasSB1	:= "SB1"
Local cAliasSA1	:= "SA1"
Local cIndex    := ""
Local cFiltro   := ""
Local cFatura   := ""
Local cCliente  := ""
Local cTpFatura := ""
Local cPrefAnt  := "" 
Local cNumAnt   := "" 
Local cParcAnt  := "" 
Local cTpAnt    := "" 
Local cClAnt    := "" 
Local cLjAnt    := "" 
Local cCpBsPisSa:= ""
Local cCpBsCofSa:= ""
Local cNota		:= ""  
Local nValorAbat := 0 
Local lFoundD1:= .F.
Local dDtIni    := mv_par01
Local dDtFin    := mv_par02
Local dDtIDep   := CTOD("  /  /  ")
Local dDtFDep   := CTOD("  /  /  ")
Local dDtFAq    := CTOD("  /  /  ")
Local dDtIAq    := CTOD("  /  /  ")
Local nPainel	:= 0
Local lDacTit	:= GetNewPar("MV_DACTIT",.T.)
Local lPisJaFol := .F.
Local nValFolSal:= 0
Local aInfFolSal  := {}
Local cDataRefFol := ""      
Local aOutrec	:={}
Local nOut 		:= 0
Local cOutRec	:= ""
Local aFilial   := {}    
Local nPainel10A	:=0
Local cCampos	:= ""
Local cWhere	:= ""
Local cOrderBy	:= ""
Local cAliasSE2	:= "SE2"
Local cAliasSED	:= "SED"
Local nIndex 	:= 0
Local lTop		:= .T.

#IFDEF TOP	
	If TcSrvType() <> "AS/400"
		lTop 	:= .T.		
	Endif
#ENDIF

//Ŀ
//Processa a Wizard com as configuracoes para o relatorio
//
If mv_par06 == 1
	cRegime		:=	"C"
	lRet		:=	Wiz_Cum(@nPainel10A)
	//Ŀ
	//Le a wizard com as configuracoes dos CFOPs
	//
	xMagLeWiz("MTR971C",@aWizard,.T.)
	aCumVlrs 	:= aClone(aWizard)
Elseif mv_par06 == 2
	cRegime		:=	"NC"
	lRet		:=	Wiz_NCum(@nPainel10A)
	//Ŀ
	//Le a wizard com as configuracoes dos CFOPs
	//
	xMagLeWiz("MTR971",@aWizard,.T.)
	aNCumVlr 	:= aClone(aWizard)
Else
	cRegime		:=	"AMB"
	lRet		:=	Wiz_Ambos(@nPainel10A)
	//Ŀ
	//Le a wizard com as configuracoes dos CFOPs
	//
	xMagLeWiz("MTR971A",@aWizard,.T.)
	aNCumVlr 	:= aClone(aWizard)
Endif
                                                 
If Empty(cFilDe) .And. Empty(cFilAte)
	cFilDe := cFilAnt
	cFilAte:= cFilAnt
Endif

//Ŀ
//Gera arquivo temporario para impressao das fichas 9A e 19A   
//
GeraTmp()
//Ŀ
//Gera arquivo temporario para impressao da ficha 10A          
//
GeraT01()
                
If lRet

	//Ŀ
	//REGIME NAO CUMULATIVO  
	//
	If mv_par06 ==2
		//Ŀ
		//Painel 1 - Apuracao  
		//
		cCfop01 := Alltrim(aWizard[01][01]) // 01.Bens para Revenda
		cCfop02 := Alltrim(aWizard[01][02]) // 02.Bens Utilizados como Insumos
		cCfop03 := Alltrim(aWizard[01][03]) // 03.Servicos Utilizados como Insumos
		cCfop04 := Alltrim(aWizard[01][04]) // 04.Despesas de Energia Eletrica
		cCfop05 := Alltrim(aWizard[01][05]) // 05.Despesa de Alugueis de Predios Locados de Pessoas Juridicas
		cCfop06 := Alltrim(aWizard[01][06]) // 06.Despesas de Alugueis de Maq./Equip. Locados de Pessoas Juridicas
		cCfop07 := Alltrim(aWizard[01][07]) // 07.Despesas de Armazenagem e Frete na Operacao de Venda
		cCfop08 := Alltrim(aWizard[01][13]) // 13.Outras Operacoes com Direito a Credito
		cCfop15 := Alltrim(aWizard[01][14]) // 16.Creditos Calculados a Aliquotas diferenciadas
		cCfop46 := Alltrim(aWizard[01][22]) // 25.Calculados a Alquota de 0,9900%
		//Ŀ
		//Painel 2 - Calculo   
		//
		cCfop09 := Alltrim(aWizard[02][01]) // 01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%
		cCfop10 := Alltrim(aWizard[02][02]) // 02.Demais Receitas - Aliquota de 1,65%
		cCfop36 := Alltrim(aWizard[02][03]) // 04.Receita Trib. Aliq.Zero 
		cCfop37 := Alltrim(aWizard[02][04]) // 05.Receita Trib. Aliq.Zero-Rev.Prod.
		cCfop38 := Alltrim(aWizard[02][05]) // 06.Receita Vendas Bens Ativ.Perman.
		cCfop40 := Alltrim(aWizard[02][06]) // 08.Receita Isenta Sem Incid.Contrib.
		cCfop41 := Alltrim(aWizard[02][08]) // 09.Receita com Susp.Contrib.
		cCfop42 := Alltrim(aWizard[02][09]) // 10.Receita Revenda Op.Subst.Trib.
		cCfop43 := Alltrim(aWizard[02][10]) // 11.Receita Tributada pelo RET
		cCfop22 := Alltrim(aWizard[02][12]) // 13.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Receita de Vendas)
		cCfop12 := Alltrim(aWizard[02][13]) // 14.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		cCfop13 := Alltrim(aWizard[02][14]) // 15.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
		cCfop14 := Alltrim(aWizard[02][15]) // 16.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
		cCfop17 := Alltrim(aWizard[02][16]) // Faturamento Mercado Interno - Tributada
		cCfop16 := Alltrim(aWizard[02][17]) // Faturamento Mercado Externo
		cCfop44 := Alltrim(aWizard[02][18]) // Faturamento Mercado Interno - No Tributada
		//Ŀ
		//IMPORTACAO - REGIME NAO CUMULATIVO  
		//
		nPainel := 3
		If mv_par09 ==2
			//Ŀ
			//Painel - IMPORTACAO    
			//
			cCfopB01 := Alltrim(aWizard[nPainel][01]) // 01.Bens para Revenda
			cCfopB02 := Alltrim(aWizard[nPainel][02]) // 02.Bens Utilizados como Insumos
			cCfopB03 := Alltrim(aWizard[nPainel][03]) // 03.Servicos Utilizados como Insumos
			cCfopB04 := Alltrim(aWizard[nPainel][04]) // 04.Despesas de Energia Eletrica
			cCfopB05 := Alltrim(aWizard[nPainel][05]) // 05.Despesa de Alugueis de Predios	
			cCfopB08 := Alltrim(aWizard[nPainel][08]) // 08.Outras Operacoes com Direito a Credito		
			cCfopB15 := Alltrim(aWizard[nPainel][09]) // 11.Creditos Calculados a Aliquotas diferenciadas
			nPainel := 4
		EndIf
		
		//Ŀ
		//Painel 3 - Calculo Aliquotas Diferenciadas  
		//
		If mv_par07 == 2 //Imprime Ficha 09A/ 19A
			cCfop18 := Alltrim(aWizard[nPainel][01]) // Receitas de Vendas
			cCfop11 := Alltrim(aWizard[nPainel][02]) // Vendas Canceladas e Descontos Incondicionais
			if mv_par09 == 2
				nPainel := 5
			EndIf
			if mv_par09 == 1  .and. mv_par12 == 1
				nPainel := 3
			EndIf				
		Endif
		
		If mv_par12 == 2 //Imprime Ficha 10A
			cCfop45 := Alltrim(aWizard[nPainel10A][01]) // Receitas de Vendas
		Endif
		
		
	//Ŀ
	//AMBOS - REGIME NAO CUMULATIVO E CUMULATIVO 
	//
	Elseif mv_par06 ==3
		//Ŀ
		//Painel 1 - Apuracao  
		//
		cCfop01 := Alltrim(aWizard[01][01]) // 01.Bens para Revenda
		cCfop02 := Alltrim(aWizard[01][02]) // 02.Bens Utilizados como Insumos
		cCfop03 := Alltrim(aWizard[01][03]) // 03.Servicos Utilizados como Insumos
		cCfop04 := Alltrim(aWizard[01][04]) // 04.Despesas de Energia Eletrica
		cCfop05 := Alltrim(aWizard[01][05]) // 05.Despesa de Alugueis de Predios Locados de Pessoas Juridicas
		cCfop06 := Alltrim(aWizard[01][06]) // 06.Despesas de Alugueis de Maq./Equip. Locados de Pessoas Juridicas
		cCfop07 := Alltrim(aWizard[01][07]) // 07.Despesas de Armazenagem e Frete na Operacao de Venda
		cCfop08 := Alltrim(aWizard[01][13]) // 13.Outras Operacoes com Direito a Credito
		cCfop15 := Alltrim(aWizard[01][14]) // 16.Creditos Calculados a Aliquotas diferenciadas
		//Ŀ
		//Painel 2 - Calculo Somente Regime Nao Cumulativo e Cumulativo  
		//
		// RECEITAS - REGIME NAO CUMULATIVO
		cCfop23 := Alltrim(aWizard[02][01]) // 01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%
		cCfop24 := Alltrim(aWizard[02][02]) // 02.Demais Receitas - Aliquota de 1,65%
        // RECEITAS - REGIME CUMULATIVO
		cCfop25 := Alltrim(aWizard[02][03]) // 04.Receita de Vendas de Bens e Servicos - Aliquota de 0,65%
		cCfop26 := Alltrim(aWizard[02][04]) // 05.Demais Receitas - Aliquota de 0,65%
		cCfop35 := Alltrim(aWizard[02][03]) // 03.Rec. Trib. ST
        // OUTRAS RECEITAS
		cCfop36 := Alltrim(aWizard[02][06]) // 04.Receita Trib. Aliq.Zero 
		cCfop37 := Alltrim(aWizard[02][07]) // 05.Receita Trib. Aliq.Zero-Rev.Prod.
		cCfop38 := Alltrim(aWizard[02][08]) // 06.Receita Vendas Bens Ativ.Perman.
		cCfop39 := Alltrim(aWizard[02][09]) // 06.Receita sem Incidencia
		cCfop40 := Alltrim(aWizard[02][10]) // 08.Receita Isenta Sem Incid.Contrib.
		cCfop41 := Alltrim(aWizard[02][11]) // 09.Receita com Susp.Contrib.
		cCfop42 := Alltrim(aWizard[02][12]) // 10.Receita Revenda Op.Subst.Trib.
		cCfop43 := Alltrim(aWizard[02][13]) // 11.Receita Tributada pelo RET
        // EXCLUSOES - REGIME NAO CUMULATIVO
		cCfop27 := Alltrim(aWizard[02][15]) // 17.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Receita de Vendas)
		cCfop28 := Alltrim(aWizard[02][16]) // 18.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		cCfop29 := Alltrim(aWizard[02][17]) // 19.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
		cCfop30 := Alltrim(aWizard[02][18]) // 20.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
        // EXCLUSOES - REGIME CUMULATIVO
		cCfop31 := Alltrim(aWizard[02][19]) // 21.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Receita de Vendas)
		cCfop32 := Alltrim(aWizard[02][20]) // 22.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		cCfop33 := Alltrim(aWizard[02][21]) // 23.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
		cCfop34 := Alltrim(aWizard[02][22]) // 24.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
        //
		cCfop17 := Alltrim(aWizard[02][23]) // Faturamento Mercado Interno - Tributada
		cCfop16 := Alltrim(aWizard[02][24]) // Faturamento Mercado Externo
		cCfop44 := Alltrim(aWizard[02][25]) // Faturamento Mercado Interno - No Tributada
		//Ŀ
		//IMPORTACAO - REGIME NAO CUMULATIVO  
		//
		nPainel := 3
		If mv_par09 ==2
			//Ŀ
			//Painel - IMPORTACAO    
			//
			cCfopB01 := Alltrim(aWizard[nPainel][01]) // 01.Bens para Revenda
			cCfopB02 := Alltrim(aWizard[nPainel][02]) // 02.Bens Utilizados como Insumos
			cCfopB03 := Alltrim(aWizard[nPainel][03]) // 03.Servicos Utilizados como Insumos
			cCfopB04 := Alltrim(aWizard[nPainel][04]) // 04.Despesas de Energia Eletrica
			cCfopB05 := Alltrim(aWizard[nPainel][05]) // 05.Despesa de Alugueis de Predios	
			cCfopB08 := Alltrim(aWizard[nPainel][08]) // 08.Outras Operacoes com Direito a Credito		
			cCfopB15 := Alltrim(aWizard[nPainel][09]) // 11.Creditos Calculados a Aliquotas diferenciadas
			nPainel := 4
		EndIf
		//Ŀ
		//Painel - Calculo Aliquotas Diferenciadas    
		//
		If mv_par07 == 2 //Imprime Ficha 09A/ 19A
			cCfop18 := Alltrim(aWizard[nPainel][01]) // Receitas de Vendas
			cCfop11 := Alltrim(aWizard[nPainel][02]) // Vendas Canceladas e Descontos Incondicionais
			if mv_par09 == 2
				nPainel := 5
			EndIf
			if mv_par09 == 1  .and. mv_par12 == 1
				nPainel := 3
			EndIf				
		Endif
		
		If mv_par12 == 2 //Imprime Ficha 10A
			cCfop45 := Alltrim(aWizard[nPainel10A][01]) // Receitas de Vendas
		Endif		
	Else
		//Ŀ
		//REGIME CUMULATIVO      
		//
		//Ŀ
		//Painel 1 - Calculo   
		//
		cCfop09 := Alltrim(aWizard[01][01]) // 01.Receita de Vendas de Bens e Servicos - Aliquota de 0,65%
		cCfop10 := Alltrim(aWizard[01][02]) // 02.Demais Receitas - Aliquota de 0,65%
		cCfop35 := Alltrim(aWizard[01][03]) // 03.Rec. Trib. ST
		cCfop36 := Alltrim(aWizard[01][04]) // 04.Receita Trib. Aliq.Zero 
		cCfop37 := Alltrim(aWizard[01][05]) // 05.Receita Trib. Aliq.Zero-Rev.Prod.
		cCfop38 := Alltrim(aWizard[01][06]) // 06.Receita Vendas Bens Ativ.Perman.
		cCfop39 := Alltrim(aWizard[01][07]) // 07.Receita sem incidencia
		cCfop40 := Alltrim(aWizard[01][08]) // 08.Receita Isenta Sem Incid.Contrib.
		cCfop41 := Alltrim(aWizard[01][09]) // 09.Receita com Susp.Contrib.
		cCfop42 := Alltrim(aWizard[01][10]) // 10.Receita Revenda Op.Subst.Trib.
		cCfop43 := Alltrim(aWizard[01][11]) // 11.Receita Tributada pelo RET
		cCfop22 := Alltrim(aWizard[01][13]) // 14.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Receita de Vendas)
		cCfop12 := Alltrim(aWizard[01][14]) // 15.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		cCfop13 := Alltrim(aWizard[01][15]) // 16.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
		cCfop14 := Alltrim(aWizard[01][16]) // 17.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
		//Ŀ
		//IMPORTACAO - REGIME NAO CUMULATIVO  
		//
		nPainel := 2
		If mv_par09 ==2
			//Ŀ
			//Painel - IMPORTACAO    
			//
			cCfopB01 := Alltrim(aWizard[nPainel][01]) // 01.Bens para Revenda
			cCfopB02 := Alltrim(aWizard[nPainel][02]) // 02.Bens Utilizados como Insumos
			cCfopB03 := Alltrim(aWizard[nPainel][03]) // 03.Servicos Utilizados como Insumos
			cCfopB04 := Alltrim(aWizard[nPainel][04]) // 04.Despesas de Energia Eletrica
			cCfopB05 := Alltrim(aWizard[nPainel][05]) // 05.Despesa de Alugueis de Predios	
			cCfopB08 := Alltrim(aWizard[nPainel][08]) // 08.Outras Operacoes com Direito a Credito		
			cCfopB15 := Alltrim(aWizard[nPainel][09]) // 11.Creditos Calculados a Aliquotas diferenciadas
			nPainel := 3
		EndIf
   		//Ŀ
		//Painel - Calculo Aliquotas Diferenciadas    
		//
		If mv_par07 == 2 //Imprime Ficha 09A/ 19A
			cCfop18 := Alltrim(aWizard[nPainel][01]) // Receitas de Vendas
			cCfop11 := Alltrim(aWizard[nPainel][02]) // Vendas Canceladas e Descontos Incondicionais
			if mv_par09 == 2
				nPainel := 4
			EndIf
			if mv_par09 == 1  .and. mv_par12 == 1
				nPainel := 2
			EndIf							
		Endif		
		If mv_par12 == 2 //Imprime Ficha 10A
			cCfop45 := Alltrim(aWizard[nPainel10A][01]) // Receitas de Vendas
		Endif		
	Endif
	
	dbSelectArea("SM0")
	dbSeek(cEmpAnt+cFilDe,.T.)
	Do While !Eof() .And. FWGrpCompany() == cEmpAnt .and. FWCodFil() <= cFilAte

		cAliasSE5	:= "SE5"
		cAliasSE1	:= "SE1"
		cAliasSD2 	:= "SD2"
		cAliasSD1 	:= "SD1"
		cAliasSF2	:= "SF2"
		cAliasSF4	:= "SF4"
		cAliasSB1	:= "SB1"
		cAliasSA1	:= "SA1"
		cAliasSF3	:=	"SF3"

		DbSelectArea("SX6")
		SX6->(DbSetOrder(1))
		//Ŀ
		//MV_CALC971 - Parametro de Calculo do Pis/Cofins	
		//
		bCond	:=	{|| xFilial("SX6")==SX6->X6_FIL .And. "MV_CALC97"$SX6->X6_VAR}
		If !SX6->(DbSeek(xFilial("SX6")+"MV_CALC97"))
			SX6->(DbSeek(Space(FWSizeFilial())+"MV_CALC97"))
			bCond	:=	{|| Space(FWSizeFilial())==SX6->X6_FIL .And. "MV_CALC97"$SX6->X6_VAR}
		EndIf
		Do While !SX6->(Eof()) .And. Eval(bCond)
			cMVCALC	+=	AllTrim (SX6->X6_CONTEUD)
			SX6->(DbSkip())
		EndDo
		//Ŀ
		//MV_APUR971 - Parametro de Apuracao do Pis/Cofins	
		//
		bCond	:=	{|| xFilial("SX6")==SX6->X6_FIL .And. "MV_APUR97"$SX6->X6_VAR}
		If !SX6->(DbSeek(xFilial("SX6")+"MV_APUR97"))
			SX6->(DbSeek(Space(FWSizeFilial())+"MV_APUR97"))
			bCond	:=	{|| Space(FWSizeFilial())==SX6->X6_FIL .And. "MV_APUR97"$SX6->X6_VAR}
		EndIf
		Do While !SX6->(Eof()) .And. Eval(bCond)
			cMVAPUR	+=	AllTrim (SX6->X6_CONTEUD)
			SX6->(DbSkip())
		EndDo
		//Ŀ
		//MV_CALCAD - Parametro de Calculo do Pis/Cofins - Aliquota Diferenciada	
		//
		bCond	:=	{|| xFilial("SX6")==SX6->X6_FIL .And. "MV_CALCAD"$SX6->X6_VAR}
		If !SX6->(DbSeek(xFilial("SX6")+"MV_CALCAD"))
			SX6->(DbSeek(Space(FWSizeFilial())+"MV_CALCAD"))
			bCond	:=	{|| Space(FWSizeFilial())==SX6->X6_FIL .And. "MV_CALCAD"$SX6->X6_VAR}
		EndIf
		Do While !SX6->(Eof()) .And. Eval(bCond)
			cMVCALCAD	+=	AllTrim (SX6->X6_CONTEUD)
			SX6->(DbSkip())
		EndDo

		If !lRegCaixa // se nao for Regime de caixa, pode ser de Competencia e regime Cumulativo
			cFilAnt	:=	FWCodFil()
		
			dbSelectArea("SF3")
			dbSetOrder(1)
		
			#IFDEF TOP
			    If TcSrvType()<>"AS/400"
				    lQuery := .T.
					cAliasSF3 := "QRYSF3"
					aStruSF3  := SF3->(dbStruct())
					cQuery := "SELECT * "
					cQuery += "FROM "+RetSqlName("SF3")+" "
					cQuery += "WHERE F3_FILIAL='"+xFilial("SF3")+"' AND "
					cQuery += "F3_ENTRADA>='"+Dtos(dDtIni)+"' AND "
					cQuery += "F3_ENTRADA<='"+Dtos(dDtFin)+"' AND "	
					cQuery += "F3_TIPO <>'P' AND "
					cQuery += "D_E_L_E_T_ = ' ' "
					//
					//Livro Selecionado
					If !((Empty (MV_PAR03)) .Or. ("*"$MV_PAR03))
						cQuery += " AND F3_NRLIVRO='"+MV_PAR03+"' "
					EndIf
					//
					cQuery += "ORDER BY "+SqlOrder(SF3->(IndexKey()))
			
					cQuery := ChangeQuery(cQuery)
					dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSF3)
			
					For nX := 1 To len(aStruSF3)
						If aStruSF3[nX][2] <> "C" .And. FieldPos(aStruSF3[nX][1])<>0
							TcSetField(cAliasSF3,aStruSF3[nX][1],aStruSF3[nX][2],aStruSF3[nX][3],aStruSF3[nX][4])
						EndIf
					Next nX
					dbSelectArea(cAliasSF3)	
				Else
			#ENDIF
			    cIndex    := CriaTrab(NIL,.F.)
			    cCondicao := 'F3_FILIAL="'+xFilial("SF3")+'" .And. '
			   	cCondicao += 'DTOS(F3_ENTRADA)>="'+DTOS(dDtIni)+'".And.DTOS(F3_ENTRADA)<="'+DTOS(dDtFin)+'" '
				cCondicao += '.And. F3_TIPO <> "P" '		
				//
				//Livro Selecionado
				If !((Empty (MV_PAR03)) .Or. ("*"$MV_PAR03))
					cCondicao += ' .AND. F3_NRLIVRO=="'+MV_PAR03+'" '
				EndIf
				//
			    IndRegua(cAliasSF3,cIndex,SF3->(IndexKey()),,cCondicao)
			    nIndex := RetIndex("SF3")
				#IFNDEF TOP
					dbSetIndex(cIndex+OrdBagExt())
				#ENDIF
				dbSelectArea("SF3")
			    dbSetOrder(nIndex+1)
			
			    dbSelectArea(cAliasSF3)
			    ProcRegua(LastRec())
			    dbGoTop()
			#IFDEF TOP
				Endif    
			#ENDIF
		
			dbSelectArea(cAliasSF3) 
			If !EOF()
				AADD(aFilial,cFilAnt)
			Endif	
			Do While !Eof() 			
				nPosMes	:=	aScan (aMes, {|aX| aX[1]==Month((cAliasSF3)->F3_ENTRADA)})
				If nPosMes==0
					aAdd (aMes, {Month((cAliasSF3)->F3_ENTRADA), {},{},{}})
					nPosMes	:=	aScan(aMes, {|aX| aX[1]==Month((cAliasSF3)->F3_ENTRADA)})								
					//
					//	CUIDADO 																	 
					// Ao Alterar a estrutura ou a alimentao do array (aMes) verifique a gerao  
					// do arquivo pois o mesmo tambm  usado para ger-lo.                         
					//				
					For nI := 1 To 52         // Tributada no Mercado Interno
						aAdd(aMes[nPosMes][2],{0,0,0})
						aAdd(aMes[nPosMes][3],{0,0,0})
					Next (nI)                 //Exportacao
				EndIf
			    //Mes
			   	Do While !Eof() .And. aMes[nPosMes][1] == Month((cAliasSF3)->F3_ENTRADA)
			   		lAliqDif := .F.		   		
					//
					//Processa por item cada documento fiscal
					//
			        If Substr((cAliasSF3)->F3_CFO,1,1) <> Substr(cCFOP,1,1) .And. cCFOP <> ""
			        	cChaveF3 := ""
			        Endif
					If cChaveF3 <> (cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA
						cChaveF3 := (cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA
				         cCFOP    := (cAliasSF3)->F3_CFO	
		
						If Substr((cAliasSF3)->F3_CFO,1,1) < "5" // Apuracao dos Creditos --> Entradas
						    dbSelectArea("SD1")
						    dbSetOrder(1)
						    If dbSeek(xFilial("SD1")+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA)
						        While !Eof() .And. (cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA ==;
						            SD1->D1_DOC+SD1->D1_SERIE+SD1->D1_FORNECE+SD1->D1_LOJA
						            dbSelectArea("SB1")
						            dbSeek(xFilial("SB1")+SD1->D1_COD)
										//Ŀ
										//Processa somente TES com direito a credito de PIS e/ou COFINS
										//
										SF4->(dbSetOrder(1))
										If ! SF4->(dbSeek(xFilial("SF4")+SD1->D1_TES)) .Or. SF4->F4_PISCOF == "4" .Or. AllTrim (SD1->D1_TIPO)$"I"
											dbSelectArea("SD1")
								        	dbSkip()                                     
								        	Loop
										Endif
										//Ŀ
										//O IPI nao deve constar no valor contabil a ser lancado
										//
/*
										If (SF4->F4_PISBRUT=="1" .Or. SF4->F4_COFBRUT=="1")
											nVAgrDes:=SD1->D1_VALDESC                          
										Endif
*/
										//Caso a base do PIS seja reduzida, usamos o campo D1_BASIMP5
										//Essa base ser usada tambem para o Cofins, independente de termos a base do Cofins reduzida (D1_BASIMP5),
										//porem nas orientaes de preenchimento da Dacon, o valor da base do Cofins  o mesmo do Pis.
										//Como no Protheus a reduo da base pode ser diferente no PIS e Cofins, adotamos que seja usada a do PIS.
										// Inserido tratamento para considerar o valor do desconto, caso flag da TES configurado. RC - 04/07/13
										nItemValCont := 	iif(SD1->D1_BASIMP6>0,SD1->D1_BASIMP6,SD1->D1_TOTAL) +; 
															IIF(cDebDBCOF$"SI" .And. cDebDBPIS$"SI",0,SD1->D1_ICMSRET) +;
															IIF(cDebDBCOF$"SP" .And. cDebDBPIS$"SP",0,SD1->D1_VALIPI) +;
															IIf(SF4->F4_AGREG$"I/B",SD1->D1_VALICM,0) -;
															Iif(SD1->D1_BASIMP6>0,0,SD1->D1_VALDESC) +;
															IIf(SF4->F4_PISBRUT=="1" .Or. SF4->F4_COFBRUT=="1", SD1->D1_VALDESC, 0)
										//Copiado da funcao da MATXFIS - MaFisBSCOF, MaFisBSPIS
										//Ŀ
										// Indica o tratamento para retirada do valor do ICMS solidario na base do PIS apurado    
										// 1 - Nunca retira                                                                       
										// 2 - Retira se houver credito do ICMS ST                                                
										// 3 - Retira se nao houver credito do ICMS ST                                            
										// 4 - Retira se houver credito do ICMS normal                                            
										// 5 - Retira se nao houver credito do ICMS normal                                        
										// 6 - Sempre retira                                                                      
										//
										If (SD1->D1_ICMSRET>0)
											If (SF4->F4_PISCRED<>"3") .And. (SF4->F4_PISCOF$"23")
												If (cDebSTCOF=="6") .Or. ;
													(SF4->F4_CREDST=="1" .And. cDebSTCOF=="2") .Or. ;
													(SF4->F4_CREDST=="2" .And. cDebSTCOF=="3") .Or. ;
													(SF4->F4_CREDICM=="S" .And. cDebSTCOF=="4") .Or. ;
													(SF4->F4_CREDICM=="N" .And. cDebSTCOF=="5")
													nItemValCont -= SD1->D1_ICMSRET
												Endif
											Else
											If (SF4->F4_PISCRED<>"3") .And. (SF4->F4_PISCOF$"13")
												If (cDebSTPIS=="6") .Or. ;
													(SF4->F4_CREDST=="1" .And. cDebSTPIS=="2") .Or. ;
													(SF4->F4_CREDST=="2" .And. cDebSTPIS=="3") .Or. ;
													(SF4->F4_CREDICM=="S" .And. cDebSTPIS=="4") .Or. ;
													(SF4->F4_CREDICM=="N" .And. cDebSTPIS=="5")
													nItemValCont -= SD1->D1_ICMSRET
												EndIf
											Endif
										EndIf
									EndIf
									//
									// Verifica as aliquotas de PIS/COFINS diferenciada    
									// PIS Padrao: 1.65% - COFINS Padrao: 7.6%             
									//
			            			//16.Creditos Calculados a Aliquotas diferenciadas  - Pis / Cofins
									If SB1->B1_PPIS <> 1.65 .And. SB1->B1_PPIS > 0 .And. SB1->B1_PCOFINS <> 7.6 .And. SB1->B1_PCOFINS > 0
										lProcessa := .F.
										nAlDifPis := SB1->B1_PPIS
										nAlDifCof := SB1->B1_PCOFINS
										If mv_par09==2
											If (AllTrim(SD1->D1_CF)$cCfopB15) .And. Substr(SD1->D1_CF,1,1) == "3"
												aMes[nPosMes][3][1][1]	+=	((nItemValCont*nAlDifPis)/100)
												aMes[nPosMes][3][2][1]	+=	((nItemValCont*nAlDifCof)/100)
								    	    	SD1->(dbSkip())
								        		Loop
											EndIf
										EndIf
										If mv_par06 ==2 .Or. mv_par06 ==3
											If (AllTrim(SD1->D1_CF)$cCfop15) .Or. "16-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif
											If lProcessa
												If Substr(SD1->D1_CF,1,1) == "3"
													aMes[nPosMes][2][1][2]	+=	((nItemValCont*nAlDifPis)/100)
													aMes[nPosMes][2][2][2]	+=	((nItemValCont*nAlDifCof)/100)
												ElseIf Substr(SD1->D1_CF,1,1) == "1"
													aMes[nPosMes][2][1][1]	+=	((nItemValCont*nAlDifPis)/100)
													aMes[nPosMes][2][2][1]	+=	((nItemValCont*nAlDifCof)/100)
												Else
													aMes[nPosMes][2][1][3]	+=	((nItemValCont*nAlDifPis)/100)
													aMes[nPosMes][2][2][3]	+=	((nItemValCont*nAlDifCof)/100)
												Endif
												dbSelectArea("SD1")
								    	    	dbSkip()
								        		Loop
									    	Endif
									    Endif
									Endif
									//
									If mv_par09 ==2
			                          	//Somente serao consideradas notas com CFOP de importacao
				            			If ! SD1->D1_TIPO $ "DB" .And. Substr(SD1->D1_CF,1,1) == "3"
							        		//01.Bens para Revenda
											If (AllTrim(SD1->D1_CF)$cCfopB01)
												aMes[nPosMes][3][3][1]	+=	nItemValCont
											Endif
											//02.Bens Utilizados como Insumos
											If (AllTrim(SD1->D1_CF)$cCfopB02)
												aMes[nPosMes][3][4][1]	+=	nItemValCont
											Endif
											//03.Servicos Utilizados como Insumos
											If (AllTrim(SD1->D1_CF)$cCfopB03)
												aMes[nPosMes][3][6][1]	+=	nItemValCont
											Endif    
											//04.Despesas de Energia Eletrica
											If (AllTrim(SD1->D1_CF)$cCfopB04)
												aMes[nPosMes][3][5][1]	+=	nItemValCont
											Endif    
										    //05.Despesa de Alugueis de Predios
											If (AllTrim(SD1->D1_CF)$cCfopB05)
												aMes[nPosMes][3][20][1] +=	nItemValCont
											Endif    
										    //13.Outras Operacoes com Direito a Credito
											If (AllTrim(SD1->D1_CF)$cCfopB08)
												aMes[nPosMes][3][22][1] +=	nItemValCont
											Endif    
			    	                    Endif
					          		EndIf
									If mv_par06 ==2 .Or. mv_par06 ==3
				            			If ! SD1->D1_TIPO $ "DB"
							        		//01.Bens para Revenda
				                           lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop01) .Or. "01-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif
					                        If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Exportacao / 3-Nao Tributada
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][3][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][3][3]	+=	nItemValCont
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][3][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][3][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][3][3]	+=	nItemValCont //N Tributada Mercado Interno
													Else
														aMes[nPosMes][2][3][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
											//02.Bens Utilizados como Insumos
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop02) .Or. "02-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][4][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][4][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][4][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][4][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][4][3]	+=	nItemValCont //N Tributada Mercado Interno
													Else
														aMes[nPosMes][2][4][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
											//03.Servicos Utilizados como Insumos
					                        lProcessa := .F.
											If ((AllTrim(SD1->D1_CF)$cCfop03) .Or. "03-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR)
												lProcessa := .T.
											Endif    
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		 //Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][6][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][6][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][6][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][6][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][6][3]	+=	nItemValCont //N Tributada Mercado Interno
													Else
														aMes[nPosMes][2][6][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
											//04.Despesas de Energia Eletrica
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop04) .Or. "04-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif    
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		 //Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][5][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][5][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][5][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][5][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][5][3]	+=	nItemValCont ///Mercado Interno NAO Tributado
													Else
														aMes[nPosMes][2][5][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
										   //05.Despesa de Alugueis de Predios Locados de Pessoas Juridicas
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop05) .Or. "05-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif    
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][20][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][20][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][20][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][20][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][20][3]	+=	nItemValCont //N Tributada Mercado Interno
													Else
														aMes[nPosMes][2][20][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif                                                  
										   //06.Despesas de Alugueis de Maq./Equip. Locados de Pessoas Juridicas
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop06) .Or. "06-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][21][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][21][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][21][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][21][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][21][3]	+=	nItemValCont //Mercado Interno NAO Tributado
													Else
														aMes[nPosMes][2][21][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
										   //07.Despesas de Armazenagem e Frete na Operacao de Venda
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop07) .Or. "07-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif    
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][23][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][23][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][23][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][23][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][23][3]	+=	nItemValCont //Mercado Interno NAO Tributado
													Else
														aMes[nPosMes][2][23][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
										   //13.Outras Operacoes com Direito a Credito
					                        lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop08) .Or. "13-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif    
										   If lProcessa 
					                           	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Nao Tributada / 3-Exportacao
                	                               If SF4->F4_RECDAC=="1"  
                    	                           		aMes[nPosMes][2][22][1]	+=	nItemValCont //Tributada Mercado Interno
	                                               Elseif SF4->F4_RECDAC=="2" 
		                                                aMes[nPosMes][2][22][3]	+=	nItemValCont //Mercado Interno NAO Tributado
        	                                       Elseif SF4->F4_RECDAC=="3"  
	            	                               		aMes[nPosMes][2][22][2]	+=	nItemValCont  //Exportacao
                    	                           Endif
                        	                    Else	
			 										If Substr(SD1->D1_CF,1,1) == "3" 
													   	aMes[nPosMes][2][22][2]	+=	nItemValCont //Exportacao
													ElseIf Substr(SD1->D1_CF,1,1) == "2" 
													   	aMes[nPosMes][2][22][3]	+=	nItemValCont //N Tributada Mercado Interno
													Else
														aMes[nPosMes][2][22][1]	+=	nItemValCont //Tributada Mercado Interno
													Endif
												Endif	
										   Endif
										    //"25.Calculados a Alquota de 0,99/4,56%"
			                                lProcessa := .F.
											If (AllTrim(SD1->D1_CF)$cCfop46) .Or. "25-"+AllTrim(SD1->D1_TES)+"-"+AllTrim(SD1->D1_CF)$cMVAPUR
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												If SB1->(FieldPos(cCampoAgro)) > 0    
		   								   			cProdAgro := SB1->&(cCampoAgro)
													If cProdAgro == "1"
														If Substr(SD1->D1_CF,1,1) == "3" 
													    	aMes[nPosMes][2][52][2]	+=	nItemValCont //Exportacao
													    Else
														    aMes[nPosMes][2][52][1]	+=	nItemValCont //Tributada Mercado Interno
														Endif
													Endif
												Endif	
										    Endif 
										//12.Devolucoes de Vendas Sujeitas a Aliquota de 1,65%/7,6% (Proc.Automatico)
										Elseif SD1->D1_TIPO == "D"
									    	If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Exportacao / 3-Nao Tributada
                	                               If SF4->F4_RECDAC=="1"  // Mercado Interno Tributada
                    	                           		aMes[nPosMes][2][7][1]	+=	nItemValCont
                                               Elseif SF4->F4_RECDAC=="2" //Mercado Interno NAO Tributado
	                                                aMes[nPosMes][2][7][3]	+=	nItemValCont
        	                                       Elseif SF4->F4_RECDAC=="3"  //Exportacao
        	                                   		nNTrib 	+=	nItemValCont
            	                               		aMes[nPosMes][2][50][2] +=	nItemValCont
                    	                           Endif
                        	                    Else
												If Substr(SD1->D1_CF,1,1) == "3"
										    		aMes[nPosMes][2][7][2]	+=	nItemValCont
											    ElseIf Substr(SD1->D1_CF,1,1) == "2" 
	                                                aMes[nPosMes][2][7][3]	+=	nItemValCont	//N Tributada Mercado Interno
												Else
													aMes[nPosMes][2][7][1]	+=	nItemValCont	//Tributada Mercado Interno
												Endif
                                            Endif								    
				                        Endif
				                    Endif
							        dbSelectArea("SD1")
						          	dbSkip()
								Enddo
							Endif
						Else
						//Calculo das Contribuicoes Pis/Cofins  --> Saidas
						    dbSelectArea("SD2")
						    dbSetOrder(3)
						    If dbSeek(xFilial("SD2")+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA)
						        While !Eof() .And. (cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA ==;
						            SD2->D2_DOC+SD2->D2_SERIE+SD2->D2_CLIENTE+SD2->D2_LOJA
									//
									//Verifica se as Aliquotas de PIS/COFINS sao Diferenciadas
									//PIS Padrao: 1.65% - COFINS Padrao: 7.6%                 
									//
									nPPis	:= 0
									nPCofins:= 0
									SB1->(dbSetOrder(1))
									If SB1->(dbSeek(xFilial("SB1")+SD2->D2_COD))
										
										//Verifica se tem preenchido os campos referente a Pauta de PIS e COFINS
										IF SB1->B1_VLR_PIS > 0 .OR. SB1->B1_VLR_COF > 0
											nPPis	:= SB1->B1_VLR_PIS
											nPCofins:= SB1->B1_VLR_COF
										Else
											nPPis	:= SB1->B1_PPIS
											nPCofins:= SB1->B1_PCOFINS
											If (nPPis <> 1.65 .And. nPPis > 0) .Or. (nPCofins <> 7.6 .And. nPCofins > 0)
												lAliqDif := .T.
											Endif
										EndIF
									Endif
									//Ŀ
									//Verifica quais as TES que dao direito ao credito de PIS/COFINS
									//
									SF4->(dbSetOrder(1))
									If !SF4->(dbSeek(xFilial("SF4")+SD2->D2_TES)) .Or. (SF4->F4_PISCOF == "4" .And. !(Left (AllTrim (SD2->D2_CF), 1)=="7"))
								        dbSelectArea("SD2")
							        	dbSkip()
						    	    	Loop
									Endif   
									lFoundD1:= .F.
									If cNota == SD2->D2_DOC 
										dbSelectArea(cAliasSD1)	 
			  							dbgotop()								   									   
									else								
									#IFDEF TOP
									    If TcSrvType()<>"AS/400"
										   lQuery := .T.
											cAliasSD1 := GetNextAlias()
											aStruSD1  := SD1->(dbStruct())
											cQuery := "SELECT * "
											cQuery += "FROM "+RetSqlName("SD1")+" "
											cQuery += "WHERE D1_FILIAL='"+xFilial("SD1")+"' AND "
											cQuery += "D1_EMISSAO>='"+Dtos(SD2->D2_EMISSAO)+"' AND "
											cQuery += "D1_EMISSAO<='"+Dtos(SD2->D2_EMISSAO)+"' AND "	
											cQuery += "D1_TIPO ='D' AND "
											cQuery += "D1_NFORI='"+SD2->D2_DOC+"' AND "
											cQuery += "D1_SERIORI='"+SD2->D2_SERIE+"' AND "
											cQuery += "D_E_L_E_T_ = ' ' "
											cQuery += "ORDER BY "+SqlOrder(SD1->(IndexKey()))
										
											cQuery := ChangeQuery(cQuery)
											dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSD1)
											cNota := SD2->D2_DOC				
											dbSelectArea(cAliasSD1)	
											dbgotop()
										Else
									#ENDIF
											cIndex    := CriaTrab(NIL,.F.)
										    cCondicao := 'D1_FILIAL="'+xFilial("SD1")+'" .And. ' 
											cCondicao += 'Dtos(D1_EMISSAO)>="'+Dtos(SD2->D2_EMISSAO) + '".And.'
										   	cCondicao += 'DTOS(D1_EMISSAO)<="'+DTOS(SD2->D2_EMISSAO)+'".And.'
											cCondicao += 'D1_TIPO = "D".And.'		
											cCondicao += 'D1_NFORI="'+SD2->D2_DOC+'".And.'
											cCondicao += 'D1_SERIORI="'+SD2->D2_SERIE+'" '
									
										    IndRegua(cAliasSD1,cIndex,SD1->(IndexKey()),,cCondicao)
										    nIndex := RetIndex("SD1")
											#IFNDEF TOP
												dbSetIndex(cIndex+OrdBagExt())
											#ENDIF
											dbSelectArea("SD1")
										    dbSetOrder(nIndex+1)
									
										    dbSelectArea(cAliasSD1)
										    ProcRegua(LastRec())
										    dbGoTop()										
									
									#IFDEF TOP
										Endif    
	   								#ENDIF
	   							
		   							EndIf								
															   	
								   While !((cAliasSD1)->(Eof())) 
										If (StrZero (Val(SD2->D2_ITEM), 2, 0)==StrZero (Val ((cAliasSD1)->D1_ITEMORI), 2, 0))
											lFoundD1   := .T.
											nValorAbat := SD2->D2_BASEICM - (cAliasSD1)->D1_BASEICM								 		  	
										Endif	
										(cAliasSD1)->(DbSkip())
									EndDo					   		

									//Ŀ
									//No caso das receitas, o valor da receita deve ser o bruto,     
									//sendo que o IPI e o ICMS ST devem ser lanados na linha propria
									//de deducoes dos valores lancados nas outras linhas.            
									//                    
									nItemValCont := 	SD2->D2_TOTAL +; 
														SD2->D2_VALFRE +;
														SD2->D2_SEGURO +;
														SD2->D2_DESPESA +;
														IIF(cDebDBCOF$"SI" .And. cDebDBPIS$"SI",0,SD2->D2_ICMSRET) +;
														IIF(cDebDBCOF$"SP" .And. cDebDBPIS$"SP",0,SD2->D2_VALIPI) +;
														IIf(SF4->F4_AGREG$"I/B",SD2->D2_VALICM,0) +;
														Iif(SD2->D2_BASIMP6>0,0,SD2->D2_DESCON) +;
														SD2->D2_DESCZFR   

							      If mv_par06 <> 3 // Diferente de Ambos 
									//
									//Regime Nao Cumulativo / Regime Cumulativo Separadamente    
									//
									If !SD2->D2_TIPO $ "DB"
	     								//01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%/7,6%
	                                	lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop09) .Or. "01-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
	        	                        If lProcessa										   									    
									     	If SF4->F4_TPREG=="1" // Se Regime Nao Cumulativo
									     		If lFoundD1 
									     			aMes[nPosMes][2][8][1]	+= nValorAbat
									     		Else
									     			aMes[nPosMes][2][8][1]	+= nItemValCont
									     		Endif
									     	else // Se Regime Cumulativo
									       		If lFoundD1 
									       			aMes[nPosMes][2][8][2]	+= nValorAbat
									       		else
									       			aMes[nPosMes][2][8][2]	+= nItemValCont
									       		Endif					
									   		endif
									    Endif     	   
									      
										//02.Demais Receitas - Aliquota de 1,65%/7,6%
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop10) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][9][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][9][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//03.Receita Trib. Reg.Subst.Trib-Aliq.0,65/3%
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop35) .Or. ;
											("02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1)
											lProcessa := .T.
										Endif
			            	            If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][28][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][28][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//05.Receita Trib. Aliq.Zero
		    		                    lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop36) .Or. ;
											("05-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("04-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
		        	                     If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo    
												aMes[nPosMes][2][29][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][29][2]	+= nItemValCont // Receita
									      EndIf
									   Endif
										//06.Receita Trib. Aliq.Zero-Rev.Prod.
				                        lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop37) .Or.;
											("06-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("05-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            			            If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][30][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][30][2]	+= nItemValCont // Receita
									      EndIf
									   Endif
										//07.Receita Vendas Bens Ativ.Perman."
		                    		    lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop38) .Or.;
											("07-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("06-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][31][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][31][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//"08.Receita Sem Incid.Contrib.
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop39) .Or. (AllTrim(SD2->D2_CF)$cCfop16) .Or. ;
										   (AllTrim(SD2->D2_CF)$cCfop40) .Or.  ;
										   ("08-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
										   ("07-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][27][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][27][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//09.Receita Isenta Sem Incid.Contrib.
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop40) .Or.; 
									     	(AllTrim(SD2->D2_CF)$cCfop36) .Or.;
											("09-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("08-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][32][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][32][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//10.Receita com Susp.Contrib.
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop41) .Or.;
											("10-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("09-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][33][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][33][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//"11.Receita Revenda Op.Subst.Trib.
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop42) .Or.;
											("11-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("10-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][34][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][34][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
										//12.Receita Tributada pelo RET
		                                lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop43) .Or.;
											("12-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 1) .Or.;
											("11-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC .And. mv_par06 == 2)
											lProcessa := .T.    	
										Endif
	            	                    If lProcessa
											If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
												aMes[nPosMes][2][35][1]	+= nItemValCont // Receita
											Else
												aMes[nPosMes][2][35][2]	+= nItemValCont // Receita
									        EndIf
									    Endif
									    //13.Contribuio para Pis/Pasep Folha de Salarios
									    If lPisFolha .And. !lPisJaFol      
									        nValFolSal := Execblock("MTR971F")              
									        aMes[nPosMes][2][36][2]	+= nValFolSal // Receita
									        lPisJaFol := .T.
									    EndIf									    
									    
									ElseIf (SD2->D2_TIPO$"D")
								        //23.(-)Ajustes Negativos de Creditos - Wizard do 1(primeiro) painel
								        //Devolucoes de Compras - Processamento Automatico
								        If !Empty(SD2->D2_NFORI)
											If Substr(SD2->D2_CF,1,1) == "7" 
									    		aMes[nPosMes][2][10][2]	+=	nItemValCont // Exportacao
										    Else
											    aMes[nPosMes][2][10][1]	+=	nItemValCont //Tributada Mercado Interno
										    Endif
	                                    Endif
								    Endif
			                        //IPI e ICMS/Substituto Tributario -> Como o IPI e lancado nas outras linhas, de ser sempre verificado
		    	                    //Se nunca retira da base de Pis/Cofins o icms retido, nao podera ser excluido nessa linha.
		    	                    
									//14.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
	            	                lProcessa := .F.
									If ((AllTrim(SD2->D2_CF)$cCfop12) .Or. "14-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
										lProcessa := .T.
									Endif		
	       							If lProcessa
										If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][15][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][15][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
										Else
											If (cDebSTCOF=="1") .And. (cDebSTPIS=="1")
												aMes[nPosMes][2][15][2]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][15][2]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif	
								        EndIf
								    Endif
								    //16.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
	               	                lProcessa := .F.
									If ((AllTrim(SD2->D2_CF)$cCfop14) .Or. "16-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
										lProcessa := .T.
									Endif		
	       							If lProcessa
										If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][16][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][16][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
										Else
											If (cDebSTCOF=="1") .And. (cDebSTPIS=="1")
												aMes[nPosMes][2][16][2]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][16][2]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif	
								        EndIf
								    Endif
							    Elseif mv_par06== 3 // Ambos os Regimes
							   		//
									//Regime Nao Cumulativo e Regime Cumulativo     
									//
        	                        // Sera identificado para as fichas 07B e 17B se o Regime e Cumulativo ou Nao
            	                    // Cumulativo atravs do produto
	 								//
									// REGIME NAO CUMULATIVO
									//                                      
            						//
									//Controle de Ambos - SF4 Ambos muda para SB1 
									//
                                	If &(cRegCam) == "3" .And. SubStr(cRegCam,1,3)=="SF4"
                                		cRegCam := "SB1->B1_TPREG"
                                	EndIf
                                	If nTpRegPrd <> 0 .And. (&(cRegCam)=="1")
										If !SD2->D2_TIPO $ "DB"
											//01.Receita de Vendas de Bens e Servicos - Aliquota de 1,65%/7,6%
				                           lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop23) .Or. "01-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		        	    	               If lProcessa
										      aMes[nPosMes][2][8][1]	+= nItemValCont // Receita
										   Endif
											//02.Demais Receitas - Aliquota de 1,65%/7,6%
					                        lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop24) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
	        		    		            If lProcessa
												aMes[nPosMes][2][9][1]	+= nItemValCont // Receita
									    	Endif
											//03.Receita Trib. Reg.Subst.Trib-Aliq.0,65/3%
			            		            lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop35) .Or. "06-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            		    	        If lProcessa
												aMes[nPosMes][2][28][1]	+= nItemValCont // Receita
										   Endif
											//05.Receita Trib. Aliq.Zero
					                        lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop36) .Or. "08-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
				            	            If lProcessa
												aMes[nPosMes][2][29][1]	+= nItemValCont // Receita
										   Endif
											//06.Receita Trib. Aliq.Zero-Rev.Prod.
					                        lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop37) .Or. "09-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
				            	            If lProcessa
												aMes[nPosMes][2][30][1]	+= nItemValCont // Receita
										   Endif
											//07.Receita Vendas Bens Ativ.Perman."
					                        lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop38) .Or. "10-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		        		    	            If lProcessa
												aMes[nPosMes][2][31][1]	+= nItemValCont // Receita
										   Endif
											//"08.Receita Sem Incid.Contrib.
			            		            lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop39) .Or. "11-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	        		    If lProcessa
												aMes[nPosMes][2][27][1]	+= nItemValCont // Receita
										   Endif
											//09.Receita Isenta Sem Incid.Contrib.
					                        lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop40) .Or. "12-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][32][1]	+= nItemValCont // Receita
										    Endif
											//10.Receita com Susp.Contrib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop41) .Or. "13-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][33][1]	+= nItemValCont // Receita
										    Endif
											//"11.Receita Revenda Op.Subst.Trib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop42) .Or. "14-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][34][1]	+= nItemValCont // Receita
										    Endif
											//12.Receita Tributada pelo RET
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop43) .Or. "15-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][35][1]	+= nItemValCont // Receita
										    Endif

   									        //13.Contribuio para Pis/Pasep Folha de Salarios
									        If lPisFolha .And. !lPisJaFol      
									            nValFolSal := Execblock("MTR971F")              
									            aMes[nPosMes][2][36][2]	+= nValFolSal // Receita
									            lPisJaFol := .T.    
									        EndIf									    
										
										ElseIf (SD2->D2_TIPO$"D")
									        //Devolucoes de Compras - Processamento Automatico
									        //23.(-)Ajustes Negativos de Creditos - Wizard do 1(primeiro) painel
									        If !Empty(SD2->D2_NFORI)
												If Substr(SD2->D2_CF,1,1) == "7" 
										    		aMes[nPosMes][2][10][2]	+=	nItemValCont // Exportacao
											    Else
												    aMes[nPosMes][2][10][1]	+=	nItemValCont //Tributada Mercado Interno
											    Endif
	                            	        Endif
                            	        Endif
										//
				                        //IPI e ICMS/Substituto Tributario -> Como o IPI e lancado nas outras linhas, de ser sempre verificado
									    //
			    	                    //Se nunca retira da base de Pis/Cofins o icms retido, nao podera ser excluido nessa linha.
										//18.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		            	                lProcessa := .F.
										If ((AllTrim(SD2->D2_CF)$cCfop28) .Or. "18-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
											lProcessa := .T.
										Endif		
	       								If lProcessa
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][15][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][15][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
									    Endif
		    	                    
									    //20.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
		               	                lProcessa := .F.
										If ((AllTrim(SD2->D2_CF)$cCfop30) .Or. "20-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
											lProcessa := .T.
										Endif		
	       								If lProcessa
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][16][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][16][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
									    Endif  
									    
									//
									// REGIME CUMULATIVO
									//
                                	Elseif nTpRegPrd <> 0 .And. (&(cRegCam)=="2")
										If !SD2->D2_TIPO $ "DB"
											//04.Receita de Vendas de Bens e Servicos - Aliquota de 0,65%/3%
		                                	lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop25) .Or. "04-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
	        	    	                    If lProcessa
										   		aMes[nPosMes][2][12][1]	+= nItemValCont // Receita
										    Endif
											//05.Demais Receitas - Aliquota de 0,65%/3%
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop26) .Or. "05-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
	            		                    If lProcessa
												aMes[nPosMes][2][13][1]	+= nItemValCont // Receita
										    	Endif       
											//03.Receita Trib. Reg.Subst.Trib-Aliq.0,65/3%
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop35) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][28][1]	+= nItemValCont // Receita
										    Endif
											//05.Receita Trib. Aliq.Zero
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop36) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][29][1]	+= nItemValCont // Receita
										    Endif
											//06.Receita Trib. Aliq.Zero-Rev.Prod.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop37) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][30][1]	+= nItemValCont // Receita
										    Endif
											//07.Receita Vendas Bens Ativ.Perman."
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop38) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][31][1]	+= nItemValCont // Receita
										    Endif
											//"08.Receita Sem Incid.Contrib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop39) .Or. (AllTrim(SD2->D2_CF)$cCfop16) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][27][1]	+= nItemValCont // Receita
										    Endif
											//09.Receita Isenta Sem Incid.Contrib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop40) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][32][1]	+= nItemValCont // Receita
										    Endif
											//10.Receita com Susp.Contrib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop41) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][33][1]	+= nItemValCont // Receita
										    Endif
											//"11.Receita Revenda Op.Subst.Trib.
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop42) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][34][1]	+= nItemValCont // Receita
										    Endif
											//12.Receita Tributada pelo RET
			                                lProcessa := .F.
											If (AllTrim(SD2->D2_CF)$cCfop43) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
												lProcessa := .T.
											Endif
		            	                    If lProcessa
												aMes[nPosMes][2][35][1]	+= nItemValCont // Receita
										    Endif
										    
									        //13.Contribuio para Pis/Pasep Folha de Salarios
 									        If lPisFolha .And. !lPisJaFol      
									            nValFolSal := Execblock("MTR971F")              
									            aMes[nPosMes][2][36][2]	+= nValFolSal // Receita
									            lPisJaFol := .T.
									        EndIf									    
										    	
										ElseIf (SD2->D2_TIPO$"D")
									        //Devolucoes de Compras - Processamento Automatico
									        //23.(-)Ajustes Negativos de Creditos - Wizard do 1(primeiro) painel
									        If !Empty(SD2->D2_NFORI)
												If Substr(SD2->D2_CF,1,1) == "7" 
										    		aMes[nPosMes][2][10][2]	+=	nItemValCont // Exportacao
											    Else
												    aMes[nPosMes][2][10][1]	+=	nItemValCont //Tributada Mercado Interno
											    Endif
	                            	        Endif
										Endif	                            	        
                                        //
				                        //IPI e ICMS/Substituto Tributario -> Como o IPI e lancado nas outras linhas, de ser sempre verificado
                                        //
			    	                    //Se nunca retira da base de Pis/Cofins o icms retido, nao podera ser excluido nessa linha.
										//22.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		            	                lProcessa := .F.
										If ((AllTrim(SD2->D2_CF)$cCfop32) .Or. "22-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
											lProcessa := .T.
										Endif		
	       								If lProcessa
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][25][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][25][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
									    Endif
									    //24.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
		               	                lProcessa := .F.
										If ((AllTrim(SD2->D2_CF)$cCfop34) .Or. "24-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
											lProcessa := .T.
										Endif		
	       								If lProcessa
										    If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
												aMes[nPosMes][2][26][1]+=	SD2->D2_VALIPI
											Else
												aMes[nPosMes][2][26][1]+=	SD2->D2_VALIPI + SD2->D2_ICMSRET
											Endif
									    Endif   
                                	Endif
                 				Endif
							    //
								//
								//Linha 09/03 - (-)IPI e ICMS/Subst. Tributario    
								//
								If lAliqDif .And.(SD2->D2_VALIPI+SD2->D2_ICMSRET) > 0
									Gravaf09(Month((cAliasSF3)->F3_ENTRADA),"03",nPPis,nPCofins,SD2->D2_ICMSRET+SD2->D2_VALIPI)
								Endif
                                //
								//
								//Linha 09/01 - Receita de Vendas        
								//
								If lAliqDif .And. (AllTrim(SD2->D2_CF)$cCfop18 .Or. "01-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALCAD)
									Gravaf09(Month((cAliasSF3)->F3_ENTRADA),"01",nPPis,nPCofins)
								Endif

								//Ŀ
								//Totaliza os faturamentos do Mercado Interno e Externo
								//
								If lTpRec .and. !Empty(SF4->F4_RECDAC)		//Receitas Dacon = 1-Tributada / 2-Exportacao / 3-Nao Tributada
									If AllTrim(SD2->D2_CF)$cCfop17 .And. SF4->F4_RECDAC=="1"  // Mercado Interno Tributada
										aMes[nPosMes][2][17][1]+=nItemValCont
									ElseIf AllTrim(SD2->D2_CF)$cCfop16 .And. SF4->F4_RECDAC=="2" //Exportacao
										aMes[nPosMes][2][18][1]+=nItemValCont
									ElseIf AllTrim(SD2->D2_CF)$cCfop44 .And. SF4->F4_RECDAC=="3"  // Mercado Interno Nao Tributada
										aMes[nPosMes][2][36][1]+=nItemValCont
									Endif
								Else
									If AllTrim(SD2->D2_CF)$cCfop17       // Mercado Interno Tributada
										aMes[nPosMes][2][17][1]+=nItemValCont
									ElseIf AllTrim(SD2->D2_CF)$cCfop16   //Exportacao
										aMes[nPosMes][2][18][1]+=nItemValCont
									ElseIf AllTrim(SD2->D2_CF)$cCfop44		// Mercado Interno Nao Tributada
										aMes[nPosMes][2][36][1]+=nItemValCont
									Endif
								Endif
								
								//
								//Linha 10 - Receita de Vendas           
								//
								If (AllTrim(SD2->D2_CF)$cCfop45) .And. !SF4->F4_SITTRIB$"10/30/60/70"
									Gravaf10(Month((cAliasSF3)->F3_ENTRADA),"01",nPPis,nPCofins)
								Endif
																
							    dbSelectArea("SD2")						    
							    dbSkip() 
   								//
								//Controle de Ambos - Reinicia a Variavel
								//
							    cRegCam	:= Iif(nTPReg == 2,"SB1->B1_TPREG",Iif(nTPReg == 1,"SF4->F4_TPREG","SA1->A1_TPREG")) 
	        	           Enddo
	            	    Endif
			            //Descontos Incondicionais
					    dbSelectArea("SF2")
					    dbSetOrder(1)
					    If dbSeek(xFilial("SF2")+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA)
						    dbSelectArea("SD2")
						    dbSetOrder(3)
					    	dbSeek(xFilial("SD2")+(cAliasSF3)->F3_NFISCAL+(cAliasSF3)->F3_SERIE+(cAliasSF3)->F3_CLIEFOR+(cAliasSF3)->F3_LOJA)
			            
							If mv_par06 <> 3 // Diferente de Ambos
								//
								//Regime Nao Cumulativo / Regime Cumulativo Separadamente    
								//
					    		If SF2->F2_DESCONT > 0 .Or. SD2->D2_DESCZFR > 0
						    		//13.Exclusoes-Vendas Canceladas e Descontos Incondicionais(Receita de Vendas)
						    		lProcessa := .F.
									If (AllTrim(SD2->D2_CF)$cCfop22) .Or. "13-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
										lProcessa := .T.
									Endif
						            If lProcessa
				   				    	If SF4->F4_TPREG=="1"
									    	aMes[nPosMes][2][19][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR
								    	Else                                                
									    	aMes[nPosMes][2][19][2] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR	  
								    	Endif
							    	Endif
							    	//
						    		//15.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
						    		lProcessa := .F.
									If (AllTrim(SD2->D2_CF)$cCfop13) .Or. "15-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
										lProcessa := .T.
									Endif
						            If lProcessa
				   				    	If SF4->F4_TPREG=="1"
									    	aMes[nPosMes][2][11][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR
								    	Else                                                
									    	aMes[nPosMes][2][11][2] +=	SF2->F2_DESCONT	 + SD2->D2_DESCZFR 
								    	Endif
							    	Endif
							    Endif
						    Elseif mv_par06 == 3
								//
								//Regime Nao Cumulativo e Regime Cumulativo     
								//
 								//
								// REGIME NAO CUMULATIVO
								//                                      
                               	If nTpRegPrd <> 0 .And. (&(cRegCam)=="1")
						    		If SF2->F2_DESCONT > 0 .Or. SD2->D2_DESCZFR > 0
							    		//17.Exclusoes-Vendas Canceladas e Descontos Incondicionais(Receita de Vendas)
							    		lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop27) .Or. "17-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
							            If lProcessa
									    	aMes[nPosMes][2][19][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR 
								    	Endif
								    	//
							    		//19.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
							    		lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop29) .Or. "19-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
							            If lProcessa
									    	aMes[nPosMes][2][11][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR 
								    	Endif
								    Endif
								//
								// REGIME CUMULATIVO
								//
                               	Elseif nTpRegPrd <> 0 .And. (&(cRegCam)=="2")
						    		If SF2->F2_DESCONT > 0
							    		//21.Exclusoes-Vendas Canceladas e Descontos Incondicionais(Receita de Vendas)
							    		lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop31) .Or. "21-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
							            If lProcessa
									    	aMes[nPosMes][2][14][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR 
								    	Endif
								    	//
							    		//23.Exclusoes-Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
							    		lProcessa := .F.
										If (AllTrim(SD2->D2_CF)$cCfop33) .Or. "23-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
											lProcessa := .T.
										Endif
							            If lProcessa
									    	aMes[nPosMes][2][24][1] +=	SF2->F2_DESCONT + SD2->D2_DESCZFR 
								    	Endif
								    Endif
								Endif
						    	//
								//
								//Linha 09/02 - (-)Vendas Canc. e Desc. Incond.
								//
						    	If lAliqDif .And. (AllTrim(SD2->D2_CF)$cCfop11 .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALCAD)
									Gravaf09(Month((cAliasSF3)->F3_ENTRADA),"02",nPPis,nPCofins,SF2->F2_DESCONT)
								Endif
							Endif
						Endif
					Endif
			    Endif
			    //                     
			    
			   If cAliasSd1 <> 'SD1' .and. Select(cAliasSd1) > 0
			      (cAliasSd1)->(DbClosearea())
			      cNota		:= ""       
			   Endif
			      
				dbSelectArea(cAliasSF3)
				dbSkip() 
			EndDo
		Enddo
		//
		If lQuery
			dbSelectArea(cAliasSF3)
			dbCloseArea()
		Else
		  	dbSelectArea("SF3")
			RetIndex("SF3")
			dbClearFilter()
			Ferase(cIndex+OrdBagExt())
		EndIf                  
		//
	    dbSelectArea ("SM0")
	    dbSkip()
	    //
	Else // Regime de Caixa
		//Ŀ
		//  Regime de Caixa - Cumulativo - Lucro Presumido                   
		// Processamento das Saidas - De acordo com SE5                      
		//
		//Ŀ
		// Tratamento para os campos do PIS - Saida                          
		//
		If !Empty( nScanPis := aScan(aRelImp2,{|x| x[1]=="SD2" .And. x[3]=="IT_BASEPS2"} ) )
			cCpBsPisSa := aRelImp2[nScanPis,2]
			nPsBsPisSa := SD2->(FieldPos(cCpBsPisSa))
		EndIf
		//Ŀ
		// Tratamento para os campos do COF - Saida                          
		//
		If !Empty( nScanCof := aScan(aRelImp2,{|x| x[1]=="SD2" .And. x[3]=="IT_BASECF2"} ) )
			cCpBsCofSa := aRelImp2[nScanCof,2]
			nPsBsCofSa := SD2->(FieldPos(cCpBsCofSa))
		EndIf 	
		//                        
		cFilAnt	:=	FWCodFil()
		//
		dBSelectArea("SE5")
		(dbSetOrder(1))                                  
		
		#IFDEF TOP
			If TcSrvType()<>"AS/400"
				lQuery := .T.
				cAliasSE5 := "a996AMontSE5"
				aStruSE5  := SE5->(dbStruct())
				
				cQuery 	:= "SELECT "
				cQuery  += "E5_FILIAL,E5_NUMERO, E5_DATA, E5_VALOR, E5_RECPAG, E5_TIPODOC, E5_PREFIXO, E5_PARCELA, E5_MOTBX, "
				cQuery  +=	"E5_BANCO, E5_AGENCIA, E5_CONTA, E5_NUMCHEQ, E5_TIPO, E5_CLIFOR, E5_LOJA, E5_SEQ, E5_DOCUMEN "
				cQuery 	+= "FROM "+RetSqlName("SE5")+" SE5 "
				cQuery 	+= "WHERE E5_FILIAL='"+xFilial("SE5")+"' AND "
				cQuery 	+= "E5_DATA>='"+Dtos(dDtIni)+"' AND "
				cQuery 	+= "E5_DATA<='"+Dtos(dDtFin)+"' AND "           
				cQuery  += "E5_RECPAG = 'R'  AND " 		// Indica que e recebimento
				cQuery  += "E5_TIPODOC IN ('BA','CP','VL','V2','LJ','ES') AND " // Principais Tp.Doc(Nao considera desconto/multa)
				cQuery  += "E5_MOTBX <> 'FAT'  AND "   // Indica que nao e baixa por fatura
				cQuery  += "SE5.D_E_L_E_T_ = ' ' "              
				cQuery += "ORDER BY "+SqlOrder(SE5->(IndexKey()))
	
				cQuery := ChangeQuery(cQuery)
				dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),cAliasSE5,.T.,.T.)
				
				For nX2 := 1 To len(aStruSE5)
					If aStruSE5[nX2][2] <> "C" .And. FieldPos(aStruSE5[nX2][1])<>0
						TcSetField(cAliasSE5,aStruSE5[nX2][1],aStruSE5[nX2][2],aStruSE5[nX2][3],aStruSE5[nX2][4])
					EndIf
				Next nX2
			
				dbSelectArea(cAliasSE5)
				dbSelectArea(cAliasSD2)                                      
				nPsBsPisSa := ( cAliasSD2 )->( FieldPos( cCpBsPisSa ) )
				nPsBsCOfSa := ( cAliasSD2 )->( FieldPos( cCpBsCofSa ) )
			Else	
		#ENDIF
				cIndex    := CriaTrab(NIL,.F.)
				cFiltro := "E5_FILIAL=='"+xFilial("SE5")+"'.And."
				cFiltro += "Dtos(E5_DATA)>='" + Dtos(dDtIni) + "'.And."
				cFiltro += "Dtos(E5_DATA)<='" + Dtos(dDtFin) + "'.And."
				cFiltro += "E5_TIPODOC $('BA,CP,VL,V2,LJ,ES') .And. "// Principais Tp.Doc(Nao considera desconto/multa)
				cFiltro += "E5_MOTBX != 'FAT' .And."
				cFiltro += "E5_RECPAG=='R' "
				
			    IndRegua(cAliasSE5,cIndex,SE5->(IndexKey()),,cFiltro)
				nIndex := RetIndex("SE5")
				#IFNDEF TOP
					dbSetIndex(cIndex+OrdBagExt())
				#ENDIF
				dbSelectArea("SE5")
			    dbSetOrder(nIndex+1)
				
			    dbSelectArea(cAliasSE5)
			    ProcRegua(LastRec())
			    dbGoTop()
		#IFDEF TOP
			Endif    
		#ENDIF
		//	                
		dbSelectArea(cAliasSE5)
		If !EOF()
			AADD(aFilial,cFilAnt)
		Endif			      
		While (cAliasSE5)->(!Eof())
			nPosMes	:= aScan (aMes, {|aX| aX[1]==Month((cAliasSE5)->E5_DATA)})
			If nPosMes==0
				aAdd (aMes, {Month((cAliasSE5)->E5_DATA), {}})
				nPosMes	:=	aScan(aMes, {|aX| aX[1]==Month((cAliasSE5)->E5_DATA)})
				For nI := 1 To 52     //48
					aAdd (aMes[nPosMes][2], {0,0})
				Next (nI)
			EndIf
	        //
	        Do While (cAliasSE5)->(!Eof()) .And. aMes[nPosMes][1] == Month((cAliasSE5)->E5_DATA)
				lValido := .T.
				//Verifica se tem baixa cancelada
			 	If TemBxCanc((cAliasSE5)->E5_PREFIXO+(cAliasSE5)->E5_NUMERO+(cAliasSE5)->E5_PARCELA+(cAliasSE5)->E5_TIPO+(cAliasSE5)->E5_CLIFOR+(cAliasSE5)->E5_LOJA+(cAliasSE5)->E5_SEQ)
					(cAliasSE5)->(dbskip())
					Loop
				EndIf
				//Compensacao com RA, Liquidacao e NCC devem ser consideradas para calculo do PIS/Cofins no Dacon
			    lConsCmp:=.F.
				If (((cAliasSE5)->E5_MOTBX == "CMP" .And. SUBSTR((cAliasSE5)->E5_DOCUMEN,nTamTit,3)$MVRECANT));
				 .Or. ((cAliasSE5)->E5_MOTBX == "LIQ").OR. ;
	 			 ((cAliasSE5)->E5_TIPO$MV_CRNEG) .And. ((cAliasSE5)->E5_MOTBX == "CMP")
		   			lConsCmp :=.T.
				Endif
				//Desconsidera Baixa por Dacao
				If !(cAliasSE5)->E5_MOTBX == "CEC" // Compensacao entre Carteiras considera na apuracao
					If !lConsCmp .And. !MovBcoBx((cAliasSE5)->E5_MOTBX,.T.)
						(cAliasSE5)->(dbskip())
						Loop
					Endif
				Endif	
			    //   
				cChaveAnt   :=	(cAliasSE5)->E5_NUMERO+(cAliasSE5)->E5_PREFIXO+(cAliasSE5)->E5_CLIFOR+(cAliasSE5)->E5_LOJA
				cChaveSe1   :=	(cAliasSE5)->E5_CLIFOR+(cAliasSE5)->E5_LOJA+(cAliasSE5)->E5_PREFIXO+(cAliasSE5)->E5_NUMERO+(cAliasSE5)->E5_PARCELA+(cAliasSE5)->E5_TIPO			
				cClAnt		:=	(cAliasSE5)->E5_CLIFOR
				cLjAnt		:=	(cAliasSE5)->E5_LOJA
				// Compensacao da Devolucao de Venda - Considerar como Devoluao de Venda
				If ((cAliasSE5)->E5_TIPO$MV_CRNEG) .And. ((cAliasSE5)->E5_MOTBX == "CMP")
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+(cAliasSE5)->E5_CLIFOR+(cAliasSE5)->E5_LOJA+(cAliasSE5)->E5_PREFIXO+(cAliasSE5)->E5_NUMERO+(cAliasSE5)->E5_PARCELA+(cAliasSE5)->E5_TIPO))
					cChaveSD1   := Iif(lDacTit,(cAliasSE1)->E1_NUM,(cAliasSE1)->E1_NUMNOTA)+(cAliasSE1)->E1_SERIE+(cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA
					//
				    DbSelectArea("SD1")
				    SD1->(dbSetOrder(1))
				    SD1->(MsSeek(xFilial("SD1")+cChaveSD1)) // procurar a nf original
				    //
		    		While !((cAliasSD1)->(Eof())) .And. xFilial("SD1") == (cAliasSD1)->D1_FILIAL .And.;
						(cAliasSD1)->(D1_DOC+D1_SERIE+D1_FORNECE+D1_LOJA)==cChaveSD1 .And.;
						(cAliasSD1)->D1_TIPO =="D"
						SF4->(dbSetOrder(1))
						SF4->(MsSeek(xFilial("SF4")+(cAliasSD1)->D1_TES))
							If (cAliasSF4)->F4_AGREG <> "N" .And. (cAliasSF4)->F4_DUPLIC == "S"
								If (cAliasSF4)->F4_PISCOF <> "4" //Nao Calcula
									nDevol += (cAliasSD1)->D1_TOTAL	 // D1_TOTAL --> D2 ATRAVES D1_NFORI
									cChaveAnt:=	(cAliasSD1)->D1_NFORI+(cAliasSD1)->D1_SERIE+(cAliasSD1)->D1_FORNECE+(cAliasSD1)->D1_LOJA
								Endif
							Endif	
						(cAliasSD1)->(dbskip())
						Loop
					Enddo
				Endif
				// Considerar o faturamento
				If ((cAliasSE5)->E5_TIPO$MVNOTAFIS)
					nPag 	+= (cAliasSE5)->E5_VALOR
				EndIf
				SE1->(dbSetOrder(2))
				SE1->(MsSeek(xFilial("SE1")+(cAliasSE5)->E5_CLIFOR+(cAliasSE5)->E5_LOJA+(cAliasSE5)->E5_PREFIXO+(cAliasSE5)->E5_NUMERO+(cAliasSE5)->E5_PARCELA+(cAliasSE5)->E5_TIPO))
				nTotAbat  := SumAbatRec((cAliasSE1)->E1_PREFIXO,(cAliasSE1)->E1_NUM,(cAliasSE1)->E1_PARCELA,(cAliasSE1)->E1_MOEDA,"V",(cAliasSE1)->E1_BAIXA)
				nPag += nTotAbat
				//
				If (cAliasSE1)->(E1_CLIENTE+E1_LOJA+E1_PREFIXO+E1_NUM+E1_PARCELA+E1_TIPO)==cChaveSe1
					//Ŀ
					// Tratamento para fatura a receber                             
					//						
					If (AllTrim ((cAliasSE1)->E1_FATURA)=="NOTFAT")
						cFatura    := (cAliasSE1)->E1_PREFIXO+(cAliasSE1)->E1_NUM
						cCliente   := (cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA
						cTpFatura  := (cAliasSE1)->E1_TIPO
						//Ŀ
						// Titulos de origem da fatura                                  
						//
						dbSelectArea("SE1")
						dbSetOrder(10)
						MsSeek(xFilial("SE1")+cCliente+cFatura,.F.)
						While ( !Eof() .And. xFilial("SE1")==(cAliasSE1)->E1_FILIAL .And.;
							(cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA+(cAliasSE1)->E1_FATPREF+(cAliasSE1)->E1_FATURA==cCliente+cFatura)
								cChaveAnt:= (cAliasSE1)->E1_NUM+(cAliasSE1)->E1_PREFIXO+(cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA
								cChaveSe1:= (cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA+(cAliasSE1)->E1_PREFIXO+(cAliasSE1)->E1_NUM+(cAliasSE1)->E1_PARCELA+(cAliasSE1)->E1_TIPO
							SE1->(dbSkip())
						EndDo
					EndIf
				EndIf			
				cChaveSd2:= cChaveAnt
				If !lDacTit
					cChaveSd2:= (cAliasSE1)->E1_NUMNOTA+(cAliasSE1)->E1_SERIE+(cAliasSE1)->E1_CLIENTE+(cAliasSE1)->E1_LOJA
				Endif
				SD2->(dbSetOrder(3))
				SD2->(MsSeek(xFilial("SD2")+cChaveSd2))
				SF2->(dbSetOrder(1))
				SF2->(MsSeek(xFilial("SF2")+cChaveSd2))
			 	SA1->(dbSetOrder(1))
				SA1->(MsSeek(xFilial("SA1")+cClAnt+cLjAnt))
				While !((cAliasSD2)->(Eof())) .And. xFilial("SD2") == (cAliasSD2)->D2_FILIAL .And.;
					 	(cAliasSD2)->(D2_DOC+D2_SERIE+D2_CLIENTE+D2_LOJA)==cChaveSd2
					SF4->(dbSetOrder(1))
					SF4->(MsSeek(xFilial("SF4")+(cAliasSD2)->D2_TES))
					SB1->(dbSetOrder(1))
					SB1->(MsSeek(xFilial("SB1")+(cAliasSD2)->D2_COD))
					If lApurac
						lValido := (cAliasSF4)->F4_PISFISC<>"2" //Aplica Credito de Pis/Cofins
					Endif
					#IFDEF SHELL
						dbSelectArea(cAliasSD2)
						If (cAliasSD2)->D2_CANCEL == "S"
							lValido := .F.
						EndIf
					#ENDIF
					If lValido
						If (cAliasSF4)->F4_AGREG <> "N" //Agrega Valor
							If (cAliasSF4)->F4_PISCOF <> "4" //Nao Calcula
								If !Empty(nPsBsPisSa) .Or. !Empty(nPsBsCofSa)
									nBasPisPas := (nPag*(cAliasSD2)->(FieldGet(nPsBsPisSa)))/(cAliasSF2)->F2_VALFAT
									nBasCofins := (nPag*(cAliasSD2)->(FieldGet(nPsBsCofSa)))/(cAliasSF2)->F2_VALFAT
									nValIpi    := (nPag*((cAliasSD2)->D2_VALIPI)/(cAliasSF2)->F2_VALFAT)
									nValIcm    := (nPag*((cAliasSD2)->D2_ICMSRET)/(cAliasSF2)->F2_VALFAT)
                                    //Devolucoes
									nBasPisDev := (nDevol*(cAliasSD2)->(FieldGet(nPsBsPisSa)))/(cAliasSF2)->F2_VALFAT
									nBasCofDev := (nDevol*(cAliasSD2)->(FieldGet(nPsBsCofSa)))/(cAliasSF2)->F2_VALFAT
									nValIpiDev := (nDevol*((cAliasSD2)->D2_VALIPI)/(cAliasSF2)->F2_VALFAT)
									nValIcmDev := (nDevol*((cAliasSD2)->D2_ICMSRET)/(cAliasSF2)->F2_VALFAT)
									//Ŀ
									// Caso a TES esteja com calcula ambos, a base nao sera acumulada novamente  
									//
									If (cAliasSF4)->F4_PISCOF =="3" //3-Ambos
										nBasCofins := 0
										nBasCofDev := 0
									Endif	
 									If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
										nItemValCont := nBasPisPas+nBasCofins+nValIpi+nBasPisDev+nBasCofDev+nValIpiDev 
									Else 	
										nItemValCont := nBasPisPas+nBasCofins+nValIpi+nValIcm+nBasPisDev+nBasCofDev+nValIpiDev+nValIcmDev
                                    Endif
								EndIf
								//
								If !(SD2->D2_TIPO $ "DB")
									//01.Receita de Vendas de Bens e Servicos - Aliquota de 0,65%/Cumulativa
	        	                    lProcessa := .F.
									If ((AllTrim(SD2->D2_CF)$cCfop09) .Or. "01-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. Empty((cAliasSD2)->D2_CODISS) //Para nao contemplar nfs com iss
										lProcessa := .T.
									Endif
	                                If lProcessa
										If SF4->F4_TPREG=="2" // Regime Cumulativo
											aMes[nPosMes][2][8][2]	+= nItemValCont
								        EndIf
								    Endif
							    	//02.Demais Receitas - Aliquota de 0,65%/Cumulativa
		                            lProcessa := .F.
									If ((AllTrim(SD2->D2_CF)$cCfop10) .Or. "02-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. Empty((cAliasSD2)->D2_CODISS) //Para nao contemplar nfs com iss
										lProcessa := .T.
									Endif
		                            If lProcessa
										If SF4->F4_TPREG=="2" // Regime Cumulativo
											aMes[nPosMes][2][9][2]+=	nItemValCont
								        EndIf
								    Endif                 
									// EXCLUSOES PARA COMPOR A BASE DE CALCULO
							    	//14.Vendas Canceladas e Descontos Incondicionais (Receita de Vendas)
				                    lProcessa := .F.
									If (AllTrim(SD2->D2_CF)$cCfop22) .Or. "14-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
										lProcessa := .T.
									Endif
									If lProcessa
										If SF4->F4_TPREG=="2" // Regime Cumulativo
											If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
										 		aMes[nPosMes][2][19][2]+=	nBasPisDev+nValIpiDev
										 	Else
												aMes[nPosMes][2][19][2]+=	nBasPisDev+nValIpiDev+nValIcmDev
										 	Endif	
										Endif
									Endif
							    	//16.Vendas Canceladas e Descontos Incondicionais (Demais Receitas)
				                    lProcessa := .F.
									If (AllTrim(SD2->D2_CF)$cCfop13) .Or. "16-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC
										lProcessa := .T.
									Endif
									If lProcessa
										If SF4->F4_TPREG=="2" // Regime Cumulativo
											If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
										 		aMes[nPosMes][2][11][2]+=	nBasPisDev+nValIpiDev
										 	Else
												aMes[nPosMes][2][11][2]+=	nBasPisDev+nValIpiDev+nValIcmDev
										 	Endif	
										Endif
									Endif
								Endif
			                    //IPI e ICMS/Substituto Tributario -> Como o IPI e lancado nas outras linhas, deve ser excluido
			                    //Se nunca retira da base de Pis/Cofins o icms retido, nao podera ser excluido nessa linha.

		                        //15.Exclusoes-IPI e ICMS/Substituto Tributario (Receita de Vendas)
		                        lProcessa := .F.
								If ((AllTrim(SD2->D2_CF)$cCfop12) .Or. "15-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
									lProcessa := .T.
								Endif
		       					If lProcessa
									If SF4->F4_TPREG=="2" // Regime Cumulativo
										If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
											aMes[nPosMes][2][15][2]+=	nValIpi
										Else
											aMes[nPosMes][2][15][2]+=	nValIpi+nValIcm
										Endif	
								    EndIf
							    Endif
   		                        //17.Exclusoes-IPI e ICMS/Substituto Tributario (Demais Receitas)
		                        lProcessa := .F.
								If ((AllTrim(SD2->D2_CF)$cCfop14) .Or. "17-"+AllTrim(SD2->D2_TES)+"-"+AllTrim(SD2->D2_CF)$cMVCALC) .And. SD2->D2_VALIPI+SD2->D2_ICMSRET > 0
									lProcessa := .T.
								Endif
		       					If lProcessa
									If SF4->F4_TPREG=="2" // Regime Cumulativo
										If (cDebSTCOF=="1") .And. (cDebSTPIS=="1") //Nunca retira o Icms Retido da Base
											aMes[nPosMes][2][16][2]+=	nValIpi
										Else
											aMes[nPosMes][2][16][2]+=	nValIpi+nValIcm
										Endif	
								    EndIf
								Endif
							Endif
						EndIf
					Endif //lValido
				(cAliasSd2)->(dbSkip())
				EndDo
				nPag:=0
				nDevol:=0
			(cAliasSE5)->(dbSkip())
			EndDo		
		EndDo
		If lQuery
			dbSelectArea(cAliasSE5)
			dbCloseArea()
		Else
			dbSelectArea("SE5")
			RetIndex("SE5")
			dbClearFilter()
			FErase(cIndex+OrdBagExt())
		EndIf
	    dbSelectArea ("SM0")
	    dbSkip()
	Endif
	
	Enddo
	//Restaura o cFilAnt
	SM0->(dbGoTo(nRegEmp)) 
	cFilAnt := FWCodFil()		
	//Ŀ
	//PE para receber valores de PIS/PASEP Folha de Pagamento quando
	//o pagamento nao gerar SF3:                                    
	//Retorno = Valor da Base PIS/PASEP		                     
	//
	nValFolSal := 0
    If lPisFolSN
	    nValFolSal := Execblock("MTR971S")              	    
	    If ValType(nValFolSal) == "N" .And. nValFolSal > 0 
			nPosMes	:=	aScan (aMes, {|aX| aX[1]==Month(dDtFin)})
			If nPosMes==0
				aAdd (aMes, {Month(dDtFin), {},{}})
				nPosMes	:=	aScan(aMes, {|aX| aX[1]==Month(dDtFin)})									
				For nI := 1 To 52       
					aAdd(aMes[nPosMes][2],{0,0,0})
					aAdd(aMes[nPosMes][3],{0,0})
				Next (nI)                               				
			EndIf		                         
			aMes[nPosMes][2][36][2]	+= nValFolSal
	    EndIf	    	    
    EndIf
    
	nX1			:= 0
	nBsCrdAqI	:= 0
	nBsCrdAqE	:= 0
	aRecAuf := {0,0,0,0,0,0,0,0}  
	For nF:=1 to Len(aFilial)
		For nY := 1 To Len (aMes)         
	        cFilAnt := aFilial[nF]	
			dDtIDep	:=	CtoD ("01/"+StrZero(aMes[nY][1],2)+"/"+StrZero(Year(mv_par02),4))
			//Ŀ
			// Deducoes do Imobilizado - Base na Depreciao               
			//	
			dDtFDep		:= CtoD (Str(F_UltDia(dDtIDep), 2)+"/"+StrZero (Month (dDtIDep), 2)+"/"+StrZero(Year(mv_par02),4))
		    nX			:= 0
		    nBaseCred	:= 0
			aAtivo 		:= DeprecAtivo(dDtIDep,dDtFDep,.T.,,,,,,cFilAnt)
			//
			If (ValType(aAtivo)=="A")
				nX        := aAtivo[1]
				nBaseCred := aAtivo[2] 
			Else 
				nX        := aAtivo
				nBaseCred := 0 
			EndIf
			//
			If (nX>0)
				nVDeprAt			+= nX
				aMes[nY][2][49][1] += nX
			Else 
				nVDeprAt            += nBaseCred 
				aMes[nY][2][49][1] += nBaseCred
			Endif
			//Ŀ
			// Aquisicoes do Imobilizado - Base na Aquisio               
			//	
		 	dDtIAq	:=	CtoD ("01/"+StrZero(aMes[nY][1],2)+"/"+StrZero(Year(mv_par02),4))
			dDtFAq 	:=  CtoD(Str(F_UltDia(dDtIAq),2)+"/"+StrZero(Month(dDtIAq),2)+"/"+StrZero(Year(mv_par02),4))
			aAtAqu  := DeprecAtivo(dDtIAq,dDtFAq,.T.,.T.,,,,,cFilAnt)
			If Substr(SD1->D1_CF,1,1) == "3"
				If (ValType (aAtAqu)=="A")
					nX1			        += aAtAqu[1]
					nBsCrdAqE  			+= aAtAqu[2]
					aMes[nY][2][37][1] += aAtAqu[2] 
				Else 
					nX1        += aAtAqu
					nBsCrdAqE  := 0
				EndIf
			Else
				If (ValType (aAtAqu)=="A")
					nX1        			+= aAtAqu[1]
					nBsCrdAqI  			+= aAtAqu[2]
					aMes[nY][2][40][1] += aAtAqu[2] 
				Else 
					nX1        += aAtAqu
					nBsCrdAqI  := 0
				EndIf
			EndIf   
			
			//Ŀ
			//  Outras Receitas (Receitas Financeiras                      
			//	
		 	dDtIRec		:=	CtoD ("01/"+StrZero(aMes[nY][1],2)+"/"+StrZero(Year(mv_par02),4))
			dDtFRec		:=	CtoD(Str(F_UltDia(dDtIRec), 2)+"/"+StrZero(Month(dDtIRec), 2)+"/"+StrZero(Year(mv_par02),4))          
			nOutRecN	:=	0
			nOutRecC	:=	0 	
			nRecVen		:=	0	
			aOutrec		:=	SEPARA(cMVOutRec,"/")	
			dbSelectArea("SE1")
			dbSetOrder(6)
			dbSeek(xFilial("SE1")+DTOS(dDtIRec),.T.)
			While SE1->(E1_EMISSAO)>= dDtIRec .And. SE1->(E1_EMISSAO) <= dDtFRec .And. !Eof()			   	
				For nOut := 1 to Len(aOutrec)
					cOutRec	:= aOutrec[nOut]		         	
			        If (AllTrim(SE1->E1_NATUREZ)==cOutRec) .And. !Empty(cOutRec)
		  			If mv_par06 <> 3
						If SF4->F4_TPREG=="1" // Regime Nao-Cumulativo
							nOutRecN			+=	SE1->(E1_VALOR)
						 	aMes[nY][2][38][1]	+=	SE1->(E1_VALOR)
						Else
							nOutRecC			+=	SE1->(E1_VALOR)
						 	aMes[nY][2][39][1]	+=	SE1->(E1_VALOR)
						EndIf
					Else
	                	If nTpRegPrd <> 0 .And. (&(cRegCam)=="1") // Regime Nao-Cumulativo
							nOutRecN			+=	SE1->(E1_VALOR)
	   						aMes[nY][2][38][1]	+=	SE1->(E1_VALOR)
						Else
							nOutRecC			+=	SE1->(E1_VALOR)
	   						aMes[nY][2][39][1]	+=	SE1->(E1_VALOR)
						Endif
	                Endif    
	            EndIf    
				If (AllTrim(SE1->E1_NATUREZ)$cMvRecVen)
		        	nRecVen				+=	SE1->(E1_VALOR)
					aMes[nY][2][51][1] +=	SE1->(E1_VALOR)
				Endif				    
				Next
				SE1->(DbSkip())	   				   	
		    Enddo
			//Ŀ
			//  Outras Receitas Auferidas                                  
			//	
		  	dDtIRec	:=	CtoD("01/"+StrZero(aMes[nY][1],2)+"/"+StrZero(Year(mv_par02),4))
			dDtFRec :=  CtoD(Str(F_UltDia(dDtIRec), 2)+"/"+StrZero(Month(dDtIRec), 2)+"/"+StrZero(Year(mv_par02),4))                        
			dbSelectArea("SE5")
			dbSetOrder(1)
			dbSeek(xFilial("SE5")+DTOS(dDtIRec),.T.)
 			While SE5->E5_DATA>= dDtIRec .And. SE5->E5_DATA <= dDtFRec .And. SE5->E5_FILORIG == cFilAnt .And. !Eof()
	        	nOut := 0
        	 	If TemBxCanc(SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_SEQ)
					(cAliasSE5)->( dbskip())
					loop
				EndIf
				For nOut := 1 to Len(aOutrec)
			   		cOutRec	:= aOutrec[nOut]		   		
		        	If mv_par06 == 2                
		        		If (AllTrim(SE5->E5_NATUREZ)==cOutRec) .And. !Empty(cOutRec)
						     nOutRecN				+=	SE5->(E5_VALOR)
						     aMes[nY][2][38][1]	+=	SE5->(E5_VALOR)
						EndIf  
					Else
						If (AllTrim(SE5->E5_NATUREZ)==cOutRec) .And. !Empty(cOutRec)
						     nOutRecC				+=	SE5->(E5_VALOR)
						     aMes[nY][2][39][1]	+=	SE5->(E5_VALOR)
						EndIf
					EndIf				
				Next                
				If (AllTrim(SE5->E5_NATUREZ)$cMvRecVen) .And. nRecVen == 0
	                nRecVen				+=	SE5->(E5_VALOR)
				    aMes[nY][2][51][1] +=	SE5->(E5_VALOR)
			    Endif	   
				//Ŀ
				//04 - Receita Tributada Aliq Zero 
				//
				If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl05) .and. SF4->F4_TPREG=="1" // Regime Nao-Cumulativo  
					aRecAuf[1]         += SE5->(E5_VALOR)
	       		   aMes[nY][2][29][1] += SE5->(E5_VALOR)
				Endif  
				//Ŀ
				//05 - Receita Auferidas Aliq Zero 
				//
				If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl05)
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
	         		   aRecAuf[1]			+= SE5->(E5_VALOR)
	         		   aMes[nY][2][41][1]	+= SE5->(E5_VALOR)
					Else  
		                //Movimentao bancria
						aRecAuf[1]         += SE5->(E5_VALOR)
		        		aMes[nY][2][41][1] += SE5->(E5_VALOR)
		    		EndIf
			    Endif
				//Ŀ
				//06 - Receita Auferidas Aliq Zero - Revenda de Produto 
				//
				If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl06)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
	                   	aRecAuf[2]+=SE5->(E5_VALOR)
	                   	aMes[nY][2][42][1] +=SE5->(E5_VALOR)
				    Else                         
		                //Movimentao bancria
						aRecAuf[2]			+= SE5->(E5_VALOR)
						aMes[nY][2][42][1] += SE5->(E5_VALOR)
					EndIf 
				Endif		        
				//Ŀ
				//07 - Receita Vendas de Bens do Ativo Permanente 
				//
				If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl07)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
				  		aRecAuf[3] +=SE5->(E5_VALOR)        
				  		aMes[nY][2][43][1] +=SE5->(E5_VALOR)
	                Else  
		                //Movimentao bancria
						aRecAuf[3]			+= SE5->(E5_VALOR)
						aMes[nY][2][43][1] += SE5->(E5_VALOR)
					EndIf
			    Endif 			    
			    //Ŀ
				//08 - Receita Sem Incidencia da Contribuicao -  Exportacao 
				//
			    If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl08)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
			    		aRecAuf[4]			+= SE5->(E5_VALOR)
			    		aMes[nY][2][44][1] += SE5->(E5_VALOR)
					Else  
		                //Movimentao bancria
						aRecAuf[4]			+= SE5->(E5_VALOR)
						aMes[nY][2][44][1] += SE5->(E5_VALOR)
					EndIf
			    Endif		        
		 		//Ŀ
				//09 - Receita Isenta e Demais Receitas Sem Incidencia da Contribuicao 
				//
				If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl09)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
	         			aRecAuf[5]			+= SE5->(E5_VALOR)
	         			aMes[nY][2][45][1] += SE5->(E5_VALOR)
					Else 
		                //Movimentao bancria
		       			aRecAuf[5]			+= SE5->(E5_VALOR)
		       			aMes[nY][2][45][1] += SE5->(E5_VALOR)
		   			EndIf                    
			    Endif    	       
	   	 		//Ŀ
				//10 - Receita com Suspensao da Contribuicao 
				//
	   			If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl10)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
				  		aRecAuf[6]			+= SE5->(E5_VALOR)
				  		aMes[nY][2][46][1] += SE5->(E5_VALOR)
	                Else  
		                //Movimentao bancria
						aRecAuf[6]			+= SE5->(E5_VALOR)
						aMes[nY][2][46][1] += SE5->(E5_VALOR)
					EndIf
			    Endif			    
			    //Ŀ
				//11 - Receita de Revenda Decorrente de operacoes  Sujeitas a ST 
				//
			    If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl11)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
						aRecAuf[7]			+= SE5->(E5_VALOR)
						aMes[nY][2][47][1] += SE5->(E5_VALOR)
	                Else  
		                //Movimentao bancria
						aRecAuf[7]			+= SE5->(E5_VALOR)
						aMes[nY][2][47][1] += SE5->(E5_VALOR)
					EndIf
			    Endif			    
			    //Ŀ
				//12 - Receita Tributada pelo RET - Patrimonio de Afetacao  
				//
			    If (AllTrim(SE5->E5_NATUREZ)$cMVRecAl12)  
					DbSelectArea("SE1")
					SE1->(dbSetOrder(2))
					SE1->(MsSeek(xFilial("SE1")+SE5->E5_CLIFOR+SE5->E5_LOJA+SE5->E5_PREFIXO+SE5->E5_NUMERO+SE5->E5_PARCELA+SE5->E5_TIPO))
	         		If !SE1->(Eof()) 
					 	aRecAuf[8] +=SE5->(E5_VALOR)
					 	aMes[nY][2][48][1] +=SE5->(E5_VALOR)
	                Else                        		    
		                //Movimentao bancria
						aRecAuf[8]         += SE5->(E5_VALOR)
						aMes[nY][2][47][1] += SE5->(E5_VALOR)
					EndIf 
			    Endif
				dbSelectArea("SE5")
				DbSkip()
		    Enddo
			//Ŀ     
		    // 04.Despesas de Energia Eletrica														 
			// 05.Despesas de Alugueis de Predios Locados de Pessoas Juridicas						 
			// 06.Despesas de Alugueis de Maquinas e Equipamentos Locados de Pessoas Juridicas		 
			//
			dDtIDe	:=	CtoD ("01/"+StrZero(aMes[nY][1],2)+"/"+StrZero(Year(mv_par02),4))
		   	dDtFDe 	:=  CtoD(Str(F_UltDia(dDtIDe),2)+"/"+StrZero(Month(dDtIDe),2)+"/"+StrZero(Year(mv_par02),4))				   	
			dbSelectArea("SE2")
			dbSetOrder(3)
            
            //Ir verificar somente uma vez a condio do mv_par06 e lTpDes
            IF (mv_par06 == 2 .Or. mv_par06 == 3) .AND. lTpDes 
			
		   		#IFDEF TOP
					If TcSrvType()<>"AS/400"	    				
													
						cCampos := "%"
						cWhere 	:= "%"
						
						cCampos		+= "SE2.E2_VENCREA, SE2.E2_EMISSAO,SE2.E2_NATUREZ,SE2.E2_VALOR,SED.ED_RECDAC "								
									
				   		If !Empty(xFilial("SE2"))
							cWhere+= "SE2.E2_FILIAL = '"+ cFilAnt + "' AND "
						Else
							cWhere+= "SE2.E2_FILIAL= '"+ xFilial("SE2") + "' AND "
							cWhere+= "SE2.E2_FILORIG= '"+ cFilAnt + "' AND "
						EndIf		
						
						cWhere += " SE2.E2_VENCREA >= '" +dTos(dDtIDe)+"' AND"
						cWhere += " SE2.E2_EMISSAO >= '" +dTos(dDtIDe)+"' AND"
						cWhere += " SE2.E2_EMISSAO <= '" +dTos(dDtFDe)+"' AND"
						cWhere += " SED.ED_RECDAC <> '' AND "
						
						cCampos += "%"
						cWhere  += "%" 
						cOrderBy  :=	"%ORDER BY 1,2,3%"
						cAliasSE2 :=	GetNextAlias()        
				
				    	BeginSql Alias cAliasSE2    
				    	
				    		COLUMN E2_EMISSAO AS DATE	    	
				    		COLUMN E2_VENCREA AS DATE	    	
				
					    	SELECT			    	 
								%Exp:cCampos%		
							FROM 
								%Table:SE2% SE2														
								INNER JOIN %Table:SED% SED ON(SED.ED_FILIAL=%xFilial:SED%  AND SED.ED_CODIGO=SE2.E2_NATUREZ AND SED.%NotDel%)						
							WHERE 
								%Exp:cWhere%
								SE2.%NotDel% 				        
						   		%Exp:cOrderBy%
						EndSql 
					Else
				#ENDIF 
						cIndex	:= CriaTrab(NIL,.F.) 
						cFiltro	:= 'DToS(E2_VENCREA)>="'+DToS(dDtIDe)+'" .AND. DToS(E2_EMISSAO)>="'+DToS(dDtIDe)+'" 
						cFiltro += ' .AND. DToS(E2_EMISSAO)<="'+DToS(dDtFDe)+'"'
						If !Empty(xFilial("SE2"))
							cFiltro += ' .AND. E2_FILIAL=="'+cFilAnt+'" '  
						Else
							cFiltro += ' .AND. E2_FILIAL=="'+xFilial("SE2") + '" '
							cFiltro += ' .AND. E2_FILORIG=="'+cFilAnt+'" '
						EndIf 
						                      	    
					    IndRegua (cAliasSE2, cIndex, SE2->(IndexKey ()),, cFiltro)
					    nIndex := RetIndex(cAliasSE2)
			            
				   		#IFNDEF TOP
		   					DbSetIndex (cIndex+OrdBagExt ())
						#ENDIF
						
						DbSelectArea (cAliasSE2)
		    			DbSetOrder (nIndex+1)
		    
		    	#IFDEF TOP
					Endif
				#ENDIF
		    			
		 		While (cAliasSE2)->(!Eof())
		 		    IF lTop
		 		    	cAliasSED:=cAliasSE2
		 		    Else
		 		    	dbSelectArea("SED")			
						SED->(dbSetOrder(1))
						SED->(MsSeek(xFilial("SED")+(cAliasSE2)->E2_NATUREZ))						
		 		    EndIF                   

         	   		If (AllTrim((cAliasSE2)->E2_NATUREZ)$cMVenergia)
           				If (cAliasSED)->ED_RECDAC=="1"  // Mercado Interno Tributada
                       	   	aMercado[01][01] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="2" //Mercado Interno Nao Tributada
                			aMercado[01][02] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="3"  //Exportacao
                        	aMercado[01][03] += (cAliasSE2)->(E2_VALOR)
                        Endif	                        
                   	Elseif(AllTrim((cAliasSE2)->E2_NATUREZ)$cMValupred) 
                   		If (cAliasSED)->ED_RECDAC=="1"  // Mercado Interno Tributada
                       	   	aMercado[02][01] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="2" //Mercado Interno Nao Tributada
                			aMercado[02][02] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="3"  // Exportacao
                        	aMercado[02][03] += (cAliasSE2)->(E2_VALOR)
                        Endif	                        	
                   	Elseif (AllTrim((cAliasSE2)->E2_NATUREZ)$cMValumaqu)
                   		If (cAliasSED)->ED_RECDAC=="1"  // Mercado Interno Tributada
                       	   	aMercado[03][01] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="2" //Mercado Interno Nao Tributada
                			aMercado[03][02] += (cAliasSE2)->(E2_VALOR)
                        Elseif (cAliasSED)->ED_RECDAC=="3"  // Exportacao
                        	aMercado[03][03] += (cAliasSE2)->(E2_VALOR)
                        Endif	
                	Endif
			
					(cAliasSE2)->( DBSKIP())	
				EndDo
				
				#IFDEF TOP
					If (TcSrvType ()<>"AS/400")
						DbSelectArea (cAliasSE2)
						(cAliasSE2)->(DbCloseArea ())
					EndIF
				#ENDIF  
			EndIF	

		Next
	Next	
	//Restaura o cFilAnt
	SM0->(dbGoTo(nRegEmp))  
	cFilAnt := FWCodFil()
Endif 

Return(aMes)

/*/


Ŀ
Program   ImpDacon   Autor Andressa Ataides        Data  11/09/2006     
Ĵ
Descrio Impressao dos Dados para preenchimento da DACON - NAO CUMULATIVO  
Ĵ
Uso        MATR971                                                          
ͼ


/*/                                                                                
Static Function ImpDacon(lEnd,wnrel,cString,Tamanho,nPagina,cRegime,Titulo,nomeprog,aMes,aMercado)

Local li      	:= 100
Local cCabec1 	:= ""
Local cCabec2 	:= ""
Local cCabec3 	:= ""
Local cCabec4 	:= ""
Local cCabec5 	:= ""
Local cValid	:= ""
Local dDtIni  	:= mv_par01
Local dDtFin  	:= mv_par02
Local nToCreMI 	:= 0
Local nToCreEX 	:= 0
Local nToCreNT 	:= 0
Local nI		:= 0
Local nY		:= 0                  
Local nVDeprAt	:= 0
Local nTotVlMI 	:= 0
Local nTotVlEX 	:= 0
Local nBsCrdAqI	:= 0
Local nBsCrdAqE	:= 0
Local nPercInt  := 0
Local nPercExt  := 0
Local nPercNTr  := 0
Local nOutRecN  := 0
Local nOutRecC  := 0  
Local nCont1	:= 0
Local nCont2	:= 0
Local nCont3    := 0
Local nAjusMI	:= 0
Local nAjusEX	:= 0
Local aRecAuf   := {}   
Local nAjusNT	:= 0
Local nNTrib	:= 0
Local nPis		:= 0
Local nCof		:= 0
Local nItem1	:= 0
Local nItem2	:= 0
Local nItem3	:= 0  
Local nQuant	:= 0
Local n09A_15   := 0
Local n09A_25   := 0
Local n10A_15   := 0
Local n10A_25   := 0
Local nVlrTot   := 0 
Local nTotVlNTr := 0   



Default aMercado  := {}

aMercado  := {{0,0,0},{0,0,0},{0,0,0}}

//Ŀ
//Processamento do Dacon - Regime Cumulativo e Nao Cumulativo             
//
aMes:= ProcDacon(@nVDeprAt,@nTotVlMI,@nTotVlEX,@nBsCrdAqI,@nBsCrdAqE,@nPercInt,@nPercExt,@nOutRecN,@nOutRecC,/*nPosMes*/,/*lRet*/,@nNTrib,@aRecAuf,,@nVAgrDes,@aMercado)


//Versao do Validador
If mv_par08 == 1
	cValid := "Dacon Mensal " + mv_par10
Elseif mv_par08 ==	2
	cValid := "Dacon Semestral " + mv_par10
Else
	cValid := "Dacon Mensal-Semestral " +mv_par10
Endif

cCabec1 := STR0093+TRANSFORM(SM0->M0_CGC,"@R 99.999.999/9999-99")+"  -  "+cValid+Space(05)+"Periodo: "+DtoC(dDtIni)+" a "+DtoC(dDtFin)//+Space(05)+cValid
cCabec2 := STR0077
cCabec3 := cCabec1
cCabec4 := STR0096
cCabec5 := cCabec2 
cCabec6 := STR0356      
                                                                   
//Ŀ
//For de impressao do array
//
For nI := 1 To Len (aMes)
	//Ŀ
	//Apuracao - Painel 1 - Regime Nao Cumulativo  
	//
	 //No se aplica o percentual de proporcao nas notas fiscais devolvidas(aMes[nI][2][7][1] / aMes[nI][2][7][2] / nNTrib
	nTotVlMI :=0  //M Interno        //M NTrib Interno
	nTotVlMI += aMes[nI][2][3][1] + aMes[nI][2][4][1]+aMes[nI][2][6][1]+aMes[nI][2][5][1]+aMes[nI][2][20][1]+aMes[nI][2][21][1]+aMes[nI][2][22][1]+aMes[nI][2][23][1]+nBsCrdAqI+nVDeprAt
	nTotVlEX :=0	
	nTotVlEX += aMes[nI][2][3][2]+aMes[nI][2][4][2]+aMes[nI][2][6][2]+aMes[nI][2][5][2]+aMes[nI][2][20][2]+aMes[nI][2][21][2]+aMes[nI][2][22][2]+aMes[nI][2][23][2]+nBsCrdAqE+nVDeprAt
    nTotVlNTr:=0
    nTotVlNTr += aMes[nI][2][3][3]	
    
	//Ŀ
	//Calcula o percentual em relacao ao total faturado de vendas ao mercado
	//interno e vendas ao mercado externo.                                  
	//
	If aMes[nI][2][17][1] <> 0 .Or. aMes[nI][2][18][1] <> 0 .Or. aMes[nI][2][36][1] <> 0
		nPercInt := aMes[nI][2][17][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
		nPercExt := aMes[nI][2][18][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
		nPercNTr := aMes[nI][2][36][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
	Else                                  
       	nPercInt := 1
       	nPercNTr := 1
	Endif
		
	//Ŀ
	//REGIME NAO CUMULATIVO 							  	
	//
	If mv_par06 ==2
		For nY:= 1 To 4
			If nY == 3 .Or. nY == 1
				cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))+Space(10)+STR0078
				cCabec2:= cCabec5
			ElseIf nY == 2 .Or. nY == 4
				cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))
				cCabec2:= STR0096
			Endif	

			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++

			If nY == 1 .Or. nY == 3
				@Li, 001 PSAY IIF(nY==1,STR0133, STR0155)
			ElseIf nY == 2 .Or. nY == 4
				@Li, 001 PSAY IIF (nY==2, STR0153, STR0156)
			Endif
			li++	
			@Li, 000 PSAY Repli("-",Limite)
			li++	
			//Ŀ
			//Ficha 06A/16A - Apuracao Pis/Cofins - Regime Nao Cumulativo - Painel 1  
			//   

			If (nY ==1 .Or. nY ==3)
				@Li, 001 PSAY IIF(nY==1,STR0134+" 1,65%",STR0134+" 7,6%")
				li++
				li++
				@Li, 001 PSAY STR0012 // "01.Bens para Revenda"
				@Li, 080 PSAY (aMes[nI][2][3][1]+aMes[nI][2][3][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY  aMes[nI][2][3][3] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][3][1]+aMes[nI][2][3][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0013 // "02.Bens Utilizados como Insumos"
				@Li, 080 PSAY (aMes[nI][2][4][1]+aMes[nI][2][4][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][4][3]+aMes[nI][2][4][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][4][1]+aMes[nI][2][4][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0014 // "03.Servicos Utilizados como Insumos"
				@Li, 080 PSAY (aMes[nI][2][6][1]+aMes[nI][2][6][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][6][3]+aMes[nI][2][6][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][6][1]+aMes[nI][2][6][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0015 //"04.Despesas de Energia Eletrica"
				@Li, 080 PSAY (aMes[nI][2][5][1]+aMes[nI][2][5][2])*nPercInt + aMercado[01][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][5][3]+aMes[nI][2][5][2])*nPercNTr + aMercado[01][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][5][1]+aMes[nI][2][5][2])*nPercExt + aMercado[01][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0135 //"05.Despesas de Alugueis de Predios Locados de Pessoas Juridicas"
				@Li, 080 PSAY (aMes[nI][2][20][1]+aMes[nI][2][20][2])*nPercInt + aMercado[02][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][20][3]+aMes[nI][2][20][2])*nPercNTr + aMercado[02][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][20][1]+aMes[nI][2][20][2])*nPercExt + aMercado[02][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0136 // "06.Despesas de Alugueis de Maquinas e Equipamentos Locados de Pessoas Juridicas"
				@Li, 080 PSAY (aMes[nI][2][21][1]+aMes[nI][2][21][2])*nPercInt + aMercado[03][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][21][3]+aMes[nI][2][21][2])*nPercNTr + aMercado[03][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][21][1]+aMes[nI][2][21][2])*nPercExt + aMercado[03][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0137 // "07.Despesas de Armazenagem de Mercadoria e Frete na Operacao de Venda"
				@Li, 080 PSAY (aMes[nI][2][23][1]+aMes[nI][2][23][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][23][3]+aMes[nI][2][23][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][23][1]+aMes[nI][2][23][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0138 // "08.Despesas de Contraprestacoes de Arrendamento Mercantil"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0139 //09.Sobre Bens do Ativo Imobilizado(Com Base nos Encargos de Depreciao)
				@Li, 080 PSAY nVDeprAt*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 110 PSAY "----"  				
				@Li, 115 PSAY nVDeprAt*nPercExt Picture "@E 99,999,999,999.99"   
				li++
				@Li, 001 PSAY STR0140 // 10.Sobre Bens do Ativo Imobilizado(Com Base no Valor de Aquisio)-Processamento Automatico
				@Li, 080 PSAY nBsCrdAqI*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nBsCrdAqI*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nBsCrdAqE*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0141 // "11.Encargos de Amortizacao de Edificacoes e Benfeitorias"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++        
				@Li, 001 PSAY IIF(nY==1,STR0142+"1,65%",STR0142+"7,6%") // "12.Devol.Vendas Suj. a Aliquota de "
				@Li, 080 PSAY aMes[nI][2][7][1] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nNTrib            Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY aMes[nI][2][7][2] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0143 // "13.Outras Operacoes com Direito a Credito"
				@Li, 080 PSAY (aMes[nI][2][22][1]+aMes[nI][2][22][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][22][3]+aMes[nI][2][22][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][22][1]+aMes[nI][2][22][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0144    //14.BASE DE CALCULO DOS CREDITOS
				@Li, 080 PSAY ((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY ((nTotVlNTr+nVAgrDes)*nPercNTr)+nNTrib Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY ((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0145+"  Alquota de 1,65%",STR0145+"  Alquota de 7,6%") //15.Creditos a Descontar"
				@Li, 080 PSAY (((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
				@Li, 097 PSAY (((nVAgrDes+nTotVlNTr)*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
				@Li, 115 PSAY (((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0027 // "APURACAO DE OUTROS CREDITOS"
				li++
				li++                        
				@Li, 001 PSAY STR0146 // "16.Creditos Calculados a Aliquotas Diferenciadas"
				If nY ==1
					@Li, 080 PSAY (aMes[nI][2][1][1])*nPercInt Picture "@E 99,999,999,999.99"
					@Li, 097 PSAY (aMes[nI][2][1][3])*nPercNTr Picture "@E 99,999,999,999.99"
					@Li, 115 PSAY (aMes[nI][2][1][2])*nPercExt Picture "@E 99,999,999,999.99"
				Else
					@Li, 080 PSAY (aMes[nI][2][2][1])*nPercInt Picture "@E 99,999,999,999.99"
					@Li, 097 PSAY (aMes[nI][2][2][3])*nPercNTr Picture "@E 99,999,999,999.99"
					@Li, 115 PSAY (aMes[nI][2][2][2])*nPercExt Picture "@E 99,999,999,999.99"
				Endif
				li++
				@Li, 001 PSAY STR0147 // "17.Creditos Calculados por Unidade de Medida de Produto"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0079 // "18.Crditos da Atividade de Transporte de Cargas - Subcontr.Servios"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"				
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0149 // "19.Credito Presumido Relativo a Estoque de Abertura"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0150 // "20.Creditos da Atividade Imobiliria"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0037 // "21.Outros Creditos a Descontar"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++                
				@Li, 001 PSAY STR0043 // "22.Ajustes Positivos de Creditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++          
				nAjusMI	:= ((aMes[nI][2][10][1]+aMes[nI][2][21][2])*nPercInt)*(IIF(nY==1,0.0165,0.076))
				nAjusNT := ((aMes[nI][2][10][3]+aMes[nI][2][21][2])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
				nAjusEX	:= ((aMes[nI][2][10][1]+aMes[nI][2][21][2])*nPercExt)*(IIF(nY==1,0.0165,0.076)) 
				@Li, 001 PSAY STR0044 // "23.(-)Ajustes Negativos de Creditos"
				@Li, 080 PSAY nAjusMI Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nAjusNT Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nAjusEX Picture "@E 99,999,999,999.99"
				li++
		        //
		        If nY ==1
					nToCreMI := (((((nTotVlMI)*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][1]))-nAjusMI
					nToCreNT := (((((nTotVlNTr)*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][3]))-nAjusNT
					nToCreEX := (((((nTotVlEX)*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][2]))-nAjusEX					
				Else
					nToCreMI := (((((nTotVlMI)*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][1]))-nAjusMI
					nToCreNT := (((((nTotVlNTr)*nPercNTr)+nNTrib) *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][3]))-nAjusNT
					nToCreEX := (((((nTotVlEX)*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][2]))-nAjusEX
				Endif	
                //
				@Li, 001 PSAY STR0152 // "24.TOTAL DE CREDITOS APURADOS APOS AJUSTES"
				@Li, 080 PSAY nToCreMI Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nToCreNT Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nToCreEX Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0080 //"CREDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS"
				li++
				li++
				@Li, 001 PSAY IIF(nY==1,STR0081,STR0171) //"25.Calculados a Alquota de 0,9900%" //"25.Calculados a Alquota de 4,56%"
				@Li, 080 PSAY ((aMes[nI][2][52][1]+aMes[nI][2][52][2])*nPercInt)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY ((aMes[nI][2][52][3]+aMes[nI][2][52][2])*nPercNTr)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY ((aMes[nI][2][52][1]+aMes[nI][2][52][2])*nPercExt)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0083,STR0172) //"26.Calculados a Alquota de 0,5775%" // "26.Calculados a Alquota de 2,66%"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0084 //"27.Ajustes Positivos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0085 //"28.(-)Ajustes Negativos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0086 //"29.TOTAL DE CREDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS, APS AJUSTES"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				li++
				@Li, 001 PSAY STR0089 //"CREDITOS DECORRENTES DA AQUISIO DE EMBALAGENS PARA REVENDA"
				li++
				li++
				@Li, 001 PSAY STR0092 //"30.Crditos Apurados"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0094 //"31.Ajustes Positivos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++				
				@Li, 001 PSAY STR0095 //"32.(-)Ajustes Negativos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++				
				@Li, 001 PSAY STR0100 //"33.TOTAL DE CREDITOS DECORRENTES DA AQUISICAO DE EMBALAGENS PARA REVENDA"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
			//Ŀ
			//Ficha 07A/17A - Calculo Pis/Cofins - Regime Nao Cumulativo - Painel 2   
			//
			Elseif (nY ==2 .Or. nY ==4)
				@Li, 001 PSAY IIF (nY==2, STR0099, STR0124)
				li++
				li++
				@Li, 001 PSAY IIF(nY==2,STR0101,STR0102) //Receita de Vendas
				@Li, 078 PSAY aMes[nI][2][8][1] Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076) Picture "@E 99,999,999,999.99" //Contribuicao
               	nCont1 := ((aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
				li++                 
				@Li, 001 PSAY IIF(nY==2,STR0103,STR0104) //Demais Receitas --Outras Receitas entrarao nesta linha
				@Li, 078 PSAY aMes[nI][2][9][1]+nOutRecN Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076) Picture "@E 99,999,999,999.99" //Contribuicao
                nCont2 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
				li++
				@Li, 001 PSAY IIF(nY==2,STR0105,STR0106)
				@Li, 112 PSAY nCont1+nCont2 Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0082
				li++
				li++
				@Li, 001 PSAY STR0107 //"04.Receita Tributada a Aliquota Zero"
				@Li, 078 PSAY aMes[nI][2][29][1] + aRecAuf[1] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0108 //"05.Receita Tributada a Aliqota Zero-Revenda Prod. Sujeitos Trib. Monof."
				@Li, 078 PSAY aMes[nI][2][30][1] + aRecAuf[2] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"       	
				li++
				@Li, 001 PSAY STR0109 //"06.Receita de Vendas de Bens do Ativo Permanente"
				@Li, 078 PSAY aMes[nI][2][31][1] + aRecAuf[3] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0110 //"07.Receita sem Incidencia da Contribuicao - Exportacao"
				@Li, 078 PSAY aMes[nI][2][27][1] + aRecAuf[4]  Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0111 //"08.Receita Isenta e Demais Receitas sem Incid.Contribuicao"
				@Li, 078 PSAY aMes[nI][2][32][1] + aRecAuf[5]  Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0112 //"09.Receita com Suspensao da Contribuicao"
				@Li, 078 PSAY aMes[nI][2][33][1] + aRecAuf[6] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0115 //"10.Receita de Revenda Dec.Operacoes Suj.Subs.Tribut."
				@Li, 078 PSAY aMes[nI][2][34][1] + aRecAuf[7] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0116 //"11.Receita Tributada pelo RET -Patrimonio de Afetacao"
				@Li, 078 PSAY aMes[nI][2][35][1] + aRecAuf[8] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				li++
				If nY==2
					@Li, 001 PSAY STR0117 //"12.CONTRIBUICAO PIS/PASEP -FOLHA DE SALARIOS"
					If lPisFolha .Or. lPisFolSN
   					    @Li, 078 PSAY "    "
					    @Li, 095 PSAY aMes[nI][2][36][2] Picture "@E 99,999,999,999.99"
					    @Li, 113 PSAY aMes[nI][2][36][2]*0.01 Picture "@E 99,999,999,999.99"
                    Else					
					    @Li, 091 PSAY "    "
					    @Li, 108 PSAY "----"
					    @Li, 125 PSAY "----"
				    EndIf
				Endif
			Endif
		Next
		
		//
		//Ŀ
		//Ficha 15B/25B - Calculo Pis/Cofins - Regime Nao Cumulativo         	
		//
		If mv_par13 == 2
			For nY:= 1 To 2          
				nVlrTot := 0
				cCabec2:= cCabec6
				li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
				li++
				If nY == 1 //Pis
					@Li, 001 PSAY STR0281 //Ficha 15B --> PIS
					nScan := aScan(aWizNCum,{|x| x[2]==STR0281 } )
				Else //Cofins
					@Li, 001 PSAY STR0337 //Ficha 25B --> COFINS
					nScan := aScan(aWizNCum,{|x| x[2]==STR0337 } )
				Endif
				li++
				@Li, 000 PSAY Repli("-",Limite)
				li++
				@Li, 001 PSAY IIF (nY==1, STR0306, STR0336)
				li++
				li++
				@Li, 001 PSAY IIF(nY==1,STR0257,STR0313	)  //01
				@Li, 108 PSAY ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*IIF(nY==1,0.0165,0.076)+;
				              ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==1,0.0165,0.076) +;
				              (((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==1,0.0065,0.076) + ;
				              ((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==1,0.0065,0.076) Picture "@E 99,999,999,999.99" //Valor
				nCont1 := ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*IIF(nY==1,0.0165,0.076)+;
						  ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==1,0.0165,0.076) +;
				          (((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==1,0.0065,0.076) + ;
				          ((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==1,0.0065,0.076)
				nVlrTot+=nCont1
				li++   
				dbSelectArea("TMP")
				cMes :=	StrZero(aMes[nI,1],2)
				If dbSeek(cMes)
					If nY == 1 // Pis
						nPis := TMP->PIS
						cCod := TMP->CODIGO
						While !Eof() .And. TMP->MES == cMes
							While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
								Do Case
									Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
									Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
									Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
								EndCase
								dbSelectArea("TMP")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							n09A_15 += (nItem1+nItem2+nItem3) * nPis / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
							nPis 	:= TMP->PIS
							cCod 	:= TMP->CODIGO
							nItem1	:= 0
							nItem2	:= 0
							nItem3	:= 0
						Enddo
					Else // Cofins
						nCof := TMP->COFINS
						cCod := TMP->CODIGO
						While !Eof() .And. TMP->MES == cMes
							While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
								Do Case
									Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
									Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
									Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
								EndCase
								dbSelectArea("TMP")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							n09A_25 += (nItem1+nItem2+nItem3) * nCof / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 25A e 25B
							nCof 	:= TMP->COFINS
							cCod 	:= TMP->CODIGO
							nItem1	:= 0
							nItem2	:= 0
							nItem3	:= 0
						Enddo
					Endif
				Endif				              
				@Li, 001 PSAY IIF(nY==1,STR0258,STR0314) //02
				@Li, 108 PSAY IIF(nY==1,n09A_15,n09A_25) Picture "@E 99,999,999,999.99"
				IIF(nY==1,nCont1:=n09A_15,nCont1:=n09A_25)
				nVlrTot+=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0259,STR0315)//03
				@Li, 120 PSAY "----"
				li++ 
				dbSelectArea("T01")
				cMes :=	StrZero(aMes[nI,1],2)
				If dbSeek(cMes)
					If nY == 1 // Pis
						nPis := T01->PIS
						cCod := T01->CODIGO
						While !Eof() .And. T01->MES == cMes
							While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
								nItem1 += T01->VALOR
								nQuant += T01->QUANT
								dbSelectArea("T01")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							n10A_15 += nQuant * nPis//Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
							nPis 	:= T01->PIS
							cCod 	:= T01->CODIGO
							nItem1	:= 0
							nQuant  := 0
						Enddo
				  	Else // Cofins
				   	   	nCof := T01->COFINS
						cCod := T01->CODIGO
						While !Eof() .And. T01->MES == cMes
							While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
								nItem1 += T01->VALOR
								nQuant += T01->QUANT
								dbSelectArea("T01")
								dbSkip()
							Enddo						
							cMes :=	StrZero(aMes[nI,1],2)
							n10A_25 += nQuant * nCof //Utilizado para gerar RESUMO de Cofins - Fichas 25A e 25B
							nCof 	:= T01->COFINS
							cCod 	:= T01->CODIGO
							nItem1	:= 0              
							nQuant  := 0
						Enddo
					Endif	
				Endif
				@Li, 001 PSAY IIF(nY==1,STR0260,STR0316) //04  
				@Li, 108 PSAY IIF(nY==1,n10A_15,n10A_25) Picture "@E 99,999,999,999.99"
				IIF(nY==1,nCont1:=n10A_15,nCont1:=n10A_25)  
				nVlrTot+=nCont1
				li++			
				@Li, 001 PSAY IIF(nY==1,STR0261,STR0317) //05
				@Li, 120 PSAY "----"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0262,STR0318) //06
				@Li, 120 PSAY "----"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0311,STR0338) //07
				@Li, 120 PSAY "----"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0310,STR0339) //08
			    @Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0308 //Creditos descontados referentes a aquisicoes no mercado interno
				li++
				li++
				@Li, 001 PSAY STR0282 //09
			    @Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][1]),nCont1:=Val(aNCumVlr[nScan][1])) Picture "@E 99,999,999,999.99"
			    nVlrTot-=nCont1  
				li++
				@Li, 001 PSAY STR0283  //10
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][2]),nCont1:=Val(aNCumVlr[nScan][2])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY STR0284  //11
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][3]),nCont1:=Val(aNCumVlr[nScan][3])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY STR0285  //12
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][4]),nCont1:=Val(aNCumVlr[nScan][4])) Picture "@E 99,999,999,999.99" 
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY STR0286  //13
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][5]),nCont1:=Val(aNCumVlr[nScan][5])) Picture "@E 99,999,999,999.99" 
				nVlrTot-=nCont1
				li++
				li++
				@Li, 001 PSAY STR0309 //Creditos descontados referentes a importacoes
				li++
				li++
				@Li, 001 PSAY STR0287  //14
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][6]),nCont1:=Val(aNCumVlr[nScan][6])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++ 
				@Li, 001 PSAY STR0288  //15
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][7]),nCont1:=Val(aNCumVlr[nScan][7])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY STR0289  //16
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][8]),nCont1:=Val(aNCumVlr[nScan][8])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++   
				@Li, 001 PSAY IIF(nY==1,STR0290,STR0340)  //17
				@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
				li++ 
				li++
				@Li, 001 PSAY STR0307  //Deducoes
				li++
				li++
				@Li, 001 PSAY IIF(nY==1,STR0291,STR0341)  //18
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][9]),nCont1:=Val(aNCumVlr[nScan][9])) Picture "@E 99,999,999,999.99" 
				nVlrTot-=nCont1
				li++ 
				@Li, 001 PSAY IIF(nY==1,STR0292,STR0342)  //19
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][10]),nCont1:=Val(aNCumVlr[nScan][10])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++  
				@Li, 001 PSAY IIF(nY==1,STR0293,STR0343)  //20
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][11]),nCont1:=Val(aNCumVlr[nScan][11])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++ 
				@Li, 001 PSAY IIF(nY==1,STR0294,STR0344)//21 
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][12]),nCont1:=Val(aNCumVlr[nScan][12])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0295,STR0345)  //22
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][13]),nCont1:=Val(aNCumVlr[nScan][13])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++ 
				@Li, 001 PSAY IIF(nY==1,STR0296,STR0346)  //23
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][14]),nCont1:=Val(aNCumVlr[nScan][14])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0297,STR0347)  //24
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][15]),nCont1:=Val(aNCumVlr[nScan][15])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0298,STR0348)  //25
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][16]),nCont1:=Val(aNCumVlr[nScan][16])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0299,STR0349)  //26
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][17]),nCont1:=Val(aNCumVlr[nScan][17])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0300,STR0350)  //27
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][18]),nCont1:=Val(aNCumVlr[nScan][18])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0301,STR0351)  //28
				@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][19]),nCont1:=Val(aNCumVlr[nScan][19])) Picture "@E 99,999,999,999.99"
				nVlrTot-=nCont1
				li++
				@Li, 001 PSAY IIF(nY==1,STR0302,STR0352)  //29
				@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
				li++
		 		@Li, 001 PSAY IIF(nY==1,STR0303,STR0353)  //30  
				@Li, 108 PSAY IIF(nY==1,Val(aNCumVlr[nScan][20]),Val(aNCumVlr[nScan][20])) Picture "@E 99,999,999,999.99" 
				li++
				@Li, 001 PSAY IIF(nY==1,STR0304,STR0354)  //31
				@Li, 108 PSAY IIF(nY==1,Val(aNCumVlr[nScan][21]),Val(aNCumVlr[nScan][21])) Picture "@E 99,999,999,999.99"
				li++
				IF nY == 1
					@Li, 001 PSAY STR0305 //32
					@Li, 108 PSAY Val(aNCumVlr[nScan][22])Picture "@E 99,999,999,999.99" 
				EndIf
				li++
			Next
		EndIf
	//Ŀ
	//REGIME CUMULATIVO 									
	//
	Elseif mv_par06 ==1
		cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))
		//
		//Ŀ
		//Ficha 08A/18A - Calculo Pis/Cofins - Regime Cumulativo - Painel 1 	
		//
		For nY:= 1 To 2 
			cCabec2:= cCabec4
			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++
			If nY == 1 //Pis
				@Li, 001 PSAY STR0098 //Ficha 08a --> PIS
			Else //Cofins
				@Li, 001 PSAY STR0123 //ficha 18a --> COFINS
			Endif
			li++
			@Li, 000 PSAY Repli("-",Limite)
			li++
			@Li, 001 PSAY IIF (nY==1, STR0099, STR0124)
			li++
			li++
			@Li, 001 PSAY IIF(nY==1,STR0118,STR0119)
			@Li, 078 PSAY aMes[nI][2][8][2] Picture "@E 99,999,999,999.99" //Receita
			@Li, 095 PSAY (aMes[nI][2][8][2]-(aMes[nI][2][19][2]+aMes[nI][2][15][2])) Picture "@E 99,999,999,999.99" //Base de Calculo
			@Li, 113 PSAY ((aMes[nI][2][8][2]-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*IIF(nY==1,0.0065,0.03) Picture "@E 99,999,999,999.99" //Contribuicao
            nCont1 := ((aMes[nI][2][8][2]-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))*IIF(nY==1,0.0065,0.03)
			li++                 
			@Li, 001 PSAY IIF(nY==1,STR0120,STR0121) // Outras Receitas entrarao nesta linha
			@Li, 078 PSAY aMes[nI][2][9][2]+nOutRecC Picture "@E 99,999,999,999.99" //Receita
			@Li, 095 PSAY (aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2]) Picture "@E 99,999,999,999.99" //Base de Calculo
			@Li, 113 PSAY ((aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*IIF(nY==1,0.0065,0.03) Picture "@E 99,999,999,999.99" //Contribuicao
            nCont2 := ((aMes[nI][2][9][2]+nOutRecC)-(aMes[nI][2][11][2]+aMes[nI][2][16][2]))*IIF(nY==1,0.0065,0.03)
			li++
			@Li, 001 PSAY IIF(nY==1,STR0122,STR0170)
			@Li, 091 PSAY "----"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0166,STR0167)
			@Li, 113 PSAY nCont1+nCont2 Picture "@E 99,999,999,999.99"
			li++
			li++
			@Li, 001 PSAY STR0082 //"OUTRAS RECEITAS AUFERIDAS"
			li++
			li++
			@Li, 001 PSAY STR0126 //"05.Receita Tributada a Aliquota Zero"
			@Li, 078 PSAY aMes[nI][2][29][2] + aRecAuf[1] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0127 //"06.Receita Tributada a Aliqota Zero-Revenda Prod. Sujeitos Trib. Monof."
			@Li, 078 PSAY aMes[nI][2][30][2]+ aRecAuf[2] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0128 //"07.Receita de Vendas de Bens do Ativo Permanente"
			@Li, 078 PSAY aMes[nI][2][31][2]+ aRecAuf[3] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0129 //"08.Receita sem Incidencia da Contribuicao - Exportacao"
			@Li, 078 PSAY aMes[nI][2][27][2]+ aRecAuf[4] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0130 //"09.Receita Isenta e Demais Receitas sem Incid.Contribuicao"
			@Li, 078 PSAY aMes[nI][2][32][2]+ aRecAuf[5] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0131 //"10.Receita com Suspensao da Contribuicao"
			@Li, 078 PSAY aMes[nI][2][33][2]+ aRecAuf[6] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0132 //"11.Receita de Revenda Dec.Operacoes Suj.Subs.Tribut."
			@Li, 078 PSAY aMes[nI][2][34][2]+ aRecAuf[7] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			@Li, 001 PSAY STR0148 //"12.Receita Tributada pelo RET -Patrimonio de Afetacao"
			@Li, 078 PSAY aMes[nI][2][35][2]+ aRecAuf[8] Picture "@E 99,999,999,999.99"
			@Li, 108 PSAY "----"
			@Li, 125 PSAY "----"
			li++
			li++
			If nY==1
				@Li, 001 PSAY STR0151 //"13.CONTRIBUICAO PIS/PASEP -FOLHA DE SALARIOS"
				If lPisFolha .Or. lPisFolSN
				    @Li, 078 PSAY "    "
				    @Li, 095 PSAY aMes[nI][2][36][2] Picture "@E 99,999,999,999.99"
				    @Li, 113 PSAY aMes[nI][2][36][2]*0.01 Picture "@E 99,999,999,999.99"
				Else
				    @Li, 091 PSAY "    "
				    @Li, 108 PSAY "----"
				    @Li, 125 PSAY "----"
			    EndIf
			Endif
		Next

		//
		//Ŀ
		//Ficha 15A/25A - Calculo Pis/Cofins - Regime Cumulativo            	
		//
		if mv_par13 == 2
		For nY:= 1 To 2          
			nVlrTot := 0
			cCabec2:= cCabec6
			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++
			If nY == 1 //Pis
				@Li, 001 PSAY STR0256 //Ficha 15A --> PIS
				nScan := aScan(aWizCum,{|x| x[2]==STR0256 } )
			Else //Cofins
				@Li, 001 PSAY STR0312 //ficha 25A --> COFINS
				nScan := aScan(aWizCum,{|x| x[2]==STR0312 } )
			Endif
			li++
			@Li, 000 PSAY Repli("-",Limite)
			li++
			@Li, 001 PSAY IIF (nY==1, STR0306, STR0336)
			li++
			li++
			@Li, 001 PSAY IIF(nY==1,STR0257,STR0313	)  //01
			@Li, 108 PSAY ((((aMes[nI][2][8][2]+aMes[nI][2][51][1])-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))+((aMes[nI][2][9][2]+aMes[nI][2][39][1])-(aMes[nI][2][11][2]+aMes[nI][2][16][2])))*IIF(nY==1,0.0065,0.03) Picture "@E 99,999,999,999.99" //Valor
			nCont1 := ((((aMes[nI][2][8][2]+aMes[nI][2][51][1])-(aMes[nI][2][19][2]+aMes[nI][2][15][2])))+((aMes[nI][2][9][2]+aMes[nI][2][39][1])-(aMes[nI][2][11][2]+aMes[nI][2][16][2])))*IIF(nY==1,0.0065,0.03)
			nVlrTot+=nCont1
			li++   
			dbSelectArea("TMP")
			cMes :=	StrZero(aMes[nI,1],2)
			If dbSeek(cMes)
				If nY == 1 // Pis
					nPis := TMP->PIS
					cCod := TMP->CODIGO
					While !Eof() .And. TMP->MES == cMes
						While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
							Do Case
								Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
								Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
								Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
							EndCase
							dbSelectArea("TMP")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n09A_15 += (nItem1+nItem2+nItem3) * nPis / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
						nPis 	:= TMP->PIS
						cCod 	:= TMP->CODIGO
						nItem1	:= 0
						nItem2	:= 0
						nItem3	:= 0
					Enddo
				Else // Cofins
					nCof := TMP->COFINS
					cCod := TMP->CODIGO
					While !Eof() .And. TMP->MES == cMes
						While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
							Do Case
								Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
								Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
								Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
							EndCase
							dbSelectArea("TMP")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n09A_25 += (nItem1+nItem2+nItem3) * nCof / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 25A e 25B
						nCof 	:= TMP->COFINS
						cCod 	:= TMP->CODIGO
						nItem1	:= 0
						nItem2	:= 0
						nItem3	:= 0
					Enddo
				Endif
			Endif				              
			@Li, 001 PSAY IIF(nY==1,STR0258,STR0314) //02
			@Li, 108 PSAY IIF(nY==1,n09A_15,n09A_25) Picture "@E 99,999,999,999.99"
			IIF(nY==1,nCont1:=n09A_15,nCont1:=n09A_25) 
			nVlrTot+=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0259,STR0315)//03
			@Li, 120 PSAY "----"
			li++ 

			//Ŀ
			//Processamento dos valores de PIS e da COFINS por unidade de medida de produto (PAUTA)
			//
			dbSelectArea("T01")
			cMes :=	StrZero(aMes[nI,1],2)
			If dbSeek(cMes)
				//Ŀ
				//Processamento dos valores de PIS
				//
				If nY == 1 // Pis
					nPis := T01->PIS
					cCod := T01->CODIGO
					While !Eof() .And. T01->MES == cMes
						While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
							nItem1 += T01->VALOR    
							nQuant += T01->QUANT
							dbSelectArea("T01")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						//Clculo de PIS e COFINS por pauta  a quantidade multiplicado pelo valor de pauta.
						n10A_15 += nQuant * nPis  //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
						nPis 	:= T01->PIS
						cCod 	:= T01->CODIGO
						nItem1	:= 0
						nQuant  := 0
					Enddo
			  	Else 
					//Ŀ
					//Processamento dos valores da COFINS
					//
			   	   	nCof := T01->COFINS
					cCod := T01->CODIGO
					While !Eof() .And. T01->MES == cMes
						While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
								nItem1 += T01->VALOR
								nQuant += T01->QUANT
							dbSelectArea("T01")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n10A_25 += nQuant * nCof  //Utilizado para gerar RESUMO de Cofins - Fichas 25A e 25B
						nCof 	:= T01->COFINS
						cCod 	:= T01->CODIGO
						nItem1	:= 0
						nQuant  := 0
					Enddo
				Endif	
			Endif
			@Li, 001 PSAY IIF(nY==1,STR0260,STR0316) //04  
			@Li, 108 PSAY IIF(nY==1,n10A_15,n10A_25) Picture "@E 99,999,999,999.99"
			IIF(nY==1,nCont1:=n10A_15,nCont1:=n10A_25)
			nVlrTot+=nCont1
			li++			
			@Li, 001 PSAY IIF(nY==1,STR0261,STR0317) //05
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0262,STR0318) //06
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0263,STR0319) //07
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0264,STR0320) //08
		    @Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0265,STR0321) //"09
			@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
			li++
			li++
			@Li, 001 PSAY STR0307 //Deducoes
			li++  
			li++
			@Li, 001 PSAY IIF(nY==1,STR0266,STR0322)  //10
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][1]),nCont1:=Val(aCumVlrs[nScan][1])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0267,STR0323)  //11
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][2]),nCont1:=Val(aCumVlrs[nScan][2])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0268,STR0324)  //12
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][3]),nCont1:=Val(aCumVlrs[nScan][3])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0269,STR0325)  //13
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][4]),nCont1:=Val(aCumVlrs[nScan][4])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0270,STR0326)  //14
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][5]),nCont1:=Val(aCumVlrs[nScan][5])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0271,STR0327)  //15
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][6]),nCont1:=Val(aCumVlrs[nScan][6])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0272,STR0328)  //16
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][7]),nCont1:=Val(aCumVlrs[nScan][7])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0273,STR0329)  //17
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][8]),nCont1:=Val(aCumVlrs[nScan][8])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++   
			@Li, 001 PSAY IIF(nY==1,STR0274,STR0330)  //18
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][9]),nCont1:=Val(aCumVlrs[nScan][9])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0275,STR0331)  //19
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][10]),nCont1:=Val(aCumVlrs[nScan][10])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0276,STR0332)  //20
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aCumVlrs[nScan][11]),nCont1:=Val(aCumVlrs[nScan][11])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++  
			@Li, 001 PSAY IIF(nY==1,STR0277,STR0333)  //21
			@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0278,STR0334)  //22 
			If lPisFolha .Or. lPisFolSN
				@Li, 108 PSAY IIF(nY==1,aMes[nI][2][36][2]*0.01,Val(aCumVlrs[nScan][12])) Picture "@E 99,999,999,999.99"
			Else
				@Li, 108 PSAY IIF(nY==1,0,Val(aCumVlrs[nScan][12])) Picture "@E 99,999,999,999.99"
			EndIf
			li++
			@Li, 001 PSAY IIF(nY==1,STR0279,STR0335)  //23
			@Li, 108 PSAY IIF(nY==1,Val(aCumVlrs[nScan][12]),Val(aCumVlrs[nScan][13])) Picture "@E 99,999,999,999.99"
			li++
			IF nY == 1
				@Li, 001 PSAY STR0280 //24
				@Li, 108 PSAY Val(aCumVlrs[nScan][13])Picture "@E 99,999,999,999.99" 
			EndIf
			li++
		Next
		Endif
	Else 
	//Ŀ
	//REGIME NAO CUMULATIVO E CUMULATIVO - AMBOS 			
	//
		For nY:= 1 To 4
			If nY == 3 .Or. nY == 1
				cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))+Space(10)+STR0078
				cCabec2:= cCabec5
			ElseIf nY == 2 .Or. nY == 4
				cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))
				cCabec2:= STR0096
			Endif	

			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++

			If nY == 1 .Or. nY == 3
				@Li, 001 PSAY IIF(nY==1,STR0133, STR0155)
			ElseIf nY == 2 .Or. nY == 4
				@Li, 001 PSAY IIF (nY==2,STR0173,STR0174)
			Endif
			li++	
			@Li, 000 PSAY Repli("-",Limite)
			li++	
			//Ŀ
			//Ficha 06A/16A - Apuracao Pis/Cofins - Regime Nao Cumulativo - Painel 1  
			//
			If (nY ==1 .Or. nY ==3)
				@Li, 001 PSAY IIF(nY==1,STR0134+" 1,65%",STR0134+" 7,6%")
				li++
				li++
				@Li, 001 PSAY STR0012 // "01.Bens para Revenda"
				@Li, 080 PSAY (aMes[nI][2][3][1]+aMes[nI][2][3][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY  aMes[nI][2][3][3] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][3][1]+aMes[nI][2][3][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0013 // "02.Bens Utilizados como Insumos"
				@Li, 080 PSAY (aMes[nI][2][4][1]+aMes[nI][2][4][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][4][3]+aMes[nI][2][4][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][4][1]+aMes[nI][2][4][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0014 // "03.Servicos Utilizados como Insumos"
				@Li, 080 PSAY (aMes[nI][2][6][1]+aMes[nI][2][6][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][6][3]+aMes[nI][2][6][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][6][1]+aMes[nI][2][6][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0015 //"04.Despesas de Energia Eletrica"
				@Li, 080 PSAY (aMes[nI][2][5][1]+aMes[nI][2][5][2])*nPercInt+aMercado[01][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][5][3]+aMes[nI][2][5][2])*nPercNTr+aMercado[01][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][5][1]+aMes[nI][2][5][2])*nPercExt+aMercado[01][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0135 //"05.Despesas de Alugueis de Predios Locados de Pessoas Juridicas"
				@Li, 080 PSAY (aMes[nI][2][20][1]+aMes[nI][2][20][2])*nPercInt+aMercado[02][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][20][3]+aMes[nI][2][20][2])*nPercNTr+aMercado[02][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][20][1]+aMes[nI][2][20][2])*nPercExt+aMercado[02][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0136 // "06.Despesas de Alugueis de Maquinas e Equipamentos Locados de Pessoas Juridicas"
				@Li, 080 PSAY (aMes[nI][2][21][1]+aMes[nI][2][21][2])*nPercInt+aMercado[03][01] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][21][3]+aMes[nI][2][21][2])*nPercNTr+aMercado[03][02] Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][21][1]+aMes[nI][2][21][2])*nPercExt+aMercado[03][03] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0137 // "07.Despesas de Armazenagem de Mercadoria e Frete na Operacao de Venda"
				@Li, 080 PSAY (aMes[nI][2][23][1]+aMes[nI][2][23][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][23][3]+aMes[nI][2][23][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][23][1]+aMes[nI][2][23][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0138 // "08.Despesas de Contraprestacoes de Arrendamento Mercantil"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0139 //09.Sobre Bens do Ativo Imobilizado(Com Base nos Encargos de Depreciao)
				@Li, 080 PSAY nVDeprAt*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 110 PSAY "----"
				@Li, 115 PSAY nVDeprAt*nPercExt Picture "@E 99,999,999,999.99"    
				li++
				@Li, 001 PSAY STR0140 // 10.Sobre Bens do Ativo Imobilizado(Com Base no Valor de Aquisio)
				@Li, 080 PSAY nBsCrdAqI*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nBsCrdAqI*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nBsCrdAqE*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0141 // "11.Encargos de Amortizacao de Edificacoes e Benfeitorias"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++        
				@Li, 001 PSAY IIF(nY==1,STR0142+"1,65%",STR0142+"7,6%") // "12.Devol.Vendas Suj. a Aliquota de "
				@Li, 080 PSAY aMes[nI][2][7][1] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nNTrib            Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY aMes[nI][2][7][2] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0143 // "13.Outras Operacoes com Direito a Credito"
				@Li, 080 PSAY (aMes[nI][2][22][1]+aMes[nI][2][22][2])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][2][22][3]+aMes[nI][2][22][2])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][2][22][1]+aMes[nI][2][22][2])*nPercExt Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY STR0144    //14.BASE DE CALCULO DOS CREDITOS
				@Li, 080 PSAY ((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1] Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY ((nTotVlNTr+nVAgrDes)*nPercNTr)+nNTrib Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY ((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2] Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0145+"  Alquota de 1,65%",STR0145+"  Alquota de 7,6%") //15.Creditos a Descontar"
				@Li, 080 PSAY (((nTotVlMI+nVAgrDes)*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
				@Li, 097 PSAY (((nTotVlNTr+nVAgrDes)*nPercNTr)+nNTrib)	*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
				@Li, 115 PSAY (((nTotVlEX+nVAgrDes)*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0027 // "APURACAO DE OUTROS CREDITOS"
				li++
				li++                        
				@Li, 001 PSAY STR0146 // "16.Creditos Calculados a Aliquotas Diferenciadas"
				If nY ==1
					@Li, 080 PSAY (aMes[nI][2][1][1])*nPercInt Picture "@E 99,999,999,999.99"
					@Li, 097 PSAY (aMes[nI][2][1][3])*nPercNTr Picture "@E 99,999,999,999.99"
					@Li, 115 PSAY (aMes[nI][2][1][2])*nPercExt Picture "@E 99,999,999,999.99"
				Else
					@Li, 080 PSAY (aMes[nI][2][2][1])*nPercInt Picture "@E 99,999,999,999.99"
					@Li, 097 PSAY (aMes[nI][2][2][3])*nPercNTr Picture "@E 99,999,999,999.99"
					@Li, 115 PSAY (aMes[nI][2][2][2])*nPercExt Picture "@E 99,999,999,999.99"
				Endif
				li++
				@Li, 001 PSAY STR0147 // "17.Creditos Calculados por Unidade de Medida de Produto"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0079 // "18.Crditos da Atividade de Transporte de Cargas - Subcontr.Servios"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"				
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0149 // "19.Credito Presumido Relativo a Estoque de Abertura"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0150 // "20.Creditos da Atividade Imobiliria"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0037 // "21.Outros Creditos a Descontar"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++                
				@Li, 001 PSAY STR0043 // "22.Ajustes Positivos de Creditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++          
				nAjusMI	:= ((aMes[nI][2][10][1]+aMes[nI][2][21][2])*nPercInt)*(IIF(nY==1,0.0165,0.076))
				nAjusEX	:= ((aMes[nI][2][10][3]+aMes[nI][2][21][2])*nPercExt)*(IIF(nY==1,0.0165,0.076)) 
				nAjusNT := ((aMes[nI][2][10][1]+aMes[nI][2][21][2])*nPercNTr)*(IIF(nY==1,0.0165,0.076)) 
				@Li, 001 PSAY STR0044 // "23.(-)Ajustes Negativos de Creditos"
				@Li, 080 PSAY nAjusMI Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nAjusNT Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nAjusEX Picture "@E 99,999,999,999.99"
				li++
		        //
		        If nY ==1
					nToCreMI := ((((((nTotVlMI+nVAgrDes))*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][1]))-nAjusMI
					nToCreNT := ((((((nTotVlNTr+nVAgrDes))*nPercNTr)+nNTrib)           *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][3]))-nAjusNT
					nToCreEX := ((((((nTotVlEX+nVAgrDes))*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][1][2]))-nAjusEX
				Else
					nToCreMI := ((((((nTotVlMI+nVAgrDes))*nPercInt)+aMes[nI][2][7][1])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][1]))-nAjusMI
					nToCreNT := ((((((nTotVlNTr+nVAgrDes))*nPercNTr)+nNTrib)           *(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][3]))-nAjusNT
					nToCreEX := ((((((nTotVlEX+nVAgrDes))*nPercExt)+aMes[nI][2][7][2])*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][2][2][2]))-nAjusEX					
				Endif	
                //
				@Li, 001 PSAY STR0152 // "24.TOTAL DE CREDITOS APURADOS APOS AJUSTES"
				@Li, 080 PSAY nToCreMI Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY nToCreNT Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY nToCreEX Picture "@E 99,999,999,999.99"
				li++
				li++
				@Li, 001 PSAY STR0080 //"CREDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS"
				li++
				li++
				@Li, 001 PSAY IIF(nY==1,STR0081,STR0171) //"25.Calculados a Alquota de 0,9900%" //"25.Calculados a Alquota de 4,56%"
				@Li, 080 PSAY ((aMes[nI][2][52][1]+aMes[nI][2][52][2])*nPercInt)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY ((aMes[nI][2][52][3]+aMes[nI][2][52][2])*nPercNTr)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY ((aMes[nI][2][52][1]+aMes[nI][2][52][2])*nPercExt)*(IIF(nY==1,0.0099,0.0456)) Picture "@E 99,999,999,999.99"
				li++
				@Li, 001 PSAY IIF(nY==1,STR0083,STR0172) //"26.Calculados a Alquota de 0,5775%" // "26.Calculados a Alquota de 2,66%"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0084 //"27.Ajustes Positivos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0085 //"28.(-)Ajustes Negativos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0086 //"29.TOTAL DE CREDITOS PRESUMIDOS - ATIVIDADES AGROINDUSTRIAIS, APS AJUSTES"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				li++
				@Li, 001 PSAY STR0089 //"CREDITOS DECORRENTES DA AQUISIO DE EMBALAGENS PARA REVENDA"
				li++
				li++
				@Li, 001 PSAY STR0092 //"30.Crditos Apurados"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++
				@Li, 001 PSAY STR0094 //"31.Ajustes Positivos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++				
				@Li, 001 PSAY STR0095 //"32.(-)Ajustes Negativos de Crditos"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"                 
				@Li, 128 PSAY "----"
				li++				
				@Li, 001 PSAY STR0100 //"33.TOTAL DE CREDITOS DECORRENTES DA AQUISICAO DE EMBALAGENS PARA REVENDA"
				@Li, 093 PSAY "----"
				@Li, 110 PSAY "----"
				@Li, 128 PSAY "----"
				li++
			//Ŀ
			//Ficha 07B/17B - Calculo Pis/Cofins - Regime Nao Cumulativo e Cumulativo - Painel 2      
			//
			Elseif (nY ==2 .Or. nY ==4)
				li++
				@Li, 001 PSAY IIF (nY==2,STR0191,STR0192)
				li++
				//
				//REGIME NAO CUMULATIVO
				//
				@Li, 001 PSAY IIF(nY==2,STR0101,STR0102) //Receita de Vendas 
				@Li, 078 PSAY aMes[nI][2][8][1]+aMes[nI][2][51][1] Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][51][1]+aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][51][1]+aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076) Picture "@E 99,999,999,999.99" //Contribuicao
               	nCont1 := ((aMes[nI][2][51][1]+aMes[nI][2][8][1]-(aMes[nI][2][19][1]+aMes[nI][2][15][1])))*IIF(nY==2,0.0165,0.076)
				li++                 
				@Li, 001 PSAY IIF(nY==2,STR0103,STR0104) //Demais Receitas --Outras Receitas entrarao nesta linha
				@Li, 078 PSAY aMes[nI][2][9][1]+nOutRecN Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076) Picture "@E 99,999,999,999.99" //Contribuicao
                nCont2 := ((aMes[nI][2][9][1]+nOutRecN)-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==2,0.0165,0.076)
				li++
				@Li, 001 PSAY IIF(nY==2,STR0105,STR0106)
				@Li, 112 PSAY nCont1+nCont2 Picture "@E 99,999,999,999.99"
				li++
				li++
				li++
				li++
				@Li, 001 PSAY IIF (nY==2, STR0176, STR0190)
				//
				//REGIME CUMULATIVO
				//
				li++
				@Li, 001 PSAY IIF(nY==2,STR0177,STR0194) //Receita de Vendas 
				@Li, 078 PSAY aMes[nI][2][12][1]+aMes[nI][2][51][1] Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][51][1]+aMes[nI][2][12][1]-(aMes[nI][2][14][1]+aMes[nI][2][25][1])) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][51][1]+aMes[nI][2][12][1]-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==2,0.0065,0.03) Picture "@E 99,999,999,999.99" //Contribuicao
               	nCont1 := ((aMes[nI][2][51][1]+aMes[nI][2][12][1]-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==2,0.0065,0.03)
				li++                 
				@Li, 001 PSAY IIF(nY==2,STR0178,STR0196) //Demais Receitas --Outras Receitas entrarao nesta linha
				@Li, 078 PSAY aMes[nI][2][13][1]+nOutRecC Picture "@E 99,999,999,999.99" //Receita
				@Li, 095 PSAY (aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1]) Picture "@E 99,999,999,999.99" //Base de Calculo
				@Li, 112 PSAY ((aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==2,0.0065,0.03) Picture "@E 99,999,999,999.99" //Contribuicao
                nCont2 := ((aMes[nI][2][13][1]+nOutRecC)-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==2,0.0065,0.03)
				li++
				@Li, 001 PSAY IIF(nY==2,STR0179,STR0193)
				@Li, 091 PSAY "----"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY IIF(nY==2,STR0180,STR0195)
				@Li, 112 PSAY nCont1+nCont2 Picture "@E 99,999,999,999.99"
				li++
				li++                 
				li++
				@Li, 001 PSAY STR0082
				li++
				@Li, 001 PSAY STR0181 //"08.Receita Tributada a Alquota Zero"
				@Li, 078 PSAY aMes[nI][2][29][1]+ aRecAuf[1] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0182 //"09.Receita Tributada a Alquota Zero-Revenda Prod. Sujeitos Trib. Monof."
				@Li, 078 PSAY aMes[nI][2][30][1] + aRecAuf[2]Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0183 //"10.Receita de Vendas de Bens do Ativo Permanente"
				@Li, 078 PSAY aMes[nI][2][31][1] + aRecAuf[3] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0184 //"11.Receita sem Incidncia da Contribuio - Exportao"
				@Li, 078 PSAY aMes[nI][2][27][1]+ aRecAuf[4] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0185 //"12.Receita Isenta e Demais Receitas sem Incid.Contribuio"
				@Li, 078 PSAY aMes[nI][2][32][1]+ aRecAuf[5] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0186 //"13.Receita com Suspenso da Contribuio"
				@Li, 078 PSAY aMes[nI][2][33][1] + aRecAuf[6] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0187 //"14.Receita de Revenda Dec.Operaes Suj.Subs.Tribut."
				@Li, 078 PSAY aMes[nI][2][34][1]+ aRecAuf[7] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"                  
				@Li, 125 PSAY "----"
				li++
				@Li, 001 PSAY STR0188 //"15.Receita Tributada pelo RET -Patrimnio de Afetao"
				@Li, 078 PSAY aMes[nI][2][35][1]+ aRecAuf[8] Picture "@E 99,999,999,999.99"
				@Li, 108 PSAY "----"
				@Li, 125 PSAY "----"
				li++
				li++
				If nY==2
					@Li, 001 PSAY STR0189 //"16.CONTRIBUIO PIS/PASEP -FOLHA DE SALRIOS"
					If lPisFolha .Or. lPisFolSN
					    @Li, 078 PSAY "    "
					    @Li, 095 PSAY aMes[nI][2][36][2] Picture "@E 99,999,999,999.99"
					    @Li, 113 PSAY aMes[nI][2][36][2]*0.01 Picture "@E 99,999,999,999.99"
					Else	
					    @Li, 091 PSAY "    "
					    @Li, 108 PSAY "----"
					    @Li, 125 PSAY "----"
				    EndIf
				Endif
			Endif
		Next 
		
		//
		//Ŀ
		//Ficha 15B/25B - Calculo Pis/Cofins - Regime Cumulativo e Nao Cumulativo 
		//
	   if mv_par13 == 2		
		For nY:= 1 To 2          
			nVlrTot := 0
			cCabec2:= cCabec6
			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++
			If nY == 1 //Pis
				@Li, 001 PSAY STR0281 //Ficha 15B --> PIS
				nScan := aScan(aWizNCum,{|x| x[2]==STR0281 } )
			Else //Cofins
				@Li, 001 PSAY STR0337 //Ficha 25B --> COFINS
				nScan := aScan(aWizNCum,{|x| x[2]==STR0337 } )
			Endif
			li++
			@Li, 000 PSAY Repli("-",Limite)
			li++
			@Li, 001 PSAY IIF (nY==1, STR0306, STR0336)
			li++
			li++
			@Li, 001 PSAY IIF(nY==1,STR0257,STR0313	)  //01
			@Li, 108 PSAY ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*IIF(nY==1,0.0165,0.076)+;
			              ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==1,0.0165,0.076) +;
			              (((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==1,0.0065,0.076) + ;
			              ((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==1,0.0065,0.076) Picture "@E 99,999,999,999.99" //Valor
			nCont1 := ((aMes[nI][2][8][1]+aMes[nI][2][51][1])-(aMes[nI][2][19][1]+aMes[nI][2][15][1]))*IIF(nY==1,0.0165,0.076)+;
					  ((aMes[nI][2][9][1]+aMes[nI][2][38][1])-(aMes[nI][2][11][1]+aMes[nI][2][16][1]))*IIF(nY==1,0.0165,0.076) +;
			          (((aMes[nI][2][12][1]+aMes[nI][2][51][1])-(aMes[nI][2][14][1]+aMes[nI][2][25][1])))*IIF(nY==1,0.0065,0.076) + ;
			          ((aMes[nI][2][13][1]+aMes[nI][2][39][1])-(aMes[nI][2][24][1]+aMes[nI][2][26][1]))*IIF(nY==1,0.0065,0.076)
			nVlrTot+=nCont1
			li++   
			dbSelectArea("TMP")
			cMes :=	StrZero(aMes[nI,1],2)
			If dbSeek(cMes)
				If nY == 1 // Pis
					nPis := TMP->PIS
					cCod := TMP->CODIGO
					While !Eof() .And. TMP->MES == cMes
						While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
							Do Case
								Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
								Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
								Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
							EndCase
							dbSelectArea("TMP")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n09A_15 += (nItem1+nItem2+nItem3) * nPis / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
						nPis 	:= TMP->PIS
						cCod 	:= TMP->CODIGO
						nItem1	:= 0
						nItem2	:= 0
						nItem3	:= 0
					Enddo
				Else // Cofins
					nCof := TMP->COFINS
					cCod := TMP->CODIGO
					While !Eof() .And. TMP->MES == cMes
						While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
							Do Case
								Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
								Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
								Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR
							EndCase
							dbSelectArea("TMP")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n09A_25 += (nItem1+nItem2+nItem3) * nCof / 100 //Utilizado para gerar RESUMO de PIS/Pasep - Fichas 25A e 25B
						nCof 	:= TMP->COFINS
						cCod 	:= TMP->CODIGO
						nItem1	:= 0
						nItem2	:= 0
						nItem3	:= 0
					Enddo
				Endif
			Endif				              
			@Li, 001 PSAY IIF(nY==1,STR0258,STR0314) //02
			@Li, 108 PSAY IIF(nY==1,n09A_15,n09A_25) Picture "@E 99,999,999,999.99"
			IIF(nY==1,nCont1:=n09A_15,nCont1:=n09A_25)
			nVlrTot+=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0259,STR0315)//03
			@Li, 120 PSAY "----"
			li++ 
			dbSelectArea("T01")
			cMes :=	StrZero(aMes[nI,1],2)
			If dbSeek(cMes)
				If nY == 1 // Pis
					nPis := T01->PIS
					cCod := T01->CODIGO
					While !Eof() .And. T01->MES == cMes
						While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
							nItem1 += T01->VALOR
							nQuant += T01->QUANT
							dbSelectArea("T01")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n10A_15 += nQuant * nPis//Utilizado para gerar RESUMO de PIS/Pasep - Fichas 15A e 15B
						nPis 	:= T01->PIS
						cCod 	:= T01->CODIGO
						nItem1	:= 0
						nQuant  := 0
					Enddo
			  	Else // Cofins
			   	   	nCof := T01->COFINS
					cCod := T01->CODIGO
					While !Eof() .And. T01->MES == cMes
						While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
							nItem1 += T01->VALOR
							nQuant += T01->QUANT
							dbSelectArea("T01")
							dbSkip()
						Enddo						
						cMes :=	StrZero(aMes[nI,1],2)
						n10A_25 += nQuant * nCof //Utilizado para gerar RESUMO de Cofins - Fichas 25A e 25B
						nCof 	:= T01->COFINS
						cCod 	:= T01->CODIGO
						nItem1	:= 0              
						nQuant  := 0
					Enddo
				Endif	
			Endif
			@Li, 001 PSAY IIF(nY==1,STR0260,STR0316) //04  
			@Li, 108 PSAY IIF(nY==1,n10A_15,n10A_25) Picture "@E 99,999,999,999.99"
			IIF(nY==1,nCont1:=n10A_15,nCont1:=n10A_25)  
			nVlrTot+=nCont1
			li++			
			@Li, 001 PSAY IIF(nY==1,STR0261,STR0317) //05
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0262,STR0318) //06
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0311,STR0338) //07
			@Li, 120 PSAY "----"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0310,STR0339) //08
		    @Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
			li++
			li++
			@Li, 001 PSAY STR0308 //Creditos descontados referentes a aquisicoes no mercado interno
			li++
			li++
			@Li, 001 PSAY STR0282 //09
		    @Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][1]),nCont1:=Val(aNCumVlr[nScan][1])) Picture "@E 99,999,999,999.99"
		    nVlrTot-=nCont1  
			li++
			@Li, 001 PSAY STR0283  //10
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][2]),nCont1:=Val(aNCumVlr[nScan][2])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY STR0284  //11
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][3]),nCont1:=Val(aNCumVlr[nScan][3])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY STR0285  //12
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][4]),nCont1:=Val(aNCumVlr[nScan][4])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY STR0286  //13
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][5]),nCont1:=Val(aNCumVlr[nScan][5])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++
			li++
			@Li, 001 PSAY STR0309 //Creditos descontados referentes a importacoes
			li++
			li++
			@Li, 001 PSAY STR0287  //14
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][6]),nCont1:=Val(aNCumVlr[nScan][6])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY STR0288  //15
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][7]),nCont1:=Val(aNCumVlr[nScan][7])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY STR0289  //16
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][8]),nCont1:=Val(aNCumVlr[nScan][8])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++   
			@Li, 001 PSAY IIF(nY==1,STR0290,STR0340)  //17
			@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
			li++ 
			li++
			@Li, 001 PSAY STR0307  //Deducoes
			li++
			li++
			@Li, 001 PSAY IIF(nY==1,STR0291,STR0341)  //18
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][9]),nCont1:=Val(aNCumVlr[nScan][9])) Picture "@E 99,999,999,999.99" 
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0292,STR0342)  //19
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][10]),nCont1:=Val(aNCumVlr[nScan][10])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++  
			@Li, 001 PSAY IIF(nY==1,STR0293,STR0343)  //20
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][11]),nCont1:=Val(aNCumVlr[nScan][11])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0294,STR0344)//21 
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][12]),nCont1:=Val(aNCumVlr[nScan][12])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0295,STR0345)  //22
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][13]),nCont1:=Val(aNCumVlr[nScan][13])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++ 
			@Li, 001 PSAY IIF(nY==1,STR0296,STR0346)  //23
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][14]),nCont1:=Val(aNCumVlr[nScan][14])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0297,STR0347)  //24
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][15]),nCont1:=Val(aNCumVlr[nScan][15])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0298,STR0348)  //25
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][16]),nCont1:=Val(aNCumVlr[nScan][16])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0299,STR0349)  //26
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][17]),nCont1:=Val(aNCumVlr[nScan][17])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0300,STR0350)  //27
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][18]),nCont1:=Val(aNCumVlr[nScan][18])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0301,STR0351)  //28
			@Li, 108 PSAY IIF(nY==1,nCont1:=Val(aNCumVlr[nScan][19]),nCont1:=Val(aNCumVlr[nScan][19])) Picture "@E 99,999,999,999.99"
			nVlrTot-=nCont1
			li++
			@Li, 001 PSAY IIF(nY==1,STR0302,STR0352)  //29
			@Li, 108 PSAY nVlrTot Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0303,STR0353)  //30  
			@Li, 108 PSAY IIF(nY==1,Val(aNCumVlr[nScan][20]),Val(aNCumVlr[nScan][20])) Picture "@E 99,999,999,999.99" 
			li++
			@Li, 001 PSAY IIF(nY==1,STR0304,STR0354)  //31
			@Li, 108 PSAY IIF(nY==1,Val(aNCumVlr[nScan][21]),Val(aNCumVlr[nScan][21])) Picture "@E 99,999,999,999.99"
			li++
			IF nY == 1
				@Li, 001 PSAY STR0305 //32
				@Li, 108 PSAY Val(aNCumVlr[nScan][22])Picture "@E 99,999,999,999.99" 
			EndIf
			li++
		Next
	Endif
	Endif
	
	//Ŀ
	//IMPORTACAO - REGIME NAO CUMULATIVO 					
	//
	If mv_par09 == 2 .And. Len(aMes[nI])>=3
	
		nTotVlMI :=0
		nTotVlMI += aMes[nI][3][3][1]+aMes[nI][3][4][1]+aMes[nI][3][6][1]+aMes[nI][3][5][1]+aMes[nI][3][20][1]+aMes[nI][3][22][1]+nBsCrdAqI+nVDeprAt
	
		//Ŀ
		//Calcula o percentual em relacao ao total faturado de vendas ao mercado
		//interno e vendas ao mercado externo.                                  
		//
		If aMes[nI][2][17][1] <> 0 .Or. aMes[nI][2][18][1] <> 0 .Or. aMes[nI][2][36][1] <> 0
			nPercInt := aMes[nI][2][17][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
			nPercExt := aMes[nI][2][18][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
			nPercNTr := aMes[nI][2][36][1] / (aMes[nI][2][17][1] + aMes[nI][2][18][1] + aMes[nI][2][36][1])
		Else
	       	nPercInt := 1
	       	nPercExt := 0
	       	nPercNTr := 0
		Endif
		
		cCabec1:= cCabec3+" - "+Alltrim(MesExtenso(aMes[nI][1]))+Space(10)+STR0078
		cCabec2:= cCabec5
		For nY:= 1 To 2
			li := cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
			li++

			@Li, 001 PSAY IIF(nY==1,STR0238, STR0239) //"Ficha 06B - Apurao dos Crditos de PIS/PASEP - Importao - Regime No Cumulativo"###"Ficha 16B - Apurao dos Crditos da COFINS - Importao - Regime No Cumulativo"
			
			li++	
			@Li, 000 PSAY Repli("-",Limite)
			li++	
			//Ŀ
			//Ficha 06B/16B   
			//
			@Li, 001 PSAY IIF(nY==1,STR0134+" 1,65%",STR0134+" 7,6%")
			li++
			li++
			@Li, 001 PSAY STR0012 // "01.Bens para Revenda"
			@Li, 080 PSAY (aMes[nI][3][3][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][3][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][3][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0013 // "02.Bens Utilizados como Insumos"
			@Li, 080 PSAY (aMes[nI][3][4][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][4][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][4][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0014 // "03.Servicos Utilizados como Insumos"
			@Li, 080 PSAY (aMes[nI][3][6][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][6][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][6][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0015 //"04.Despesas de Energia Eletrica"
			@Li, 080 PSAY (aMes[nI][3][5][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][5][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][5][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0225 //"05.Despesas de Alugueis de Predios"
			@Li, 080 PSAY (aMes[nI][3][20][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][20][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][20][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0226 //"06.Sobre Bens do Ativo Imobilizado(Com Base nos Encargos de Depreciao)"
			@Li, 080 PSAY nVDeprAt*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 110 PSAY "----"
			@Li, 115 PSAY nVDeprAt*nPercExt Picture "@E 99,999,999,999.99"   
			li++
			@Li, 001 PSAY STR0227 //"07.Sobre Bens do Ativo Imobilizado(Com Base no Valor de Aquisio)"
			@Li, 080 PSAY nBsCrdAqI*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY nBsCrdAqI*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY nBsCrdAqE*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0228 //"08.Outras Operacoes com Direito a Credito"
			@Li, 080 PSAY (aMes[nI][3][22][1])*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY (aMes[nI][3][22][1])*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY (aMes[nI][3][22][1])*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY STR0229 //"09.BASE DE CALCULO DOS CREDITOS"
			@Li, 080 PSAY nTotVlMI*nPercInt Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY nTotVlMI*nPercNTr Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY nTotVlMI*nPercExt Picture "@E 99,999,999,999.99"
			li++
			@Li, 001 PSAY IIF(nY==1,STR0230+"  Alquota de 1,65%",STR0230+"  Alquota de 7,6%") //"10.Creditos a Descontar"###"10.Creditos a Descontar"
			@Li, 080 PSAY (nTotVlMI*nPercInt)*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
			@Li, 097 PSAY (nTotVlMI*nPercNTr)*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99" 
			@Li, 115 PSAY (nTotVlMI*nPercExt)*(IIF(nY==1,0.0165,0.076)) Picture "@E 99,999,999,999.99"
			li++
			li++
			@Li, 001 PSAY STR0027 // "APURACAO DE OUTROS CREDITOS"
			li++
			li++                        
			@Li, 001 PSAY STR0231 //"11.Creditos Calculados a Aliquotas Diferenciadas"
			If nY ==1
				@Li, 080 PSAY (aMes[nI][3][1][1])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][3][1][1])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][3][1][1])*nPercExt Picture "@E 99,999,999,999.99"
			Else
				@Li, 080 PSAY (aMes[nI][3][2][1])*nPercInt Picture "@E 99,999,999,999.99"
				@Li, 097 PSAY (aMes[nI][3][2][1])*nPercNTr Picture "@E 99,999,999,999.99"
				@Li, 115 PSAY (aMes[nI][3][2][1])*nPercExt Picture "@E 99,999,999,999.99"
			Endif
			li++
			@Li, 001 PSAY STR0232 //"12.Creditos Calculados por Unidade de Medida de Produto"
			@Li, 093 PSAY "----"
			@Li, 110 PSAY "----"
			@Li, 128 PSAY "----"
			li++
			@Li, 001 PSAY STR0252 //"13.Credito presumido Relat. Estoque de Abertura - Alcool"
			@Li, 093 PSAY "----"
			@Li, 110 PSAY "----"                 
			@Li, 128 PSAY "----"
            li++
			@Li, 001 PSAY STR0233 //"14.Creditos da Atividade Imobiliria"
			@Li, 093 PSAY "----"
			@Li, 110 PSAY "----"                 
			@Li, 128 PSAY "----"
			li++
			@Li, 001 PSAY STR0234 //"15.Outros Creditos a Descontar"
			@Li, 093 PSAY "----"
			@Li, 110 PSAY "----"                 
			@Li, 128 PSAY "----"
			li++                
			@Li, 001 PSAY STR0235 //"16.Ajustes Positivos de Creditos"
			@Li, 093 PSAY "----"
			@Li, 110 PSAY "----"                 
			@Li, 128 PSAY "----"
			li++          
			nAjusMI	:= ((aMes[nI][3][10][1])*nPercInt)*(IIF(nY==1,0.0165,0.076))
			nAjusEX	:= ((aMes[nI][3][10][1])*nPercExt)*(IIF(nY==1,0.0165,0.076)) 
			nAjusNT := ((aMes[nI][3][10][1])*nPercNTr)*(IIF(nY==1,0.0165,0.076))
			@Li, 001 PSAY STR0236 //"16.(-)Ajustes Negativos de Creditos"
			@Li, 080 PSAY nAjusMI Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY nAjusNT Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY nAjusEX Picture "@E 99,999,999,999.99"
			li++
	        //
	        If nY ==1
				nToCreMI := ((((nTotVlMI)*nPercInt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusMI
				nToCreNT := ((((nTotVlMI)*nPercNTr)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusNT
				nToCreEX := ((((nTotVlMI)*nPercExt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][1][1]))-nAjusEX
			Else
				nToCreMI := ((((nTotVlMI)*nPercInt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][2][1]))-nAjusMI
				nToCreNT := ((((nTotVlMI)*nPercNTr)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][2][1]))-nAjusNT
				nToCreEX := ((((nTotVlMI)*nPercExt)*(IIF(nY==1,0.0165,0.076)))+(aMes[nI][3][2][1]))-nAjusEX
			Endif	
                //
			@Li, 001 PSAY STR0237 //"18.TOTAL DE CREDITOS APURADOS APOS AJUSTES"
			@Li, 080 PSAY nToCreMI Picture "@E 99,999,999,999.99"
			@Li, 097 PSAY nToCreNT Picture "@E 99,999,999,999.99"
			@Li, 115 PSAY nToCreEX Picture "@E 99,999,999,999.99"
			li++
			
		Next
	EndIf
	
	//Ŀ
	//Imprime Ficha 09A/19A - PIS/PASEP E COFINS- Aliquotas Diferenciadas 
	//
	If mv_par07 == 2
		Impf09(aMes[nI,1],Titulo,nPagina,NomeProg,Tamanho,cCabec1)
	Endif
	
	//Ŀ
	//Imprime Ficha 10A - PIS/PASEP - Aliquotas por Unidade de Medida     
	//
	If mv_par12 == 2
		Impf10(aMes[nI,1],Titulo,nPagina,NomeProg,Tamanho,cCabec1)
	Endif 
	
	If mv_par14 == 2
		Impf11(Titulo,nPagina,NomeProg,Tamanho,cCabec1,"PIS")
		Impf11(Titulo,nPagina,NomeProg,Tamanho,cCabec1,"COF")
		Impf12(Titulo,nPagina,NomeProg,Tamanho,cCabec1,"PIS")
		Impf12(Titulo,nPagina,NomeProg,Tamanho,cCabec1,"COF")
	EndIf    
		
Next (nY)

Return(.T.)

/*/


Ŀ
Program   Gravaf09   Autor Sergio S. Fuzinaka      Data   11/09/2006    
Ĵ
Descricao Grava a Ficha 09(PIS/PASEP) - Diferencial de Aliquota             
Ĵ
Uso       MATR971                                                           
ٱ


/*/                                                                                
Static Function Gravaf09(nMes,cItem,nPPis,nPCofins,nValor)

Local aArea	:= GetArea()

If cItem == "01"	//Receitas de Vendas
	nValor := SD2->D2_TOTAL+SD2->D2_ICMSRET+SD2->D2_VALFRE+SD2->D2_SEGURO+SD2->D2_DESPESA+SD2->D2_VALIPI
Endif

dbSelectArea("TMP")
dbSetOrder(1)
If !dbSeek(StrZero(nMes,2)+cItem+Str(nPPis,5,2)+Str(nPCofins,5,2))
	RecLock("TMP",.T.)
	TMP->MES	:= StrZero(nMes,2)
	TMP->CODIGO	:= SD2->D2_COD
	TMP->ITEM	:= cItem
	TMP->PIS	:= nPPis
	TMP->COFINS	:= nPCofins
Else
	RecLock("TMP",.F.)
Endif
TMP->VALOR	+= nValor
MsUnlock()

RestArea(aArea)

Return Nil

/*/


Ŀ
Program   Gravaf10   Autor Luccas Curcio           Data   17/01/2011    
Ĵ
Descricao Grava a Ficha 10(PIS/PASEP) - Unidade de Medida                   
Ĵ
Uso       MATR971                                                           
ٱ


/*/                                                                                
Static Function Gravaf10(nMes,cItem,nPPis,nPCofins,nValor)

Local aArea	:= GetArea()

If cItem == "01"	//Receitas de Vendas
	nValor := SD2->D2_TOTAL+SD2->D2_ICMSRET+SD2->D2_VALFRE+SD2->D2_SEGURO+SD2->D2_DESPESA+SD2->D2_VALIPI
	nQuant := SD2->D2_QUANT 
	//Verifica se aplica a segunda unidade
	If mv_par15 == 2 .AND. SB1->B1_UM <> SB1->B1_SEGUM  //mauro
		If SB1->B1_TIPCONV == "D"		
			nQuant /= SB1->B1_CONV
			nValor *= SB1->B1_CONV
		Else                     		
			nQuant *= SB1->B1_CONV
			nValor /= SB1->B1_CONV 
		Endif	
	Endif		
Endif

dbSelectArea("T01")
dbSetOrder(1)
//Faz dbseek com chave da tabela temporria T01 - mes+codigo+item
If !dbSeek(StrZero(nMes,2)+SD2->D2_COD+cItem)
	RecLock("T01",.T.)
	T01->MES	:= StrZero(nMes,2)
	T01->CODIGO	:= SD2->D2_COD
	T01->ITEM	:= cItem
	T01->PIS	:= nPPis
	T01->COFINS	:= nPCofins
Else
	RecLock("T01",.F.)
Endif
T01->VALOR	+= nValor
T01->QUANT  += nQuant
MsUnlock()

RestArea(aArea)

Return Nil

/*/


Ŀ
Program   Impf09     Autor Sergio S. Fuzinaka      Data    12.08.2005   
Ĵ
Descricao Imprime a Ficha 09(PIS/PASEP) - Diferencial de Aliquota           
Ĵ
Uso       MATR971                                                           
ٱ


/*/

Static Function Impf09(nMes,Titulo,nPagina,NomeProg,Tamanho,cCabec1)

Local aArea		:= GetArea()
Local cCabec2	:= STR0158
Local cMes		:= StrZero(nMes,2)
Local cCod		:= ""
Local nLin		:= 0
Local nPis		:= 0
Local nCof		:= 0
Local nItem1	:= 0
Local nItem2	:= 0
Local nItem3	:= 0

dbSelectArea("TMP")
If dbSeek(cMes)
	//Ŀ
	//Ficha 09A -Calculo da Contribuio PIS/PASEP- Alquotas Diferenciadas 	
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	@ ++nLin, 001 PSAY OemToAnsi(STR0168)
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	nPis := TMP->PIS
	cCod := TMP->CODIGO
	While !Eof() .And. TMP->MES == cMes
		While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
			Do Case
				Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
				Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR
				Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR				
			EndCase			
			dbSelectArea("TMP")
			dbSkip()
		Enddo
		@ ++nLin, 001 PSAY "Produto: " + Alltrim(cCod) + " - " + Alltrim(Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC"))
		@ nLin , 070 PSAY nItem1 Picture "@E 99,999,999,999.99" //Receita de Vendas
		@ nLin, 087 PSAY (nItem1-(nItem2+nItem3)) Picture "@E 99,999,999,999.99" //Base de Calculo
		@ nLin, 109 PSAY nPis Picture "@E 99.99" // Aliquota
		@ nLin, 114 PSAY (((nItem1-(nItem2+nItem3))*nPis)/100) Picture "@E 99,999,999,999.99" //Valor Apurado
		nPis 	:= TMP->PIS
		cCod 	:= TMP->CODIGO		
		nItem1	:= 0
		nItem2	:= 0
		nItem3	:= 0
	Enddo
Endif	

dbSelectArea("TMP")
If dbSeek(cMes)
	//Ŀ
	//Ficha 19A -Calculo da Contribuio PIS/PASEP- Alquotas Diferenciadas 	
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	@ ++nLin, 001 PSAY OemToAnsi(STR0169)
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	nCof := TMP->COFINS
	cCod := TMP->CODIGO
	While !Eof() .And. TMP->MES == cMes
		While !Eof() .And. TMP->MES == cMes .And. TMP->CODIGO == cCod
			Do Case
				Case TMP->ITEM == "01"	;	nItem1 := TMP->VALOR
				Case TMP->ITEM == "02"	;	nItem2 := TMP->VALOR				
				Case TMP->ITEM == "03"	;	nItem3 := TMP->VALOR				
			EndCase			
			dbSelectArea("TMP")
			dbSkip()
		Enddo
		@ ++nLin, 001 PSAY "Produto: " + Alltrim(cCod) + " - " + Alltrim(Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC"))
		@ nLin , 070 PSAY nItem1 Picture "@E 99,999,999,999.99" //Receita de Vendas
		@ nLin, 087 PSAY (nItem1-(nItem2+nItem3)) Picture "@E 99,999,999,999.99" //Base de Calculo
		@ nLin, 109 PSAY nCof Picture "@E 99.99" // Aliquota
		@ nLin, 114 PSAY (((nItem1-(nItem2+nItem3))*nCof)/100) Picture "@E 99,999,999,999.99" //Valor Apurado
		nCof 	:= TMP->COFINS
		cCod 	:= TMP->CODIGO		
		nItem1	:= 0
		nItem2	:= 0
		nItem3	:= 0
	Enddo
Endif

RestArea(aArea)

Return Nil

/*/


Ŀ
Program   Impf10     Autor Luccas Curcio      Data    17/01/2011        
Ĵ
Descricao Imprime a Ficha 10(PIS/PASEP) - Unidade de Medida                 
Ĵ
Uso       MATR971                                                           
ٱ


/*/

Static Function Impf10(nMes,Titulo,nPagina,NomeProg,Tamanho,cCabec1)

Local cCabec2	:= STR0158
Local cMes		:= StrZero(nMes,2)
Local cCod		:= ""
Local nLin		:= 0
Local nPis		:= 0
Local nCof		:= 0
Local nItem1	:= 0
Local nQuant	:= 0
Local cDsc		:= ""

dbSelectArea("T01")
If dbSeek(cMes)
	//Ŀ
	//Ficha 10A - Calculo da Contribuio PIS/PASEP - Alquotas por Unidade de Medida 	 
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	@ ++nLin, 001 PSAY OemToAnsi(STR0254)
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	nPis := T01->PIS
	cCod := T01->CODIGO
	cDsc := Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC")	
	While !Eof() .And. T01->MES == cMes
		While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
			nItem1 += T01->VALOR
			nQuant += T01->QUANT			
			dbSelectArea("T01")
			dbSkip()
		Enddo	
		@ ++nLin, 001 PSAY "Produto: " + Alltrim(cCod) + " - " + Alltrim(cDsc)
		@ nLin , 070 PSAY nItem1 Picture "@E 99,999,999,999.99" //Receita de Vendas
		@ nLin, 087 PSAY nQuant Picture "@E 99999999.99" //Quantidade
		@ nLin, 109 PSAY nPis Picture "@E 99.9999" // Aliquota
		@ nLin, 114 PSAY nQuant * nPis  Picture "@E 99,999,999,999.99" //Valor Apurado
		nPis 	:= T01->PIS
		cCod 	:= T01->CODIGO		
		nItem1	:= 0
		nQuant  := 0
	Enddo
Endif


dbSelectArea("T01")
If dbSeek(cMes)
	//Ŀ
	//Ficha 20A - Calculo da Contribuio COFINS - Alquotas por Unidade de Medida 	 
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	@ ++nLin, 001 PSAY OemToAnsi(STR0355)
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	nCof := T01->COFINS
	cCod := T01->CODIGO
	While !Eof() .And. T01->MES == cMes
		While !Eof() .And. T01->MES == cMes .And. T01->CODIGO == cCod
			nItem1 += T01->VALOR
			nQuant += T01->QUANT			
			dbSelectArea("T01")
			dbSkip()
		Enddo
		@ ++nLin, 001 PSAY "Produto: " + Alltrim(cCod) + " - " + Alltrim(Posicione("SB1",1,xFilial("SB1")+cCod,"B1_DESC"))
		@ nLin , 070 PSAY nItem1 Picture "@E 99,999,999,999.99" //Receita de Vendas
		@ nLin, 087 PSAY nQuant Picture "@E 99999999.99" //Quantidade
		@ nLin, 109 PSAY nCof Picture "@E 99.9999" // Aliquota
		@ nLin, 114 PSAY nQuant * nCof  Picture "@E 99,999,999,999.99" //Valor Apurado
		nCof 	:= T01->COFINS
		cCod 	:= T01->CODIGO		
		nItem1	:= 0
		nQuant  := 0
	Enddo
Endif

Return Nil

/*/


Ŀ
Program   Impf11     Autor Beatriz Scarpa    		 Data    21.05.2013   
Ĵ
Descricao Imprime a Ficha 11(PIS/PASEP) - Controle do Diferimento           
          Imprime a Ficha 21(COFINS)    - Controle do Diferimento           
Ĵ
Uso       MATR971                                                           
ٱ


/*/

Static Function Impf11(Titulo,nPagina,NomeProg,Tamanho,cCabec1,cTpCon) 

Local aArea		:= GetArea()
Local cCabec2	:= IIf(cTpCon=="PIS",STR0361,STR0362)
Local cDtPer	:= StrZero(Month(mv_par02), 2)+StrZero(Year(mv_par02),4)
Local cRegApur	:= ""

Do Case
	Case mv_par06 == 1 ; cRegApur := "Regime Cumulativo"
	Case mv_par06 == 2 ; cRegApur := "Regime No-Cumulativo"
	Case mv_par06 == 3 ; cRegApur := "Regime Cumulativo e No Cumulativo (Ambos)"
EndCase

dbSelectArea("CFB")
dbSetOrder(1)

If dbSeek(xFilial("CFB")+cDtPer+cTpCon)
	//Ŀ
	//Ficha 11 -Calculo da Contribuio PIS/PASEP- Controle de Diferimento 	
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	If mv_par06 <> 1
		@ ++nLin, 001 PSAY OemToAnsi(STR0359)
	Else
		@ ++nLin, 001 PSAY OemToAnsi(STR0360)
	EndIf
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	@ ++nLin, 001 PSAY cRegApur //Tipo do Regime de Apuracao
	@ nLin, 063 PSAY SubStr(cDtPer,1,2)+"/"+SubStr(cDtPer,3,4) //Periodo do Diferimento
	@ nLin, 078 PSAY CFB->CFB_CONREC Picture "@E 99,999,999,999.99" //Contribuicao Diferida
	If mv_par06 <> 1 
		@ nLin, 103 PSAY CFB->CFB_CREDES Picture "@E 99,999,999,999.99" //Credito Diferido
	EndIf
Endif	

RestArea(aArea)

Return Nil 

/*/


Ŀ
Program   Impf12     Autor Beatriz Scarpa    		 Data    21.05.2013   
Ĵ
Descricao Imprime a Ficha 12(PIS/PASEP) - Controle do Diferimento           
          Imprime a Ficha 22(COFINS)    - Controle do Diferimento           
Ĵ
Uso       MATR971                                                           
ٱ


/*/

Static Function Impf12(Titulo,nPagina,NomeProg,Tamanho,cCabec1,cTpCon) 

Local aArea		:= GetArea()
Local cCabec2	:= IIf(cTpCon=="PIS",STR0357,STR0358)
Local cDtPer	:= StrZero(Month(mv_par02), 2)+StrZero(Year(mv_par02),4)
Local cRegApur	:= ""

Do Case
	Case mv_par06 == 1 ; cRegApur := "Regime Cumulativo"
	Case mv_par06 == 2 ; cRegApur := "Regime No-Cumulativo"
	Case mv_par06 == 3 ; cRegApur := "Regime Cumulativo e No Cumulativo (Ambos)"
EndCase

dbSelectArea("CFA")
dbSetOrder(1)

If dbSeek(xFilial("CFA")+cDtPer+cTpCon)
	//Ŀ
	//Ficha 12 -Calculo da Contribuio PIS/PASEP- Controle de Diferimento 	
	//
	nLin := Cabec(Titulo,cCabec1,cCabec2,nomeprog,Tamanho,15)
	If mv_par06 <> 1
		@ ++nLin, 001 PSAY OemToAnsi(STR0359)
	Else
		@ ++nLin, 001 PSAY OemToAnsi(STR0360)
	EndIf	
	@ ++nLin, 000 PSAY Replicate("-",Limite)
	@ ++nLin, 001 PSAY cRegApur //Tipo do Regime de Apuracao
	@ nLin, 063 PSAY SubStr(cDtPer,1,2)+"/"+SubStr(cDtPer,3,4) //Periodo do Diferimento
	@ nLin, 078 PSAY CFA->CFA_CONDIF Picture "@E 99,999,999,999.99" //Contribuicao Diferida
	If mv_par06 <> 1 
		@ nLin, 103 PSAY CFA->CFA_CREDIF Picture "@E 99,999,999,999.99" //Credito Diferido
	EndIf
Endif	

RestArea(aArea)

Return Nil

/*/


Ŀ
Program   GeraTmp    Autor Sergio S. Fuzinaka      Data   11/09/2006    
Ĵ
Descricao Gera arquivo temporario para impressao das fichas 9 e 15          
Ĵ
Uso       MATR971                                                           
ٱ


/*/                                                                                
Static Function GeraTmp()

Local aStru	:= {}
Local cArq	:= ""

AADD(aStru,{"MES"		,"C",002,0})	//Mes de Referencia
AADD(aStru,{"CODIGO"	,"C",015,0})	//Codigo do Produto
AADD(aStru,{"ITEM"		,"C",002,0})	//Numero do Item: 01.Receitas de Vendas; 02.(-)Vendas Canc. e Desc. Incondic.; 03.(-)Outras Exclusoes
AADD(aStru,{"PIS"		,"N",005,2})	//Aliquota PIS/PASEP
AADD(aStru,{"COFINS"	,"N",005,2})	//Aliquota COFINS
AADD(aStru,{"VALOR"		,"N",015,2})	//Valor 

cArq := CriaTrab(aStru)
dbUseArea(.T.,__LocalDriver,cArq,"TMP")
IndRegua("TMP",cArq,"MES+CODIGO+ITEM")

Return Nil

/*/


Ŀ
Program   GeraT01    Autor Luccas Curcio      Data   17/01/2011         
Ĵ
Descricao Gera arquivo temporario para impressao das fichas 10              
Ĵ
Uso       MATR971                                                           
ٱ


/*/
Static Function GeraT01()

Local aStru	:= {}
Local cArq	:= ""

AADD(aStru,{"MES"		,"C",002,0})	//Mes de Referencia
AADD(aStru,{"CODIGO"	,"C",TamSx3("B1_COD")[1],0})	//Codigo do Produto
AADD(aStru,{"ITEM"		,"C",002,0})	//Numero do Item: 01.Receitas de Vendas; 02.(-)Vendas Canc. e Desc. Incondic.; 03.(-)Outras Exclusoes
AADD(aStru,{"PIS"		,"N",007,4})	//Aliquota PIS/PASEP
AADD(aStru,{"COFINS"	,"N",007,4})	//Aliquota COFINS
AADD(aStru,{"VALOR"		,"N",015,2})	//Valor
AADD(aStru,{"QUANT"     ,"N",011,2})   //Quantidade 

cArq := CriaTrab(aStru)
dbUseArea(.T.,__LocalDriver,cArq,"T01")
IndRegua("T01",cArq,"MES+CODIGO+ITEM")

Return Nil
                   
/*/


Ŀ
Funcao    AjustaSX1  Autor  Nereu Humberto Jr      Data 12.12.2002
Ĵ
Descrio Cria as perguntas necesarias para o programa                
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
                                                                      
Ĵ
   DATA    Programador   Manutencao Efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function AjustaSX1()

Local aHelpPor :={} 
Local aHelpEng :={} 
Local aHelpSpa :={} 
Local nTamSx1Grp :=Len(SX1->X1_GRUPO)
      
dbSelectArea("SX1")
dbSetOrder(1)
If dbSeek(PadR("MTR971",nTamSx1Grp)+"08")
	If ALLTRIM(UPPER(SX1->X1_PERGUNT)) <> "APLICATIVO"
		RecLock("SX1",.F.)
		dbDelete()
		MsUnlock()
	Endif
Endif 

dbSelectArea("SX1")
dbSetOrder(1)
If dbSeek(PadR("MTR971",nTamSx1Grp)+"13")
	If (SX1->X1_PERGUNT) <> "Imprime Ficha 15/25"
		RecLock("SX1",.F.)
			SX1->X1_PERGUNT := "Imprime Ficha 15/25"
		MsUnlock()
	Endif
Endif

dbSelectArea("SX1")
dbSetOrder(1)
If dbSeek(PadR("MTR971",nTamSx1Grp)+"14")
	If (SX1->X1_PERGUNT) <> "Imprime Fichas 11/12 e 21/22"
		RecLock("SX1",.F.)
			SX1->X1_PERGUNT := "Imprime Fichas 11/12 e 21/22"
		MsUnlock()
	Endif
Endif

If dbSeek(PadR("MTR971",nTamSx1Grp)+"04") .And. SX1->(AllTrim(X1_F3)<>"XM0" .Or. AllTrim(X1_GRPSXG)<>"033")
	RecLock("SX1",.F.)
		SX1->X1_F3		:=	"XM0"
		SX1->X1_GRPSXG	:=	"033"
	MsUnlock()
EndIf

If dbSeek(PadR("MTR971",nTamSx1Grp)+"05") .And. SX1->(AllTrim(X1_F3)<>"XM0" .Or. AllTrim(X1_GRPSXG)<>"033")
	RecLock("SX1",.F.)
		SX1->X1_F3		:=	"XM0"
		SX1->X1_GRPSXG	:=	"033"
	MsUnlock()
EndIf

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
/*-----------------------MV_PAR08--------------------------*/
Aadd( aHelpPor, "Informe o tipo de aplicativo a ")
Aadd( aHelpPor, "ser utilizado para apresentao") 
Aadd( aHelpPor, "das informaes.               ")
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"08","Aplicativo","Aplicativo","Aplicativo","mv_ch8",;
"N",1,0,1,"C","","","","","mv_par08","Mensal","Mensal","Mensal","",;
"Semestral","Semestral","Semestral",;
"Mens-Semestral","Mens-Semestral","Mens-Semestral","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR09--------------------------*/
aHelpPor := {}
Aadd( aHelpPor, "Selecione se deseja imprimir as fichas  " )
Aadd( aHelpPor, "6B/16B.Importao-Regime No Cumulativo." )

aHelpEng := aHelpSpa := aHelpPor

PutSx1( PadR("MTR971",nTamSx1Grp),"09","Imprime Ficha 06B/16B","Imprime Ficha 06B/16B","Imprime Ficha 06B/16B","mv_ch9",;
"N",1,0,1,"C","","","","","mv_par09","Nao","Nao","Nao","","Sim","Sim","Sim","","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

//Atualizando pergunta 06
//Regime de Apuracao de Pis/Pasep e Cofins 
If dbSeek(PadR("MTR971",nTamSx1Grp)+"06")
   RecLock("SX1",.F.)
   SX1->X1_DEF03 	:= 'Ambos'
   SX1->X1_DEFSPA3 	:= 'Ambas'
   SX1->X1_DEFENG3 	:= 'Both'
   MsUnLock()
Endif

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
/*-----------------------MV_PAR10--------------------------*/
Aadd( aHelpPor, "Informe a verso do aplicativo ")
Aadd( aHelpPor, "a ser utilizada para apresenta-") 
Aadd( aHelpPor, "o das informaes.           ")
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"10","Verso","Verso","Verso","mv_cha",;
"C",3,0,0,"G","","","","","mv_par10","","","","",;
"","","",;
"","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)   

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
/*-----------------------MV_PAR11--------------------------*/
Aadd( aHelpPor, "Informe se deve ou no gerar o ")
Aadd( aHelpPor, "arquivo magntico da Dacon") 
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"11","Gera Arquivo","Gera Arquivo","Gera Arquivo","mv_chb",;
"N",1,0,0,"C","","","","","mv_par11","Nao","Nao","Nao","","Sim","Sim","Sim",;
"","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 

/*-----------------------MV_PAR12--------------------------*/
Aadd( aHelpPor, "Informe se deve ou no imprimir ")
Aadd( aHelpPor, "a Ficha 10A") 
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"12","Imprime Ficha 10A","Imprime Ficha 10A","Imprime Ficha 10A","mv_chc",;
"N",1,0,1,"C","","","","","mv_par12","Nao","Nao","Nao","","Sim","Sim","Sim","","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 

/*-----------------------MV_PAR13--------------------------*/
Aadd( aHelpPor, "Informe se deve ou no imprimir ")
Aadd( aHelpPor, "a Ficha 15 e 25") 
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"13","Imprime Ficha 15/25","Imprime Ficha 15/25","Imprime Ficha 15/25","mv_chd",;
"N",1,0,1,"C","","","","","mv_par13","Nao","No","No","","Sim","Yes","S","","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={}  

/*-----------------------MV_PAR14--------------------------*/
Aadd( aHelpPor, "Informe se deve ou no imprimir ")
Aadd( aHelpPor, "as Fichas 11/12 e 21/22") 
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"14","Imprime Fichas 11/12 e 21/22","Imprime Fichas 11/12 e 21/22","Imprime Fichas 11/12 e 21/22","mv_che",;
"N",1,0,1,"C","","","","","mv_par14","Nao","No","No","","Sim","Yes","S","","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 

/*-----------------------MV_PAR15--------------------------*/
Aadd( aHelpPor, "Utiliza a Segunda Unidade na gerao")
Aadd( aHelpPor, "das Fichas 10A e 20A.") 
Aadd( aHelpPor, "A quantidade e o valor sero calculados") 
Aadd( aHelpPor, "pelo Fator de Converso cadastrado.") 
//                                          
aHelpEng := aHelpSpa := aHelpPor

PutSx1(PadR("MTR971",nTamSx1Grp),"15","Utiliza a Segunda Unidade?","Utiliza a Segunda Unidade?","Utiliza a Segunda Unidade?","mv_chf",;
"N",1,0,1,"C","","","","","mv_par15","Nao","Nao","Nao","","Sim","Sim","Sim","","","","","","","","","",;
aHelpPor,aHelpEng,aHelpSpa)

aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 


Return   
